/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/platform","vs/base/common/path","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/resources","vs/platform/log/common/log","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/strings","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/base/common/objects","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/registry/common/platform","vs/base/common/json","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/configuration/common/configurationRegistry","vs/base/common/map","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","child_process","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","fs","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/codicons","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/normalization","vs/base/common/glob","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/mime","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","util","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(K){for(var e=[],v=0,k=K.length;v<k;v++)e[v]=Z[K[v]];return e};define(Z[87],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function v(k,L){if(!k)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=v}),define(Z[63],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const v=Object.prototype.hasOwnProperty;function k(n){const m=[];for(let d in n)v.call(n,d)&&m.push(n[d]);return m}e.values=k;function L(n,m){for(let d in n)if(v.call(n,d)&&m({key:d,value:n[d]},function(){delete n[d]})===!1)return}e.forEach=L;function A(n,m){const d=Object.create(null);for(const g of n){const h=m(g);let C=d[h];C||(C=d[h]=[]),C.push(g)}return d}e.groupBy=A;function O(n){const m=Object.create(null);return n&&n.forEach((d,g)=>{m[g]=d}),m}e.fromMap=O;function P(n,m){const d=[],g=[];for(let h of n)m.has(h)||d.push(h);for(let h of m)n.has(h)||g.push(h);return{removed:d,added:g}}e.diffSets=P;function S(n,m){const d=[],g=[];for(let[h,C]of n)m.has(h)||d.push(C);for(let[h,C]of m)n.has(h)||g.push(C);return{removed:d,added:g}}e.diffMaps=S;class w{constructor(){this.map=new Map}add(m,d){let g=this.map.get(m);g||(g=new Set,this.map.set(m,g)),g.add(d)}delete(m,d){const g=this.map.get(m);!g||(g.delete(d),g.size===0&&this.map.delete(m))}forEach(m,d){const g=this.map.get(m);!g||g.forEach(d)}}e.SetMap=w}),define(Z[64],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function v(O){return(P,S,w)=>{let n=null,m=null;if(typeof w.value=="function"?(n="value",m=w.value):typeof w.get=="function"&&(n="get",m=w.get),!m)throw new Error("not supported");w[n]=O(m,S)}}e.createDecorator=v;function k(O,P,S){let w=null,n=null;if(typeof S.value=="function"?(w="value",n=S.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(w="get",n=S.get),!n)throw new Error("not supported");const m=`$memoize$${P}`;S[w]=function(...d){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,d)}),this[m]}}e.memoize=k;function L(O,P,S){return v((w,n)=>{const m=`$debounce$${n}`,d=`$debounce$result$${n}`;return function(...g){this[d]||(this[d]=S?S():void 0),clearTimeout(this[m]),P&&(this[d]=P(this[d],...g),g=[this[d]]),this[m]=setTimeout(()=>{w.apply(this,g),this[d]=S?S():void 0},O)}})}e.debounce=L;function A(O,P,S){return v((w,n)=>{const m=`$throttle$timer$${n}`,d=`$throttle$result$${n}`,g=`$throttle$lastRun$${n}`,h=`$throttle$pending$${n}`;return function(...C){if(this[d]||(this[d]=S?S():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),P&&(this[d]=P(this[d],...C)),this[h])return;const D=this[g]+O;D<=Date.now()?(this[g]=Date.now(),w.apply(this,[this[d]]),this[d]=S?S():void 0):(this[h]=!0,this[m]=setTimeout(()=>{this[h]=!1,this[g]=Date.now(),w.apply(this,[this[d]]),this[d]=S?S():void 0},D-Date.now()))}})}e.throttle=A}),define(Z[11],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class v{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=v,e.errorHandler=new v;function k(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=k;function L(a){S(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=L;function A(a){S(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=A;function O(a){if(a instanceof Error){let{name:t,message:r}=a;const i=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:i}}return a}e.transformErrorForSerialization=O;const P="Canceled";function S(a){return a instanceof Error&&a.name===P&&a.message===P}e.isPromiseCanceledError=S;class w extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=w;function n(){const a=new Error(P);return a.name=a.message,a}e.canceled=n;function m(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=m;function d(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=d;function g(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=g;function h(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=h;function C(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=C;class D extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=D;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;function p(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=p;function s(a,t=Object.create(null)){const r=new Error(a);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=s}),define(Z[19],ee([0,1,11]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function k(R,T=0){return R[R.length-(1+T)]}e.tail=k;function L(R){if(R.length===0)throw new Error("Invalid tail call");return[R.slice(0,R.length-1),R[R.length-1]]}e.tail2=L;function A(R,T,M=(N,B)=>N===B){if(R===T)return!0;if(!R||!T||R.length!==T.length)return!1;for(let N=0,B=R.length;N<B;N++)if(!M(R[N],T[N]))return!1;return!0}e.equals=A;function O(R,T,M){let N=0,B=R.length-1;for(;N<=B;){const G=(N+B)/2|0,Q=M(R[G],T);if(Q<0)N=G+1;else if(Q>0)B=G-1;else return G}return-(N+1)}e.binarySearch=O;function P(R,T){let M=0,N=R.length;if(N===0)return 0;for(;M<N;){const B=Math.floor((M+N)/2);T(R[B])?N=B:M=B+1}return M}e.findFirstInSorted=P;function S(R,T,M){if(R=R|0,R>=T.length)throw new TypeError("invalid index");let N=T[Math.floor(T.length*Math.random())],B=[],G=[],Q=[];for(let X of T){const ie=M(X,N);ie<0?B.push(X):ie>0?G.push(X):Q.push(X)}return R<B.length?S(R,B,M):R<B.length+Q.length?Q[0]:S(R-(B.length+Q.length),G,M)}e.quickSelect=S;function w(R,T){const M=[];let N;for(const B of R.slice(0).sort(T))!N||T(N[0],B)!==0?(N=[B],M.push(N)):N.push(B);return M}e.groupBy=w;function n(R,T,M){const N=[];function B(X,ie,ne){if(ie===0&&ne.length===0)return;const oe=N[N.length-1];oe&&oe.start+oe.deleteCount===X?(oe.deleteCount+=ie,oe.toInsert.push(...ne)):N.push({start:X,deleteCount:ie,toInsert:ne})}let G=0,Q=0;for(;;){if(G===R.length){B(G,0,T.slice(Q));break}if(Q===T.length){B(G,R.length-G,[]);break}const X=R[G],ie=T[Q],ne=M(X,ie);ne===0?(G+=1,Q+=1):ne<0?(B(G,1,[]),G+=1):ne>0&&(B(G,0,[ie]),Q+=1)}return N}e.sortedDiff=n;function m(R,T,M){const N=n(R,T,M),B=[],G=[];for(const Q of N)B.push(...R.slice(Q.start,Q.start+Q.deleteCount)),G.push(...Q.toInsert);return{removed:B,added:G}}e.delta=m;function d(R,T,M){if(M===0)return[];const N=R.slice(0,M).sort(T);return h(R,T,N,M,R.length),N}e.top=d;function g(R,T,M,N,B){return M===0?Promise.resolve([]):new Promise((G,Q)=>{(async()=>{const X=R.length,ie=R.slice(0,M).sort(T);for(let ne=M,oe=Math.min(M+N,X);ne<X;ne=oe,oe=Math.min(oe+N,X)){if(ne>M&&await new Promise(he=>setTimeout(he)),B&&B.isCancellationRequested)throw v.canceled();h(R,T,ie,ne,oe)}return ie})().then(G,Q)})}e.topAsync=g;function h(R,T,M,N,B){for(const G=M.length;N<B;N++){const Q=R[N];if(T(Q,M[G-1])<0){M.pop();const X=P(M,ie=>T(Q,ie)<0);M.splice(X,0,Q)}}}function C(R){return R.filter(T=>!!T)}e.coalesce=C;function D(R){let T=0;for(let M=0;M<R.length;M++)R[M]&&(R[T]=R[M],T+=1);R.length=T}e.coalesceInPlace=D;function b(R,T,M){R.splice(M,0,R.splice(T,1)[0])}e.move=b;function I(R){return!Array.isArray(R)||R.length===0}e.isFalsyOrEmpty=I;function p(R){return Array.isArray(R)&&R.length>0}e.isNonEmptyArray=p;function s(R,T){if(!T)return R.filter((N,B)=>R.indexOf(N)===B);const M=Object.create(null);return R.filter(N=>{const B=T(N);return M[B]?!1:(M[B]=!0,!0)})}e.distinct=s;function a(R){const T=new Set;return R.filter(M=>T.has(M)?!1:(T.add(M),!0))}e.distinctES6=a;function t(R){const T=Object.create(null);return M=>{const N=R(M);return T[N]?!1:(T[N]=!0,!0)}}e.uniqueFilter=t;function r(R,T){for(let M=R.length-1;M>=0;M--){const N=R[M];if(T(N))return M}return-1}e.lastIndex=r;function i(R,T){return R.length>0?R[0]:T}e.firstOrDefault=i;function o(R,T,M=(N,B)=>N===B){let N=0;for(let B=0,G=Math.min(R.length,T.length);B<G&&M(R[B],T[B]);B++)N++;return N}e.commonPrefixLength=o;function u(R){return[].concat(...R)}e.flatten=u;function c(R,T){let M=typeof T=="number"?R:0;typeof T=="number"?M=R:(M=0,T=R);const N=[];if(M<=T)for(let B=M;B<T;B++)N.push(B);else for(let B=M;B>T;B--)N.push(B);return N}e.range=c;function l(R,T,M){return R.reduce((N,B)=>(N[T(B)]=M?M(B):B,N),Object.create(null))}e.index=l;function y(R,T){return R.push(T),()=>E(R,T)}e.insert=y;function E(R,T){const M=R.indexOf(T);if(M>-1)return R.splice(M,1),T}e.remove=E;function f(R,T,M){const N=R.slice(0,T),B=R.slice(T);return N.concat(M,B)}e.arrayInsert=f;function U(R,T){let M;if(typeof T=="number"){let N=T;M=()=>{const B=Math.sin(N++)*179426549;return B-Math.floor(B)}}else M=Math.random;for(let N=R.length-1;N>0;N-=1){const B=Math.floor(M()*(N+1)),G=R[N];R[N]=R[B],R[B]=G}}e.shuffle=U;function F(R,T){const M=R.indexOf(T);M>-1&&(R.splice(M,1),R.unshift(T))}e.pushToStart=F;function z(R,T){const M=R.indexOf(T);M>-1&&(R.splice(M,1),R.push(T))}e.pushToEnd=z;function $(R,T){return Array.isArray(R)?R.map(T):T(R)}e.mapArrayOrNot=$;function H(R){return Array.isArray(R)?R:[R]}e.asArray=H;function V(R){return R[Math.floor(Math.random()*R.length)]}e.getRandomElement=V;function _(R,T){for(const M of R){const N=T(M);if(N!==void 0)return N}}e.mapFind=_;function x(R,T){let M=Number.MAX_SAFE_INTEGER,N=0;return R.forEach((B,G)=>{const Q=T(B);Q<M&&(M=Q,N=G)}),N}e.minIndex=x;function j(R,T){let M=Number.MIN_SAFE_INTEGER,N=0;return R.forEach((B,G)=>{const Q=T(B);Q>M&&(M=Q,N=G)}),N}e.maxIndex=j;class q{constructor(T){this.items=T,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(T){let M=this.firstIdx;for(;M<this.items.length&&T(this.items[M]);)M++;const N=M===this.firstIdx?null:this.items.slice(this.firstIdx,M);return this.firstIdx=M,N}takeFromEndWhile(T){let M=this.lastIdx;for(;M>=0&&T(this.items[M]);)M--;const N=M===this.lastIdx?null:this.items.slice(M+1,this.lastIdx+1);return this.lastIdx=M,N}}e.ArrayQueue=q}),define(Z[65],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function v(k){const L=this;let A=!1,O;return function(){return A||(A=!0,O=k.apply(L,arguments)),O}}e.once=v}),define(Z[53],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var v;(function(k){function L(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}k.is=L;const A=Object.freeze([]);function O(){return A}k.empty=O;function*P(a){yield a}k.single=P;function S(a){return a||A}k.from=S;function w(a){return!a||a[Symbol.iterator]().next().done===!0}k.isEmpty=w;function n(a){return a[Symbol.iterator]().next().value}k.first=n;function m(a,t){for(const r of a)if(t(r))return!0;return!1}k.some=m;function d(a,t){for(const r of a)if(t(r))return r}k.find=d;function*g(a,t){for(const r of a)t(r)&&(yield r)}k.filter=g;function*h(a,t){let r=0;for(const i of a)yield t(i,r++)}k.map=h;function*C(...a){for(const t of a)for(const r of t)yield r}k.concat=C;function*D(a){for(const t of a)for(const r of t)yield r}k.concatNested=D;function b(a,t,r){let i=r;for(const o of a)i=t(i,o);return i}k.reduce=b;function*I(a,t,r=a.length){for(t<0&&(t+=a.length),r<0?r+=a.length:r>a.length&&(r=a.length);t<r;t++)yield a[t]}k.slice=I;function p(a,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,a];const i=a[Symbol.iterator]();for(let o=0;o<t;o++){const u=i.next();if(u.done)return[r,k.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return i}}]}k.consume=p;function s(a,t,r=(i,o)=>i===o){const i=a[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const u=i.next(),c=o.next();if(u.done!==c.done)return!1;if(u.done)return!0;if(!r(u.value,c.value))return!1}}k.equals=s})(v=e.Iterable||(e.Iterable={}))}),define(Z[32],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var v;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(v=e.ScanError||(e.ScanError={}));var k;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var L;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(L=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(t){t.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function O(t,r=!1){let i=0,o=t.length,u="",c=0,l=16,y=0;function E(V){let _=0,x=0;for(;_<V;){const j=t.charCodeAt(i);if(j>=48&&j<=57)x=x*16+j-48;else if(j>=65&&j<=70)x=x*16+j-65+10;else if(j>=97&&j<=102)x=x*16+j-97+10;else break;i++,_++}return _<V&&(x=-1),x}function f(V){i=V,u="",c=0,l=16,y=0}function U(){const V=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&w(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&w(t.charCodeAt(i)))for(i++;i<t.length&&w(t.charCodeAt(i));)i++;else return y=3,t.substring(V,i);let _=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&w(t.charCodeAt(i))){for(i++;i<t.length&&w(t.charCodeAt(i));)i++;_=i}else y=3;return t.substring(V,_)}function F(){let V="",_=i;for(;;){if(i>=o){V+=t.substring(_,i),y=2;break}const x=t.charCodeAt(i);if(x===34){V+=t.substring(_,i),i++;break}if(x===92){if(V+=t.substring(_,i),i++,i>=o){y=2;break}switch(t.charCodeAt(i++)){case 34:V+='"';break;case 92:V+="\\";break;case 47:V+="/";break;case 98:V+="\b";break;case 102:V+="\f";break;case 110:V+=`
`;break;case 114:V+="\r";break;case 116:V+="	";break;case 117:const q=E(4);q>=0?V+=String.fromCharCode(q):y=4;break;default:y=5}_=i;continue}if(x>=0&&x<=31)if(S(x)){V+=t.substring(_,i),y=2;break}else y=6;i++}return V}function z(){if(u="",y=0,c=i,i>=o)return c=o,l=17;let V=t.charCodeAt(i);if(P(V)){do i++,u+=String.fromCharCode(V),V=t.charCodeAt(i);while(P(V));return l=15}if(S(V))return i++,u+=String.fromCharCode(V),V===13&&t.charCodeAt(i)===10&&(i++,u+=`
`),l=14;switch(V){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,u=F(),l=10;case 47:const _=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<o&&!S(t.charCodeAt(i));)i++;return u=t.substring(_,i),l=12}if(t.charCodeAt(i+1)===42){i+=2;const x=o-1;let j=!1;for(;i<x;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,j=!0;break}i++}return j||(i++,y=1),u=t.substring(_,i),l=13}return u+=String.fromCharCode(V),i++,l=16;case 45:if(u+=String.fromCharCode(V),i++,i===o||!w(t.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=U(),l=11;default:for(;i<o&&$(V);)i++,V=t.charCodeAt(i);if(c!==i){switch(u=t.substring(c,i),u){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return u+=String.fromCharCode(V),i++,l=16}}function $(V){if(P(V)||S(V))return!1;switch(V){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let V;do V=z();while(V>=12&&V<=15);return V}return{setPosition:f,getPosition:()=>i,scan:r?H:z,getToken:()=>l,getTokenValue:()=>u,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>y}}e.createScanner=O;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function w(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function m(t,r){const i=[],o=new Object;let u;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function y(E,f,U,F){c.value=E,c.offset=f,c.length=U,c.type=F,c.colonOffset=void 0,u=c}try{p(t,{onObjectBegin:(E,f)=>{if(r<=E)throw o;u=void 0,l=r>E,i.push("")},onObjectProperty:(E,f,U)=>{if(r<f||(y(E,f,U,"property"),i[i.length-1]=E,r<=f+U))throw o},onObjectEnd:(E,f)=>{if(r<=E)throw o;u=void 0,i.pop()},onArrayBegin:(E,f)=>{if(r<=E)throw o;u=void 0,i.push(0)},onArrayEnd:(E,f)=>{if(r<=E)throw o;u=void 0,i.pop()},onLiteralValue:(E,f,U)=>{if(r<f||(y(E,f,U,a(E)),r<=f+U))throw o},onSeparator:(E,f,U)=>{if(r<=f)throw o;if(E===":"&&u&&u.type==="property")u.colonOffset=f,l=!1,u=void 0;else if(E===","){const F=i[i.length-1];typeof F=="number"?i[i.length-1]=F+1:(l=!0,i[i.length-1]=""),u=void 0}}})}catch(E){if(E!==o)throw E}return{path:i,previousNode:u,isAtPropertyKey:l,matches:E=>{let f=0;for(let U=0;f<E.length&&U<i.length;U++)if(E[f]===i[U]||E[f]==="*")f++;else if(E[f]!=="**")return!1;return f===E.length}}}e.getLocation=m;function d(t,r=[],i=A.DEFAULT){let o=null,u=[];const c=[];function l(E){Array.isArray(u)?u.push(E):o!==null&&(u[o]=E)}return p(t,{onObjectBegin:()=>{const E={};l(E),c.push(u),u=E,o=null},onObjectProperty:E=>{o=E},onObjectEnd:()=>{u=c.pop()},onArrayBegin:()=>{const E=[];l(E),c.push(u),u=E,o=null},onArrayEnd:()=>{u=c.pop()},onLiteralValue:l,onError:(E,f,U)=>{r.push({error:E,offset:f,length:U})}},i),u[0]}e.parse=d;function g(t,r=[],i=A.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(E){o.type==="property"&&(o.length=E-o.offset,o=o.parent)}function c(E){return o.children.push(E),E}p(t,{onObjectBegin:E=>{o=c({type:"object",offset:E,length:-1,parent:o,children:[]})},onObjectProperty:(E,f,U)=>{o=c({type:"property",offset:f,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:E,offset:f,length:U,parent:o})},onObjectEnd:(E,f)=>{o.length=E+f-o.offset,o=o.parent,u(E+f)},onArrayBegin:(E,f)=>{o=c({type:"array",offset:E,length:-1,parent:o,children:[]})},onArrayEnd:(E,f)=>{o.length=E+f-o.offset,o=o.parent,u(E+f)},onLiteralValue:(E,f,U)=>{c({type:a(E),offset:f,length:U,parent:o,value:E}),u(f+U)},onSeparator:(E,f,U)=>{o.type==="property"&&(E===":"?o.colonOffset=f:E===","&&u(f))},onError:(E,f,U)=>{r.push({error:E,offset:f,length:U})}},i);const y=o.children[0];return y&&delete y.parent,y}e.parseTree=g;function h(t,r){if(!t)return;let i=t;for(let o of r)if(typeof o=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let u=!1;for(const c of i.children)if(Array.isArray(c.children)&&c.children[0].value===o){i=c.children[1],u=!0;break}if(!u)return}else{const u=o;if(i.type!=="array"||u<0||!Array.isArray(i.children)||u>=i.children.length)return;i=i.children[u]}return i}e.findNodeAtLocation=h;function C(t){if(!t.parent||!t.parent.children)return[];const r=C(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=C;function D(t){switch(t.type){case"array":return t.children.map(D);case"object":const r=Object.create(null);for(let i of t.children){const o=i.children[1];o&&(r[i.children[0].value]=D(o))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=D;function b(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=b;function I(t,r,i=!1){if(b(t,r,i)){const o=t.children;if(Array.isArray(o))for(let u=0;u<o.length&&o[u].offset<=r;u++){const c=I(o[u],r,i);if(c)return c}return t}}e.findNodeAtOffset=I;function p(t,r,i=A.DEFAULT){const o=O(t,!1);function u(G){return G?()=>G(o.getTokenOffset(),o.getTokenLength()):()=>!0}function c(G){return G?Q=>G(Q,o.getTokenOffset(),o.getTokenLength()):()=>!0}const l=u(r.onObjectBegin),y=c(r.onObjectProperty),E=u(r.onObjectEnd),f=u(r.onArrayBegin),U=u(r.onArrayEnd),F=c(r.onLiteralValue),z=c(r.onSeparator),$=u(r.onComment),H=c(r.onError),V=i&&i.disallowComments,_=i&&i.allowTrailingComma;function x(){for(;;){const G=o.scan();switch(o.getTokenError()){case 4:j(14);break;case 5:j(15);break;case 3:j(13);break;case 1:V||j(11);break;case 2:j(12);break;case 6:j(16);break}switch(G){case 12:case 13:V?j(10):$();break;case 16:j(1);break;case 15:case 14:break;default:return G}}}function j(G,Q=[],X=[]){if(H(G),Q.length+X.length>0){let ie=o.getToken();for(;ie!==17;){if(Q.indexOf(ie)!==-1){x();break}else if(X.indexOf(ie)!==-1)break;ie=x()}}}function q(G){const Q=o.getTokenValue();return G?F(Q):y(Q),x(),!0}function R(){switch(o.getToken()){case 11:let G=0;try{G=JSON.parse(o.getTokenValue()),typeof G!="number"&&(j(2),G=0)}catch(Q){j(2)}F(G);break;case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return x(),!0}function T(){return o.getToken()!==10?(j(3,[],[2,5]),!1):(q(!1),o.getToken()===6?(z(":"),x(),B()||j(4,[],[2,5])):j(5,[],[2,5]),!0)}function M(){l(),x();let G=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(G||j(4,[],[]),z(","),x(),o.getToken()===2&&_)break}else G&&j(6,[],[]);T()||j(4,[],[2,5]),G=!0}return E(),o.getToken()!==2?j(7,[2],[]):x(),!0}function N(){f(),x();let G=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(G||j(4,[],[]),z(","),x(),o.getToken()===4&&_)break}else G&&j(6,[],[]);B()||j(4,[],[4,5]),G=!0}return U(),o.getToken()!==4?j(8,[4],[]):x(),!0}function B(){switch(o.getToken()){case 3:return N();case 1:return M();case 10:return q(!0);default:return R()}}return x(),o.getToken()===17?i.allowEmptyContent?!0:(j(4,[],[]),!1):B()?(o.getToken()!==17&&j(9,[],[]),!0):(j(4,[],[]),!1)}e.visit=p;function s(t,r){let i=O(t),o=[],u,c=0,l;do switch(l=i.getPosition(),u=i.scan(),u){case 12:case 13:case 17:c!==l&&o.push(t.substring(c,l)),r!==void 0&&o.push(i.getTokenValue().replace(/[^\r\n]/g,r)),c=i.getPosition();break}while(u!==17);return o.join("")}e.stripComments=s;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(Z[46],ee([0,1,32]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function k(S,w,n){let m,d,g,h,C;if(w){for(h=w.offset,C=h+w.length,g=h;g>0&&!P(S,g-1);)g--;let c=C;for(;c<S.length&&!P(S,c);)c++;d=S.substring(g,c),m=A(d,n)}else d=S,m=0,g=0,h=0,C=S.length;const D=O(n,S);let b=!1,I=0,p;n.insertSpaces?p=L(" ",n.tabSize||4):p="	";const s=v.createScanner(d,!1);let a=!1;function t(){return D+L(p,m+I)}function r(){let c=s.scan();for(b=!1;c===15||c===14;)b=b||c===14,c=s.scan();return a=c===16||s.getTokenError()!==0,c}const i=[];function o(c,l,y){!a&&l<C&&y>h&&S.substring(l,y)!==c&&i.push({offset:l,length:y-l,content:c})}let u=r();if(u!==17){const c=s.getTokenOffset()+g,l=L(p,m);o(l,g,c)}for(;u!==17;){let c=s.getTokenOffset()+s.getTokenLength()+g,l=r(),y="";for(;!b&&(l===12||l===13);){const f=s.getTokenOffset()+g;o(" ",c,f),c=s.getTokenOffset()+s.getTokenLength()+g,y=l===12?t():"",l=r()}if(l===2)u!==1&&(I--,y=t());else if(l===4)u!==3&&(I--,y=t());else{switch(u){case 3:case 1:I++,y=t();break;case 5:case 12:y=t();break;case 13:b?y=t():y=" ";break;case 6:y=" ";break;case 10:if(l===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?y=" ":l!==5&&l!==17&&(a=!0);break;case 16:a=!0;break}b&&(l===12||l===13)&&(y=t())}const E=s.getTokenOffset()+g;o(y,c,E),u=l}return i}e.format=k;function L(S,w){let n="";for(let m=0;m<w;m++)n+=S;return n}function A(S,w){let n=0,m=0;const d=w.tabSize||4;for(;n<S.length;){const g=S.charAt(n);if(g===" ")m++;else if(g==="	")m+=d;else break;n++}return Math.floor(m/d)}function O(S,w){for(let n=0;n<w.length;n++){const m=w.charAt(n);if(m==="\r")return n+1<w.length&&w.charAt(n+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=O;function P(S,w){return`\r
`.indexOf(S.charAt(w))!==-1}e.isEOL=P}),define(Z[40],ee([0,1,32,46]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function L(w,n,m){return A(w,n,void 0,m)}e.removeProperty=L;function A(w,n,m,d,g){const h=n.slice(),C=[],D=v.parseTree(w,C);let b,I;for(;h.length>0&&(I=h.pop(),b=v.findNodeAtLocation(D,h),b===void 0&&m!==void 0);)typeof I=="string"?m={[I]:m}:m=[m];if(b)if(b.type==="object"&&typeof I=="string"&&Array.isArray(b.children)){const p=v.findNodeAtLocation(b,[I]);if(p!==void 0)if(m===void 0){if(!p.parent)throw new Error("Malformed AST");const s=b.children.indexOf(p.parent);let a,t=p.parent.offset+p.parent.length;if(s>0){const r=b.children[s-1];a=r.offset+r.length}else a=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return O(w,{offset:a,length:t-a,content:""},d)}else return O(w,{offset:p.offset,length:p.length,content:JSON.stringify(m)},d);else{if(m===void 0)return[];const s=`${JSON.stringify(I)}: ${JSON.stringify(m)}`,a=g?g(b.children.map(r=>r.children[0].value)):b.children.length;let t;if(a>0){const r=b.children[a-1];t={offset:r.offset+r.length,length:0,content:","+s}}else b.children.length===0?t={offset:b.offset+1,length:0,content:s}:t={offset:b.offset+1,length:0,content:s+","};return O(w,t,d)}}else if(b.type==="array"&&typeof I=="number"&&Array.isArray(b.children))if(m!==void 0){const p=`${JSON.stringify(m)}`;let s;if(b.children.length===0||I===0)s={offset:b.offset+1,length:0,content:b.children.length===0?p:p+","};else{const a=I===-1||I>b.children.length?b.children.length:I,t=b.children[a-1];s={offset:t.offset+t.length,length:0,content:","+p}}return O(w,s,d)}else{const p=I,s=b.children[p];let a;if(b.children.length===1)a={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===p){const t=b.children[p-1],r=t.offset+t.length,i=b.offset+b.length;a={offset:r,length:i-2-r,content:""}}else a={offset:s.offset,length:b.children[p+1].offset-s.offset,content:""};return O(w,a,d)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${b.type}`);else{if(m===void 0)throw new Error("Can not delete in empty document");return O(w,{offset:D?D.offset:0,length:D?D.length:0,content:JSON.stringify(m)},d)}}e.setProperty=A;function O(w,n,m){let d=P(w,n),g=n.offset,h=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;g>0&&!k.isEOL(d,g-1);)g--;for(;h<d.length&&!k.isEOL(d,h);)h++}const C=k.format(d,{offset:g,length:h-g},m);for(let b=C.length-1;b>=0;b--){const I=C[b];d=P(d,I),g=Math.min(g,I.offset),h=Math.max(h,I.offset+I.length),h+=I.content.length-I.length}const D=w.length-(d.length-h)-g;return[{offset:g,length:D,content:d.substring(g,h)}]}e.withFormatting=O;function P(w,n){return w.substring(0,n.offset)+n.content+w.substring(n.offset+n.length)}e.applyEdit=P;function S(w,n){let m=n.slice(0).sort((g,h)=>{const C=g.offset-h.offset;return C===0?g.length-h.length:C}),d=w.length;for(let g=m.length-1;g>=0;g--){let h=m[g];if(h.offset+h.length<=d)w=P(w,h);else throw new Error("Overlapping edit");d=h.offset}return w}e.applyEdits=S}),define(Z[2],ee([0,1,65,53]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const L=!1;let A=null;function O(s){A=s}if(e.setDisposableTracker=O,L){const s="__is_disposable_tracked__";A=new class{trackDisposable(a){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[s]||console.log(t)},3e3)}markTracked(a){if(a&&a!==C.None)try{a[s]=!0}catch{}}}}function P(s){!A||A.markTracked(s)}function S(s){return A&&A.trackDisposable(s),s}e.trackDisposable=S;class w extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=w;function n(s){return typeof s.dispose=="function"&&s.dispose.length===0}e.isDisposable=n;function m(s){if(k.Iterable.is(s)){let a=[];for(const t of s)if(t){P(t);try{t.dispose()}catch(r){a.push(r)}}if(a.length===1)throw a[0];if(a.length>1)throw new w(a);return Array.isArray(s)?[]:s}else if(s)return P(s),s.dispose(),s}e.dispose=m;function d(...s){return s.forEach(P),g(()=>m(s))}e.combinedDisposable=d;function g(s){const a=S({dispose:()=>{P(a),s()}});return a}e.toDisposable=g;class h{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{m(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return P(a),this._isDisposed?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class C{constructor(){this._store=new h,S(this)}dispose(){P(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=C,C.None=Object.freeze({dispose(){}});class D{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&P(a),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,P(this),this._value?.dispose(),this._value=void 0}}e.MutableDisposable=D;class b{constructor(){this.references=new Map}acquire(a,...t){let r=this.references.get(a);r||(r={counter:0,object:this.createReferencedObject(a,...t)},this.references.set(a,r));const{object:i}=r,o=v.once(()=>{--r.counter==0&&(this.destroyReferencedObject(a,r.object),this.references.delete(a))});return r.counter++,{object:i,dispose:o}}}e.ReferenceCollection=b;class I{constructor(a){this.referenceCollection=a}async acquire(a,...t){const r=this.referenceCollection.acquire(a,...t);try{return{object:await r.object,dispose:()=>r.dispose()}}catch(i){throw r.dispose(),i}}}e.AsyncReferenceCollection=I;class p{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=p}),define(Z[88],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class v{constructor(A){this.element=A,this.next=v.Undefined,this.prev=v.Undefined}}v.Undefined=new v(void 0);class k{constructor(){this._first=v.Undefined,this._last=v.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===v.Undefined}clear(){let A=this._first;for(;A!==v.Undefined;){const O=A.next;A.prev=v.Undefined,A.next=v.Undefined,A=O}this._first=v.Undefined,this._last=v.Undefined,this._size=0}unshift(A){return this._insert(A,!1)}push(A){return this._insert(A,!0)}_insert(A,O){const P=new v(A);if(this._first===v.Undefined)this._first=P,this._last=P;else if(O){const w=this._last;this._last=P,P.prev=w,w.next=P}else{const w=this._first;this._first=P,P.next=w,w.prev=P}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(P))}}shift(){if(this._first!==v.Undefined){const A=this._first.element;return this._remove(this._first),A}}pop(){if(this._last!==v.Undefined){const A=this._last.element;return this._remove(this._last),A}}_remove(A){if(A.prev!==v.Undefined&&A.next!==v.Undefined){const O=A.prev;O.next=A.next,A.next.prev=O}else A.prev===v.Undefined&&A.next===v.Undefined?(this._first=v.Undefined,this._last=v.Undefined):A.next===v.Undefined?(this._last=this._last.prev,this._last.next=v.Undefined):A.prev===v.Undefined&&(this._first=this._first.next,this._first.prev=v.Undefined);this._size-=1}*[Symbol.iterator](){let A=this._first;for(;A!==v.Undefined;)yield A.element,A=A.next}}e.LinkedList=k}),function(){function K(L){const A=[];typeof L=="number"&&A.push("code/timeOrigin",L);function O(S){A.push(S,Date.now())}function P(){const S=[];for(let w=0;w<A.length;w+=2)S.push({name:A[w],startTime:A[w+1]});return S}return{mark:O,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?K():{mark(L){performance.mark(L)},getMarks(){let L=performance.timeOrigin;typeof L!="number"&&(L=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(L)}];for(const O of performance.getEntriesByType("mark"))A.push({name:O.name,startTime:Math.round(L+O.startTime)});return A}};if(typeof process=="object"){const L=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return K(L)}else return console.trace("perf-util loaded in UNKNOWN environment"),K()}function v(L){return L.MonacoPerformanceMarks||(L.MonacoPerformanceMarks=e()),L.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return v(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=v(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=v(k))}(),define(Z[7],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const v="en";let k=!1,L=!1,A=!1,O=!1,P=!1,S=!1,w=!1,n,m=v,d,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?h=e.globals.vscode.process:typeof process!="undefined"&&(h=process);const C=typeof h?.versions?.electron=="string"&&h.type==="renderer";if(e.isElectronSandboxed=C&&h?.sandboxed,e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=h?.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!C)g=navigator.userAgent,k=g.indexOf("Windows")>=0,L=g.indexOf("Macintosh")>=0,w=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=g.indexOf("Linux")>=0,S=!0,n=navigator.language,m=n;else if(typeof h=="object"){k=h.platform==="win32",L=h.platform==="darwin",A=h.platform==="linux",O=A&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,n=v,m=v;const i=h.env.VSCODE_NLS_CONFIG;if(i)try{const o=JSON.parse(i),u=o.availableLanguages["*"];n=o.locale,m=u||v,d=o._translationsConfigFile}catch(o){}P=!0}else console.error("Unable to resolve platform.");var D;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(D=e.Platform||(e.Platform={}));function b(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=b;let I=0;L?I=1:k?I=3:A&&(I=2),e.isWindows=k,e.isMacintosh=L,e.isLinux=A,e.isLinuxSnap=O,e.isNative=P,e.isWeb=S,e.isIOS=w,e.platform=I,e.userAgent=g,e.language=m;var p;(function(i){function o(){return e.language}i.value=o;function u(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=u;function c(){return e.language==="en"}i.isDefault=c})(p=e.Language||(e.Language={})),e.locale=n,e.translationsConfigFile=d,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let u=[];e.globals.addEventListener("message",l=>{if(l.data&&l.data.vscodeSetImmediateId)for(let y=0,E=u.length;y<E;y++){const f=u[y];if(f.id===l.data.vscodeSetImmediateId){u.splice(y,1),f.callback();return}}});let c=0;return l=>{const y=++c;u.push({id:y,callback:l}),e.globals.postMessage({vscodeSetImmediateId:y},"*")}}if(typeof h?.nextTick=="function")return h.nextTick.bind(h);const o=Promise.resolve();return u=>o.then(u)}();var s;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||w?2:k?1:3;let a=!0,t=!1;function r(){if(!t){t=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,a=new Uint16Array(i.buffer)[0]===(2<<8)+1}return a}e.isLittleEndian=r}),define(Z[34],ee([0,1,7]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let k;if(typeof v.globals.vscode!="undefined"&&typeof v.globals.vscode.process!="undefined"){const L=v.globals.vscode.process;k={get platform(){return L.platform},get env(){return L.env},cwd(){return L.cwd()},nextTick(A){return v.setImmediate(A)}}}else typeof process!="undefined"?k={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(L){return process.nextTick(L)}}:k={get platform(){return v.isWindows?"win32":v.isMacintosh?"darwin":"linux"},nextTick(L){return v.setImmediate(L)},get env(){return{}},cwd(){return"/"}};e.cwd=k.cwd,e.env=k.env,e.platform=k.platform,e.nextTick=k.nextTick}),define(Z[8],ee([0,1,34]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const k=65,L=97,A=90,O=122,P=46,S=47,w=92,n=58,m=63;class d extends Error{constructor(s,a,t){let r;typeof a=="string"&&a.indexOf("not ")===0?(r="must not be",a=a.replace(/^not /,"")):r="must be";const i=s.indexOf(".")!==-1?"property":"argument";let o=`The "${s}" ${i} ${r} of type ${a}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function g(p,s){if(typeof p!="string")throw new d(s,"string",p)}function h(p){return p===S||p===w}function C(p){return p===S}function D(p){return p>=k&&p<=A||p>=L&&p<=O}function b(p,s,a,t){let r="",i=0,o=-1,u=0,c=0;for(let l=0;l<=p.length;++l){if(l<p.length)c=p.charCodeAt(l);else{if(t(c))break;c=S}if(t(c)){if(!(o===l-1||u===1))if(u===2){if(r.length<2||i!==2||r.charCodeAt(r.length-1)!==P||r.charCodeAt(r.length-2)!==P){if(r.length>2){const y=r.lastIndexOf(a);y===-1?(r="",i=0):(r=r.slice(0,y),i=r.length-1-r.lastIndexOf(a)),o=l,u=0;continue}else if(r.length!==0){r="",i=0,o=l,u=0;continue}}s&&(r+=r.length>0?`${a}..`:"..",i=2)}else r.length>0?r+=`${a}${p.slice(o+1,l)}`:r=p.slice(o+1,l),i=l-o-1;o=l,u=0}else c===P&&u!==-1?++u:u=-1}return r}function I(p,s){if(s===null||typeof s!="object")throw new d("pathObject","Object",s);const a=s.dir||s.root,t=s.base||`${s.name||""}${s.ext||""}`;return a?a===s.root?`${a}${t}`:`${a}${p}${t}`:t}e.win32={resolve(...p){let s="",a="",t=!1;for(let r=p.length-1;r>=-1;r--){let i;if(r>=0){if(i=p[r],g(i,"path"),i.length===0)continue}else s.length===0?i=v.cwd():(i=v.env[`=${s}`]||v.cwd(),(i===void 0||i.slice(0,2).toLowerCase()!==s.toLowerCase()&&i.charCodeAt(2)===w)&&(i=`${s}\\`));const o=i.length;let u=0,c="",l=!1;const y=i.charCodeAt(0);if(o===1)h(y)&&(u=1,l=!0);else if(h(y))if(l=!0,h(i.charCodeAt(1))){let E=2,f=E;for(;E<o&&!h(i.charCodeAt(E));)E++;if(E<o&&E!==f){const U=i.slice(f,E);for(f=E;E<o&&h(i.charCodeAt(E));)E++;if(E<o&&E!==f){for(f=E;E<o&&!h(i.charCodeAt(E));)E++;(E===o||E!==f)&&(c=`\\\\${U}\\${i.slice(f,E)}`,u=E)}}}else u=1;else D(y)&&i.charCodeAt(1)===n&&(c=i.slice(0,2),u=2,o>2&&h(i.charCodeAt(2))&&(l=!0,u=3));if(c.length>0)if(s.length>0){if(c.toLowerCase()!==s.toLowerCase())continue}else s=c;if(t){if(s.length>0)break}else if(a=`${i.slice(u)}\\${a}`,t=l,l&&s.length>0)break}return a=b(a,!t,"\\",h),t?`${s}\\${a}`:`${s}${a}`||"."},normalize(p){g(p,"path");const s=p.length;if(s===0)return".";let a=0,t,r=!1;const i=p.charCodeAt(0);if(s===1)return C(i)?"\\":p;if(h(i))if(r=!0,h(p.charCodeAt(1))){let u=2,c=u;for(;u<s&&!h(p.charCodeAt(u));)u++;if(u<s&&u!==c){const l=p.slice(c,u);for(c=u;u<s&&h(p.charCodeAt(u));)u++;if(u<s&&u!==c){for(c=u;u<s&&!h(p.charCodeAt(u));)u++;if(u===s)return`\\\\${l}\\${p.slice(c)}\\`;u!==c&&(t=`\\\\${l}\\${p.slice(c,u)}`,a=u)}}}else a=1;else D(i)&&p.charCodeAt(1)===n&&(t=p.slice(0,2),a=2,s>2&&h(p.charCodeAt(2))&&(r=!0,a=3));let o=a<s?b(p.slice(a),!r,"\\",h):"";return o.length===0&&!r&&(o="."),o.length>0&&h(p.charCodeAt(s-1))&&(o+="\\"),t===void 0?r?`\\${o}`:o:r?`${t}\\${o}`:`${t}${o}`},isAbsolute(p){g(p,"path");const s=p.length;if(s===0)return!1;const a=p.charCodeAt(0);return h(a)||s>2&&D(a)&&p.charCodeAt(1)===n&&h(p.charCodeAt(2))},join(...p){if(p.length===0)return".";let s,a;for(let i=0;i<p.length;++i){const o=p[i];g(o,"path"),o.length>0&&(s===void 0?s=a=o:s+=`\\${o}`)}if(s===void 0)return".";let t=!0,r=0;if(typeof a=="string"&&h(a.charCodeAt(0))){++r;const i=a.length;i>1&&h(a.charCodeAt(1))&&(++r,i>2&&(h(a.charCodeAt(2))?++r:t=!1))}if(t){for(;r<s.length&&h(s.charCodeAt(r));)r++;r>=2&&(s=`\\${s.slice(r)}`)}return e.win32.normalize(s)},relative(p,s){if(g(p,"from"),g(s,"to"),p===s)return"";const a=e.win32.resolve(p),t=e.win32.resolve(s);if(a===t||(p=a.toLowerCase(),s=t.toLowerCase(),p===s))return"";let r=0;for(;r<p.length&&p.charCodeAt(r)===w;)r++;let i=p.length;for(;i-1>r&&p.charCodeAt(i-1)===w;)i--;const o=i-r;let u=0;for(;u<s.length&&s.charCodeAt(u)===w;)u++;let c=s.length;for(;c-1>u&&s.charCodeAt(c-1)===w;)c--;const l=c-u,y=o<l?o:l;let E=-1,f=0;for(;f<y;f++){const F=p.charCodeAt(r+f);if(F!==s.charCodeAt(u+f))break;F===w&&(E=f)}if(f!==y){if(E===-1)return t}else{if(l>y){if(s.charCodeAt(u+f)===w)return t.slice(u+f+1);if(f===2)return t.slice(u+f)}o>y&&(p.charCodeAt(r+f)===w?E=f:f===2&&(E=3)),E===-1&&(E=0)}let U="";for(f=r+E+1;f<=i;++f)(f===i||p.charCodeAt(f)===w)&&(U+=U.length===0?"..":"\\..");return u+=E,U.length>0?`${U}${t.slice(u,c)}`:(t.charCodeAt(u)===w&&++u,t.slice(u,c))},toNamespacedPath(p){if(typeof p!="string")return p;if(p.length===0)return"";const s=e.win32.resolve(p);if(s.length<=2)return p;if(s.charCodeAt(0)===w){if(s.charCodeAt(1)===w){const a=s.charCodeAt(2);if(a!==m&&a!==P)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(D(s.charCodeAt(0))&&s.charCodeAt(1)===n&&s.charCodeAt(2)===w)return`\\\\?\\${s}`;return p},dirname(p){g(p,"path");const s=p.length;if(s===0)return".";let a=-1,t=0;const r=p.charCodeAt(0);if(s===1)return h(r)?p:".";if(h(r)){if(a=t=1,h(p.charCodeAt(1))){let u=2,c=u;for(;u<s&&!h(p.charCodeAt(u));)u++;if(u<s&&u!==c){for(c=u;u<s&&h(p.charCodeAt(u));)u++;if(u<s&&u!==c){for(c=u;u<s&&!h(p.charCodeAt(u));)u++;if(u===s)return p;u!==c&&(a=t=u+1)}}}}else D(r)&&p.charCodeAt(1)===n&&(a=s>2&&h(p.charCodeAt(2))?3:2,t=a);let i=-1,o=!0;for(let u=s-1;u>=t;--u)if(h(p.charCodeAt(u))){if(!o){i=u;break}}else o=!1;if(i===-1){if(a===-1)return".";i=a}return p.slice(0,i)},basename(p,s){s!==void 0&&g(s,"ext"),g(p,"path");let a=0,t=-1,r=!0,i;if(p.length>=2&&D(p.charCodeAt(0))&&p.charCodeAt(1)===n&&(a=2),s!==void 0&&s.length>0&&s.length<=p.length){if(s===p)return"";let o=s.length-1,u=-1;for(i=p.length-1;i>=a;--i){const c=p.charCodeAt(i);if(h(c)){if(!r){a=i+1;break}}else u===-1&&(r=!1,u=i+1),o>=0&&(c===s.charCodeAt(o)?--o==-1&&(t=i):(o=-1,t=u))}return a===t?t=u:t===-1&&(t=p.length),p.slice(a,t)}for(i=p.length-1;i>=a;--i)if(h(p.charCodeAt(i))){if(!r){a=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":p.slice(a,t)},extname(p){g(p,"path");let s=0,a=-1,t=0,r=-1,i=!0,o=0;p.length>=2&&p.charCodeAt(1)===n&&D(p.charCodeAt(0))&&(s=t=2);for(let u=p.length-1;u>=s;--u){const c=p.charCodeAt(u);if(h(c)){if(!i){t=u+1;break}continue}r===-1&&(i=!1,r=u+1),c===P?a===-1?a=u:o!==1&&(o=1):a!==-1&&(o=-1)}return a===-1||r===-1||o===0||o===1&&a===r-1&&a===t+1?"":p.slice(a,r)},format:I.bind(null,"\\"),parse(p){g(p,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return s;const a=p.length;let t=0,r=p.charCodeAt(0);if(a===1)return h(r)?(s.root=s.dir=p,s):(s.base=s.name=p,s);if(h(r)){if(t=1,h(p.charCodeAt(1))){let E=2,f=E;for(;E<a&&!h(p.charCodeAt(E));)E++;if(E<a&&E!==f){for(f=E;E<a&&h(p.charCodeAt(E));)E++;if(E<a&&E!==f){for(f=E;E<a&&!h(p.charCodeAt(E));)E++;E===a?t=E:E!==f&&(t=E+1)}}}}else if(D(r)&&p.charCodeAt(1)===n){if(a<=2)return s.root=s.dir=p,s;if(t=2,h(p.charCodeAt(2))){if(a===3)return s.root=s.dir=p,s;t=3}}t>0&&(s.root=p.slice(0,t));let i=-1,o=t,u=-1,c=!0,l=p.length-1,y=0;for(;l>=t;--l){if(r=p.charCodeAt(l),h(r)){if(!c){o=l+1;break}continue}u===-1&&(c=!1,u=l+1),r===P?i===-1?i=l:y!==1&&(y=1):i!==-1&&(y=-1)}return u!==-1&&(i===-1||y===0||y===1&&i===u-1&&i===o+1?s.base=s.name=p.slice(o,u):(s.name=p.slice(o,i),s.base=p.slice(o,u),s.ext=p.slice(i,u))),o>0&&o!==t?s.dir=p.slice(0,o-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...p){let s="",a=!1;for(let t=p.length-1;t>=-1&&!a;t--){const r=t>=0?p[t]:v.cwd();g(r,"path"),r.length!==0&&(s=`${r}/${s}`,a=r.charCodeAt(0)===S)}return s=b(s,!a,"/",C),a?`/${s}`:s.length>0?s:"."},normalize(p){if(g(p,"path"),p.length===0)return".";const s=p.charCodeAt(0)===S,a=p.charCodeAt(p.length-1)===S;return p=b(p,!s,"/",C),p.length===0?s?"/":a?"./":".":(a&&(p+="/"),s?`/${p}`:p)},isAbsolute(p){return g(p,"path"),p.length>0&&p.charCodeAt(0)===S},join(...p){if(p.length===0)return".";let s;for(let a=0;a<p.length;++a){const t=p[a];g(t,"path"),t.length>0&&(s===void 0?s=t:s+=`/${t}`)}return s===void 0?".":e.posix.normalize(s)},relative(p,s){if(g(p,"from"),g(s,"to"),p===s||(p=e.posix.resolve(p),s=e.posix.resolve(s),p===s))return"";const a=1,t=p.length,r=t-a,i=1,o=s.length-i,u=r<o?r:o;let c=-1,l=0;for(;l<u;l++){const E=p.charCodeAt(a+l);if(E!==s.charCodeAt(i+l))break;E===S&&(c=l)}if(l===u)if(o>u){if(s.charCodeAt(i+l)===S)return s.slice(i+l+1);if(l===0)return s.slice(i+l)}else r>u&&(p.charCodeAt(a+l)===S?c=l:l===0&&(c=0));let y="";for(l=a+c+1;l<=t;++l)(l===t||p.charCodeAt(l)===S)&&(y+=y.length===0?"..":"/..");return`${y}${s.slice(i+c)}`},toNamespacedPath(p){return p},dirname(p){if(g(p,"path"),p.length===0)return".";const s=p.charCodeAt(0)===S;let a=-1,t=!0;for(let r=p.length-1;r>=1;--r)if(p.charCodeAt(r)===S){if(!t){a=r;break}}else t=!1;return a===-1?s?"/":".":s&&a===1?"//":p.slice(0,a)},basename(p,s){s!==void 0&&g(s,"ext"),g(p,"path");let a=0,t=-1,r=!0,i;if(s!==void 0&&s.length>0&&s.length<=p.length){if(s===p)return"";let o=s.length-1,u=-1;for(i=p.length-1;i>=0;--i){const c=p.charCodeAt(i);if(c===S){if(!r){a=i+1;break}}else u===-1&&(r=!1,u=i+1),o>=0&&(c===s.charCodeAt(o)?--o==-1&&(t=i):(o=-1,t=u))}return a===t?t=u:t===-1&&(t=p.length),p.slice(a,t)}for(i=p.length-1;i>=0;--i)if(p.charCodeAt(i)===S){if(!r){a=i+1;break}}else t===-1&&(r=!1,t=i+1);return t===-1?"":p.slice(a,t)},extname(p){g(p,"path");let s=-1,a=0,t=-1,r=!0,i=0;for(let o=p.length-1;o>=0;--o){const u=p.charCodeAt(o);if(u===S){if(!r){a=o+1;break}continue}t===-1&&(r=!1,t=o+1),u===P?s===-1?s=o:i!==1&&(i=1):s!==-1&&(i=-1)}return s===-1||t===-1||i===0||i===1&&s===t-1&&s===a+1?"":p.slice(s,t)},format:I.bind(null,"/"),parse(p){g(p,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(p.length===0)return s;const a=p.charCodeAt(0)===S;let t;a?(s.root="/",t=1):t=0;let r=-1,i=0,o=-1,u=!0,c=p.length-1,l=0;for(;c>=t;--c){const y=p.charCodeAt(c);if(y===S){if(!u){i=c+1;break}continue}o===-1&&(u=!1,o=c+1),y===P?r===-1?r=c:l!==1&&(l=1):r!==-1&&(l=-1)}if(o!==-1){const y=i===0&&a?1:i;r===-1||l===0||l===1&&r===o-1&&r===i+1?s.base=s.name=p.slice(y,o):(s.name=p.slice(y,r),s.base=p.slice(y,o),s.ext=p.slice(r,o))}return i>0?s.dir=p.slice(0,i-1):a&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=v.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v.platform==="win32"?e.win32.join:e.posix.join,e.resolve=v.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=v.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=v.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=v.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=v.platform==="win32"?e.win32.extname:e.posix.extname,e.format=v.platform==="win32"?e.win32.format:e.posix.format,e.parse=v.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=v.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=v.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(K,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var v=e();for(var k in v)(typeof exports=="object"?exports:K)[k]=v[k]}}(typeof self!="undefined"?self:this,function(){return function(K){var e={};function v(k){if(e[k])return e[k].exports;var L=e[k]={i:k,l:!1,exports:{}};return K[k].call(L.exports,L,L.exports,v),L.l=!0,L.exports}return v.m=K,v.c=e,v.d=function(k,L,A){v.o(k,L)||Object.defineProperty(k,L,{enumerable:!0,get:A})},v.r=function(k){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(k,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(k,"__esModule",{value:!0})},v.t=function(k,L){if(1&L&&(k=v(k)),8&L||4&L&&typeof k=="object"&&k&&k.__esModule)return k;var A=Object.create(null);if(v.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:k}),2&L&&typeof k!="string")for(var O in k)v.d(A,O,function(P){return k[P]}.bind(null,O));return A},v.n=function(k){var L=k&&k.__esModule?function(){return k.default}:function(){return k};return v.d(L,"a",L),L},v.o=function(k,L){return Object.prototype.hasOwnProperty.call(k,L)},v.p="",v(v.s=0)}([function(K,e,v){(function(k){var L;e=K.exports=X,L=typeof k=="object"&&k.env&&k.env.NODE_DEBUG&&/\bsemver\b/i.test(k.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,O=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],S=e.src=[],w=0,n=w++;S[n]="0|[1-9]\\d*";var m=w++;S[m]="[0-9]+";var d=w++;S[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=w++;S[g]="("+S[n]+")\\.("+S[n]+")\\.("+S[n]+")";var h=w++;S[h]="("+S[m]+")\\.("+S[m]+")\\.("+S[m]+")";var C=w++;S[C]="(?:"+S[n]+"|"+S[d]+")";var D=w++;S[D]="(?:"+S[m]+"|"+S[d]+")";var b=w++;S[b]="(?:-("+S[C]+"(?:\\."+S[C]+")*))";var I=w++;S[I]="(?:-?("+S[D]+"(?:\\."+S[D]+")*))";var p=w++;S[p]="[0-9A-Za-z-]+";var s=w++;S[s]="(?:\\+("+S[p]+"(?:\\."+S[p]+")*))";var a=w++,t="v?"+S[g]+S[b]+"?"+S[s]+"?";S[a]="^"+t+"$";var r="[v=\\s]*"+S[h]+S[I]+"?"+S[s]+"?",i=w++;S[i]="^"+r+"$";var o=w++;S[o]="((?:<|>)?=?)";var u=w++;S[u]=S[m]+"|x|X|\\*";var c=w++;S[c]=S[n]+"|x|X|\\*";var l=w++;S[l]="[v=\\s]*("+S[c]+")(?:\\.("+S[c]+")(?:\\.("+S[c]+")(?:"+S[b]+")?"+S[s]+"?)?)?";var y=w++;S[y]="[v=\\s]*("+S[u]+")(?:\\.("+S[u]+")(?:\\.("+S[u]+")(?:"+S[I]+")?"+S[s]+"?)?)?";var E=w++;S[E]="^"+S[o]+"\\s*"+S[l]+"$";var f=w++;S[f]="^"+S[o]+"\\s*"+S[y]+"$";var U=w++;S[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=w++;S[F]="(?:~>?)";var z=w++;S[z]="(\\s*)"+S[F]+"\\s+",P[z]=new RegExp(S[z],"g");var $=w++;S[$]="^"+S[F]+S[l]+"$";var H=w++;S[H]="^"+S[F]+S[y]+"$";var V=w++;S[V]="(?:\\^)";var _=w++;S[_]="(\\s*)"+S[V]+"\\s+",P[_]=new RegExp(S[_],"g");var x=w++;S[x]="^"+S[V]+S[l]+"$";var j=w++;S[j]="^"+S[V]+S[y]+"$";var q=w++;S[q]="^"+S[o]+"\\s*("+r+")$|^$";var R=w++;S[R]="^"+S[o]+"\\s*("+t+")$|^$";var T=w++;S[T]="(\\s*)"+S[o]+"\\s*("+r+"|"+S[l]+")",P[T]=new RegExp(S[T],"g");var M=w++;S[M]="^\\s*("+S[l]+")\\s+-\\s+("+S[l]+")\\s*$";var N=w++;S[N]="^\\s*("+S[y]+")\\s+-\\s+("+S[y]+")\\s*$";var B=w++;S[B]="(<|>)?=?\\s*\\*";for(var G=0;G<35;G++)L(G,S[G]),P[G]||(P[G]=new RegExp(S[G]));function Q(J,re){if(J instanceof X)return J;if(typeof J!="string"||J.length>A||!(re?P[i]:P[a]).test(J))return null;try{return new X(J,re)}catch(se){return null}}function X(J,re){if(J instanceof X){if(J.loose===re)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof X))return new X(J,re);L("SemVer",J,re),this.loose=re;var se=J.trim().match(re?P[i]:P[a]);if(!se)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>O||this.major<0)throw new TypeError("Invalid major version");if(this.minor>O||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>O||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(ye){if(/^[0-9]+$/.test(ye)){var ve=+ye;if(ve>=0&&ve<O)return ve}return ye}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=Q,e.valid=function(J,re){var se=Q(J,re);return se?se.version:null},e.clean=function(J,re){var se=Q(J.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=X,X.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},X.prototype.toString=function(){return this.version},X.prototype.compare=function(J){return L("SemVer.compare",this.version,this.loose,J),J instanceof X||(J=new X(J,this.loose)),this.compareMain(J)||this.comparePre(J)},X.prototype.compareMain=function(J){return J instanceof X||(J=new X(J,this.loose)),ne(this.major,J.major)||ne(this.minor,J.minor)||ne(this.patch,J.patch)},X.prototype.comparePre=function(J){if(J instanceof X||(J=new X(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],ye=J.prerelease[re];if(L("prerelease compare",re,se,ye),se===void 0&&ye===void 0)return 0;if(ye===void 0)return 1;if(se===void 0)return-1;if(se!==ye)return ne(se,ye)}while(++re)},X.prototype.inc=function(J,re){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,re,se,ye){typeof se=="string"&&(ye=se,se=void 0);try{return new X(J,se).inc(re,ye).version}catch(ve){return null}},e.diff=function(J,re){if(pe(J,re))return null;var se=Q(J),ye=Q(re);if(se.prerelease.length||ye.prerelease.length){for(var ve in se)if((ve==="major"||ve==="minor"||ve==="patch")&&se[ve]!==ye[ve])return"pre"+ve;return"prerelease"}for(var ve in se)if((ve==="major"||ve==="minor"||ve==="patch")&&se[ve]!==ye[ve])return ve},e.compareIdentifiers=ne;var ie=/^[0-9]+$/;function ne(J,re){var se=ie.test(J),ye=ie.test(re);return se&&ye&&(J=+J,re=+re),se&&!ye?-1:ye&&!se?1:J<re?-1:J>re?1:0}function oe(J,re,se){return new X(J,se).compare(new X(re,se))}function he(J,re,se){return oe(J,re,se)>0}function me(J,re,se){return oe(J,re,se)<0}function pe(J,re,se){return oe(J,re,se)===0}function Ie(J,re,se){return oe(J,re,se)!==0}function Re(J,re,se){return oe(J,re,se)>=0}function Fe(J,re,se){return oe(J,re,se)<=0}function Oe(J,re,se,ye){var ve;switch(re){case"===":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),ve=J===se;break;case"!==":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),ve=J!==se;break;case"":case"=":case"==":ve=pe(J,se,ye);break;case"!=":ve=Ie(J,se,ye);break;case">":ve=he(J,se,ye);break;case">=":ve=Re(J,se,ye);break;case"<":ve=me(J,se,ye);break;case"<=":ve=Fe(J,se,ye);break;default:throw new TypeError("Invalid operator: "+re)}return ve}function ke(J,re){if(J instanceof ke){if(J.loose===re)return J;J=J.value}if(!(this instanceof ke))return new ke(J,re);L("comparator",J,re),this.loose=re,this.parse(J),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,L("comp",this)}e.rcompareIdentifiers=function(J,re){return ne(re,J)},e.major=function(J,re){return new X(J,re).major},e.minor=function(J,re){return new X(J,re).minor},e.patch=function(J,re){return new X(J,re).patch},e.compare=oe,e.compareLoose=function(J,re){return oe(J,re,!0)},e.rcompare=function(J,re,se){return oe(re,J,se)},e.sort=function(J,re){return J.sort(function(se,ye){return e.compare(se,ye,re)})},e.rsort=function(J,re){return J.sort(function(se,ye){return e.rcompare(se,ye,re)})},e.gt=he,e.lt=me,e.eq=pe,e.neq=Ie,e.gte=Re,e.lte=Fe,e.cmp=Oe,e.Comparator=ke;var _e={};function be(J,re){if(J instanceof be)return J.loose===re?J:new be(J.raw,re);if(J instanceof ke)return new be(J.value,re);if(!(this instanceof be))return new be(J,re);if(this.loose=re,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Ae(J){return!J||J.toLowerCase()==="x"||J==="*"}function Ke(J,re,se,ye,ve,Pe,we,Te,Ce,Le,Ue,W,te){return((re=Ae(se)?"":Ae(ye)?">="+se+".0.0":Ae(ve)?">="+se+"."+ye+".0":">="+re)+" "+(Te=Ae(Ce)?"":Ae(Le)?"<"+(+Ce+1)+".0.0":Ae(Ue)?"<"+Ce+"."+(+Le+1)+".0":W?"<="+Ce+"."+Le+"."+Ue+"-"+W:"<="+Te)).trim()}function Ye(J,re){for(var se=0;se<J.length;se++)if(!J[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<J.length;se++)if(L(J[se].semver),J[se].semver!==_e&&J[se].semver.prerelease.length>0){var ye=J[se].semver;if(ye.major===re.major&&ye.minor===re.minor&&ye.patch===re.patch)return!0}return!1}return!0}function $e(J,re,se){try{re=new be(re,se)}catch(ye){return!1}return re.test(J)}function xe(J,re,se,ye){var ve,Pe,we,Te,Ce;switch(J=new X(J,ye),re=new be(re,ye),se){case">":ve=he,Pe=Fe,we=me,Te=">",Ce=">=";break;case"<":ve=me,Pe=Re,we=he,Te="<",Ce="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(J,re,ye))return!1;for(var Le=0;Le<re.set.length;++Le){var Ue=re.set[Le],W=null,te=null;if(Ue.forEach(function(ae){ae.semver===_e&&(ae=new ke(">=0.0.0")),W=W||ae,te=te||ae,ve(ae.semver,W.semver,ye)?W=ae:we(ae.semver,te.semver,ye)&&(te=ae)}),W.operator===Te||W.operator===Ce||(!te.operator||te.operator===Te)&&Pe(J,te.semver)||te.operator===Ce&&we(J,te.semver))return!1}return!0}ke.prototype.parse=function(J){var re=this.loose?P[q]:P[R],se=J.match(re);if(!se)throw new TypeError("Invalid comparator: "+J);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new X(se[2],this.loose):this.semver=_e},ke.prototype.toString=function(){return this.value},ke.prototype.test=function(J){return L("Comparator.test",J,this.loose),this.semver===_e||(typeof J=="string"&&(J=new X(J,this.loose)),Oe(J,this.operator,this.semver,this.loose))},ke.prototype.intersects=function(J,re){if(!(J instanceof ke))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new be(J.value,re),$e(this.value,se,re);if(J.operator==="")return se=new be(this.value,re),$e(J.semver,se,re);var ye=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),ve=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Pe=this.semver.version===J.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Te=Oe(this.semver,"<",J.semver,re)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),Ce=Oe(this.semver,">",J.semver,re)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return ye||ve||Pe&&we||Te||Ce},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(J){var re=this.loose;J=J.trim(),L("range",J,re);var se=re?P[N]:P[M];J=J.replace(se,Ke),L("hyphen replace",J),J=J.replace(P[T],"$1$2$3"),L("comparator trim",J,P[T]),J=(J=(J=J.replace(P[z],"$1~")).replace(P[_],"$1^")).split(/\s+/).join(" ");var ye=re?P[q]:P[R],ve=J.split(" ").map(function(Pe){return function(we,Te){return L("comp",we),we=function(Ce,Le){return Ce.trim().split(/\s+/).map(function(Ue){return function(W,te){L("caret",W,te);var ae=te?P[j]:P[x];return W.replace(ae,function(le,ce,fe,ge,Se){var ue;return L("caret",W,le,ce,fe,ge,Se),Ae(ce)?ue="":Ae(fe)?ue=">="+ce+".0.0 <"+(+ce+1)+".0.0":Ae(ge)?ue=ce==="0"?">="+ce+"."+fe+".0 <"+ce+"."+(+fe+1)+".0":">="+ce+"."+fe+".0 <"+(+ce+1)+".0.0":Se?(L("replaceCaret pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),ue=ce==="0"?fe==="0"?">="+ce+"."+fe+"."+ge+Se+" <"+ce+"."+fe+"."+(+ge+1):">="+ce+"."+fe+"."+ge+Se+" <"+ce+"."+(+fe+1)+".0":">="+ce+"."+fe+"."+ge+Se+" <"+(+ce+1)+".0.0"):(L("no pr"),ue=ce==="0"?fe==="0"?">="+ce+"."+fe+"."+ge+" <"+ce+"."+fe+"."+(+ge+1):">="+ce+"."+fe+"."+ge+" <"+ce+"."+(+fe+1)+".0":">="+ce+"."+fe+"."+ge+" <"+(+ce+1)+".0.0"),L("caret return",ue),ue})}(Ue,Le)}).join(" ")}(we,Te),L("caret",we),we=function(Ce,Le){return Ce.trim().split(/\s+/).map(function(Ue){return function(W,te){var ae=te?P[H]:P[$];return W.replace(ae,function(le,ce,fe,ge,Se){var ue;return L("tilde",W,le,ce,fe,ge,Se),Ae(ce)?ue="":Ae(fe)?ue=">="+ce+".0.0 <"+(+ce+1)+".0.0":Ae(ge)?ue=">="+ce+"."+fe+".0 <"+ce+"."+(+fe+1)+".0":Se?(L("replaceTilde pr",Se),Se.charAt(0)!=="-"&&(Se="-"+Se),ue=">="+ce+"."+fe+"."+ge+Se+" <"+ce+"."+(+fe+1)+".0"):ue=">="+ce+"."+fe+"."+ge+" <"+ce+"."+(+fe+1)+".0",L("tilde return",ue),ue})}(Ue,Le)}).join(" ")}(we,Te),L("tildes",we),we=function(Ce,Le){return L("replaceXRanges",Ce,Le),Ce.split(/\s+/).map(function(Ue){return function(W,te){W=W.trim();var ae=te?P[f]:P[E];return W.replace(ae,function(le,ce,fe,ge,Se,ue){L("xRange",W,le,ce,fe,ge,Se,ue);var Ee=Ae(fe),De=Ee||Ae(ge),Me=De||Ae(Se);return ce==="="&&Me&&(ce=""),Ee?le=ce===">"||ce==="<"?"<0.0.0":"*":ce&&Me?(De&&(ge=0),Me&&(Se=0),ce===">"?(ce=">=",De?(fe=+fe+1,ge=0,Se=0):Me&&(ge=+ge+1,Se=0)):ce==="<="&&(ce="<",De?fe=+fe+1:ge=+ge+1),le=ce+fe+"."+ge+"."+Se):De?le=">="+fe+".0.0 <"+(+fe+1)+".0.0":Me&&(le=">="+fe+"."+ge+".0 <"+fe+"."+(+ge+1)+".0"),L("xRange return",le),le})}(Ue,Le)}).join(" ")}(we,Te),L("xrange",we),we=function(Ce,Le){return L("replaceStars",Ce,Le),Ce.trim().replace(P[B],"")}(we,Te),L("stars",we),we}(Pe,re)}).join(" ").split(/\s+/);return this.loose&&(ve=ve.filter(function(Pe){return!!Pe.match(ye)})),ve=ve.map(function(Pe){return new ke(Pe,re)})},be.prototype.intersects=function(J,re){if(!(J instanceof be))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(ye){return J.set.some(function(ve){return ve.every(function(Pe){return ye.intersects(Pe,re)})})})})},e.toComparators=function(J,re){return new be(J,re).set.map(function(se){return se.map(function(ye){return ye.value}).join(" ").trim().split(" ")})},be.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new X(J,this.loose));for(var re=0;re<this.set.length;re++)if(Ye(this.set[re],J))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(J,re,se){var ye=null,ve=null;try{var Pe=new be(re,se)}catch(we){return null}return J.forEach(function(we){Pe.test(we)&&(ye&&ve.compare(we)!==-1||(ve=new X(ye=we,se)))}),ye},e.minSatisfying=function(J,re,se){var ye=null,ve=null;try{var Pe=new be(re,se)}catch(we){return null}return J.forEach(function(we){Pe.test(we)&&(ye&&ve.compare(we)!==1||(ve=new X(ye=we,se)))}),ye},e.validRange=function(J,re){try{return new be(J,re).range||"*"}catch(se){return null}},e.ltr=function(J,re,se){return xe(J,re,"<",se)},e.gtr=function(J,re,se){return xe(J,re,">",se)},e.outside=xe,e.prerelease=function(J,re){var se=Q(J,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(J,re,se){return J=new be(J,se),re=new be(re,se),J.intersects(re)},e.coerce=function(J){if(J instanceof X)return J;if(typeof J!="string")return null;var re=J.match(P[U]);return re==null?null:Q((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,v(1))},function(K,e){var v,k,L=K.exports={};function A(){throw new Error("setTimeout has not been defined")}function O(){throw new Error("clearTimeout has not been defined")}function P(D){if(v===setTimeout)return setTimeout(D,0);if((v===A||!v)&&setTimeout)return v=setTimeout,setTimeout(D,0);try{return v(D,0)}catch(b){try{return v.call(null,D,0)}catch(I){return v.call(this,D,0)}}}(function(){try{v=typeof setTimeout=="function"?setTimeout:A}catch(D){v=A}try{k=typeof clearTimeout=="function"?clearTimeout:O}catch(D){k=O}})();var S,w=[],n=!1,m=-1;function d(){n&&S&&(n=!1,S.length?w=S.concat(w):m=-1,w.length&&g())}function g(){if(!n){var D=P(d);n=!0;for(var b=w.length;b;){for(S=w,w=[];++m<b;)S&&S[m].run();m=-1,b=w.length}S=null,n=!1,function(I){if(k===clearTimeout)return clearTimeout(I);if((k===O||!k)&&clearTimeout)return k=clearTimeout,clearTimeout(I);try{k(I)}catch(p){try{return k.call(null,I)}catch(s){return k.call(this,I)}}}(D)}}function h(D,b){this.fun=D,this.array=b}function C(){}L.nextTick=function(D){var b=new Array(arguments.length-1);if(arguments.length>1)for(var I=1;I<arguments.length;I++)b[I-1]=arguments[I];w.push(new h(D,b)),w.length!==1||n||P(g)},h.prototype.run=function(){this.fun.apply(null,this.array)},L.title="browser",L.browser=!0,L.env={},L.argv=[],L.version="",L.versions={},L.on=C,L.addListener=C,L.once=C,L.off=C,L.removeListener=C,L.removeAllListeners=C,L.emit=C,L.prependListener=C,L.prependOnceListener=C,L.listeners=function(D){return[]},L.binding=function(D){throw new Error("process.binding is not supported")},L.cwd=function(){return"/"},L.chdir=function(D){throw new Error("process.chdir is not supported")},L.umask=function(){return 0}}])}),define(Z[89],ee([0,1,7]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const k=v.globals.performance&&typeof v.globals.performance.now=="function";class L{constructor(O){this._highResolution=k&&O,this._startTime=this._now(),this._stopTime=-1}static create(O=!0){return new L(O)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?v.globals.performance.now():Date.now()}}e.StopWatch=L}),define(Z[3],ee([0,1,11,65,2,88,89]),function(K,e,v,k,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(p){p.None=()=>L.Disposable.None;function s(V){return(_,x=null,j)=>{let q=!1,R;return R=V(T=>{if(!q)return R?R.dispose():q=!0,_.call(x,T)},null,j),q&&R.dispose(),R}}p.once=s;function a(V,_){return c((x,j=null,q)=>V(R=>x.call(j,_(R)),null,q))}p.map=a;function t(V,_){return c((x,j=null,q)=>V(R=>{_(R),x.call(j,R)},null,q))}p.forEach=t;function r(V,_){return c((x,j=null,q)=>V(R=>_(R)&&x.call(j,R),null,q))}p.filter=r;function i(V){return V}p.signal=i;function o(...V){return(_,x=null,j)=>L.combinedDisposable(...V.map(q=>q(R=>_.call(x,R),null,j)))}p.any=o;function u(V,_,x){let j=x;return a(V,q=>(j=_(j,q),j))}p.reduce=u;function c(V){let _;const x=new d({onFirstListenerAdd(){_=V(x.fire,x)},onLastListenerRemove(){_.dispose()}});return x.event}function l(V,_,x=100,j=!1,q){let R,T,M,N=0;const B=new d({leakWarningThreshold:q,onFirstListenerAdd(){R=V(G=>{N++,T=_(T,G),j&&!M&&(B.fire(T),T=void 0),clearTimeout(M),M=setTimeout(()=>{const Q=T;T=void 0,M=void 0,(!j||N>1)&&B.fire(Q),N=0},x)})},onLastListenerRemove(){R.dispose()}});return B.event}p.debounce=l;function y(V,_=(x,j)=>x===j){let x=!0,j;return r(V,q=>{const R=x||!_(q,j);return x=!1,j=q,R})}p.latch=y;function E(V,_){return[p.filter(V,_),p.filter(V,x=>!_(x))]}p.split=E;function f(V,_=!1,x=[]){let j=x.slice(),q=V(M=>{j?j.push(M):T.fire(M)});const R=()=>{j&&j.forEach(M=>T.fire(M)),j=null},T=new d({onFirstListenerAdd(){q||(q=V(M=>T.fire(M)))},onFirstListenerDidAdd(){j&&(_?setTimeout(R):R())},onLastListenerRemove(){q&&q.dispose(),q=null}});return T.event}p.buffer=f;class U{constructor(_){this.event=_}map(_){return new U(a(this.event,_))}forEach(_){return new U(t(this.event,_))}filter(_){return new U(r(this.event,_))}reduce(_,x){return new U(u(this.event,_,x))}latch(){return new U(y(this.event))}debounce(_,x=100,j=!1,q){return new U(l(this.event,_,x,j,q))}on(_,x,j){return this.event(_,x,j)}once(_,x,j){return s(this.event)(_,x,j)}}function F(V){return new U(V)}p.chain=F;function z(V,_,x=j=>j){const j=(...M)=>T.fire(x(...M)),q=()=>V.on(_,j),R=()=>V.removeListener(_,j),T=new d({onFirstListenerAdd:q,onLastListenerRemove:R});return T.event}p.fromNodeEventEmitter=z;function $(V,_,x=j=>j){const j=(...M)=>T.fire(x(...M)),q=()=>V.addEventListener(_,j),R=()=>V.removeEventListener(_,j),T=new d({onFirstListenerAdd:q,onLastListenerRemove:R});return T.event}p.fromDOMEventEmitter=$;function H(V){return new Promise(_=>s(V)(_))}p.toPromise=H})(P=e.Event||(e.Event={}));class S{constructor(s){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${s}_${S._idPool++}`}start(s){this._stopWatch=new O.StopWatch(!0),this._listenerCount=s}stop(){if(this._stopWatch){const s=this._stopWatch.elapsed();this._elapsedOverall+=s,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${s.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let w=-1;function n(p){const s=w;return w=p,{dispose(){w=s}}}e.setGlobalLeakWarningThreshold=n;class m{constructor(s,a=Math.random().toString(18).slice(2,5)){this.customThreshold=s,this.name=a,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(s){let a=w;if(typeof this.customThreshold=="number"&&(a=this.customThreshold),a<=0||s<a)return;this._stacks||(this._stacks=new Map);const t=new Error().stack.split(`
`).slice(3).join(`
`),r=this._stacks.get(t)||0;if(this._stacks.set(t,r+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=a*.5;let i,o=0;for(const[u,c]of this._stacks)(!i||o<c)&&(i=u,o=c);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${o}):`),console.warn(i)}return()=>{const i=this._stacks.get(t)||0;this._stacks.set(t,i-1)}}}class d{constructor(s){this._disposed=!1,this._options=s,this._leakageMon=w>0?new m(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(s,a,t)=>{this._listeners||(this._listeners=new A.LinkedList);const r=this._listeners.isEmpty();r&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(a?[s,a]:s);r&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,s,a);const o=this._leakageMon?.check(this._listeners.size);let u;return u={dispose:()=>{o&&o(),u.dispose=d._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},t instanceof L.DisposableStore?t.add(u):Array.isArray(t)&&t.push(u),u}),this._event}fire(s){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new A.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,s]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(r){v.onUnexpectedError(r)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=d,d._noop=function(){};class g extends d{async fireAsync(s,a,t){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const r of this._listeners)this._asyncDeliveryQueue.push([r,s]);for(;this._asyncDeliveryQueue.size>0&&!a.isCancellationRequested;){const[r,i]=this._asyncDeliveryQueue.shift(),o=[],u={...i,waitUntil:c=>{if(Object.isFrozen(o))throw new Error("waitUntil can NOT be called asynchronous");t&&(c=t(c,typeof r=="function"?r:r[0])),o.push(c)}};try{typeof r=="function"?r.call(void 0,u):r[0].call(r[1],u)}catch(c){v.onUnexpectedError(c);continue}Object.freeze(o),await Promise.allSettled(o).then(c=>{for(const l of c)l.status==="rejected"&&v.onUnexpectedError(l.reason)})}}}}e.AsyncEmitter=g;class h extends d{constructor(s){super(s);this._isPaused=0,this._eventQueue=new A.LinkedList,this._mergeFn=s?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const s=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(s))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(s){this._listeners&&(this._isPaused!==0?this._eventQueue.push(s):super.fire(s))}}e.PauseableEmitter=h;class C extends h{constructor(s){super(s);this._delay=s.delay??100}fire(s){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(s)}}e.DebounceEmitter=C;class D{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(s){const a={event:s,listener:null};this.events.push(a),this.hasListeners&&this.hook(a);const t=()=>{this.hasListeners&&this.unhook(a);const r=this.events.indexOf(a);this.events.splice(r,1)};return L.toDisposable(k.once(t))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(s=>this.hook(s))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(s=>this.unhook(s))}hook(s){s.listener=s.event(a=>this.emitter.fire(a))}unhook(s){s.listener&&s.listener.dispose(),s.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=D;class b{constructor(){this.buffers=[]}wrapEvent(s){return(a,t,r)=>s(i=>{const o=this.buffers[this.buffers.length-1];o?o.push(()=>a.call(t,i)):a.call(t,i)},void 0,r)}bufferEvents(s){const a=[];this.buffers.push(a);const t=s();return this.buffers.pop(),a.forEach(r=>r()),t}}e.EventBufferer=b;class I{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=L.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(s){this.inputEvent=s,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=s(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=I}),define(Z[29],ee([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const k=Object.freeze(function(P,S){const w=setTimeout(P.bind(S),0);return{dispose(){clearTimeout(w)}}});var L;(function(P){function S(w){return w===P.None||w===P.Cancelled||w instanceof A?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}P.isCancellationToken=S,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:v.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:k})})(L=e.CancellationToken||(e.CancellationToken={}));class A{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?k:(this._emitter||(this._emitter=new v.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class O{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new A),this._token}cancel(){this._token?this._token instanceof A&&this._token.cancel():this._token=L.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof A&&this._token.dispose():this._token=L.None}}e.CancellationTokenSource=O}),define(Z[54],ee([0,1,3]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class k{constructor(){this._icons=new Map,this._onDidRegister=new v.Emitter}add(m){const d=this._icons.get(m.id);d?m.description?d.description=m.description:console.error(`Duplicate registration of codicon ${m.id}`):(this._icons.set(m.id,m),this._onDidRegister.fire(m))}get(m){return this._icons.get(m)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const L=new k;e.iconRegistry=L;function A(n,m){return new P(n,m)}e.registerCodicon=A;function O(n){return n?n.replace(/\$\((.*?)\)/g,(m,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=O;class P{constructor(m,d,g){this.id=m,this.definition=d,this.description=g,L.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function S(n,m){const d=["codicon","codicon-"+n];return m&&d.push("codicon-modifier-"+m),d}e.getClassNamesArray=S;var w;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const m=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function d(C){if(C instanceof P)return["codicon","codicon-"+C.id];const D=m.exec(C.id);if(!D)return d(P.error);let[,b,I]=D;const p=["codicon","codicon-"+b];return I&&p.push("codicon-modifier-"+I.substr(1)),p}n.asClassNameArray=d;function g(C){return d(C).join(" ")}n.asClassName=g;function h(C){return"."+d(C).join(".")}n.asCSSSelector=h})(w=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(Z[47],ee([0,1,11,2]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function L(p){const s=p;return s?[s.on,s.pause,s.resume,s.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=L;function A(p){const s=p;return s?L(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}e.isReadableBufferedStream=A;function O(p,s){return new P(p,s)}e.newWriteableStream=O;class P{constructor(s,a){this.reducer=s,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(a=>a(s))}emitError(s){this.listeners.error.length===0?v.onUnexpectedError(s):this.listeners.error.slice(0).forEach(a=>a(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,a){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(s,a){if(this.state.destroyed)return;let t;switch(s){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(a);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(p,s){const a=[];let t;for(;(t=p.read())!==null;)a.push(t);return s(a)}e.consumeReadable=S;function w(p,s,a){const t=[];let r;for(;(r=p.read())!==null&&t.length<a;)t.push(r);return r===null&&t.length>0?s(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return p.read()}}}e.peekReadable=w;function n(p,s){return new Promise((a,t)=>{const r=[];m(p,{onData:i=>{s&&r.push(i)},onError:i=>{s?t(i):a(void 0)},onEnd:()=>{a(s?s(r):void 0)}})})}e.consumeStream=n;function m(p,s){p.on("error",a=>s.onError(a)),p.on("end",()=>s.onEnd()),p.on("data",a=>s.onData(a))}e.listenStream=m;function d(p,s){return new Promise((a,t)=>{const r=new k.DisposableStore,i=[],o=l=>{if(i.push(l),i.length>s)return r.dispose(),p.pause(),a({stream:p,buffer:i,ended:!1})},u=l=>t(l),c=()=>a({stream:p,buffer:i,ended:!0});r.add(k.toDisposable(()=>p.removeListener("error",u))),p.on("error",u),r.add(k.toDisposable(()=>p.removeListener("end",c))),p.on("end",c),r.add(k.toDisposable(()=>p.removeListener("data",o))),p.on("data",o)})}e.peekStream=d;function g(p,s){const a=O(s);return a.end(p),a}e.toStream=g;function h(){const p=O(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=h;function C(p){let s=!1;return{read:()=>s?null:(s=!0,p)}}e.toReadable=C;function D(p,s,a){const t=O(a);return m(p,{onData:r=>t.write(s.data(r)),onError:r=>t.error(s.error?s.error(r):r),onEnd:()=>t.end()}),t}e.transform=D;function b(p,s,a){let t=!1;return{read:()=>{const r=s.read();return t?r:(t=!0,r!==null?a([p,r]):p)}}}e.prefixedReadable=b;function I(p,s,a){let t=!1;const r=O(a);return m(s,{onData:i=>t?r.write(i):(t=!0,r.write(a([p,i]))),onError:i=>r.error(i),onEnd:()=>{t||(t=!0,r.write(p)),r.end()}}),r}e.prefixedStream=I}),define(Z[20],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function v(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=v;const k=/{(\d+)}/g;function L(W,...te){return te.length===0?W:W.replace(k,function(ae,le){const ce=parseInt(le,10);return isNaN(ce)||ce<0||ce>=te.length?ae:te[ce]})}e.format=L;const A=/{([^}]+)}/g;function O(W,te){return W.replace(A,(ae,le)=>te[le]??ae)}e.format2=O;function P(W){return W.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=P;function S(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=S;function w(W,te){let ae=0;const le=te.charCodeAt(0);for(let ce=W.length-1;ce>=0;ce--)W.charCodeAt(ce)===le&&ae++;return ae}e.count=w;function n(W,te,ae="\u2026"){return W.length<=te?W:`${W.substr(0,te)}${ae}`}e.truncate=n;function m(W,te=" "){const ae=d(W,te);return g(ae,te)}e.trim=m;function d(W,te){if(!W||!te)return W;const ae=te.length;if(ae===0||W.length===0)return W;let le=0;for(;W.indexOf(te,le)===le;)le=le+ae;return W.substring(le)}e.ltrim=d;function g(W,te){if(!W||!te)return W;const ae=te.length,le=W.length;if(ae===0||le===0)return W;let ce=le,fe=-1;for(;fe=W.lastIndexOf(te,ce-1),!(fe===-1||fe+ae!==ce);){if(fe===0)return"";ce=fe}return W.substring(0,ce)}e.rtrim=g;function h(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function C(W){return W.replace(/\*/g,"")}e.stripWildcards=C;function D(W,te,ae={}){if(!W)throw new Error("Cannot create regex from empty string");te||(W=S(W)),ae.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let le="";return ae.global&&(le+="g"),ae.matchCase||(le+="i"),ae.multiline&&(le+="m"),ae.unicode&&(le+="u"),new RegExp(W,le)}e.createRegExp=D;function b(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=b;function I(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=I;function p(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=p;function s(W){return W.split(/\r\n|\r|\n/)}e.splitLines=s;function a(W){for(let te=0,ae=W.length;te<ae;te++){const le=W.charCodeAt(te);if(le!==32&&le!==9)return te}return-1}e.firstNonWhitespaceIndex=a;function t(W,te=0,ae=W.length){for(let le=te;le<ae;le++){const ce=W.charCodeAt(le);if(ce!==32&&ce!==9)return W.substring(te,le)}return W.substring(te,ae)}e.getLeadingWhitespace=t;function r(W,te=W.length-1){for(let ae=te;ae>=0;ae--){const le=W.charCodeAt(ae);if(le!==32&&le!==9)return ae}return-1}e.lastNonWhitespaceIndex=r;function i(W,te){return W<te?-1:W>te?1:0}e.compare=i;function o(W,te,ae=0,le=W.length,ce=0,fe=te.length){for(;ae<le&&ce<fe;ae++,ce++){let ue=W.charCodeAt(ae),Ee=te.charCodeAt(ce);if(ue<Ee)return-1;if(ue>Ee)return 1}const ge=le-ae,Se=fe-ce;return ge<Se?-1:ge>Se?1:0}e.compareSubstring=o;function u(W,te){return c(W,te,0,W.length,0,te.length)}e.compareIgnoreCase=u;function c(W,te,ae=0,le=W.length,ce=0,fe=te.length){for(;ae<le&&ce<fe;ae++,ce++){let ue=W.charCodeAt(ae),Ee=te.charCodeAt(ce);if(ue===Ee)continue;const De=ue-Ee;if(!(De===32&&y(Ee))&&!(De===-32&&y(ue)))return l(ue)&&l(Ee)?De:o(W.toLowerCase(),te.toLowerCase(),ae,le,ce,fe)}const ge=le-ae,Se=fe-ce;return ge<Se?-1:ge>Se?1:0}e.compareSubstringIgnoreCase=c;function l(W){return W>=97&&W<=122}e.isLowerAsciiLetter=l;function y(W){return W>=65&&W<=90}e.isUpperAsciiLetter=y;function E(W){return l(W)||y(W)}function f(W,te){return W.length===te.length&&U(W,te)}e.equalsIgnoreCase=f;function U(W,te,ae=W.length){for(let le=0;le<ae;le++){const ce=W.charCodeAt(le),fe=te.charCodeAt(le);if(ce!==fe){if(E(ce)&&E(fe)){const ge=Math.abs(ce-fe);if(ge!==0&&ge!==32)return!1}else if(String.fromCharCode(ce).toLowerCase()!==String.fromCharCode(fe).toLowerCase())return!1}}return!0}function F(W,te){const ae=te.length;return te.length>W.length?!1:U(W,te,ae)}e.startsWithIgnoreCase=F;function z(W,te){let ae,le=Math.min(W.length,te.length);for(ae=0;ae<le;ae++)if(W.charCodeAt(ae)!==te.charCodeAt(ae))return ae;return le}e.commonPrefixLength=z;function $(W,te){let ae,le=Math.min(W.length,te.length);const ce=W.length-1,fe=te.length-1;for(ae=0;ae<le;ae++)if(W.charCodeAt(ce-ae)!==te.charCodeAt(fe-ae))return ae;return le}e.commonSuffixLength=$;function H(W){return 55296<=W&&W<=56319}e.isHighSurrogate=H;function V(W){return 56320<=W&&W<=57343}e.isLowSurrogate=V;function _(W,te){return(W-55296<<10)+(te-56320)+65536}e.computeCodePoint=_;function x(W,te,ae){const le=W.charCodeAt(ae);if(H(le)&&ae+1<te){const ce=W.charCodeAt(ae+1);if(V(ce))return _(le,ce)}return le}e.getNextCodePoint=x;function j(W,te){const ae=W.charCodeAt(te-1);if(V(ae)&&te>1){const le=W.charCodeAt(te-2);if(H(le))return _(le,ae)}return ae}function q(W,te){const ae=ve.getInstance(),le=te,ce=W.length,fe=x(W,ce,te);te+=fe>=65536?2:1;let ge=ae.getGraphemeBreakType(fe);for(;te<ce;){const Se=x(W,ce,te),ue=ae.getGraphemeBreakType(Se);if(se(ge,ue))break;te+=Se>=65536?2:1,ge=ue}return te-le}e.nextCharLength=q;function R(W,te){const ae=ve.getInstance(),le=te,ce=j(W,te);te-=ce>=65536?2:1;let fe=ae.getGraphemeBreakType(ce);for(;te>0;){const ge=j(W,te),Se=ae.getGraphemeBreakType(ge);if(se(Se,fe))break;te-=ge>=65536?2:1,fe=Se}return le-te}e.prevCharLength=R;function T(W,te){const ae=ve.getInstance(),le=W.length,ce=te,fe=x(W,le,te),ge=ae.getGraphemeBreakType(fe);te+=fe>=65536?2:1;let Se=ge;for(;te<le;){const Ee=x(W,le,te),De=ae.getGraphemeBreakType(Ee);if(se(Se,De))break;te+=Ee>=65536?2:1,Se=De}const ue=te;for(te=ce,Se=ge;te>0;){const Ee=j(W,te),De=ae.getGraphemeBreakType(Ee);if(se(De,Se))break;te-=Ee>=65536?2:1,Se=De}return[te,ue]}function M(W,te){return te>0&&V(W.charCodeAt(te))?T(W,te-1):T(W,te)}e.getCharContainingOffset=M;function N(W){const te=W.length;let ae=0,le=0;for(;le<te;){const ge=x(W,te,le);le+=ge>=65536?2:1,ge<128?ae+=1:ge<2048?ae+=2:ge<65536?ae+=3:ae+=4}const ce=new Uint8Array(ae);le=0;let fe=0;for(;le<te;){const ge=x(W,te,le);le+=ge>=65536?2:1,ge<128?ce[fe++]=ge:ge<2048?(ce[fe++]=192|(ge&1984)>>>6,ce[fe++]=128|(ge&63)>>>0):ge<65536?(ce[fe++]=224|(ge&61440)>>>12,ce[fe++]=128|(ge&4032)>>>6,ce[fe++]=128|(ge&63)>>>0):(ce[fe++]=240|(ge&1835008)>>>18,ce[fe++]=128|(ge&258048)>>>12,ce[fe++]=128|(ge&4032)>>>6,ce[fe++]=128|(ge&63)>>>0)}return ce}e.encodeUTF8=N;function B(W){const te=W.byteLength,ae=[];let le=0;for(;le<te;){const ce=W[le];let fe;if(ce>=240&&le+3<te?fe=(W[le++]&7)<<18>>>0|(W[le++]&63)<<12>>>0|(W[le++]&63)<<6>>>0|(W[le++]&63)<<0>>>0:ce>=224&&le+2<te?fe=(W[le++]&15)<<12>>>0|(W[le++]&63)<<6>>>0|(W[le++]&63)<<0>>>0:ce>=192&&le+1<te?fe=(W[le++]&31)<<6>>>0|(W[le++]&63)<<0>>>0:fe=W[le++],fe>=0&&fe<=55295||fe>=57344&&fe<=65535)ae.push(String.fromCharCode(fe));else if(fe>=65536&&fe<=1114111){const ge=fe-65536,Se=55296+((ge&1047552)>>>10),ue=56320+((ge&1023)>>>0);ae.push(String.fromCharCode(Se)),ae.push(String.fromCharCode(ue))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=B;const G=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Q(W){return G.test(W)}e.containsRTL=Q;const X=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ie(W){return X.test(W)}e.containsEmoji=ie;const ne=/^[\t\n\r\x20-\x7E]*$/;function oe(W){return ne.test(W)}e.isBasicASCII=oe,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function he(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=he;function me(W){for(let te=0,ae=W.length;te<ae;te++)if(pe(W.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=me;function pe(W){return W=+W,W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=pe;function Ie(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129003||W>=129280&&W<=129535||W>=129648&&W<=129750}e.isEmojiImprecise=Ie;function Re(W,te){if(W.length<te)return W;const ae=/\b/g;let le=0;for(;ae.test(W)&&!(W.length-ae.lastIndex<te);)le=ae.lastIndex,ae.lastIndex+=1;return W.substring(le).replace(/^\s/,"")}e.lcut=Re;const Fe=/\x1B\x5B[12]?K/g,Oe=/\x1b\[\d+m/g,ke=/\x1b\[0?m/g;function _e(W){return W&&(W=W.replace(Fe,""),W=W.replace(Oe,""),W=W.replace(ke,"")),W}e.removeAnsiEscapeCodes=_e,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function be(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=be;function Ae(W){return be(W)?W.substr(1):W}e.stripUTF8BOM=Ae;function Ke(W,te){if(!W||!te||W.length<te.length)return!1;const ae=te.length,le=W.toLowerCase();let ce=0,fe=-1;for(;ce<ae;){const ge=le.indexOf(te[ce],fe+1);if(ge<0)return!1;fe=ge,ce++}return!0}e.fuzzyContains=Ke;function Ye(W,te=!1){return W?(te&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=Ye;function $e(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=$e;function xe(W,te=1){if(te===0)return"";let ae=-1;do ae=W.indexOf(`
`,ae+1),te--;while(te>0&&ae>=0);return ae===-1?W:(W[ae-1]==="\r"&&ae--,W.substr(0,ae))}e.getNLines=xe;function J(W){const te=90-65+1;return W=W%(2*te),W<te?String.fromCharCode(97+W):String.fromCharCode(65+W-te)}e.singleLetterHash=J;function re(W){return ve.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=re;function se(W,te){return W===0?te!==5&&te!==7:W===2&&te===3?!1:W===4||W===2||W===3||te===4||te===2||te===3?!0:!(W===8&&(te===8||te===9||te===11||te===12)||(W===11||W===9)&&(te===9||te===10)||(W===12||W===10)&&te===10||te===5||te===13||te===7||W===1||W===13&&te===14||W===6&&te===6)}e.breakBetweenGraphemeBreakType=se;var ye;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(ye=e.GraphemeBreakType||(e.GraphemeBreakType={}));class ve{constructor(){this._data=Pe()}static getInstance(){return ve._INSTANCE||(ve._INSTANCE=new ve),ve._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const ae=this._data,le=ae.length/3;let ce=1;for(;ce<=le;)if(te<ae[3*ce])ce=2*ce;else if(te>ae[3*ce+1])ce=2*ce+1;else return ae[3*ce+2];return 0}}ve._INSTANCE=null;function Pe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function we(W,te){if(W===0)return 0;const ae=Te(W,te);if(ae!==void 0)return ae;const le=j(te,W);return W-=Ce(le),W}e.getLeftDeleteOffset=we;function Te(W,te){let ae=j(te,W);for(W-=Ce(ae);Le(ae)||ae===65039||ae===8419;){if(W===0)return;ae=j(te,W),W-=Ce(ae)}if(!!Ie(ae)){if(W>=0){const le=j(te,W);le===8205&&(W-=Ce(le))}return W}}function Ce(W){return W>=65536?2:1}function Le(W){return 127995<=W&&W<=127999}var Ue;(function(W){W[W.zwj=8205]="zwj",W[W.emojiVariantSelector=65039]="emojiVariantSelector",W[W.enclosingKeyCap=8419]="enclosingKeyCap"})(Ue||(Ue={}))}),define(Z[25],ee([0,1,20,47]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined",A=typeof TextEncoder!="undefined",O=typeof TextDecoder!="undefined";let P,S;class w{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return L?new w(Buffer.allocUnsafe(l)):new w(new Uint8Array(l))}static wrap(l){return L&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new w(l)}static fromString(l,y){return!(y?.dontUseNodeBuffer||!1)&&L?new w(Buffer.from(l)):A?(P||(P=new TextEncoder),new w(P.encode(l))):new w(v.encodeUTF8(l))}static concat(l,y){if(typeof y=="undefined"){y=0;for(let U=0,F=l.length;U<F;U++)y+=l[U].byteLength}const E=w.alloc(y);let f=0;for(let U=0,F=l.length;U<F;U++){const z=l[U];E.set(z,f),f+=z.byteLength}return E}toString(){return L?this.buffer.toString():O?(S||(S=new TextDecoder),S.decode(this.buffer)):v.decodeUTF8(this.buffer)}slice(l,y){return new w(this.buffer.subarray(l,y))}set(l,y){l instanceof w?this.buffer.set(l.buffer,y):this.buffer.set(l,y)}readUInt32BE(l){return d(this.buffer,l)}writeUInt32BE(l,y){g(this.buffer,l,y)}readUInt32LE(l){return h(this.buffer,l)}writeUInt32LE(l,y){C(this.buffer,l,y)}readUInt8(l){return D(this.buffer,l)}writeUInt8(l,y){b(this.buffer,l,y)}}e.VSBuffer=w;function n(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0}e.readUInt16LE=n;function m(c,l,y){c[y+0]=l&255,l=l>>>8,c[y+1]=l&255}e.writeUInt16LE=m;function d(c,l){return c[l]*2**24+c[l+1]*2**16+c[l+2]*2**8+c[l+3]}e.readUInt32BE=d;function g(c,l,y){c[y+3]=l,l=l>>>8,c[y+2]=l,l=l>>>8,c[y+1]=l,l=l>>>8,c[y]=l}e.writeUInt32BE=g;function h(c,l){return c[l+0]<<0>>>0|c[l+1]<<8>>>0|c[l+2]<<16>>>0|c[l+3]<<24>>>0}e.readUInt32LE=h;function C(c,l,y){c[y+0]=l&255,l=l>>>8,c[y+1]=l&255,l=l>>>8,c[y+2]=l&255,l=l>>>8,c[y+3]=l&255}e.writeUInt32LE=C;function D(c,l){return c[l]}e.readUInt8=D;function b(c,l,y){c[y]=l}e.writeUInt8=b;function I(c){return k.consumeReadable(c,l=>w.concat(l))}e.readableToBuffer=I;function p(c){return k.toReadable(c)}e.bufferToReadable=p;function s(c){return k.consumeStream(c,l=>w.concat(l))}e.streamToBuffer=s;async function a(c){return c.ended?w.concat(c.buffer):w.concat([...c.buffer,await s(c.stream)])}e.bufferedStreamToBuffer=a;function t(c){return k.toStream(c,l=>w.concat(l))}e.bufferToStream=t;function r(c){return k.transform(c,{data:l=>typeof l=="string"?w.fromString(l):w.wrap(l)},l=>w.concat(l))}e.streamToBufferReadableStream=r;function i(c){return k.newWriteableStream(l=>w.concat(l),c)}e.newWriteableBufferStream=i;function o(c,l){return k.prefixedReadable(c,l,y=>w.concat(y))}e.prefixedBufferReadable=o;function u(c,l){return k.prefixedStream(c,l,y=>w.concat(y))}e.prefixedBufferStream=u}),define(Z[16],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function v(l){return Array.isArray(l)}e.isArray=v;function k(l){return typeof l=="string"}e.isString=k;function L(l){return Array.isArray(l)&&l.every(y=>k(y))}e.isStringArray=L;function A(l){return typeof l=="object"&&l!==null&&!Array.isArray(l)&&!(l instanceof RegExp)&&!(l instanceof Date)}e.isObject=A;function O(l){return typeof l=="number"&&!isNaN(l)}e.isNumber=O;function P(l){return!!l&&typeof l[Symbol.iterator]=="function"}e.isIterable=P;function S(l){return l===!0||l===!1}e.isBoolean=S;function w(l){return typeof l=="undefined"}e.isUndefined=w;function n(l){return!m(l)}e.isDefined=n;function m(l){return w(l)||l===null}e.isUndefinedOrNull=m;function d(l,y){if(!l)throw new Error(y?`Unexpected type, expected '${y}'`:"Unexpected type")}e.assertType=d;function g(l){if(m(l))throw new Error("Assertion Failed: argument is undefined or null");return l}e.assertIsDefined=g;function h(...l){const y=[];for(let E=0;E<l.length;E++){const f=l[E];if(m(f))throw new Error(`Assertion Failed: argument at index ${E} is undefined or null`);y.push(f)}return y}e.assertAllDefined=h;const C=Object.prototype.hasOwnProperty;function D(l){if(!A(l))return!1;for(let y in l)if(C.call(l,y))return!1;return!0}e.isEmptyObject=D;function b(l){return typeof l=="function"}e.isFunction=b;function I(...l){return l.length>0&&l.every(b)}e.areFunctions=I;function p(l,y){const E=Math.min(l.length,y.length);for(let f=0;f<E;f++)s(l[f],y[f])}e.validateConstraints=p;function s(l,y){if(k(y)){if(typeof l!==y)throw new Error(`argument does not match constraint: typeof ${y}`)}else if(b(y)){try{if(l instanceof y)return}catch{}if(!m(l)&&l.constructor===y||y.length===1&&y.call(void 0,l)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=s;function a(l){let y=[],E=Object.getPrototypeOf(l);for(;Object.prototype!==E;)y=y.concat(Object.getOwnPropertyNames(E)),E=Object.getPrototypeOf(E);return y}e.getAllPropertyNames=a;function t(l){const y=[];for(const E of a(l))typeof l[E]=="function"&&y.push(E);return y}e.getAllMethodNames=t;function r(l,y){const E=U=>function(){const F=Array.prototype.slice.call(arguments,0);return y(U,F)};let f={};for(const U of l)f[U]=E(U);return f}e.createProxyObject=r;function i(l){return l===null?void 0:l}e.withNullAsUndefined=i;function o(l){return typeof l=="undefined"?null:l}e.withUndefinedAsNull=o;function u(l){return class{constructor(){return new Proxy({},{get(y,E){if(y[E])return y[E];throw new Error(`Not Implemented: ${l}->${String(E)}`)}})}}}e.NotImplementedProxy=u;function c(l){throw new Error("Unreachable")}e.assertNever=c}),define(Z[41],ee([0,1,7,20,8,16]),function(K,e,v,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function O(i){return i===47||i===92}e.isPathSeparator=O;function P(i){return i.replace(/[\\/]/g,L.posix.sep)}e.toSlashes=P;function S(i){return i.indexOf("/")===-1&&(i=P(i)),/^[a-zA-Z]:(\/|$)/.test(i)&&(i="/"+i),i}e.toPosixPath=S;function w(i,o=L.posix.sep){if(!i)return"";const u=i.length,c=i.charCodeAt(0);if(O(c)){if(O(i.charCodeAt(1))&&!O(i.charCodeAt(2))){let y=3;const E=y;for(;y<u&&!O(i.charCodeAt(y));y++);if(E!==y&&!O(i.charCodeAt(y+1))){for(y+=1;y<u;y++)if(O(i.charCodeAt(y)))return i.slice(0,y+1).replace(/[\\/]/g,o)}}return o}else if(b(c)&&i.charCodeAt(1)===58)return O(i.charCodeAt(2))?i.slice(0,2)+o:i.slice(0,2);let l=i.indexOf("://");if(l!==-1){for(l+=3;l<u;l++)if(O(i.charCodeAt(l)))return i.slice(0,l+1)}return""}e.getRoot=w;function n(i){if(!v.isWindows||!i||i.length<5)return!1;let o=i.charCodeAt(0);if(o!==92||(o=i.charCodeAt(1),o!==92))return!1;let u=2;const c=u;for(;u<i.length&&(o=i.charCodeAt(u),o!==92);u++);return!(c===u||(o=i.charCodeAt(u+1),isNaN(o)||o===92))}e.isUNC=n;const m=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function h(i,o=v.isWindows){const u=o?m:d;return!(!i||i.length===0||/^\s+$/.test(i)||(u.lastIndex=0,u.test(i))||o&&g.test(i)||i==="."||i===".."||o&&i[i.length-1]==="."||o&&i.length!==i.trim().length||i.length>255)}e.isValidBasename=h;function C(i,o,u){const c=i===o;return!u||c?c:!i||!o?!1:k.equalsIgnoreCase(i,o)}e.isEqual=C;function D(i,o,u,c=L.sep){if(i===o)return!0;if(!i||!o||o.length>i.length)return!1;if(u){if(!k.startsWithIgnoreCase(i,o))return!1;if(o.length===i.length)return!0;let y=o.length;return o.charAt(o.length-1)===c&&y--,i.charAt(y)===c}return o.charAt(o.length-1)!==c&&(o+=c),i.indexOf(o)===0}e.isEqualOrParent=D;function b(i){return i>=65&&i<=90||i>=97&&i<=122}e.isWindowsDriveLetter=b;function I(i,o){return v.isWindows&&i.endsWith(":")&&(i+=L.sep),L.isAbsolute(i)||(i=L.join(o,i)),i=L.normalize(i),v.isWindows?(i=k.rtrim(i,L.sep),i.endsWith(":")&&(i+=L.sep)):(i=k.rtrim(i,L.sep),i||(i=L.sep)),i}e.sanitizeFilePath=I;function p(i){const o=L.normalize(i);return v.isWindows?i.length>3?!1:s(o)&&(i.length===2||o.charCodeAt(2)===92):o===L.posix.sep}e.isRootOrDriveLetter=p;function s(i){return v.isWindows?b(i.charCodeAt(0))&&i.charCodeAt(1)===58:!1}e.hasDriveLetter=s;function a(i){return s(i)?i[0]:void 0}e.getDriveLetter=a;function t(i,o,u){return o.length>i.length?-1:i===o?0:(u&&(i=i.toLowerCase(),o=o.toLowerCase()),i.indexOf(o))}e.indexOfPath=t;function r(i){const o=i.split(":");let u,c,l;if(o.forEach(y=>{const E=Number(y);A.isNumber(E)?c===void 0?c=E:l===void 0&&(l=E):u=u?[u,y].join(":"):y}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:c!==void 0?c:void 0,column:l!==void 0?l:c!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(Z[26],ee([0,1,16]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function k(C){if(!C||typeof C!="object"||C instanceof RegExp)return C;const D=Array.isArray(C)?[]:{};return Object.keys(C).forEach(b=>{C[b]&&typeof C[b]=="object"?D[b]=k(C[b]):D[b]=C[b]}),D}e.deepClone=k;function L(C){if(!C||typeof C!="object")return C;const D=[C];for(;D.length>0;){const b=D.shift();Object.freeze(b);for(const I in b)if(A.call(b,I)){const p=b[I];typeof p=="object"&&!Object.isFrozen(p)&&D.push(p)}}return C}e.deepFreeze=L;const A=Object.prototype.hasOwnProperty;function O(C,D){return P(C,D,new Set)}e.cloneAndChange=O;function P(C,D,b){if(v.isUndefinedOrNull(C))return C;const I=D(C);if(typeof I!="undefined")return I;if(v.isArray(C)){const p=[];for(const s of C)p.push(P(s,D,b));return p}if(v.isObject(C)){if(b.has(C))throw new Error("Cannot clone recursive data-structure");b.add(C);const p={};for(let s in C)A.call(C,s)&&(p[s]=P(C[s],D,b));return b.delete(C),p}return C}function S(C,D,b=!0){return v.isObject(C)?(v.isObject(D)&&Object.keys(D).forEach(I=>{I in C?b&&(v.isObject(C[I])&&v.isObject(D[I])?S(C[I],D[I],b):C[I]=D[I]):C[I]=D[I]}),C):D}e.mixin=S;function w(C,D){if(C===D)return!0;if(C==null||D===null||D===void 0||typeof C!=typeof D||typeof C!="object"||Array.isArray(C)!==Array.isArray(D))return!1;let b,I;if(Array.isArray(C)){if(C.length!==D.length)return!1;for(b=0;b<C.length;b++)if(!w(C[b],D[b]))return!1}else{const p=[];for(I in C)p.push(I);p.sort();const s=[];for(I in D)s.push(I);if(s.sort(),!w(p,s))return!1;for(b=0;b<p.length;b++)if(!w(C[p[b]],D[p[b]]))return!1}return!0}e.equals=w;function n(C){const D=new Set;return JSON.stringify(C,(b,I)=>{if(v.isObject(I)||Array.isArray(I)){if(D.has(I))return"[Circular]";D.add(I)}return I})}e.safeStringify=n;function m(C,D,b){const I=D(C);return typeof I=="undefined"?b:I}e.getOrDefault=m;function d(C,D){const b=Object.create(null);return!C||!D||Object.keys(D).forEach(p=>{const s=C[p],a=D[p];w(s,a)||(b[p]=a)}),b}e.distinct=d;function g(C,D){const b=D.toLowerCase(),I=Object.keys(C).find(p=>p.toLowerCase()===b);return I?C[I]:C[D]}e.getCaseInsensitive=g;function h(C,D){const b=Object.create(null);for(const I of Object.keys(C))D(I,C[I])&&(b[I]=C[I]);return b}e.filter=h}),define(Z[5],ee([0,1,7,8]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const L=/^\w[\w\d+.-]*$/,A=/^\//,O=/^\/\//;function P(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!L.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!A.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(O.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(i,o){return!i&&!o?"file":i}function w(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==m&&(o=m+o):o=m;break}return o}const n="",m="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{constructor(o,u,c,l,y,E=!1){typeof o=="object"?(this.scheme=o.scheme||n,this.authority=o.authority||n,this.path=o.path||n,this.query=o.query||n,this.fragment=o.fragment||n):(this.scheme=S(o,E),this.authority=u||n,this.path=w(this.scheme,c||n),this.query=l||n,this.fragment=y||n,P(this,E))}static isUri(o){return o instanceof g?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return p(this,!1)}with(o){if(!o)return this;let{scheme:u,authority:c,path:l,query:y,fragment:E}=o;return u===void 0?u=this.scheme:u===null&&(u=n),c===void 0?c=this.authority:c===null&&(c=n),l===void 0?l=this.path:l===null&&(l=n),y===void 0?y=this.query:y===null&&(y=n),E===void 0?E=this.fragment:E===null&&(E=n),u===this.scheme&&c===this.authority&&l===this.path&&y===this.query&&E===this.fragment?this:new C(u,c,l,y,E)}static parse(o,u=!1){const c=d.exec(o);return c?new C(c[2]||n,r(c[4]||n),r(c[5]||n),r(c[7]||n),r(c[9]||n),u):new C(n,n,n,n,n)}static file(o){let u=n;if(v.isWindows&&(o=o.replace(/\\/g,m)),o[0]===m&&o[1]===m){const c=o.indexOf(m,2);c===-1?(u=o.substring(2),o=m):(u=o.substring(2,c),o=o.substring(c)||m)}return new C("file",u,o,n,n)}static from(o){const u=new C(o.scheme,o.authority,o.path,o.query,o.fragment);return P(u,!0),u}static joinPath(o,...u){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return v.isWindows&&o.scheme==="file"?c=g.file(k.win32.join(p(o,!0),...u)).path:c=k.posix.join(o.path,...u),o.with({path:c})}toString(o=!1){return s(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof g)return o;{const u=new C(o);return u._formatted=o.external,u._fsPath=o._sep===h?o.fsPath:null,u}}else return o}}e.URI=g;const h=v.isWindows?1:void 0;class C extends g{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=p(this,!1)),this._fsPath}toString(o=!1){return o?s(this,!0):(this._formatted||(this._formatted=s(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=h),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const D={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(i,o){let u,c=-1;for(let l=0;l<i.length;l++){const y=i.charCodeAt(l);if(y>=97&&y<=122||y>=65&&y<=90||y>=48&&y<=57||y===45||y===46||y===95||y===126||o&&y===47)c!==-1&&(u+=encodeURIComponent(i.substring(c,l)),c=-1),u!==void 0&&(u+=i.charAt(l));else{u===void 0&&(u=i.substr(0,l));const E=D[y];E!==void 0?(c!==-1&&(u+=encodeURIComponent(i.substring(c,l)),c=-1),u+=E):c===-1&&(c=l)}}return c!==-1&&(u+=encodeURIComponent(i.substring(c))),u!==void 0?u:i}function I(i){let o;for(let u=0;u<i.length;u++){const c=i.charCodeAt(u);c===35||c===63?(o===void 0&&(o=i.substr(0,u)),o+=D[c]):o!==void 0&&(o+=i[u])}return o!==void 0?o:i}function p(i,o){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,v.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=p;function s(i,o){const u=o?I:b;let c="",{scheme:l,authority:y,path:E,query:f,fragment:U}=i;if(l&&(c+=l,c+=":"),(y||l==="file")&&(c+=m,c+=m),y){let F=y.indexOf("@");if(F!==-1){const z=y.substr(0,F);y=y.substr(F+1),F=z.indexOf(":"),F===-1?c+=u(z,!1):(c+=u(z.substr(0,F),!1),c+=":",c+=u(z.substr(F+1),!1)),c+="@"}y=y.toLowerCase(),F=y.indexOf(":"),F===-1?c+=u(y,!1):(c+=u(y.substr(0,F),!1),c+=y.substr(F))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const F=E.charCodeAt(1);F>=65&&F<=90&&(E=`/${String.fromCharCode(F+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const F=E.charCodeAt(0);F>=65&&F<=90&&(E=`${String.fromCharCode(F+32)}:${E.substr(2)}`)}c+=u(E,!0)}return f&&(c+="?",c+=u(f,!1)),U&&(c+="#",c+=o?U:b(U,!1)),c}function a(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+a(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,o=>a(o)):i}}),define(Z[90],ee([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function k(w){const n=w;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=k;function L(w){const n=[];let m;try{const d=JSON.parse(w.arguments),g=d[d.length-1];g&&g.__$stack&&(d.pop(),m=g.__$stack),n.push(...d)}catch(d){n.push("Unable to log remote console arguments",w.arguments)}return{args:n,stack:m}}e.parse=L;function A(w){if(typeof w!="string")return A(L(w).stack);const n=w;if(n){const m=O(n),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(d&&d.length===4)return{uri:v.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=A;function O(w){if(!w)return w;const n=w.indexOf(`
`);return n===-1?w:w.substring(0,n)}function P(w,n){const{args:m,stack:d}=L(w),g=typeof m[0]=="string"&&m.length===1;let h=O(d);h&&(h=`(${h.trim()})`);let C=[];if(typeof m[0]=="string"?h&&g?C=[`%c[${n}] %c${m[0]} %c${h}`,S("blue"),S(""),S("grey")]:C=[`%c[${n}] %c${m[0]}`,S("blue"),S(""),...m.slice(1)]:C=[`%c[${n}]%`,S("blue"),...m],h&&!g&&C.push(h),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,C)}e.log=P;function S(w){return`color: ${w}`}});var ut=this&&this.__classPrivateFieldSet||function(K,e,v,k,L){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!L)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?K!==e||!L:!e.has(K))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?L.call(K,v):L?L.value=v:e.set(K,v),v},ze=this&&this.__classPrivateFieldGet||function(K,e,v,k){if(v==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?K!==e||!k:!e.has(K))throw new TypeError("Cannot read private member from an object whose class did not declare it");return v==="m"?k:v==="a"?k.call(K):k?k.value:e.get(K)};define(Z[38],ee([0,1,5,20]),function(K,e,v,k){"use strict";var L,A,O;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,r,i){let o=t.get(r);return o===void 0&&(o=i,t.set(r,o)),o}e.getOrSet=P;function S(t){const r=[];return t.forEach((i,o)=>{r.push(`${o} => ${i}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=S;function w(t){const r=[];return t.forEach(i=>{r.push(i)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=w;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const i=r.charCodeAt(0),o=this._value.charCodeAt(this._pos);return i-o}value(){return this._value[this._pos]}}e.StringIterator=n;class m{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?k.compareSubstring(r,this._value,0,r.length,this._from,this._to):k.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=m;class d{constructor(r=!0,i=!0){this._splitOnBackslash=r,this._caseSensitive=i}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const i=this._value.charCodeAt(this._to);if(i===47||this._splitOnBackslash&&i===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?k.compareSubstring(r,this._value,0,r.length,this._from,this._to):k.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var g;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(g||(g={}));class h{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return k.compareIgnoreCase(r,this._value.scheme);if(this._states[this._stateIdx]===2)return k.compareIgnoreCase(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return k.compare(r,this._value.query);if(this._states[this._stateIdx]===5)return k.compare(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class C{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class D{constructor(r){this._iter=r}static forUris(r=()=>!1){return new D(new h(r))}static forPaths(){return new D(new d)}static forStrings(){return new D(new n)}static forConfigKeys(){return new D(new m)}clear(){this._root=void 0}set(r,i){const o=this._iter.reset(r);let u;for(this._root||(this._root=new C,this._root.segment=o.value()),u=this._root;;){const l=o.cmp(u.segment);if(l>0)u.left||(u.left=new C,u.left.segment=o.value()),u=u.left;else if(l<0)u.right||(u.right=new C,u.right.segment=o.value()),u=u.right;else if(o.hasNext())o.next(),u.mid||(u.mid=new C,u.mid.segment=o.value()),u=u.mid;else break}const c=u.value;return u.value=i,u.key=r,c}get(r){return this._getNode(r)?.value}_getNode(r){const i=this._iter.reset(r);let o=this._root;for(;o;){const u=i.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(i.hasNext())i.next(),o=o.mid;else break}return o}has(r){const i=this._getNode(r);return!(i?.value===void 0&&i?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,i){const o=this._iter.reset(r),u=[];let c=this._root;for(;c;){const l=o.cmp(c.segment);if(l>0)u.push([1,c]),c=c.left;else if(l<0)u.push([-1,c]),c=c.right;else if(o.hasNext())o.next(),u.push([0,c]),c=c.mid;else{for(i?(c.left=void 0,c.mid=void 0,c.right=void 0):c.value=void 0;u.length>0&&c.isEmpty();){let[y,E]=u.pop();switch(y){case 1:E.left=void 0;break;case 0:E.mid=void 0;break;case-1:E.right=void 0;break}c=E}break}}}findSubstr(r){const i=this._iter.reset(r);let o=this._root,u;for(;o;){const c=i.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(i.hasNext())i.next(),u=o.value||u,o=o.mid;else break}return o&&o.value||u}findSuperstr(r){const i=this._iter.reset(r);let o=this._root;for(;o;){const u=i.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(i.hasNext())i.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(r){for(const[i,o]of this)r(o,i)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const i=[r];for(;i.length>0;){const o=i.pop();o&&(o.value&&(yield[o.key,o.value]),o.left&&i.push(o.left),o.mid&&i.push(o.mid),o.right&&i.push(o.right))}}}e.TernarySearchTree=D;class b{constructor(r,i){this[L]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=i??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,i){return this.map.set(this.toKey(r),i),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,i){typeof i!="undefined"&&(r=r.bind(i));for(let[o,u]of this.map)r(u,v.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield v.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[v.URI.parse(r[0]),r[1]]}*[(L=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[v.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var I;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class p{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,i=0){const o=this._map.get(r);if(!!o)return i!==0&&this.touch(o,i),o.value}set(r,i,o=0){let u=this._map.get(r);if(u)u.value=i,o!==0&&this.touch(u,o);else{switch(u={key:r,value:i,next:void 0,previous:void 0},o){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const i=this._map.get(r);if(!!i)return this._map.delete(r),this.removeItem(i),this._size--,i.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,i){const o=this._state;let u=this._head;for(;u;){if(i?r.bind(i)(u.value,u.key,this):r(u.value,u.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,i=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.key,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return u}values(){const r=this,i=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:o.value,done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return u}entries(){const r=this,i=this._state;let o=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==i)throw new Error("LinkedMap got modified during iteration.");if(o){const c={value:[o.key,o.value],done:!1};return o=o.next,c}else return{value:void 0,done:!0}}};return u}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let i=this._head,o=this.size;for(;i&&o>r;)this._map.delete(i.key),i=i.next,o--;this._head=i,this._size=o,i&&(i.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const i=r.next,o=r.previous;if(!i||!o)throw new Error("Invalid list");i.previous=o,o.next=i}r.next=void 0,r.previous=void 0,this._state++}touch(r,i){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(i!==1&&i!==2)){if(i===1){if(r===this._head)return;const o=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(o.previous=u,u.next=o),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(i===2){if(r===this._tail)return;const o=r.next,u=r.previous;r===this._head?(o.previous=void 0,this._head=o):(o.previous=u,u.next=o),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((i,o)=>{r.push([o,i])}),r}fromJSON(r){this.clear();for(const[i,o]of r)this.set(i,o)}}e.LinkedMap=p;class s extends p{constructor(r,i=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,i),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,i=2){return super.get(r,i)}peek(r){return super.get(r,0)}set(r,i){return super.set(r,i,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=s;class a{constructor(r){O.set(this,void 0),ut(this,O,r,"f")}get size(){return ze(this,O,"f").size}forEach(r,i){ze(this,O,"f").forEach(r,i)}get(r){return ze(this,O,"f").get(r)}has(r){return ze(this,O,"f").has(r)}entries(){return ze(this,O,"f").entries()}keys(){return ze(this,O,"f").keys()}values(){return ze(this,O,"f").values()}[(O=new WeakMap,Symbol.iterator)](){return ze(this,O,"f").entries()}}e.ReadonlyMapView=a}),define(Z[91],ee([0,1,25,20,5]),function(K,e,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(n){return JSON.stringify(n,S)}e.stringify=A;function O(n){let m=JSON.parse(n);return m=w(m),m}e.parse=O;var P;(function(n){n[n.Uri=1]="Uri",n[n.Regexp=2]="Regexp",n[n.ScmResource=3]="ScmResource",n[n.ScmResourceGroup=4]="ScmResourceGroup",n[n.ScmProvider=5]="ScmProvider",n[n.CommentController=6]="CommentController",n[n.CommentThread=7]="CommentThread",n[n.CommentThreadReply=8]="CommentThreadReply",n[n.CommentNode=9]="CommentNode",n[n.CommentThreadNode=10]="CommentThreadNode",n[n.TimelineActionContext=11]="TimelineActionContext",n[n.NotebookCellActionContext=12]="NotebookCellActionContext",n[n.TestItemContext=13]="TestItemContext"})(P=e.MarshalledId||(e.MarshalledId={}));function S(n,m){return m instanceof RegExp?{$mid:2,source:m.source,flags:k.regExpFlags(m)}:m}function w(n,m=0){if(!n||m>200)return n;if(typeof n=="object"){switch(n.$mid){case 1:return L.URI.revive(n);case 2:return new RegExp(n.source,n.flags)}if(n instanceof v.VSBuffer||n instanceof Uint8Array)return n;if(Array.isArray(n))for(let d=0;d<n.length;++d)n[d]=w(n[d],m+1);else for(const d in n)Object.hasOwnProperty.call(n,d)&&(n[d]=w(n[d],m+1))}return n}e.revive=w}),define(Z[17],ee([0,1,5,7]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var L;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeInteractive="vscode-interactive",P.vscodeInteractiveInput="vscode-interactive-input",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(L=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,w,n){this._hosts[S]=w,this._ports[S]=n}setConnectionToken(S,w){this._connectionTokens[S]=w}rewrite(S){if(this._delegate)return this._delegate(S);const w=S.authority;let n=this._hosts[w];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const m=this._ports[w],d=this._connectionTokens[w];let g=`path=${encodeURIComponent(S.path)}`;return typeof d=="string"&&(g+=`&tkn=${encodeURIComponent(d)}`),v.URI.from({scheme:k.isWeb?this._preferredWebSchema:L.vscodeRemoteResource,authority:`${n}:${m}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new A;class O{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(S,w,n){const m=this.toUri(S,w);if(m.scheme===L.vscodeRemote)return e.RemoteAuthorities.rewrite(m);let d=!1;return k.isNative&&(n||k.isPreferringBrowserCodeLoad)&&m.scheme===L.file&&(d=!0),m.scheme===L.file&&typeof k.globals.importScripts=="function"&&k.globals.origin==="vscode-file://vscode-app"&&(d=!0),d?m.with({scheme:L.vscodeFileResource,authority:m.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):m}asFileUri(S,w){const n=this.toUri(S,w);return n.scheme===L.vscodeFileResource?n.with({scheme:L.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(S,w){return v.URI.isUri(S)?S:v.URI.parse(w.toUrl(S))}}e.FileAccess=new O}),define(Z[66],ee([0,1,38]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const k=new v.LRUCache(1e4);function L(w){return S(w,"NFC",k)}e.normalizeNFC=L;const A=new v.LRUCache(1e4);function O(w){return S(w,"NFD",A)}e.normalizeNFD=O;const P=/[^\u0000-\u0080]/;function S(w,n,m){if(!e.canNormalize||!w)return w;const d=m.get(w);if(d)return d;let g;return P.test(w)?g=w.normalize(n):g=w,m.set(w,g),g}e.removeAccents=function(){if(e.canNormalize){const w=/[\u0300-\u036f]/g;return function(n){return O(n).replace(w,"")}}else return function(w){return w}}()}),define(Z[14],ee([0,1,41,8,5,20,17,7]),function(K,e,v,k,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(g){return L.uriToFsPath(g,!0)}e.originalFSPath=S;class w{constructor(h){this._ignorePathCasing=h}compare(h,C,D=!1){return h===C?0:A.compare(this.getComparisonKey(h,D),this.getComparisonKey(C,D))}isEqual(h,C,D=!1){return h===C?!0:!h||!C?!1:this.getComparisonKey(h,D)===this.getComparisonKey(C,D)}getComparisonKey(h,C=!1){return h.with({path:this._ignorePathCasing(h)?h.path.toLowerCase():void 0,fragment:C?null:void 0}).toString()}ignorePathCasing(h){return this._ignorePathCasing(h)}isEqualOrParent(h,C,D=!1){if(h.scheme===C.scheme){if(h.scheme===O.Schemas.file)return v.isEqualOrParent(S(h),S(C),this._ignorePathCasing(h))&&h.query===C.query&&(D||h.fragment===C.fragment);if(e.isEqualAuthority(h.authority,C.authority))return v.isEqualOrParent(h.path,C.path,this._ignorePathCasing(h),"/")&&h.query===C.query&&(D||h.fragment===C.fragment)}return!1}joinPath(h,...C){return L.URI.joinPath(h,...C)}basenameOrAuthority(h){return e.basename(h)||h.authority}basename(h){return k.posix.basename(h.path)}extname(h){return k.posix.extname(h.path)}dirname(h){if(h.path.length===0)return h;let C;return h.scheme===O.Schemas.file?C=L.URI.file(k.dirname(S(h))).path:(C=k.posix.dirname(h.path),h.authority&&C.length&&C.charCodeAt(0)!==47&&(console.error(`dirname("${h.toString})) resulted in a relative path`),C="/")),h.with({path:C})}normalizePath(h){if(!h.path.length)return h;let C;return h.scheme===O.Schemas.file?C=L.URI.file(k.normalize(S(h))).path:C=k.posix.normalize(h.path),h.with({path:C})}relativePath(h,C){if(h.scheme!==C.scheme||!e.isEqualAuthority(h.authority,C.authority))return;if(h.scheme===O.Schemas.file){const I=k.relative(S(h),S(C));return P.isWindows?v.toSlashes(I):I}let D=h.path||"/",b=C.path||"/";if(this._ignorePathCasing(h)){let I=0;for(const p=Math.min(D.length,b.length);I<p&&!(D.charCodeAt(I)!==b.charCodeAt(I)&&D.charAt(I).toLowerCase()!==b.charAt(I).toLowerCase());I++);D=b.substr(0,I)+D.substr(I)}return k.posix.relative(D,b)}resolvePath(h,C){if(h.scheme===O.Schemas.file){const D=L.URI.file(k.resolve(S(h),C));return h.with({authority:D.authority,path:D.path})}return C=v.toPosixPath(C),h.with({path:k.posix.resolve(h.path,C)})}isAbsolutePath(h){return!!h.path&&h.path[0]==="/"}isEqualAuthority(h,C){return h===C||A.equalsIgnoreCase(h,C)}hasTrailingPathSeparator(h,C=k.sep){if(h.scheme===O.Schemas.file){const D=S(h);return D.length>v.getRoot(D).length&&D[D.length-1]===C}else{const D=h.path;return D.length>1&&D.charCodeAt(D.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(h.fsPath)}}removeTrailingPathSeparator(h,C=k.sep){return e.hasTrailingPathSeparator(h,C)?h.with({path:h.path.substr(0,h.path.length-1)}):h}addTrailingPathSeparator(h,C=k.sep){let D=!1;if(h.scheme===O.Schemas.file){const b=S(h);D=b!==void 0&&b.length===v.getRoot(b).length&&b[b.length-1]===C}else{C="/";const b=h.path;D=b.length===1&&b.charCodeAt(b.length-1)===47}return!D&&!e.hasTrailingPathSeparator(h,C)?h.with({path:h.path+"/"}):h}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(g=>g.scheme===O.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new w(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(g,h){const C=[];for(let D=0;D<g.length;D++){const b=h(g[D]);g.some((I,p)=>p===D?!1:e.isEqualOrParent(b,h(I)))||C.push(g[D])}return C}e.distinctParents=n;var m;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function h(C){const D=new Map;C.path.substring(C.path.indexOf(";")+1,C.path.lastIndexOf(";")).split(";").forEach(p=>{const[s,a]=p.split(":");s&&a&&D.set(s,a)});const I=C.path.substring(0,C.path.indexOf(";"));return I&&D.set(g.META_DATA_MIME,I),D}g.parseMetaData=h})(m=e.DataUri||(e.DataUri={}));function d(g,h,C){if(h){let D=g.path;return D&&D[0]!==k.posix.sep&&(D=k.posix.sep+D),g.with({scheme:C,authority:h,path:D})}return g.with({scheme:C})}e.toLocalResource=d}),define(Z[6],ee([0,1,29,11,3,2,14]),function(K,e,v,k,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(j){return!!j&&typeof j.then=="function"}e.isThenable=P;function S(j){const q=new v.CancellationTokenSource,R=j(q.token),T=new Promise((M,N)=>{q.token.onCancellationRequested(()=>{N(k.canceled())}),Promise.resolve(R).then(B=>{q.dispose(),M(B)},B=>{q.dispose(),N(B)})});return new class{cancel(){q.cancel()}then(M,N){return T.then(M,N)}catch(M){return this.then(void 0,M)}finally(M){return T.finally(M)}}}e.createCancelablePromise=S;function w(j,q,R){return Promise.race([j,new Promise(T=>q.onCancellationRequested(()=>T(R)))])}e.raceCancellation=w;async function n(j){let q=-1;const R=j.map((M,N)=>M.then(B=>(q=N,B))),T=await Promise.race(R);return j.forEach((M,N)=>{N!==q&&M.cancel()}),T}e.raceCancellablePromises=n;function m(j,q,R){let T;const M=setTimeout(()=>{T?.(void 0),R?.()},q);return Promise.race([j.finally(()=>clearTimeout(M)),new Promise(N=>T=N)])}e.raceTimeout=m;function d(j){return new Promise((q,R)=>{const T=j();P(T)?T.then(q,R):q(T)})}e.asPromise=d;class g{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(q){if(this.activePromise){if(this.queuedPromiseFactory=q,!this.queuedPromise){const R=()=>{this.queuedPromise=null;const T=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,T};this.queuedPromise=new Promise(T=>{this.activePromise.then(R,R).then(T)})}return new Promise((R,T)=>{this.queuedPromise.then(R,T)})}return this.activePromise=q(),new Promise((R,T)=>{this.activePromise.then(M=>{this.activePromise=null,R(M)},M=>{this.activePromise=null,T(M)})})}}e.Throttler=g;class h{constructor(){this.current=Promise.resolve(null)}queue(q){return this.current=this.current.then(()=>q(),()=>q())}}e.Sequencer=h;class C{constructor(){this.promiseMap=new Map}queue(q,R){const M=(this.promiseMap.get(q)??Promise.resolve()).catch(()=>{}).then(R).finally(()=>{this.promiseMap.get(q)===M&&this.promiseMap.delete(q)});return this.promiseMap.set(q,M),M}}e.SequencerByKey=C;class D{constructor(q){this.defaultDelay=q,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(q,R=this.defaultDelay){return this.task=q,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((T,M)=>{this.doResolve=T,this.doReject=M}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const T=this.task;return this.task=null,T()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},R),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(k.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=D;class b{constructor(q){this.delayer=new D(q),this.throttler=new g}trigger(q,R){return this.delayer.trigger(()=>this.throttler.queue(q),R)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=b;class I{constructor(){this._isOpen=!1,this._promise=new Promise((q,R)=>{this._completePromise=q})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=I;class p extends I{constructor(q){super();this._timeout=setTimeout(()=>this.open(),q)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=p;function s(j,q){return q?new Promise((R,T)=>{const M=setTimeout(R,j);q.onCancellationRequested(()=>{clearTimeout(M),T(k.canceled())})}):S(R=>s(j,R))}e.timeout=s;function a(j,q=0){const R=setTimeout(j,q);return A.toDisposable(()=>clearTimeout(R))}e.disposableTimeout=a;function t(j){return j.then(void 0,q=>{})}e.ignoreErrors=t;function r(j){const q=[];let R=0;const T=j.length;function M(){return R<T?j[R++]():null}function N(B){B!=null&&q.push(B);const G=M();return G?G.then(N):Promise.resolve(q)}return Promise.resolve(null).then(N)}e.sequence=r;function i(j,q=T=>!!T,R=null){let T=0;const M=j.length,N=()=>{if(T>=M)return Promise.resolve(R);const B=j[T++];return Promise.resolve(B()).then(Q=>q(Q)?Promise.resolve(Q):N())};return N()}e.first=i;function o(j,q=T=>!!T,R=null){if(j.length===0)return Promise.resolve(R);let T=j.length;const M=()=>{T=-1;for(const N of j)N.cancel?.()};return new Promise((N,B)=>{for(const G of j)G.then(Q=>{--T>=0&&q(Q)?(M(),N(Q)):T===0&&N(R)}).catch(Q=>{--T>=0&&(M(),B(Q))})})}e.firstParallel=o;class u{constructor(q){this._size=0,this.maxDegreeOfParalellism=q,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new L.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(q){return this._size++,new Promise((R,T)=>{this.outstandingPromises.push({factory:q,c:R,e:T}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const q=this.outstandingPromises.shift();this.runningPromises++;const R=q.factory();R.then(q.c,q.e),R.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=u;class c extends u{constructor(){super(1)}}e.Queue=c;class l{constructor(){this.queues=new Map}queueFor(q,R=O.extUri){const T=R.getComparisonKey(q);let M=this.queues.get(T);return M||(M=new c,L.Event.once(M.onFinished)(()=>{M?.dispose(),this.queues.delete(T)}),this.queues.set(T,M)),M}dispose(){this.queues.forEach(q=>q.dispose()),this.queues.clear()}}e.ResourceQueue=l;class y{constructor(q,R){this._token=-1,typeof q=="function"&&typeof R=="number"&&this.setIfNotSet(q,R)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(q,R){this.cancel(),this._token=setTimeout(()=>{this._token=-1,q()},R)}setIfNotSet(q,R){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,q()},R))}}e.TimeoutTimer=y;class E{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(q,R){this.cancel(),this._token=setInterval(()=>{q()},R)}}e.IntervalTimer=E;class f{constructor(q,R){this.timeoutToken=-1,this.runner=q,this.timeout=R,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(q=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,q)}get delay(){return this.timeout}set delay(q){this.timeout=q}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=f;class U extends f{constructor(q,R){super(q,R);this.units=[]}work(q){this.units.push(q),this.isScheduled()||this.schedule()}doRun(){const q=this.units;this.units=[],this.runner&&this.runner(q)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=U;class F extends A.Disposable{constructor(q,R,T,M){super();this.maxWorkChunkSize=q,this.maxPendingWork=R,this.throttleDelay=T,this.handler=M,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(q){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+q.length>this.maxPendingWork)return!1}else if(this.pending+q.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...q),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new f(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=F,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const j=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=q=>{const R=setTimeout(()=>q(j));let T=!1;return{dispose(){T||(T=!0,clearTimeout(R))}}}}else e.runWhenIdle=(j,q)=>{const R=requestIdleCallback(j,typeof q=="number"?{timeout:q}:void 0);let T=!1;return{dispose(){T||(T=!0,cancelIdleCallback(R))}}}}();class z{constructor(q){this._didRun=!1,this._executor=()=>{try{this._value=q()}catch(R){this._error=R}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=z;async function $(j,q,R){let T;for(let M=0;M<R;M++)try{return await j()}catch(N){T=N,await s(q)}throw T}e.retry=$;class H{hasPending(q){return this._pending?typeof q=="number"?this._pending.taskId===q:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(q,R,T){return this._pending={taskId:q,cancel:()=>T?.(),promise:R},R.then(()=>this.donePending(q),()=>this.donePending(q)),R}donePending(q){this._pending&&q===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const q=this._next;this._next=void 0,q.run().then(q.promiseResolve,q.promiseReject)}}setNext(q){if(this._next)this._next.run=q;else{let R,T;const M=new Promise((N,B)=>{R=N,T=B});this._next={run:q,promise:M,promiseResolve:R,promiseReject:T}}return this._next.promise}}e.TaskSequentializer=H;class V{constructor(q){this.interval=q,this.lastIncrementTime=0,this.value=0}increment(){const q=Date.now();return q-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=q,this.value=0),this.value++,this.value}}e.IntervalCounter=V;class _{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((q,R)=>{this.completeCallback=q,this.errorCallback=R})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(q){return new Promise(R=>{this.completeCallback(q),this.resolved=!0,R()})}error(q){return new Promise(R=>{this.errorCallback(q),this.rejected=!0,R()})}cancel(){new Promise(q=>{this.errorCallback(k.canceled()),this.rejected=!0,q()})}}e.DeferredPromise=_;var x;(function(j){async function q(R){let T;const M=await Promise.all(R.map(N=>N.then(B=>B,B=>{T||(T=B)})));if(typeof T!="undefined")throw T;return M}j.settled=q})(x=e.Promises||(e.Promises={}))}),define(Z[67],ee([0,1,20,41,8,38,6]),function(K,e,v,k,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const S="**",w="/",n="[/\\\\]",m="[^/\\\\]",d=/\//g;function g(T){switch(T){case 0:return"";case 1:return`${m}*?`;default:return`(?:${n}|${m}+${n}|${n}${m}+)*?`}}function h(T,M){if(!T)return[];const N=[];let B=!1,G=!1,Q="";for(const X of T){switch(X){case M:if(!B&&!G){N.push(Q),Q="";continue}break;case"{":B=!0;break;case"}":B=!1;break;case"[":G=!0;break;case"]":G=!1;break}Q+=X}return Q&&N.push(Q),N}e.splitGlobAware=h;function C(T){if(!T)return"";let M="";const N=h(T,w);if(N.every(B=>B===S))M=".*";else{let B=!1;N.forEach((G,Q)=>{if(G===S){B||(M+=g(2),B=!0);return}let X=!1,ie="",ne=!1,oe="";for(const he of G){if(he!=="}"&&X){ie+=he;continue}if(ne&&(he!=="]"||!oe)){let me;he==="-"?me=he:(he==="^"||he==="!")&&!oe?me="^":he===w?me="":me=v.escapeRegExpCharacters(he),oe+=me;continue}switch(he){case"{":X=!0;continue;case"[":ne=!0;continue;case"}":M+=`(?:${h(ie,",").map(Ie=>C(Ie)).join("|")})`,X=!1,ie="";break;case"]":M+="["+oe+"]",ne=!1,oe="";break;case"?":M+=m;continue;case"*":M+=g(1);continue;default:M+=v.escapeRegExpCharacters(he)}}Q<N.length-1&&(N[Q+1]!==S||Q+2<N.length)&&(M+=n),B=!1})}return M}const D=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,p=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new A.LRUCache(1e4),r=function(){return!1},i=function(){return null};function o(T,M){if(!T)return i;let N;typeof T!="string"?N=T.pattern:N=T,N=N.trim();const B=`${N}_${!!M.trimForExclusions}`;let G=t.get(B);if(G)return u(G,T);let Q;if(D.test(N)){const X=N.substr(4);G=function(ie,ne){return typeof ie=="string"&&ie.endsWith(X)?N:null}}else(Q=b.exec(c(N,M)))?G=l(Q[1],N):(M.trimForExclusions?p:I).test(N)?G=y(N,M):(Q=s.exec(c(N,M)))?G=E(Q[1].substr(1),N,!0):(Q=a.exec(c(N,M)))?G=E(Q[1],N,!1):G=f(N);return t.set(B,G),u(G,T)}function u(T,M){return typeof M=="string"?T:function(N,B){return k.isEqualOrParent(N,M.base)?T(L.relative(M.base,N),B):null}}function c(T,M){return M.trimForExclusions&&T.endsWith("/**")?T.substr(0,T.length-2):T}function l(T,M){const N=`/${T}`,B=`\\${T}`,G=function(X,ie){return typeof X!="string"?null:ie?ie===T?M:null:X===T||X.endsWith(N)||X.endsWith(B)?M:null},Q=[T];return G.basenames=Q,G.patterns=[M],G.allBasenames=Q,G}function y(T,M){const N=R(T.slice(1,-1).split(",").map(ie=>o(ie,M)).filter(ie=>ie!==i),T),B=N.length;if(!B)return i;if(B===1)return N[0];const G=function(ie,ne){for(let oe=0,he=N.length;oe<he;oe++)if(N[oe](ie,ne))return T;return null},Q=N.find(ie=>!!ie.allBasenames);Q&&(G.allBasenames=Q.allBasenames);const X=N.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return X.length&&(G.allPaths=X),G}function E(T,M,N){const B=L.sep===L.posix.sep,G=B?T:T.replace(d,L.sep),Q=L.sep+G,X=L.posix.sep+T,ie=N?function(ne,oe){return typeof ne=="string"&&(ne===G||ne.endsWith(Q)||!B&&(ne===T||ne.endsWith(X)))?M:null}:function(ne,oe){return typeof ne=="string"&&(ne===G||!B&&ne===T)?M:null};return ie.allPaths=[(N?"*/":"./")+T],ie}function f(T){try{const M=new RegExp(`^${C(T)}$`);return function(N){return M.lastIndex=0,typeof N=="string"&&M.test(N)?T:null}}catch(M){return i}}function U(T,M,N){return!T||typeof M!="string"?!1:F(T)(M,void 0,N)}e.match=U;function F(T,M={}){if(!T)return r;if(typeof T=="string"||V(T)){const N=o(T,M);if(N===i)return r;const B=function(G,Q){return!!N(G,Q)};return N.allBasenames&&(B.allBasenames=N.allBasenames),N.allPaths&&(B.allPaths=N.allPaths),B}return j(T,M)}e.parse=F;function z(T){if(!T)return;let M;return N=>(M||(M=(T()||Promise.resolve([])).then(B=>B?H(B):{})),M.then(B=>!!B[N]))}e.hasSiblingPromiseFn=z;function $(T){if(!T)return;let M;return N=>{if(!M){const B=T();M=B?H(B):{}}return!!M[N]}}e.hasSiblingFn=$;function H(T){const M={};for(const N of T)M[N]=!0;return M}function V(T){const M=T;return M&&typeof M.base=="string"&&typeof M.pattern=="string"}e.isRelativePattern=V;function _(T){return T.allBasenames||[]}e.getBasenameTerms=_;function x(T){return T.allPaths||[]}e.getPathTerms=x;function j(T,M){const N=R(Object.getOwnPropertyNames(T).map(ie=>q(ie,T[ie],M)).filter(ie=>ie!==i)),B=N.length;if(!B)return i;if(!N.some(ie=>!!ie.requiresSiblings)){if(B===1)return N[0];const ie=function(he,me){for(let pe=0,Ie=N.length;pe<Ie;pe++){const Re=N[pe](he,me);if(Re)return Re}return null},ne=N.find(he=>!!he.allBasenames);ne&&(ie.allBasenames=ne.allBasenames);const oe=N.reduce((he,me)=>me.allPaths?he.concat(me.allPaths):he,[]);return oe.length&&(ie.allPaths=oe),ie}const G=function(ie,ne,oe){let he;for(let me=0,pe=N.length;me<pe;me++){const Ie=N[me];Ie.requiresSiblings&&oe&&(ne||(ne=L.basename(ie)),he||(he=ne.substr(0,ne.length-L.extname(ie).length)));const Re=Ie(ie,ne,he,oe);if(Re)return Re}return null},Q=N.find(ie=>!!ie.allBasenames);Q&&(G.allBasenames=Q.allBasenames);const X=N.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return X.length&&(G.allPaths=X),G}function q(T,M,N){if(M===!1)return i;const B=o(T,N);if(B===i)return i;if(typeof M=="boolean")return B;if(M){const G=M.when;if(typeof G=="string"){const Q=(X,ie,ne,oe)=>{if(!oe||!B(X,ie))return null;const he=G.replace("$(basename)",ne),me=oe(he);return O.isThenable(me)?me.then(pe=>pe?T:null):me?T:null};return Q.requiresSiblings=!0,Q}}return B}function R(T,M){const N=T.filter(ie=>!!ie.basenames);if(N.length<2)return T;const B=N.reduce((ie,ne)=>{const oe=ne.basenames;return oe?ie.concat(oe):ie},[]);let G;if(M){G=[];for(let ie=0,ne=B.length;ie<ne;ie++)G.push(M)}else G=N.reduce((ie,ne)=>{const oe=ne.patterns;return oe?ie.concat(oe):ie},[]);const Q=function(ie,ne){if(typeof ie!="string")return null;if(!ne){let he;for(he=ie.length;he>0;he--){const me=ie.charCodeAt(he-1);if(me===47||me===92)break}ne=ie.substr(he)}const oe=B.indexOf(ne);return oe!==-1?G[oe]:null};Q.basenames=B,Q.patterns=G,Q.allBasenames=B;const X=T.filter(ie=>!ie.basenames);return X.push(Q),X}}),define(Z[92],ee([0,1,8,20,67,17,14]),function(K,e,v,k,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let S=[],w=[],n=[];function m(r,i=!1){const o=d(r);S.push(o),o.userConfigured?n.push(o):w.push(o),i&&!o.userConfigured&&S.forEach(u=>{u.mime===o.mime||u.userConfigured||(o.extension&&u.extension===o.extension&&console.warn(`Overwriting extension <<${o.extension}>> to now point to mime <<${o.mime}>>`),o.filename&&u.filename===o.filename&&console.warn(`Overwriting filename <<${o.filename}>> to now point to mime <<${o.mime}>>`),o.filepattern&&u.filepattern===o.filepattern&&console.warn(`Overwriting filepattern <<${o.filepattern}>> to now point to mime <<${o.mime}>>`),o.firstline&&u.firstline===o.firstline&&console.warn(`Overwriting firstline <<${o.firstline}>> to now point to mime <<${o.mime}>>`))})}e.registerTextMime=m;function d(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(v.posix.sep)>=0:!1}}function g(r){r?(S=S.filter(i=>!i.userConfigured),n=[]):(S=[],w=[],n=[])}e.clearTextMimes=g;function h(r,i){let o;if(r)switch(r.scheme){case A.Schemas.file:o=r.fsPath;break;case A.Schemas.data:o=O.DataUri.parseMetaData(r).get(O.DataUri.META_DATA_LABEL);break;default:o=r.path}if(!o)return[P.unknown];o=o.toLowerCase();const u=v.basename(o),c=C(o,u,n);if(c)return[c,P.text];const l=C(o,u,w);if(l)return[l,P.text];if(i){const y=D(i);if(y)return[y,P.text]}return[P.unknown]}e.guessMimeTypes=h;function C(r,i,o){let u=null,c=null,l=null;for(let y=o.length-1;y>=0;y--){const E=o[y];if(i===E.filenameLowercase){u=E;break}if(E.filepattern&&(!c||E.filepattern.length>c.filepattern.length)){const f=E.filepatternOnPath?r:i;L.match(E.filepatternLowercase,f)&&(c=E)}E.extension&&(!l||E.extension.length>l.extension.length)&&i.endsWith(E.extensionLowercase)&&(l=E)}return u?u.mime:c?c.mime:l?l.mime:null}function D(r){if(k.startsWithUTF8BOM(r)&&(r=r.substr(1)),r.length>0)for(let i=S.length-1;i>=0;i--){const o=S[i];if(!o.firstline)continue;const u=r.match(o.firstline);if(u&&u.length>0)return o.mime}return null}function b(r){return r?typeof r=="string"?r===P.binary||r===P.text||r===P.unknown:r.length===1&&b(r[0]):!0}e.isUnspecific=b;const I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function p(r){const i=v.extname(r);return I[i.toLowerCase()]}e.getMediaMime=p;function s(r){for(const i in I)if(I[i]===r)return i}e.getExtensionForMimeType=s;const a=/^(.+)\/(.+?)(;.+)?$/;function t(r,i){const o=a.exec(r);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${o[3]??""}`:i?void 0:r}e.normalizeMimeType=t}),define(Z[93],ee([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(n){return n.toJSON()}class L{constructor(m){this._uriTransformer=m}transformIncoming(m){const d=this._uriTransformer.transformIncoming(m);return d===m?m:k(v.URI.from(d))}transformOutgoing(m){const d=this._uriTransformer.transformOutgoing(m);return d===m?m:k(v.URI.from(d))}transformOutgoingURI(m){const d=this._uriTransformer.transformOutgoing(m);return d===m?m:v.URI.from(d)}transformOutgoingScheme(m){return this._uriTransformer.transformOutgoingScheme(m)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function A(n,m,d){if(!n||d>200)return null;if(typeof n=="object"){if(n instanceof v.URI)return m.transformOutgoing(n);for(let g in n)if(Object.hasOwnProperty.call(n,g)){const h=A(n[g],m,d+1);h!==null&&(n[g]=h)}}return null}function O(n,m){const d=A(n,m,0);return d===null?n:d}e.transformOutgoingURIs=O;function P(n,m,d,g){if(!n||g>200)return null;if(typeof n=="object"){if(n.$mid===1)return d?v.URI.revive(m.transformIncoming(n)):m.transformIncoming(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const C=P(n[h],m,d,g+1);C!==null&&(n[h]=C)}}return null}function S(n,m){const d=P(n,m,!1,0);return d===null?n:d}e.transformIncomingURIs=S;function w(n,m){const d=P(n,m,!0,0);return d===null?n:d}e.transformAndReviveIncomingURIs=w}),define(Z[30],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const v=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(S){return v.test(S)}e.isUUID=k;const L=new Uint8Array(16),A=[];for(let S=0;S<256;S++)A.push(S.toString(16).padStart(2,"0"));let O;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?O=crypto.getRandomValues.bind(crypto):O=function(S){for(let w=0;w<S.length;w++)S[w]=Math.floor(Math.random()*256);return S};function P(){O(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let S=0,w="";return w+=A[L[S++]],w+=A[L[S++]],w+=A[L[S++]],w+=A[L[S++]],w+="-",w+=A[L[S++]],w+=A[L[S++]],w+="-",w+=A[L[S++]],w+=A[L[S++]],w+="-",w+=A[L[S++]],w+=A[L[S++]],w+="-",w+=A[L[S++]],w+=A[L[S++]],w+=A[L[S++]],w+=A[L[S++]],w+=A[L[S++]],w+=A[L[S++]],w}e.generateUuid=P}),define(Z[68],ee([0,1,207]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class k{constructor(A="utf8"){this.stringDecoder=new v.StringDecoder(A),this.remaining=null}write(A){const O=[],P=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(P.length<1)return O;let S=0,w,n=S;for(;n<P.length;)if(w=P.charCodeAt(n),w===13||w===10){if(O.push(P.substring(S,n)),n++,n<P.length){const m=w;w=P.charCodeAt(n),(m===13&&w===10||m===10&&w===13)&&n++}S=n}else n++;return this.remaining=S<P.length?P.substr(S):null,O}end(){return this.remaining}}e.LineDecoder=k}),define(Z[94],ee([0,1,35]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const k=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function L(P){const S=P.replace(/\-/g,":").toLowerCase();return!k.has(S)}function A(){return new Promise(async(P,S)=>{const w=setTimeout(()=>S("Unable to retrieve mac address (timeout after 10s)"),1e4);try{P(await O())}catch(n){S(n)}finally{clearTimeout(w)}})}e.getMac=A;function O(){return new Promise((P,S)=>{try{const w=v.networkInterfaces();for(let n in w){const m=w[n];if(m){for(const{mac:d}of m)if(L(d))return P(d)}}S("Unable to retrieve mac address (unexpected format)")}catch(w){S(w)}})}}),define(Z[95],ee([0,1,11,30,35,38,94]),function(K,e,v,k,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=A.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,m=0;const d=L.networkInterfaces();for(let g in d){const h=d[g];if(h)for(const{mac:C,internal:D}of h)D||(m+=1,this._isVirtualMachineMacAdress(C.toUpperCase())&&(n+=1))}this._value=m>0?n/m:0}return this._value}};let P;async function S(){return P||(P=(async()=>await w()||k.generateUuid())()),P}e.getMachineId=S;async function w(){try{const n=await new Promise((d,g)=>{K(["crypto"],d,g)}),m=await O.getMac();return n.createHash("sha256").update(m,"utf8").digest("hex")}catch(n){v.onUnexpectedError(n);return}}}),define(Z[18],ee([0,1,48,35,208,8,6,7,41,30,66,14,5]),function(K,e,v,k,L,A,O,P,S,w,n,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var g;(function(_){_[_.UNLINK=0]="UNLINK",_[_.MOVE=1]="MOVE"})(g=e.RimRafMode||(e.RimRafMode={}));async function h(_,x=g.UNLINK){if(S.isRootOrDriveLetter(_))throw new Error("rimraf - will refuse to recursively delete root");return x===g.UNLINK?D(_):C(_)}async function C(_){try{const x=A.join(k.tmpdir(),w.generateUuid());try{await e.Promises.rename(_,x)}catch(j){return D(_)}D(x).catch(j=>{})}catch(x){if(x.code!=="ENOENT")throw x}}async function D(_){return e.Promises.rmdir(_,{recursive:!0,maxRetries:3})}function b(_){if(S.isRootOrDriveLetter(_))throw new Error("rimraf - will refuse to recursively delete root");v.rmdirSync(_,{recursive:!0})}e.rimrafSync=b;async function I(_,x){return a(await(x?p(_):L.promisify(v.readdir)(_)))}async function p(_){try{return await L.promisify(v.readdir)(_,{withFileTypes:!0})}catch(q){console.warn("[node.js fs] readdir with filetypes failed with error: ",q)}const x=[],j=await I(_);for(const q of j){let R=!1,T=!1,M=!1;try{const N=await e.Promises.lstat(A.join(_,q));R=N.isFile(),T=N.isDirectory(),M=N.isSymbolicLink()}catch(N){console.warn("[node.js fs] unexpected error from lstat after readdir: ",N)}x.push({name:q,isFile:()=>R,isDirectory:()=>T,isSymbolicLink:()=>M})}return x}function s(_){return a(v.readdirSync(_))}e.readdirSync=s;function a(_){return _.map(x=>typeof x=="string"?P.isMacintosh?n.normalizeNFC(x):x:(x.name=P.isMacintosh?n.normalizeNFC(x.name):x.name,x))}async function t(_){const x=await I(_),j=[];for(const q of x)await i.existsDirectory(A.join(_,q))&&j.push(q);return j}function r(_,x=1e3){return new Promise(j=>{let q=!1;const R=setInterval(()=>{q||(q=!0,v.access(_,T=>{q=!1,T&&(clearInterval(R),j(void 0))}))},x)})}e.whenDeleted=r;var i;(function(_){async function x(R){let T;try{if(T=await e.Promises.lstat(R),!T.isSymbolicLink())return{stat:T}}catch(M){}try{return{stat:await e.Promises.stat(R),symbolicLink:T?.isSymbolicLink()?{dangling:!1}:void 0}}catch(M){if(M.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};if(P.isWindows&&M.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(R)),symbolicLink:{dangling:!1}}}catch(N){if(N.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};throw N}throw M}}_.stat=x;async function j(R){try{const{stat:T,symbolicLink:M}=await _.stat(R);return T.isFile()&&M?.dangling!==!0}catch(T){}return!1}_.existsFile=j;async function q(R){try{const{stat:T,symbolicLink:M}=await _.stat(R);return T.isDirectory()&&M?.dangling!==!0}catch(T){}return!1}_.existsDirectory=q})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const o=new O.ResourceQueue;function u(_,x,j){return o.queueFor(d.URI.file(_),m.extUriBiasedIgnorePathCase).queue(()=>{const q=E(j);return new Promise((R,T)=>l(_,x,q,M=>M?T(M):R()))})}let c=!0;function l(_,x,j,q){if(!c)return v.writeFile(_,x,{mode:j.mode,flag:j.flag},q);v.open(_,j.flag,j.mode,(R,T)=>{if(R)return q(R);v.writeFile(T,x,M=>{if(M)return v.close(T,()=>q(M));v.fdatasync(T,N=>(N&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",N),c=!1),v.close(T,B=>q(B))))})})}function y(_,x,j){const q=E(j);if(!c)return v.writeFileSync(_,x,{mode:q.mode,flag:q.flag});const R=v.openSync(_,q.flag,q.mode);try{v.writeFileSync(R,x);try{v.fdatasyncSync(R)}catch(T){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",T),c=!1}}finally{v.closeSync(R)}}e.writeFileSync=y;function E(_){return _?{mode:typeof _.mode=="number"?_.mode:438,flag:typeof _.flag=="string"?_.flag:"w"}:{mode:438,flag:"w"}}async function f(_,x){if(_===x)return;async function j(q){try{const R=await e.Promises.lstat(q);if(R.isDirectory()||R.isSymbolicLink())return;await e.Promises.utimes(q,R.atime,new Date)}catch(R){}}try{await e.Promises.rename(_,x),await j(x)}catch(q){if(_.toLowerCase()!==x.toLowerCase()&&q.code==="EXDEV"||_.endsWith("."))await U(_,x,{preserveSymlinks:!1}),await h(_,g.MOVE),await j(x);else throw q}}async function U(_,x,j){return z(_,x,{root:{source:_,target:x},options:j,handledSourcePaths:new Set})}const F=511;async function z(_,x,j){if(j.handledSourcePaths.has(_))return;j.handledSourcePaths.add(_);const{stat:q,symbolicLink:R}=await i.stat(_);if(R){if(j.options.preserveSymlinks)try{return await V(_,x,j)}catch(T){console.warn("[node.js fs] copy of symlink failed: ",T)}if(R.dangling)return}return q.isDirectory()?$(_,x,q.mode&F,j):H(_,x,q.mode&F)}async function $(_,x,j,q){await e.Promises.mkdir(x,{recursive:!0,mode:j});const R=await I(_);for(const T of R)await z(A.join(_,T),A.join(x,T),q)}async function H(_,x,j){await e.Promises.copyFile(_,x),await e.Promises.chmod(x,j)}async function V(_,x,j){let q=await e.Promises.readlink(_);S.isEqualOrParent(q,j.root.source,!P.isLinux)&&(q=A.join(j.root.target,q.substr(j.root.source.length+1))),await e.Promises.symlink(q,x)}e.Promises=new class{get access(){return L.promisify(v.access)}get stat(){return L.promisify(v.stat)}get lstat(){return L.promisify(v.lstat)}get utimes(){return L.promisify(v.utimes)}get read(){return L.promisify(v.read)}get readFile(){return L.promisify(v.readFile)}get write(){return L.promisify(v.write)}get appendFile(){return L.promisify(v.appendFile)}get fdatasync(){return L.promisify(v.fdatasync)}get truncate(){return L.promisify(v.truncate)}get rename(){return L.promisify(v.rename)}get copyFile(){return L.promisify(v.copyFile)}get open(){return L.promisify(v.open)}get close(){return L.promisify(v.close)}get symlink(){return L.promisify(v.symlink)}get readlink(){return L.promisify(v.readlink)}get chmod(){return L.promisify(v.chmod)}get mkdir(){return L.promisify(v.mkdir)}get unlink(){return L.promisify(v.unlink)}get rmdir(){return L.promisify(v.rmdir)}get realpath(){return L.promisify(v.realpath)}async exists(_){try{return await e.Promises.access(_),!0}catch{return!1}}get readdir(){return I}get readDirsInDir(){return t}get writeFile(){return u}get rm(){return h}get move(){return f}get copy(){return U}}}),define(Z[96],ee([0,1,48,20,8,18]),function(K,e,v,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function O(n){const m=L.dirname(n);if(n===m)return n;const d=(L.basename(n)||n).toLowerCase();try{const h=A.readdirSync(m).filter(C=>C.toLowerCase()===d);if(h.length===1){const C=O(m);if(C)return L.join(C,h[0])}else if(h.length>1){const C=h.indexOf(d);if(C>=0){const D=O(m);if(D)return L.join(D,h[C])}}}catch(g){}return null}e.realcaseSync=O;async function P(n){try{return await A.Promises.realpath(n)}catch(m){const d=w(n);return await A.Promises.access(d,v.constants.R_OK),d}}e.realpath=P;function S(n){try{return v.realpathSync(n)}catch(m){const d=w(n);return v.accessSync(d,v.constants.R_OK),d}}e.realpathSync=S;function w(n){return k.rtrim(L.normalize(n),L.sep)}}),define(Z[97],ee([0,1,18,35,8]),function(K,e,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,O=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var S;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(S||(S={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class m{constructor(a,t,r){this.exePath=a,this.displayName=t,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await v.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:s=!1}={}){return s?w===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:s=!1,findPreview:a=!1}={}){const t=d({useAlternateBitness:s});if(!t)return null;const r=L.join(t,"PowerShell");if(!await v.SymlinkSupport.existsDirectory(r))return null;let i=-1,o=null;for(const l of await v.Promises.readdir(r)){let y=-1;if(a){const f=l.indexOf("-");if(f<0)continue;const U=l.substring(0,f);if(!A.test(U)||l.substring(f+1)!=="preview")continue;y=parseInt(U,10)}else{if(!A.test(l))continue;y=parseInt(l,10)}if(y<=i)continue;const E=L.join(r,l,"pwsh.exe");!await v.SymlinkSupport.existsFile(E)||(o=E,i=y)}if(!o)return null;const u=t.includes("x86")?" (x86)":"",c=a?" Preview":"";return new m(o,`PowerShell${c}${u}`,!0)}async function h({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const a=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await v.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=s?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:O,pwshMsixName:"PowerShell (Store)"};for(const i of await v.Promises.readdir(a))if(t.test(i)){const o=L.join(a,i,"pwsh.exe");return new m(o,r)}return null}function C(){const s=L.join(k.homedir(),".dotnet","tools","pwsh.exe");return new m(s,".NET Core PowerShell Global Tool")}function D(){const s=L.join(process.env.windir,w===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new m(s,"Windows PowerShell",!0)}async function*b(){let s=await g();s&&(yield s),s=await g({useAlternateBitness:!0}),s&&(yield s),s=await h(),s&&(yield s),s=C(),s&&(yield s),s=await g({findPreview:!0}),s&&(yield s),s=await h({findPreview:!0}),s&&(yield s),s=await g({useAlternateBitness:!0,findPreview:!0}),s&&(yield s),s=D(),s&&(yield s)}async function*I(){for await(const s of b())await s.exists()&&(yield s)}e.enumeratePowerShellInstallations=I;async function p(){for await(const s of I())return s;return null}e.getFirstAvailablePowerShellInstallation=p}),define(Z[98],ee([0,1,42,17]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function L(O){return new Promise((P,S)=>{let w;const n=new Map;function m(g,h,C,D,b){const I=n.get(h);if(g===O||I){const p={name:d(C),cmd:C,pid:g,ppid:h,load:D,mem:b};n.set(g,p),g===O&&(w=p),I&&(I.children||(I.children=[]),I.children.push(p),I.children.length>1&&(I.children=I.children.sort((s,a)=>s.pid-a.pid)))}}function d(g){const h=/--disable-blink-features=Auxclick/,C=/\\watcher\\win32\\CodeHelper\.exe/,D=/--crashes-directory/,b=/\\pipe\\winpty-control/,I=/conhost\.exe/,p=/--type=([a-zA-Z-]+)/;if(C.exec(g))return"watcherService ";if(D.exec(g))return"electron-crash-reporter";if(b.exec(g))return"winpty-process";if(I.exec(g))return"console-window-host (Windows internal process)";let s=p.exec(g);if(s&&s.length===2)return s[1]==="renderer"?h.exec(g)?"shared-process":"window":s[1];const a=/[a-zA-Z-]+\.js/g;let t="";do s=a.exec(g),s&&(t+=s+" ");while(s);return t&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron_node ${t}`:g}if(process.platform==="win32"){const g=h=>h.indexOf("\\\\?\\")===0||h.indexOf("\\??\\")===0?h.substr(4):h.indexOf('"\\\\?\\')===0||h.indexOf('"\\??\\')===0?'"'+h.substr(5):h;new Promise((h,C)=>{K(["windows-process-tree"],h,C)}).then(h=>{h.getProcessList(O,C=>{h.getProcessCpuUsage(C,D=>{const b=new Map;D.forEach(I=>{const p=g(I.commandLine||"");b.set(I.pid,{name:d(p),cmd:p,pid:I.pid,ppid:I.ppid,load:I.cpu||0,mem:I.memory||0})}),w=b.get(O),w?(b.forEach(I=>{const p=b.get(I.ppid);p&&(p.children||(p.children=[]),p.children.push(I))}),b.forEach(I=>{I.children&&(I.children=I.children.sort((p,s)=>p.pid-s.pid))}),P(w)):S(new Error(`Root process ${O} not found`))})},h.ProcessDataFlag.CommandLine|h.ProcessDataFlag.Memory)})}else{let g=function(){let h=[w];const C=[];for(;h.length;){const b=h.shift();b&&(C.push(b.pid),b.children&&(h=h.concat(b.children)))}let D=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",K).fsPath);D+=" "+C.join(" "),v.exec(D,{},(b,I,p)=>{if(b||p)S(b||new Error(p.toString()));else{const s=I.toString().split(`
`);for(let a=0;a<C.length;a++){const t=n.get(C[a]);t.load=parseFloat(s[a])}if(!w){S(new Error(`Root process ${O} not found`));return}P(w)}})};v.exec("which ps",{},(h,C,D)=>{if(h||D)if(process.platform!=="linux")S(h||new Error(D.toString()));else{const b=JSON.stringify(k.FileAccess.asFileUri("vs/base/node/ps.sh",K).fsPath);v.exec(b,{},(I,p,s)=>{I||s?S(I||new Error(s.toString())):(A(p,m),g())})}else{const b=C.toString().trim(),I="-ax -o pid=,ppid=,pcpu=,pmem=,command=";v.exec(`${b} ${I}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(p,s,a)=>{p||a&&!a.includes("screen size is bogus")?S(p||new Error(a.toString())):(A(s,m),process.platform==="linux"?g():w?P(w):S(new Error(`Root process ${O} not found`)))})}})}})}e.listProcesses=L;function A(O,P){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=O.toString().split(`
`);for(const n of w){const m=S.exec(n.trim());m&&m.length===6&&P(parseInt(m[1]),parseInt(m[2]),m[5],parseFloat(m[3]),parseFloat(m[4]))}}}),define(Z[99],ee([0,1,8,48,7,66,2,18]),function(K,e,v,k,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function S(m,d,g){return n({path:m,isDirectory:!1},d,g)}e.watchFile=S;function w(m,d,g){return n({path:m,isDirectory:!0},d,g)}e.watchFolder=w,e.CHANGE_BUFFER_DELAY=100;function n(m,d,g){const h=v.basename(m.path),C=new Map;let D=!1,b=[O.toDisposable(()=>{C.forEach(I=>O.dispose(I)),C.clear()})];try{const I=k.watch(m.path);b.push(O.toDisposable(()=>{I.removeAllListeners(),I.close()}));const p=new Set;m.isDirectory&&P.Promises.readdir(m.path).then(s=>s.forEach(a=>p.add(a))),I.on("error",(s,a)=>{D||g(`Failed to watch ${m.path} for changes using fs.watch() (${s}, ${a})`)}),I.on("change",(s,a)=>{if(D)return;let t="";if(a&&(t=a.toString(),L.isMacintosh&&(t=A.normalizeNFC(t))),!t||s!=="change"&&s!=="rename")return;const r=m.isDirectory?v.join(m.path,t):m.path;if(m.isDirectory)if(s==="rename"){const i=C.get(r);i&&O.dispose(i);const o=setTimeout(async()=>{C.delete(r);const u=await P.Promises.exists(r);if(D)return;let c;u?p.has(t)?c="changed":(c="added",p.add(t)):(p.delete(t),c="deleted"),d(c,r)},e.CHANGE_BUFFER_DELAY);C.set(r,O.toDisposable(()=>clearTimeout(o)))}else{let i;p.has(t)?i="changed":(i="added",p.add(t)),d(i,r)}else if(s==="rename"||t!==h){const i=setTimeout(async()=>{const o=await P.Promises.exists(r);D||(o?(d("changed",r),b=[n(m,d,g)]):d("deleted",r))},e.CHANGE_BUFFER_DELAY);O.dispose(b),b=[O.toDisposable(()=>clearTimeout(i))]}else d("changed",r)})}catch(I){P.Promises.exists(m.path).then(p=>{p&&!D&&g(`Failed to watch ${m.path} for changes using fs.watch() (${I.toString()})`)})}return O.toDisposable(()=>{D=!0,b=O.dispose(b)})}});var de=this&&this.__decorate||function(K,e,v,k){var L=arguments.length,A=L<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,v):k,O;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(K,e,v,k);else for(var P=K.length-1;P>=0;P--)(O=K[P])&&(A=(L<3?O(A):L>3?O(e,v,A):O(e,v))||A);return L>3&&A&&Object.defineProperty(e,v,A),A};define(Z[36],ee([0,1,3,2,6,29,11,25,19,16,91,20,64]),function(K,e,v,k,L,A,O,P,S,w,n,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var g;(function(R){R[R.Promise=100]="Promise",R[R.PromiseCancel=101]="PromiseCancel",R[R.EventListen=102]="EventListen",R[R.EventDispose=103]="EventDispose"})(g=e.RequestType||(e.RequestType={}));function h(R){switch(R){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var C;(function(R){R[R.Initialize=200]="Initialize",R[R.PromiseSuccess=201]="PromiseSuccess",R[R.PromiseError=202]="PromiseError",R[R.PromiseErrorObj=203]="PromiseErrorObj",R[R.EventFire=204]="EventFire"})(C=e.ResponseType||(e.ResponseType={}));function D(R){switch(R){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(R){R[R.Uninitialized=0]="Uninitialized",R[R.Idle=1]="Idle"})(b||(b={}));class I{constructor(T){this.buffer=T,this.pos=0}read(T){const M=this.buffer.slice(this.pos,this.pos+T);return this.pos+=M.byteLength,M}}class p{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(T){this.buffers.push(T)}}var s;(function(R){R[R.Undefined=0]="Undefined",R[R.String=1]="String",R[R.Buffer=2]="Buffer",R[R.VSBuffer=3]="VSBuffer",R[R.Array=4]="Array",R[R.Object=5]="Object"})(s||(s={}));function a(R){const T=P.VSBuffer.alloc(4);return T.writeUInt32BE(R,0),T}function t(R){return R.read(4).readUInt32BE(0)}function r(R){const T=P.VSBuffer.alloc(1);return T.writeUInt8(R,0),T}const i={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object)},o=typeof Buffer!="undefined";function u(R,T){if(typeof T=="undefined")R.write(i.Undefined);else if(typeof T=="string"){const M=P.VSBuffer.fromString(T);R.write(i.String),R.write(a(M.byteLength)),R.write(M)}else if(o&&Buffer.isBuffer(T)){const M=P.VSBuffer.wrap(T);R.write(i.Buffer),R.write(a(M.byteLength)),R.write(M)}else if(T instanceof P.VSBuffer)R.write(i.VSBuffer),R.write(a(T.byteLength)),R.write(T);else if(Array.isArray(T)){R.write(i.Array),R.write(a(T.length));for(const M of T)u(R,M)}else{const M=P.VSBuffer.fromString(JSON.stringify(T));R.write(i.Object),R.write(a(M.byteLength)),R.write(M)}}function c(R){switch(R.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return R.read(t(R)).toString();case s.Buffer:return R.read(t(R)).buffer;case s.VSBuffer:return R.read(t(R));case s.Array:{const M=t(R),N=[];for(let B=0;B<M;B++)N.push(c(R));return N}case s.Object:return JSON.parse(R.read(t(R)).toString())}}class l{constructor(T,M,N=null,B=1e3){this.protocol=T,this.ctx=M,this.logger=N,this.timeoutDelay=B,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(G=>this.onRawMessage(G)),this.sendResponse({type:200})}registerChannel(T,M){this.channels.set(T,M),setTimeout(()=>this.flushPendingRequests(T),0)}sendResponse(T){switch(T.type){case 200:{const M=this.send([T.type]);this.logger&&this.logger.logOutgoing(M,0,1,D(T.type));return}case 201:case 202:case 204:case 203:{const M=this.send([T.type,T.id],T.data);this.logger&&this.logger.logOutgoing(M,T.id,1,D(T.type),T.data);return}}}send(T,M=void 0){const N=new p;return u(N,T),u(N,M),this.sendBuffer(N.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(M){return 0}}onRawMessage(T){const M=new I(T),N=c(M),B=c(M),G=N[0];switch(G){case 100:return this.logger&&this.logger.logIncoming(T.byteLength,N[1],1,`${h(G)}: ${N[2]}.${N[3]}`,B),this.onPromise({type:G,id:N[1],channelName:N[2],name:N[3],arg:B});case 102:return this.logger&&this.logger.logIncoming(T.byteLength,N[1],1,`${h(G)}: ${N[2]}.${N[3]}`,B),this.onEventListen({type:G,id:N[1],channelName:N[2],name:N[3],arg:B});case 101:return this.logger&&this.logger.logIncoming(T.byteLength,N[1],1,`${h(G)}`),this.disposeActiveRequest({type:G,id:N[1]});case 103:return this.logger&&this.logger.logIncoming(T.byteLength,N[1],1,`${h(G)}`),this.disposeActiveRequest({type:G,id:N[1]})}}onPromise(T){const M=this.channels.get(T.channelName);if(!M){this.collectPendingRequest(T);return}const N=new A.CancellationTokenSource;let B;try{B=M.call(this.ctx,T.name,T.arg,N.token)}catch(X){B=Promise.reject(X)}const G=T.id;B.then(X=>{this.sendResponse({id:G,data:X,type:201}),this.activeRequests.delete(T.id)},X=>{X instanceof Error?this.sendResponse({id:G,data:{message:X.message,name:X.name,stack:X.stack?X.stack.split?X.stack.split(`
`):X.stack:void 0},type:202}):this.sendResponse({id:G,data:X,type:203}),this.activeRequests.delete(T.id)});const Q=k.toDisposable(()=>N.cancel());this.activeRequests.set(T.id,Q)}onEventListen(T){const M=this.channels.get(T.channelName);if(!M){this.collectPendingRequest(T);return}const N=T.id,G=M.listen(this.ctx,T.name,T.arg)(Q=>this.sendResponse({id:N,data:Q,type:204}));this.activeRequests.set(T.id,G)}disposeActiveRequest(T){const M=this.activeRequests.get(T.id);M&&(M.dispose(),this.activeRequests.delete(T.id))}collectPendingRequest(T){let M=this.pendingRequests.get(T.channelName);M||(M=[],this.pendingRequests.set(T.channelName,M));const N=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.sendResponse({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);M.push({request:T,timeoutTimer:N})}flushPendingRequests(T){const M=this.pendingRequests.get(T);if(M){for(const N of M)switch(clearTimeout(N.timeoutTimer),N.request.type){case 100:this.onPromise(N.request);break;case 102:this.onEventListen(N.request);break}this.pendingRequests.delete(T)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}e.ChannelServer=l;var y;(function(R){R[R.LocalSide=0]="LocalSide",R[R.OtherSide=1]="OtherSide"})(y=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(T,M=null){this.protocol=T,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new v.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(N=>this.onBuffer(N)),this.logger=M}getChannel(T){const M=this;return{call(N,B,G){return M.isDisposed?Promise.reject(O.canceled()):M.requestPromise(T,N,B,G)},listen(N,B){return M.isDisposed?Promise.reject(O.canceled()):M.requestEvent(T,N,B)}}}requestPromise(T,M,N,B=A.CancellationToken.None){const G=this.lastRequestId++,X={id:G,type:100,channelName:T,name:M,arg:N};if(B.isCancellationRequested)return Promise.reject(O.canceled());let ie;return new Promise((oe,he)=>{if(B.isCancellationRequested)return he(O.canceled());const me=()=>{const Fe=Oe=>{switch(Oe.type){case 201:this.handlers.delete(G),oe(Oe.data);break;case 202:this.handlers.delete(G);const ke=new Error(Oe.data.message);ke.stack=Oe.data.stack,ke.name=Oe.data.name,he(ke);break;case 203:this.handlers.delete(G),he(Oe.data);break}};this.handlers.set(G,Fe),this.sendRequest(X)};let pe=null;this.state===b.Idle?me():(pe=L.createCancelablePromise(Fe=>this.whenInitialized()),pe.then(()=>{pe=null,me()}));const Ie=()=>{pe?(pe.cancel(),pe=null):this.sendRequest({id:G,type:101}),he(O.canceled())},Re=B.onCancellationRequested(Ie);ie=k.combinedDisposable(k.toDisposable(Ie),Re),this.activeRequests.add(ie)}).finally(()=>{this.activeRequests.delete(ie)})}requestEvent(T,M,N){const B=this.lastRequestId++,Q={id:B,type:102,channelName:T,name:M,arg:N};let X=null;const ie=new v.Emitter({onFirstListenerAdd:()=>{X=L.createCancelablePromise(oe=>this.whenInitialized()),X.then(()=>{X=null,this.activeRequests.add(ie),this.sendRequest(Q)})},onLastListenerRemove:()=>{X?(X.cancel(),X=null):(this.activeRequests.delete(ie),this.sendRequest({id:B,type:103}))}}),ne=oe=>ie.fire(oe.data);return this.handlers.set(B,ne),ie.event}sendRequest(T){switch(T.type){case 100:case 102:{const M=this.send([T.type,T.id,T.channelName,T.name],T.arg);this.logger&&this.logger.logOutgoing(M,T.id,0,`${h(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const M=this.send([T.type,T.id]);this.logger&&this.logger.logOutgoing(M,T.id,0,h(T.type));return}}}send(T,M=void 0){const N=new p;return u(N,T),u(N,M),this.sendBuffer(N.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch(M){return 0}}onBuffer(T){const M=new I(T),N=c(M),B=c(M),G=N[0];switch(G){case 200:return this.logger&&this.logger.logIncoming(T.byteLength,0,0,D(G)),this.onResponse({type:N[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(T.byteLength,N[1],0,D(G),B),this.onResponse({type:N[0],id:N[1],data:B})}}onResponse(T){if(T.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const M=this.handlers.get(T.id);M&&M(T)}get onDidInitializePromise(){return v.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(T=>T.dispose()),this.activeRequests.clear()}}de([d.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class f{constructor(T){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new v.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new v.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,T(({protocol:M,onDidClientDisconnect:N})=>{v.Event.once(M.onMessage)(G=>{const Q=new I(G),X=c(Q),ie=new l(M,X),ne=new E(M);this.channels.forEach((he,me)=>ie.registerChannel(me,he));const oe={channelServer:ie,channelClient:ne,ctx:X};this._connections.add(oe),this._onDidAddConnection.fire(oe),N(()=>{ie.dispose(),ne.dispose(),this._connections.delete(oe),this._onDidRemoveConnection.fire(oe)})})})}get connections(){const T=[];return this._connections.forEach(M=>T.push(M)),T}getChannel(T,M){const N=this;return{call(B,G,Q){let X;if(w.isFunction(M)){let ne=S.getRandomElement(N.connections.filter(M));X=ne?Promise.resolve(ne):v.Event.toPromise(v.Event.filter(N.onDidAddConnection,M))}else X=M.routeCall(N,B,G);const ie=X.then(ne=>ne.channelClient.getChannel(T));return F(ie).call(B,G,Q)},listen(B,G){if(w.isFunction(M))return N.getMulticastEvent(T,M,B,G);const Q=M.routeEvent(N,B,G).then(X=>X.channelClient.getChannel(T));return F(Q).listen(B,G)}}}getMulticastEvent(T,M,N,B){const G=this;let Q=new k.DisposableStore;const X=new v.Emitter({onFirstListenerAdd:()=>{Q=new k.DisposableStore;const ie=new v.EventMultiplexer,ne=new Map,oe=me=>{const Ie=me.channelClient.getChannel(T).listen(N,B),Re=ie.add(Ie);ne.set(me,Re)},he=me=>{const pe=ne.get(me);!pe||(pe.dispose(),ne.delete(me))};G.connections.filter(M).forEach(oe),v.Event.filter(G.onDidAddConnection,M)(oe,void 0,Q),G.onDidRemoveConnection(he,void 0,Q),ie.event(X.fire,X,Q),Q.add(ie)},onLastListenerRemove:()=>{Q.dispose()}});return X.event}registerChannel(T,M){this.channels.set(T,M),this._connections.forEach(N=>{N.channelServer.registerChannel(T,M)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=f;class U{constructor(T,M,N=null){const B=new p;u(B,M),T.send(B.buffer),this.channelClient=new E(T,N),this.channelServer=new l(T,M,N)}getChannel(T){return this.channelClient.getChannel(T)}registerChannel(T,M){this.channelServer.registerChannel(T,M)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function F(R){return{call(T,M,N){return R.then(B=>B.call(T,M,N))},listen(T,M){const N=new v.Relay;return R.then(B=>N.input=B.listen(T,M)),N.event}}}e.getDelayedChannel=F;function z(R){let T=!1;return{call(M,N,B){return T?R.call(M,N,B):L.timeout(0).then(()=>T=!0).then(()=>R.call(M,N,B))},listen(M,N){if(T)return R.listen(M,N);const B=new v.Relay;return L.timeout(0).then(()=>T=!0).then(()=>B.input=R.listen(M,N)),B.event}}}e.getNextTickChannel=z;class ${constructor(T){this.fn=T}routeCall(T){return this.route(T)}routeEvent(T){return this.route(T)}async route(T){for(const M of T.connections)if(await Promise.resolve(this.fn(M.ctx)))return Promise.resolve(M);return await v.Event.toPromise(T.onDidAddConnection),await this.route(T)}}e.StaticRouter=$;var H;(function(R){function T(B,G){const Q=B,X=G&&G.disableMarshalling,ie=new Map;for(const ne in Q)N(ne)&&ie.set(ne,v.Event.buffer(Q[ne],!0));return new class{listen(ne,oe){const he=ie.get(oe);if(he)return he;throw new Error(`Event not found: ${oe}`)}call(ne,oe,he){const me=Q[oe];if(typeof me=="function"){if(!X&&Array.isArray(he))for(let pe=0;pe<he.length;pe++)he[pe]=n.revive(he[pe]);return me.apply(Q,he)}throw new Error(`Method not found: ${oe}`)}}}R.fromService=T;function M(B,G){const Q=G&&G.disableMarshalling;return new Proxy({},{get(X,ie){if(typeof ie=="string")return G?.properties?.has(ie)?G.properties.get(ie):N(ie)?B.listen(ie):async function(...ne){let oe;G&&!w.isUndefinedOrNull(G.context)?oe=[G.context,...ne]:oe=ne;const he=await B.call(ie,oe);return Q?he:n.revive(he)};throw new Error(`Property not found: ${String(ie)}`)}})}R.toService=M;function N(B){return B[0]==="o"&&B[1]==="n"&&m.isUpperAsciiLetter(B.charCodeAt(2))}})(H=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function _(R){if(Array.isArray(R))return R;if(R&&typeof R=="object"&&typeof R.toString=="function"){let T=R.toString();if(T!=="[object Object]")return T}return R}function x(R){return Array.isArray(R)?R.map(_):_(R)}function j(R,T,M,N,B,G,Q){Q=x(Q);const X=V[B],ie=X[N%X.length];let ne=[`%c[${R}]%c[${String(T).padStart(7," ")}]%c[len: ${String(M).padStart(5," ")}]%c${String(N).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(G)?(ne=ne.concat(Q),ne.push(")")):ne.push(Q),console.log.apply(console,ne)}e.logWithColors=j;class q{constructor(T,M){this._outgoingPrefix=T,this._incomingPrefix=M,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(T,M,N,B,G){this._totalOutgoing+=T,j(this._outgoingPrefix,this._totalOutgoing,T,M,N,B,G)}logIncoming(T,M,N,B,G){this._totalIncoming+=T,j(this._incomingPrefix,this._totalIncoming,T,M,N,B,G)}}e.IPCLogger=q}),define(Z[100],ee([0,1,3,36,25]),function(K,e,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class A{constructor(S){this.port=S,this.onMessage=v.Event.fromDOMEventEmitter(this.port,"message",w=>L.VSBuffer.wrap(w.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}e.Protocol=A;class O extends k.IPCClient{constructor(S,w){const n=new A(S);super(n,w);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=O}),define(Z[101],ee([0,1,102,3,36,100]),function(K,e,v,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class O extends L.IPCServer{static getOnDidClientConnect(){const S=k.Event.fromNodeEventEmitter(v.ipcRenderer,"vscode:createMessageChannel",(w,n)=>n);return k.Event.map(S,w=>{const{port1:n,port2:m}=new MessageChannel,g={protocol:new A.Protocol(n),onDidClientDisconnect:k.Event.fromDOMEventEmitter(n,"close")};return v.ipcRenderer.postMessage("vscode:createMessageChannelResult",w,[m]),g})}constructor(){super(O.getOnDidClientConnect())}}e.Server=O}),define(Z[103],ee([0,1,11,25]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(P,S){P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const w=new XMLHttpRequest;return new Promise((n,m)=>{w.open(P.type||"GET",P.url||"",!0,P.user,P.password),A(w,P),w.responseType="arraybuffer",w.onerror=d=>m(new Error(w.statusText&&"XHR failed: "+w.statusText||"XHR failed")),w.onload=d=>{n({res:{statusCode:w.status,headers:O(w)},stream:k.bufferToStream(k.VSBuffer.wrap(new Uint8Array(w.response)))})},w.ontimeout=d=>m(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(w.timeout=P.timeout),w.send(P.data),S.onCancellationRequested(()=>{w.abort(),m(v.canceled())})})}e.request=L;function A(P,S){if(S.headers){e:for(let w in S.headers){switch(w){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(w,S.headers[w])}}}function O(P){const S=Object.create(null);for(const w of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(w){const n=w.indexOf(":");S[w.substr(0,n).trim().toLowerCase()]=w.substr(n+1).trim()}return S}}),define(Z[69],ee([0,1,2,3,6,16]),function(K,e,v,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var O;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(O=e.StorageHint||(e.StorageHint={}));var P;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(P||(P={}));class S extends v.Disposable{constructor(m,d=Object.create(null)){super();this.database=m,this.options=d,this._onDidChangeStorage=this._register(new k.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new L.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(m=>this.onDidChangeItemsExternal(m)))}onDidChangeItemsExternal(m){m.changed?.forEach((d,g)=>this.accept(g,d)),m.deleted?.forEach(d=>this.accept(d,void 0))}accept(m,d){if(this.state===P.Closed)return;let g=!1;A.isUndefinedOrNull(d)?g=this.cache.delete(m):this.cache.get(m)!==d&&(this.cache.set(m,d),g=!0),g&&this._onDidChangeStorage.fire(m)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==O.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(m,d){const g=this.cache.get(m);return A.isUndefinedOrNull(g)?d:g}getBoolean(m,d){const g=this.get(m);return A.isUndefinedOrNull(g)?d:g==="true"}getNumber(m,d){const g=this.get(m);return A.isUndefinedOrNull(g)?d:parseInt(g,10)}async set(m,d){if(this.state===P.Closed)return;if(A.isUndefinedOrNull(d))return this.delete(m);const g=String(d);if(this.cache.get(m)!==g)return this.cache.set(m,g),this.pendingInserts.set(m,g),this.pendingDeletes.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async delete(m){if(!(this.state===P.Closed||!this.cache.delete(m)))return this.pendingDeletes.has(m)||this.pendingDeletes.add(m),this.pendingInserts.delete(m),this._onDidChangeStorage.fire(m),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(m){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const m={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(m).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(m=>this.whenFlushedCallbacks.push(m))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=S,S.DEFAULT_FLUSH_DELAY=100;class w{constructor(){this.onDidChangeItemsExternal=k.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(m){m.insert&&m.insert.forEach((d,g)=>this.items.set(g,d)),m.delete&&m.delete.forEach(d=>this.items.delete(d))}async close(){}}e.InMemoryStorageDatabase=w}),define(Z[104],ee([12,13]),function(K,e){return K.create("vs/base/common/date",e)}),define(Z[55],ee([0,1,104]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,L=k*60,A=L*24,O=A*7,P=A*30,S=A*365;function w(m,d){typeof m!="number"&&(m=m.getTime());const g=Math.round((new Date().getTime()-m)/1e3);if(g<-30)return v.localize(0,null,w(new Date().getTime()+g*1e3,!1));if(g<30)return v.localize(1,null);let h;return g<k?(h=g,d?h===1?v.localize(2,null,h):v.localize(3,null,h):h===1?v.localize(4,null,h):v.localize(5,null,h)):g<L?(h=Math.floor(g/k),d?h===1?v.localize(6,null,h):v.localize(7,null,h):h===1?v.localize(8,null,h):v.localize(9,null,h)):g<A?(h=Math.floor(g/L),d?h===1?v.localize(10,null,h):v.localize(11,null,h):h===1?v.localize(12,null,h):v.localize(13,null,h)):g<O?(h=Math.floor(g/A),d?h===1?v.localize(14,null,h):v.localize(15,null,h):h===1?v.localize(16,null,h):v.localize(17,null,h)):g<P?(h=Math.floor(g/O),d?h===1?v.localize(18,null,h):v.localize(19,null,h):h===1?v.localize(20,null,h):v.localize(21,null,h)):g<S?(h=Math.floor(g/P),d?h===1?v.localize(22,null,h):v.localize(23,null,h):h===1?v.localize(24,null,h):v.localize(25,null,h)):(h=Math.floor(g/S),d?h===1?v.localize(26,null,h):v.localize(27,null,h):h===1?v.localize(28,null,h):v.localize(29,null,h))}e.fromNow=w;function n(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(Z[105],ee([12,13]),function(K,e){return K.create("vs/base/common/errorMessage",e)}),define(Z[43],ee([0,1,105,16,19]),function(K,e,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(w,n){return n&&(w.stack||w.stacktrace)?v.localize(0,null,P(w),O(w.stack)||O(w.stacktrace)):P(w)}function O(w){return Array.isArray(w)?w.join(`
`):w}function P(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?v.localize(1,null,w.message):w.message||v.localize(2,null)}function S(w=null,n=!1){if(!w)return v.localize(3,null);if(Array.isArray(w)){const m=L.coalesce(w),d=S(m[0],n);return m.length>1?v.localize(4,null,d,m.length):d}if(k.isString(w))return w;if(w.detail){const m=w.detail;if(m.error)return A(m.error,n);if(m.exception)return A(m.exception,n)}return w.stack?A(w,n):w.message?w.message:v.localize(5,null)}e.toErrorMessage=S}),define(Z[106],ee([12,13]),function(K,e){return K.create("vs/base/node/processes",e)}),define(Z[107],ee([0,1,8,18,42,106,34,16,26,41,7,68,17]),function(K,e,v,k,L,A,O,P,S,w,n,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function g(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(s,a){if(n.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const r=L.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],t);return new Promise(i=>{r.once("error",o=>{i({success:!1,error:o})}),r.once("exit",(o,u)=>{i(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?g(t.status):1})}else if(n.isLinux||n.isMacintosh)try{const t=d.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",K).fsPath;return new Promise(r=>{L.execFile(t,[s.pid.toString()],{encoding:"utf8",shell:!0},(i,o,u)=>{r(i?{success:!1,error:i}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function C(s=O.env){return s.comspec||"cmd.exe"}e.getWindowsShell=C;class D{constructor(a,t,r,i){if(t!==void 0&&r!==void 0&&i!==void 0)this.cmd=a,this.args=t,this.shell=r,this.options=i;else{const o=a;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(O.env).forEach(u=>{o[u]=O.env[u]}),Object.keys(this.options.env).forEach(u=>{o[u]=this.options.env[u]}),this.options.env=o}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(v.sep);return t!==-1&&(a=a.substring(t+1)),D.WellKnowCommands[a]?a:"other"}start(a){return n.isWindows&&(this.options&&this.options.cwd&&w.isUNC(this.options.cwd)||!this.options&&w.isUNC(O.cwd()))?Promise.reject(new Error(A.localize(0,null))):this.useExec().then(t=>{let r,i;const o=new Promise((u,c)=>{r=u,i=c});if(t){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=L.exec(u,this.options,(c,l,y)=>{this.childProcess=null;const E=c;E&&E.killed?i({killed:this.terminateRequested,stdout:l.toString(),stderr:y.toString()}):this.handleExec(r,a,c,l,y)})}else{let u=null;const c=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,r,a,i);const y={terminated:this.terminateRequested};P.isNumber(l)&&(y.cmdCode=l),r(y)};if(this.shell&&n.isWindows){const l=S.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let y=!1,E=!1;const f=[];let U=this.ensureQuotes(this.cmd);f.push(U.value),y=U.quoted,this.args&&this.args.forEach(z=>{U=this.ensureQuotes(z),f.push(U.value),E=E&&U.quoted});const F=["/s","/c"];y?E?F.push('"'+f.join(" ")+'"'):f.length>1?F.push('"'+f[0]+'" '+f.slice(1).join(" ")):F.push('"'+f[0]+'"'):F.push(f.join(" ")),u=L.spawn(C(),F,l)}else this.cmd&&(u=L.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(P.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",l=>{this.childProcess=null,i({terminated:this.terminateRequested,error:l})}),u.pid&&(this.childProcess.on("close",c),this.handleSpawn(u,r,a,i,!0)))}return o})}handleClose(a,t,r,i){}ensureQuotes(a){return D.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,h(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!n.isWindows)return a(!1);const t=L.spawn(C(),["/s","/c"]);t.on("error",r=>a(!0)),t.on("exit",r=>a(!1))})}}e.AbstractProcess=D,D.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},D.regexp=/^[^"].* .*[^"]/;class b extends D{constructor(a,t,r,i){super(a,t,r,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,r,i,o){[i,o].forEach((u,c)=>{const l=new m.LineDecoder;l.write(u).forEach(f=>{t({line:f,source:c===0?0:1})});const E=l.end();E&&t({line:E,source:c===0?0:1})}),a({terminated:this.terminateRequested,error:r})}handleSpawn(a,t,r,i,o){const u=new m.LineDecoder,c=new m.LineDecoder;a.stdout.on("data",l=>{u.write(l).forEach(E=>r({line:E,source:0}))}),a.stderr.on("data",l=>{c.write(l).forEach(E=>r({line:E,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=c}handleClose(a,t,r,i){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&r({line:o,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&r({line:u,source:1})}}e.LineProcess=b;function I(s){let a=[],t=!1;const r=function(i){if(t){a.push(i);return}(!s.send(i,u=>{if(u&&console.error(u),t=!1,a.length>0){const c=a.slice(0);a=[],c.forEach(l=>r(l))}})||n.isWindows)&&(t=!0)};return{send:r}}e.createQueuedSender=I;var p;(function(s){async function a(t,r,i){if(v.isAbsolute(t))return t;if(r===void 0&&(r=O.cwd()),v.dirname(t)!=="."||(i===void 0&&P.isString(O.env.PATH)&&(i=O.env.PATH.split(v.delimiter)),i===void 0||i.length===0))return v.join(r,t);async function u(c){return await k.Promises.exists(c)?!(await k.Promises.stat(c)).isDirectory():!1}for(let c of i){let l;if(v.isAbsolute(c)?l=v.join(c,t):l=v.join(r,c,t),await u(l))return l;let y=l+".com";if(await u(y)||(y=l+".exe",await u(y)))return y}return v.join(r,t)}s.findExecutable=a})(p=e.win32||(e.win32={}))}),define(Z[49],ee([0,1,42,2,6,26,3,107,36,90,29,11,25,7]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class h extends S.ChannelServer{constructor(b){super({send:I=>{try{process.send&&process.send(I.buffer.toString("base64"))}catch(p){}},onMessage:O.Event.fromNodeEventEmitter(process,"message",I=>d.VSBuffer.wrap(Buffer.from(I,"base64")))},b);process.once("disconnect",()=>this.dispose())}}e.Server=h;class C{constructor(b,I){this.modulePath=b,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new O.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const p=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new L.Delayer(p),this.child=null,this._client=null}getChannel(b){const I=this;return{call(p,s,a){return I.requestPromise(b,p,s,a)},listen(p,s){return I.requestEvent(b,p,s)}}}requestPromise(b,I,p,s=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(m.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(b),t=L.createCancelablePromise(o=>a.call(I,p,o)),r=s.onCancellationRequested(()=>t.cancel()),i=k.toDisposable(()=>t.cancel());return this.activeRequests.add(i),t.finally(()=>{r.dispose(),this.activeRequests.delete(i),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(b,I,p){if(!this.disposeDelayer)return O.Event.None;this.disposeDelayer.cancel();let s;const a=new O.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(b).listen(I,p)(a.fire,a),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const b=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env={...A.deepClone(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(I.env={...I.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),g.isMacintosh&&I.env&&delete I.env.DYLD_LIBRARY_PATH,this.child=v.fork(this.modulePath,b,I);const p=new O.Emitter;O.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if(w.isRemoteConsoleLog(u)){w.log(u,`IPC Library: ${this.options.serverName}`);return}p.fire(d.VSBuffer.wrap(Buffer.from(u,"base64")))});const a=this.options.useQueue?P.createQueuedSender(this.child):this.child,t=u=>this.child&&this.child.connected&&a.send(u.buffer.toString("base64")),r=p.event,i={send:t,onMessage:r};this._client=new S.ChannelClient(i);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,c)=>{process.removeListener("exit",o),this.activeRequests.forEach(l=>k.dispose(l)),this.activeRequests.clear(),u!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+c),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:c})})}return this._client}getCachedChannel(b){let I=this.channels.get(b);return I||(I=this.client.getChannel(b),this.channels.set(b,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=C}),define(Z[108],ee([12,13]),function(K,e){return K.create("vs/base/node/zip",e)}),define(Z[109],ee([12,13]),function(K,e){return K.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[110],ee([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[111],ee([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[112],ee([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[113],ee([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[114],ee([12,13]),function(K,e){return K.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[115],ee([12,13]),function(K,e){return K.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[116],ee([12,13]),function(K,e){return K.create("vs/platform/files/common/fileService",e)}),define(Z[117],ee([12,13]),function(K,e){return K.create("vs/platform/files/common/files",e)}),define(Z[118],ee([12,13]),function(K,e){return K.create("vs/platform/files/common/io",e)}),define(Z[119],ee([12,13]),function(K,e){return K.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[120],ee([12,13]),function(K,e){return K.create("vs/platform/request/common/request",e)}),define(Z[121],ee([12,13]),function(K,e){return K.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[122],ee([12,13]),function(K,e){return K.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Z[123],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[124],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[125],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[126],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[127],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[128],ee([12,13]),function(K,e){return K.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[129],ee([0,1,8,14,64,55,17,5,34]),function(K,e,v,k,L,A,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(h,C,D){this._args=h,this.paths=C,this.productService=D}get appRoot(){return v.dirname(O.FileAccess.asFileUri("",K).fsPath)}get userHome(){return P.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return P.URI.file(v.join(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return k.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return k.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=A.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=v.join(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return P.URI.file(v.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return k.joinPath(P.URI.file(v.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return P.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return P.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return k.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return k.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=S.env.VSCODE_PORTABLE;return h?P.URI.file(v.join(h,"argv.json")):k.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return k.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file(v.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return v.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?v.resolve(h):v.normalize(v.join(O.FileAccess.asFileUri("",K).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?v.resolve(h):v.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return v.resolve(h);const C=S.env.VSCODE_EXTENSIONS;if(C)return C;const D=S.env.VSCODE_PORTABLE;return D?v.join(D,"extensions"):k.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(C=>/^[^:/?#]+?:\/\//.test(C)?P.URI.parse(C):P.URI.file(v.normalize(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?P.URI.parse(h):P.URI.file(v.normalize(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!S.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return k.joinPath(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return P.URI.file(v.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}de([L.memoize],w.prototype,"appRoot",null),de([L.memoize],w.prototype,"userHome",null),de([L.memoize],w.prototype,"userDataPath",null),de([L.memoize],w.prototype,"appSettingsHome",null),de([L.memoize],w.prototype,"tmpDir",null),de([L.memoize],w.prototype,"userRoamingDataHome",null),de([L.memoize],w.prototype,"settingsResource",null),de([L.memoize],w.prototype,"userDataSyncHome",null),de([L.memoize],w.prototype,"userDataSyncLogResource",null),de([L.memoize],w.prototype,"sync",null),de([L.memoize],w.prototype,"machineSettingsResource",null),de([L.memoize],w.prototype,"globalStorageHome",null),de([L.memoize],w.prototype,"workspaceStorageHome",null),de([L.memoize],w.prototype,"keybindingsResource",null),de([L.memoize],w.prototype,"keyboardLayoutResource",null),de([L.memoize],w.prototype,"argvResource",null),de([L.memoize],w.prototype,"snippetsHome",null),de([L.memoize],w.prototype,"isExtensionDevelopment",null),de([L.memoize],w.prototype,"untitledWorkspacesHome",null),de([L.memoize],w.prototype,"installSourcePath",null),de([L.memoize],w.prototype,"builtinExtensionsPath",null),de([L.memoize],w.prototype,"extensionsPath",null),de([L.memoize],w.prototype,"extensionDevelopmentLocationURI",null),de([L.memoize],w.prototype,"extensionDevelopmentKind",null),de([L.memoize],w.prototype,"extensionTestsLocationURI",null),de([L.memoize],w.prototype,"debugExtensionHost",null),de([L.memoize],w.prototype,"serviceMachineIdResource",null),de([L.memoize],w.prototype,"telemetryLogResource",null),de([L.memoize],w.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=w;function n(g,h){return d(g["inspect-extensions"],g["inspect-brk-extensions"],5870,h,g.debugId)}e.parseExtensionHostPort=n;function m(g,h){return d(g["inspect-search"],g["inspect-brk-search"],5876,h)}e.parseSearchPort=m;function d(g,h,C,D,b){const p=Number(h||g)||(D?null:C),s=p?Boolean(!!h):!1;return{port:p,break:s,debugId:b}}}),function(){"use strict";function K(e,v,k,L){function A(P){const S=O(P),w=[S];return e.isAbsolute(S)||w.unshift(L),e.resolve(...w)}function O(P){const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");const w=P["user-data-dir"];if(w)return w;let n=process.env.VSCODE_APPDATA;if(!n)switch(process.platform){case"win32":if(n=process.env.APPDATA,!n){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");n=e.join(m,"AppData","Roaming")}break;case"darwin":n=e.join(v.homedir(),"Library","Application Support");break;case"linux":n=process.env.XDG_CONFIG_HOME||e.join(v.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(n,k)}return{getUserDataPath:A}}if(typeof define=="function")define(Z[130],ee([0,209,35,17,14,34]),function(e,v,k,L,A,O){const P=A.dirname(L.FileAccess.asFileUri("",e)),S=e.__$__nodeRequire(A.joinPath(P,"package.json").fsPath);return K(v,k,S.name,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),v=require("path"),k=require("os");module.exports=K(v,k,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[131],ee([0,1,35,130,129]),function(K,e,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class A extends L.AbstractNativeEnvironmentService{constructor(P,S){super(P,{homeDir:v.homedir(),tmpDir:v.tmpdir(),userDataDir:k.getUserDataPath(P)},S)}}e.NativeEnvironmentService=A}),define(Z[132],ee([0,1,5]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const k=/^([^@:]+@)?([^:]+):/,L=/^([^@:]+@)?([^:]+):(.+)$/,A=/^([^@]+@)?([^:]+)(:\d+)?$/,O=/([^@:.]+\.[^@:.]+)(:\d+)?$/,P=/^\s*url\s*=\s*(.+\S)\s*$/mg,S=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function w(D){const b=D.match(O);return b?b[1]:null}function n(D){if(D.indexOf("://")===-1){const b=D.match(k);return b?w(b[2]):null}try{const b=v.URI.parse(D);if(b.authority)return w(b.authority)}catch(b){}return null}function m(D,b){const I=new Set;let p;for(;p=P.exec(D);){const a=n(p[1]);a&&I.add(a)}const s=new Set(b);return Array.from(I).map(a=>s.has(a)?a:a.replace(S,"a"))}e.getDomainsOfRemotes=m;function d(D){const b=D.match(A);return b?b[2]:null}function g(D,b,I){return D&&b?(I&&b.endsWith(".git")&&(b=b.substr(0,b.length-4)),b.indexOf("/")===0?`${D}${b}`:`${D}/${b}`):null}function h(D,b){if(D.indexOf("://")===-1){const I=D.match(L);if(I)return g(I[2],I[3],b)}try{const I=v.URI.parse(D);if(I.authority)return g(d(I.authority),I.path,b)}catch(I){}return null}function C(D,b=!1){const I=[];let p;for(;p=P.exec(D);){const s=h(p[1],b);s&&I.push(s)}return I}e.getRemotes=C}),define(Z[133],ee([0,1,3,5,93,26,2]),function(K,e,v,k,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function P(h,C){return k.URI.revive(C?C.transformIncoming(h):h)}function S(h,C){return C?C.transformOutgoingURI(h):h}function w(h,C){C=C||L.DefaultURITransformer;const D=h.manifest;return{...L.transformAndReviveIncomingURIs({...h,manifest:void 0},C),manifest:D}}function n(h,C){return C?A.cloneAndChange(h,D=>D instanceof k.URI?C.transformOutgoingURI(D):void 0):h}class m{constructor(C,D){this.service=C,this.getUriTransformer=D,this.onInstallExtension=v.Event.buffer(C.onInstallExtension,!0),this.onDidInstallExtension=v.Event.buffer(C.onDidInstallExtension,!0),this.onUninstallExtension=v.Event.buffer(C.onUninstallExtension,!0),this.onDidUninstallExtension=v.Event.buffer(C.onDidUninstallExtension,!0)}listen(C,D){const b=this.getUriTransformer(C);switch(D){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return v.Event.map(this.onDidInstallExtension,I=>({...I,local:I.local?n(I.local,b):I.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(C,D,b){const I=this.getUriTransformer(C);switch(D){case"zip":return this.service.zip(w(b[0],I)).then(p=>S(p,I));case"unzip":return this.service.unzip(P(b[0],I));case"install":return this.service.install(P(b[0],I),b[1]);case"getManifest":return this.service.getManifest(P(b[0],I));case"canInstall":return this.service.canInstall(b[0]);case"installFromGallery":return this.service.installFromGallery(b[0],b[1]);case"uninstall":return this.service.uninstall(w(b[0],I),b[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(w(b[0],I));case"getInstalled":return this.service.getInstalled(b[0]).then(p=>p.map(s=>n(s,I)));case"updateMetadata":return this.service.updateMetadata(w(b[0],I),b[1]).then(p=>n(p,I));case"updateExtensionScope":return this.service.updateExtensionScope(w(b[0],I),b[1]).then(p=>n(p,I));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=m;class d extends O.Disposable{constructor(C){super();this.channel=C,this._onInstallExtension=this._register(new v.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new v.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new v.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new v.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(D=>this._onInstallExtension.fire(D))),this._register(this.channel.listen("onDidInstallExtension")(D=>this._onDidInstallExtension.fire({...D,local:D.local?w(D.local,null):D.local}))),this._register(this.channel.listen("onUninstallExtension")(D=>this._onUninstallExtension.fire(D))),this._register(this.channel.listen("onDidUninstallExtension")(D=>this._onDidUninstallExtension.fire(D)))}zip(C){return Promise.resolve(this.channel.call("zip",[C]).then(D=>k.URI.revive(D)))}unzip(C){return Promise.resolve(this.channel.call("unzip",[C]))}install(C,D){return Promise.resolve(this.channel.call("install",[C,D])).then(b=>w(b,null))}getManifest(C){return Promise.resolve(this.channel.call("getManifest",[C]))}async canInstall(C){return!0}installFromGallery(C,D){return Promise.resolve(this.channel.call("installFromGallery",[C,D])).then(b=>w(b,null))}uninstall(C,D){return Promise.resolve(this.channel.call("uninstall",[C,D]))}reinstallFromGallery(C){return Promise.resolve(this.channel.call("reinstallFromGallery",[C]))}getInstalled(C=null){return Promise.resolve(this.channel.call("getInstalled",[C])).then(D=>D.map(b=>w(b,null)))}updateMetadata(C,D){return Promise.resolve(this.channel.call("updateMetadata",[C,D])).then(b=>w(b,null))}updateExtensionScope(C,D){return Promise.resolve(this.channel.call("updateExtensionScope",[C,D])).then(b=>w(b,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=d;class g{constructor(C){this.service=C}listen(C,D){throw new Error("Invalid listen")}call(C,D,b){switch(D){case"getConfigBasedTips":return this.service.getConfigBasedTips(k.URI.revive(b[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=g}),define(Z[134],ee([0,1,26]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const k=/^%([\w\d.-]+)%$/i;function L(A,O){const P=S=>{if(typeof S!="string")return;const w=k.exec(S);if(!w)return;const n=O[w[1]]??S;return typeof n=="string"?n:typeof n.message=="string"?n.message:S};return v.cloneAndChange(A,P)}e.localizeManifest=L}),define(Z[135],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class v{constructor(A){this.channel=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A,O,P,S){return this.channel.call("promptImportantExtensionsInstallNotification",[A,O,P,S])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=v;class k{constructor(A){this.service=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,P){switch(O){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(P[0],P[1],P[2],P[3])}throw new Error(`Call not found: ${O}`)}}e.ExtensionRecommendationNotificationServiceChannel=k}),define(Z[70],ee([0,1,115]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,L=/^-(\d{4})(\d{2})(\d{2})$/;function A(d){return d=d.trim(),d==="*"||k.test(d)}e.isValidVersionStr=A;function O(d){if(!A(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=d.match(k);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=O;function P(d){if(!d)return null;let g=d.majorBase,h=d.majorMustEqual,C=d.minorBase,D=d.minorMustEqual,b=d.patchBase,I=d.patchMustEqual;d.hasCaret&&(g===0||(D=!1),I=!1);let p=0;if(d.preRelease){const s=L.exec(d.preRelease);if(s){const[,a,t,r]=s;p=Date.UTC(Number(a),Number(t)-1,Number(r))}}return{majorBase:g,majorMustEqual:h,minorBase:C,minorMustEqual:D,patchBase:b,patchMustEqual:I,isMinimum:d.hasGreaterEquals,notBefore:p}}e.normalizeVersion=P;function S(d,g,h){let C;typeof d=="string"?C=P(O(d)):C=d;let D;g instanceof Date?D=g.getTime():typeof g=="string"&&(D=new Date(g).getTime());let b;if(typeof h=="string"?b=P(O(h)):b=h,!C||!b)return!1;let I=C.majorBase,p=C.minorBase,s=C.patchBase,a=b.majorBase,t=b.minorBase,r=b.patchBase,i=b.notBefore,o=b.majorMustEqual,u=b.minorMustEqual,c=b.patchMustEqual;return b.isMinimum?I>a?!0:I<a?!1:p>t?!0:p<t||D&&D<i?!1:s>=r:(I===1&&a===0&&(!o||!u||!c)&&(a=1,t=0,r=0,o=!0,u=!1,c=!1),I<a?!1:I>a?!o:p<t?!1:p>t?!u:s<r?!1:s>r?!c:!(D&&D<i))}e.isValidVersion=S;function w(d,g,h,C){return h.isBuiltin||typeof h.main=="undefined"?!0:m(d,g,h.engines.vscode,C)}e.isValidExtensionVersion=w;function n(d,g,h){return d==="*"||m(g,h,d)}e.isEngineValid=n;function m(d,g,h,C=[]){let D=P(O(h));if(!D)return C.push(v.localize(0,null,h)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return C.push(v.localize(1,null,h)),!1}else if(!D.majorMustEqual)return C.push(v.localize(2,null,h)),!1;return S(d,g,D)?!0:(C.push(v.localize(3,null,d,h)),!1)}}),define(Z[136],ee([0,1,36,49,2,17]),function(K,e,v,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class O extends L.Disposable{constructor(S,w,n,m){super();this.folders=S,this.onDidFilesChange=w,this.onLogMessage=n,this.verboseLogging=m,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new k.Client(A.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=O.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService(v.getNextTickChannel(S.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.setFolders(this.folders)}setVerboseLogging(S){this.verboseLogging=S,!this.isDisposed&&this.service&&this.service.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${S}`})}setFolders(S){this.folders=S,this.service&&this.service.setRoots(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=O,O.MAX_RESTARTS=5}),define(Z[137],ee([0,1,36,49,2,17]),function(K,e,v,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class O extends L.Disposable{constructor(S,w,n,m,d={}){super();this.folders=S,this.onDidFilesChange=w,this.onLogMessage=n,this.verboseLogging=m,this.watcherOptions=d,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new k.Client(A.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=O.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=v.ProxyChannel.toService(v.getNextTickChannel(S.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(w=>!this.isDisposed&&this.onDidFilesChange(w))),this._register(this.service.onDidLogMessage(w=>this.onLogMessage(w))),this.service.setRoots(this.folders)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${S}`})}setVerboseLogging(S){this.verboseLogging=S,this.service&&this.service.setVerboseLogging(S)}setFolders(S){this.folders=S,this.service&&this.service.setRoots(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=O,O.MAX_RESTARTS=5}),define(Z[138],ee([0,1,42,68,67,17]),function(K,e,v,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class O{constructor(S,w,n,m,d){this.watchedFolder=S,this.eventCallback=n,this.logCallback=m,this.verboseLogging=d,this.restartCounter=0,Array.isArray(w)?this.ignored=w.map(g=>L.parse(g)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${S}, excludes: ${w.join(",")}`),this.startWatcher()}startWatcher(){const S=[this.watchedFolder];this.verboseLogging&&S.push("-verbose"),this.handle=v.spawn(A.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",K).fsPath,S);const w=new k.LineDecoder;this.handle.stdout.on("data",n=>{const m=[];for(const d of w.write(n)){const g=d.split("|");if(g.length===2){const h=Number(g[0]),C=g[1];if(h>=0&&h<3){if(this.ignored&&this.ignored.some(D=>D(C))){this.verboseLogging&&this.log(C);continue}m.push({type:O.changeTypeMap[h],path:C})}else this.log(g[1])}}m.length>0&&this.eventCallback(m)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,m)=>this.onExit(n,m))}onError(S){this.error("process error: "+S.toString())}onExit(S,w){this.handle&&(this.error(`terminated unexpectedly (code: ${S}, signal: ${w})`),this.restartCounter<=O.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(S){this.logCallback({type:"error",message:`[File Watcher (C#)] ${S}`})}log(S){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${S}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=O,O.MAX_RESTARTS=5,O.changeTypeMap=[0,1,2]}),define(Z[139],ee([0,1,138,8,20]),function(K,e,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class A{constructor(P,S,w,n){this.onDidFilesChange=S,this.onLogMessage=w,this.verboseLogging=n,this.service=void 0,this.folder=P[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(k.posix.sep)&&(this.folder.path=L.rtrim(this.folder.path,k.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new v.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,P=>this.onFileEvents(P),P=>this.onLogMessage(P),this.verboseLogging)}setVerboseLogging(P){this.verboseLogging=P,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(P){this.isDisposed||P.length>0&&this.onDidFilesChange(P)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=A}),define(Z[50],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class v{constructor(L,A=[],O=!1){this.ctor=L,this.staticArguments=A,this.supportsDelayedInstantiation=O}}e.SyncDescriptor=v}),define(Z[140],ee([0,1,50]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function L(O,P,S){P instanceof v.SyncDescriptor||(P=new v.SyncDescriptor(P,[],S)),k.push([O,P])}e.registerSingleton=L;function A(){return k}e.getSingletonServiceDescriptors=A}),define(Z[141],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class v{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=v;class k{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let O of this._nodes.values())O.outgoing.size===0&&A.push(O);return A}insertEdge(A,O){const P=this.lookupOrInsertNode(A),S=this.lookupOrInsertNode(O);P.outgoing.set(this._hashFn(O),S),S.incoming.set(this._hashFn(A),P)}removeNode(A){const O=this._hashFn(A);this._nodes.delete(O);for(let P of this._nodes.values())P.outgoing.delete(O),P.incoming.delete(O)}lookupOrInsertNode(A){const O=this._hashFn(A);let P=this._nodes.get(O);return P||(P=new v(A),this._nodes.set(O,P)),P}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[O,P]of this._nodes)A.push(`${O}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,O]of this._nodes){const P=new Set([A]),S=this._findCycle(O,P);if(S)return S}}_findCycle(A,O){for(let[P,S]of A.outgoing){if(O.has(P))return[...O,P].join(" -> ");O.add(P);const w=this._findCycle(S,O);if(w)return w;O.delete(P)}}}e.Graph=k}),define(Z[4],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var v;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function S(w){return w[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=S})(v=e._util||(e._util={})),e.IInstantiationService=L("instantiationService");function k(P,S,w,n){S[v.DI_TARGET]===S?S[v.DI_DEPENDENCIES].push({id:P,index:w,optional:n}):(S[v.DI_DEPENDENCIES]=[{id:P,index:w,optional:n}],S[v.DI_TARGET]=S)}function L(P){if(v.serviceIds.has(P))return v.serviceIds.get(P);const S=function(w,n,m){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(S,w,m,!1)};return S.toString=()=>P,v.serviceIds.set(P,S),S}e.createDecorator=L;function A(P){return P}e.refineServiceDecorator=A;function O(P){return function(S,w,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");k(P,S,n,!0)}}e.optional=O}),define(Z[142],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=v.createDecorator("checksumService")}),define(Z[143],ee([0,1,20,4,7]),function(K,e,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=L.userAgent||"";const O=new Map;O.set("false",!1),O.set("true",!0),O.set("isMac",L.isMacintosh),O.set("isLinux",L.isLinux),O.set("isWindows",L.isWindows),O.set("isWeb",L.isWeb),O.set("isMacNative",L.isMacintosh&&!L.isWeb),O.set("isEdge",A.indexOf("Edg/")>=0),O.set("isFirefox",A.indexOf("Firefox")>=0),O.set("isChrome",A.indexOf("Chrome")>=0),O.set("isSafari",A.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var S;(function(E){E[E.False=0]="False",E[E.True=1]="True",E[E.Defined=2]="Defined",E[E.Not=3]="Not",E[E.Equals=4]="Equals",E[E.NotEquals=5]="NotEquals",E[E.And=6]="And",E[E.Regex=7]="Regex",E[E.NotRegex=8]="NotRegex",E[E.Or=9]="Or",E[E.In=10]="In",E[E.NotIn=11]="NotIn",E[E.Greater=12]="Greater",E[E.GreaterEquals=13]="GreaterEquals",E[E.Smaller=14]="Smaller",E[E.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class w{static false(){return m.INSTANCE}static true(){return d.INSTANCE}static has(f){return g.create(f)}static equals(f,U){return h.create(f,U)}static notEquals(f,U){return b.create(f,U)}static regex(f,U){return r.create(f,U)}static in(f,U){return C.create(f,U)}static not(f){return I.create(f)}static and(...f){return o.create(f)}static or(...f){return u.create(f)}static greater(f,U){return p.create(f,U)}static less(f,U){return a.create(f,U)}static deserialize(f,U=!1){if(!!f)return this._deserializeOrExpression(f,U)}static _deserializeOrExpression(f,U){let F=f.split("||");return u.create(F.map(z=>this._deserializeAndExpression(z,U)))}static _deserializeAndExpression(f,U){let F=f.split("&&");return o.create(F.map(z=>this._deserializeOne(z,U)))}static _deserializeOne(f,U){if(f=f.trim(),f.indexOf("!=")>=0){let F=f.split("!=");return b.create(F[0].trim(),this._deserializeValue(F[1],U))}if(f.indexOf("==")>=0){let F=f.split("==");return h.create(F[0].trim(),this._deserializeValue(F[1],U))}if(f.indexOf("=~")>=0){let F=f.split("=~");return r.create(F[0].trim(),this._deserializeRegexValue(F[1],U))}if(f.indexOf(" in ")>=0){let F=f.split(" in ");return C.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(f)){const F=f.split(">=");return s.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(f)){const F=f.split(">");return p.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(f)){const F=f.split("<=");return t.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(f)){const F=f.split("<");return a.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(f)?I.create(f.substr(1).trim()):g.create(f)}static _deserializeValue(f,U){if(f=f.trim(),f==="true")return!0;if(f==="false")return!1;let F=/^'([^']*)'$/.exec(f);return F?F[1].trim():f}static _deserializeRegexValue(f,U){if(v.isFalsyOrWhitespace(f)){if(U)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let F=f.indexOf("/"),z=f.lastIndexOf("/");if(F===z||F<0){if(U)throw new Error(`bad regexp-value '${f}', missing /-enclosure`);return console.warn(`bad regexp-value '${f}', missing /-enclosure`),null}let $=f.slice(F+1,z),H=f[z+1]==="i"?"i":"";try{return new RegExp($,H)}catch(V){if(U)throw new Error(`bad regexp-value '${f}', parse error: ${V}`);return console.warn(`bad regexp-value '${f}', parse error: ${V}`),null}}}e.ContextKeyExpr=w;function n(E,f){return E.cmp(f)}class m{constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=m,m.INSTANCE=new m;class d{constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return m.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class g{constructor(f){this.key=f,this.type=2}static create(f){const U=O.get(f);return typeof U=="boolean"?U?d.INSTANCE:m.INSTANCE:new g(f)}cmp(f){return f.type!==this.type?this.type-f.type:l(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return I.create(this.key)}}e.ContextKeyDefinedExpr=g;class h{constructor(f,U){this.key=f,this.value=U,this.type=4}static create(f,U){if(typeof U=="boolean")return U?g.create(f):I.create(f);const F=O.get(f);return typeof F=="boolean"?U===(F?"true":"false")?d.INSTANCE:m.INSTANCE:new h(f,U)}cmp(f){return f.type!==this.type?this.type-f.type:y(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(f){return f.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=h;class C{constructor(f,U){this.key=f,this.valueKey=U,this.type=10}static create(f,U){return new C(f,U)}cmp(f){return f.type!==this.type?this.type-f.type:y(this.key,this.valueKey,f.key,f.valueKey)}equals(f){return f.type===this.type?this.key===f.key&&this.valueKey===f.valueKey:!1}evaluate(f){const U=f.getValue(this.valueKey),F=f.getValue(this.key);return Array.isArray(U)?U.indexOf(F)>=0:typeof F=="string"&&typeof U=="object"&&U!==null?P.call(U,F):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(f){return f.mapIn(this.key,this.valueKey)}negate(){return D.create(this)}}e.ContextKeyInExpr=C;class D{constructor(f){this._actual=f,this.type=11}static create(f){return new D(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new D(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotInExpr=D;class b{constructor(f,U){this.key=f,this.value=U,this.type=5}static create(f,U){if(typeof U=="boolean")return U?I.create(f):g.create(f);const F=O.get(f);return typeof F=="boolean"?U===(F?"true":"false")?m.INSTANCE:d.INSTANCE:new b(f,U)}cmp(f){return f.type!==this.type?this.type-f.type:y(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return f.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(f){return f.mapNotEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class I{constructor(f){this.key=f,this.type=3}static create(f){const U=O.get(f);return typeof U=="boolean"?U?m.INSTANCE:d.INSTANCE:new I(f)}cmp(f){return f.type!==this.type?this.type-f.type:l(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}evaluate(f){return!f.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(f){return f.mapNot(this.key)}negate(){return g.create(this.key)}}e.ContextKeyNotExpr=I;class p{constructor(f,U){this.key=f,this.value=U,this.type=12}static create(f,U){return new p(f,U)}cmp(f){return f.type!==this.type?this.type-f.type:y(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=p;class s{constructor(f,U){this.key=f,this.value=U,this.type=13}static create(f,U){return new s(f,U)}cmp(f){return f.type!==this.type?this.type-f.type:y(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(f){return f.mapGreaterEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=s;class a{constructor(f,U){this.key=f,this.value=U,this.type=14}static create(f,U){return new a(f,U)}cmp(f){return f.type!==this.type?this.type-f.type:y(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmaller(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeySmallerExpr=a;class t{constructor(f,U){this.key=f,this.value=U,this.type=15}static create(f,U){return new t(f,U)}cmp(f){return f.type!==this.type?this.type-f.type:y(this.key,this.value,f.key,f.value)}equals(f){return f.type===this.type?this.key===f.key&&this.value===f.value:!1}evaluate(f){return parseFloat(f.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(f){return f.mapSmallerEquals(this.key,this.value)}negate(){return p.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(f,U){this.key=f,this.regexp=U,this.type=7}static create(f,U){return new r(f,U)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.key<f.key)return-1;if(this.key>f.key)return 1;const U=this.regexp?this.regexp.source:"",F=f.regexp?f.regexp.source:"";return U<F?-1:U>F?1:0}equals(f){if(f.type===this.type){const U=this.regexp?this.regexp.source:"",F=f.regexp?f.regexp.source:"";return this.key===f.key&&U===F}return!1}evaluate(f){let U=f.getValue(this.key);return this.regexp?this.regexp.test(U):!1}serialize(){const f=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${f}`}keys(){return[this.key]}map(f){return f.mapRegex(this.key,this.regexp)}negate(){return i.create(this)}}e.ContextKeyRegexExpr=r;class i{constructor(f){this._actual=f,this.type=8}static create(f){return new i(f)}cmp(f){return f.type!==this.type?this.type-f.type:this._actual.cmp(f._actual)}equals(f){return f.type===this.type?this._actual.equals(f._actual):!1}evaluate(f){return!this._actual.evaluate(f)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(f){return new i(this._actual.map(f))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;class o{constructor(f){this.expr=f,this.type=6}static create(f){return o._normalizeArr(f)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const z=n(this.expr[U],f.expr[U]);if(z!==0)return z}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(f.expr[U]))return!1;return!0}return!1}evaluate(f){for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].evaluate(f))return!1;return!0}static _normalizeArr(f){const U=[];let F=!1;for(const z of f)if(!!z){if(z.type===1){F=!0;continue}if(z.type===0)return m.INSTANCE;if(z.type===6){U.push(...z.expr);continue}U.push(z)}if(U.length===0&&F)return d.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];for(U.sort(n);U.length>1;){const z=U[U.length-1];if(z.type!==9)break;U.pop();const $=U.pop(),H=u.create(z.expr.map(V=>o.create([V,$])));H&&(U.push(H),U.sort(n))}return U.length===1?U[0]:new o(U)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(let U of this.expr)f.push(...U.keys());return f}map(f){return new o(this.expr.map(U=>U.map(f)))}negate(){let f=[];for(let U of this.expr)f.push(U.negate());return u.create(f)}}e.ContextKeyAndExpr=o;class u{constructor(f){this.expr=f,this.type=9}static create(f){const U=u._normalizeArr(f);if(U.length!==0)return U.length===1?U[0]:new u(U)}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let U=0,F=this.expr.length;U<F;U++){const z=n(this.expr[U],f.expr[U]);if(z!==0)return z}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let U=0,F=this.expr.length;U<F;U++)if(!this.expr[U].equals(f.expr[U]))return!1;return!0}return!1}evaluate(f){for(let U=0,F=this.expr.length;U<F;U++)if(this.expr[U].evaluate(f))return!0;return!1}static _normalizeArr(f){let U=[],F=!1;if(f){for(let z=0,$=f.length;z<$;z++){const H=f[z];if(!!H){if(H.type===0){F=!0;continue}if(H.type===1)return[d.INSTANCE];if(H.type===9){U=U.concat(H.expr);continue}U.push(H)}}if(U.length===0&&F)return[m.INSTANCE];U.sort(n)}return U}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(let U of this.expr)f.push(...U.keys());return f}map(f){return new u(this.expr.map(U=>U.map(f)))}negate(){let f=[];for(let F of this.expr)f.push(F.negate());const U=F=>F.type===9?F.expr:[F];for(;f.length>1;){const F=f.shift(),z=f.shift(),$=[];for(const H of U(F))for(const V of U(z))$.push(w.and(H,V));f.unshift(w.or(...$))}return f[0]}}e.ContextKeyOrExpr=u;class c extends g{constructor(f,U,F){super(f);this._defaultValue=U,typeof F=="object"?c._info.push({...F,key:f}):F!==!0&&c._info.push({key:f,description:F,type:U!=null?typeof U:void 0})}static all(){return c._info.values()}bindTo(f){return f.createKey(this.key,this._defaultValue)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return w.not(this.key)}isEqualTo(f){return w.equals(this.key,f)}notEqualsTo(f){return w.notEquals(this.key,f)}}e.RawContextKey=c,c._info=[],e.IContextKeyService=k.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function l(E,f){return E<f?-1:E>f?1:0}function y(E,f,U,F){return E<U?-1:E>U?1:f<F?-1:f>F?1:0}}),define(Z[71],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=v.createDecorator(e.ID);function k(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=k}),define(Z[72],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=v.createDecorator("downloadService")}),define(Z[9],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=v.createDecorator("environmentService"),e.INativeEnvironmentService=v.refineServiceDecorator(e.IEnvironmentService)}),define(Z[28],ee([0,1,110,4,17]),function(K,e,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function A(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=A;var O;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=5]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(O=e.SortBy||(e.SortBy={}));var P;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var S;(function(m){m.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var w;(function(m){m[m.None=0]="None",m[m.Install=1]="Install",m[m.Update=2]="Update"})(w=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=k.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(d,g){super(d);this.code=g,this.name=g}}e.ExtensionManagementError=n,e.IExtensionManagementService=k.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=k.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=k.createDecorator("IExtensionTipsService"),e.DefaultIconPath=L.FileAccess.asBrowserUri("./media/defaultIcon.png",K).toString(!0),e.ExtensionsLabel=v.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=v.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=k.createDecorator("IExtensionManagementCLIService")});var Y=this&&this.__param||function(K,e){return function(v,k){e(v,k,K)}};define(Z[144],ee([0,1,2,28]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let L=class extends v.Disposable{constructor(O){super();this.extensionManagementService=O,this._register(O),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};L=de([Y(0,k.IExtensionManagementService)],L),e.DeprecatedExtensionsCleaner=L}),define(Z[73],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var k;(function(O){O[O.FILE=1]="FILE",O[O.WORKSPACE=2]="WORKSPACE",O[O.EXE=3]="EXE"})(k=e.RecommendationSource||(e.RecommendationSource={}));function L(O){switch(O){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=L;var A;(function(O){O.Ignored="ignored",O.Cancelled="cancelled",O.TooMany="toomany",O.IncompatibleWindow="incompatibleWindow",O.Accepted="reacted"})(A=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=v.createDecorator("IExtensionRecommendationNotificationService")}),define(Z[74],ee([0,1,20,4]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function L(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkspaceSupportTypeMessage=L;function A(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var O;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(O=e.ExtensionType||(e.ExtensionType={}));class P{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,d){if(typeof m=="undefined"||m===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof m=="string"||typeof d=="string"){let g=typeof m=="string"?m:m.value,h=typeof d=="string"?d:d.value;return v.equalsIgnoreCase(g,h)}return m._lower===d._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=P;function S(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=S;function w(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=w,e.IBuiltinExtensionsScannerService=k.createDecorator("IBuiltinExtensionsScannerService")}),define(Z[33],ee([0,1,20,74]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function L(h,C){return h.uuid&&C.uuid?h.uuid===C.uuid:h.id===C.id?!0:v.compareIgnoreCase(h.id,C.id)===0}e.areSameExtensions=L;class A{constructor(C,D){this.version=D,this.id=C.id,this.uuid=C.uuid}key(){return`${this.id}-${this.version}`}equals(C){return C instanceof A?L(this,C)&&this.version===C.version:!1}}e.ExtensionIdentifierWithVersion=A;function O(h,C){return`${h}.${C}`}e.getExtensionId=O;function P(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function S(h,C){return P(O(h,C))}e.getGalleryExtensionId=S;function w(h,C){const D=[],b=I=>{for(const p of D)if(p.some(s=>L(C(s),C(I))))return p;return null};for(const I of h){const p=b(I);p?p.push(I):D.push([I])}return D}e.groupByExtension=w;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function m(h){return{id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0),...h.telemetryData}}e.getGalleryExtensionTelemetryData=m,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function d(h){const C=new Set;for(const D of h)D.malicious&&C.add(D.id.id);return C}e.getMaliciousExtensionsSet=d;function g(h,C){const D=[],b=C.manifest.extensionDependencies?.slice(0)??[];for(;b.length;){const I=b.shift();if(I&&D.every(p=>!L(p.identifier,{id:I}))){const p=h.filter(s=>L(s.identifier,{id:I}));p.length===1&&(D.push(p[0]),b.push(...p[0].manifest.extensionDependencies?.slice(0)??[]))}}return D}e.getExtensionDependencies=g}),define(Z[145],ee([0,1,2,8,74,18]),function(K,e,v,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends v.Disposable{constructor(S,w){super();this.environmentService=S,this.extensionsManifestCache=k.join(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(w.onDidInstallExtension(n=>this.onDidInstallExtension(n))),this._register(w.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtension(S){S.error||this.invalidate()}onDidUnInstallExtension(S){S.error||this.invalidate()}invalidate(){A.Promises.rm(this.extensionsManifestCache,A.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=O}),define(Z[10],ee([0,1,117,8,5,4,20,16,38]),function(K,e,v,k,L,A,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=A.createDecorator("fileService");function w(_){return _.create===!0}e.isFileOpenForWriteOptions=w;var n;(function(_){_[_.Unknown=0]="Unknown",_[_.File=1]="File",_[_.Directory=2]="Directory",_[_.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var m;(function(_){_[_.Readonly=1]="Readonly"})(m=e.FilePermission||(e.FilePermission={}));var d;(function(_){_[_.FileReadWrite=2]="FileReadWrite",_[_.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",_[_.FileReadStream=16]="FileReadStream",_[_.FileFolderCopy=8]="FileFolderCopy",_[_.PathCaseSensitive=1024]="PathCaseSensitive",_[_.Readonly=2048]="Readonly",_[_.Trash=4096]="Trash",_[_.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function g(_){return!!(_.capabilities&2)}e.hasReadWriteCapability=g;function h(_){return!!(_.capabilities&8)}e.hasFileFolderCopyCapability=h;function C(_){return!!(_.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function D(_){return!!(_.capabilities&16)}e.hasFileReadStreamCapability=D;var b;(function(_){_.FileExists="EntryExists",_.FileNotFound="EntryNotFound",_.FileNotADirectory="EntryNotADirectory",_.FileIsADirectory="EntryIsADirectory",_.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",_.FileTooLarge="EntryTooLarge",_.FileWriteLocked="EntryWriteLocked",_.NoPermissions="NoPermissions",_.Unavailable="Unavailable",_.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class I extends Error{constructor(x,j){super(x);this.code=j}}e.FileSystemProviderError=I;function p(_,x){const j=new I(_.toString(),x);return a(j,x),j}e.createFileSystemProviderError=p;function s(_){return _||p(v.localize(0,null),b.Unknown)}e.ensureFileSystemProviderError=s;function a(_,x){return _.name=x?`${x} (FileSystemError)`:"FileSystemError",_}e.markAsFileSystemProviderError=a;function t(_){if(!_)return b.Unknown;if(_ instanceof I)return _.code;const x=/^(.+) \(FileSystemError\)$/.exec(_.name);if(!x)return b.Unknown;switch(x[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(_){if(_ instanceof y)return _.fileOperationResult;switch(t(_)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var i;(function(_){_[_.CREATE=0]="CREATE",_[_.DELETE=1]="DELETE",_[_.MOVE=2]="MOVE",_[_.COPY=3]="COPY"})(i=e.FileOperation||(e.FileOperation={}));class o{constructor(x,j,q){this.resource=x,this.operation=j,this.target=q}isOperation(x){return this.operation===x}}e.FileOperationEvent=o;var u;(function(_){_[_.UPDATED=0]="UPDATED",_[_.ADDED=1]="ADDED",_[_.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class c{constructor(x,j){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const q of x)switch(q.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>j)),this.added.set(q.resource,q);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>j)),this.updated.set(q.resource,q);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>j)),this.deleted.set(q.resource,q);break}}contains(x,...j){return this.doContains(x,{includeChildren:!1},...j)}affects(x,...j){return this.doContains(x,{includeChildren:!0},...j)}doContains(x,j,...q){if(!x)return!1;const R=q.length>0;return!!((!R||q.includes(1))&&(this.added?.get(x)||j.includeChildren&&this.added?.findSuperstr(x))||(!R||q.includes(0))&&(this.updated?.get(x)||j.includeChildren&&this.updated?.findSuperstr(x))||(!R||q.includes(2))&&(this.deleted?.findSubstr(x)||j.includeChildren&&this.deleted?.findSuperstr(x)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=c;function l(_,x,j){return!_||!x||_===x||x.length>_.length?!1:(x.charAt(x.length-1)!==k.sep&&(x+=k.sep),j?O.startsWithIgnoreCase(_,x):_.indexOf(x)===0)}e.isParent=l;class y extends Error{constructor(x,j,q){super(x);this.fileOperationResult=j,this.options=q}}e.FileOperationError=y;class E extends y{constructor(x,j,q){super(x,2,q);this.stat=j}}e.NotModifiedSinceFileOperationError=E;var f;(function(_){_[_.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",_[_.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",_[_.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",_[_.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",_[_.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",_[_.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",_[_.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",_[_.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",_[_.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",_[_.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",_[_.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",_[_.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(f=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(_){_[_.FILE=0]="FILE",_[_.FOLDER=1]="FOLDER",_[_.ROOT_FOLDER=2]="ROOT_FOLDER"})(U=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function F(_){if(!(typeof _.size!="number"||typeof _.mtime!="number"))return _.mtime.toString(29)+_.size.toString(31)}e.etag=F;async function z(_,x){if(!x.canHandleResource(L.URI.from({scheme:_.scheme})))return new Promise(j=>{const q=x.onDidChangeFileSystemProviderRegistrations(R=>{R.scheme===_.scheme&&R.added&&(q.dispose(),j())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(x){return P.isNumber(x)||(x=0),x<$.KB?v.localize(1,null,x.toFixed(0)):x<$.MB?v.localize(2,null,(x/$.KB).toFixed(2)):x<$.GB?v.localize(3,null,(x/$.MB).toFixed(2)):x<$.TB?v.localize(4,null,(x/$.GB).toFixed(2)):v.localize(5,null,(x/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var H;(function(_){_[_.IA32=0]="IA32",_[_.OTHER=1]="OTHER"})(H=e.Arch||(e.Arch={}));function V(_){return{maxFileSize:_===0?300*$.MB:16*$.GB,maxHeapSize:_===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=V}),define(Z[146],ee([0,1,147,47,10]),function(K,e,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let A=class{constructor(P){this.fileService=P}checksum(P){return new Promise(async(S,w)=>{const n=v.createHash("md5"),m=(await this.fileService.readFileStream(P)).value;k.listenStream(m,{onData:d=>n.update(d.buffer),onError:d=>w(d),onEnd:()=>S(n.digest("base64").replace(/=+$/,""))})})}};A=de([Y(0,L.IFileService)],A),e.ChecksumService=A}),define(Z[75],ee([0,1,5,10,7]),function(K,e,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function A(S){return S.map(w=>({type:w.type,resource:v.URI.file(w.path)}))}e.toFileChanges=A;function O(S){const w=new P;for(const n of S)w.processEvent(n);return w.normalize()}e.normalizeFileChanges=O;class P{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(w){const n=this.mapPathToChange.get(w.path);if(n){const m=n.type,d=w.type;m===1&&d===2?(this.mapPathToChange.delete(w.path),this.normalized.splice(this.normalized.indexOf(n),1)):m===2&&d===1?n.type=0:m===1&&d===0||(n.type=d)}else this.normalized.push(w),this.mapPathToChange.set(w.path,w)}normalize(){const w=[],n=[];return this.normalized.filter(m=>m.type!==2?(w.push(m),!1):!0).sort((m,d)=>m.path.length-d.path.length).filter(m=>n.some(d=>k.isParent(m.path,d,!L.isLinux))?!1:(n.push(m.path),!0)).concat(w)}}}),define(Z[148],ee([0,1,75,2,18,96,99,6,8]),function(K,e,v,k,L,A,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class w extends k.Disposable{constructor(m,d,g,h){super();this.path=m,this.onDidFilesChange=d,this.onLogMessage=g,this.verboseLogging=h,this.fileChangesDelayer=this._register(new P.ThrottledDelayer(O.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(m){this.verboseLogging=m}async startWatching(){try{const{stat:m,symbolicLink:d}=await L.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let g=this.path;if(d)try{g=await A.realpath(g)}catch(h){if(this.onError(h),d.dangling)return}m.isDirectory()?this._register(O.watchFolder(g,(h,C)=>{this.onFileChange({type:h==="changed"?0:h==="added"?1:2,path:S.join(this.path,S.basename(C))})},h=>this.onError(h))):this._register(O.watchFile(g,h=>{this.onFileChange({type:h==="changed"?0:2,path:this.path})},h=>this.onError(h)))}catch(m){m.code!=="ENOENT"&&this.onError(m)}}onFileChange(m){this.fileChangesBuffer.push(m),this.verboseLogging&&this.onVerbose(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const g=v.normalizeFileChanges(d);if(this.verboseLogging)for(const h of g)this.onVerbose(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);g.length>0&&this.onDidFilesChange(g)})}onError(m){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${m}`})}onVerbose(m){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=w}),define(Z[76],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class v{constructor(...L){this._entries=new Map;for(let[A,O]of L)this.set(A,O)}set(L,A){const O=this._entries.get(L);return this._entries.set(L,A),O}has(L){return this._entries.has(L)}get(L){return this._entries.get(L)}}e.ServiceCollection=v}),define(Z[149],ee([0,1,11,141,50,4,76,6]),function(K,e,v,k,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class w extends Error{constructor(h){super("cyclic dependency between services");this.message=h.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${h.toString()}`}}class n{constructor(h=new O.ServiceCollection,C=!1,D){this._activeInstantiations=new Set,this._services=h,this._strict=C,this._parent=D,this._services.set(A.IInstantiationService,this)}createChild(h){return new n(h,this._strict,this)}invokeFunction(h,...C){let D=d.traceInvocation(h),b=!1;try{return h({get:(p,s)=>{if(b)throw v.illegalState("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(p,D);if(!a&&s!==A.optional)throw new Error(`[invokeFunction] unknown service '${p}'`);return a}},...C)}finally{b=!0,D.stop()}}createInstance(h,...C){let D,b;return h instanceof L.SyncDescriptor?(D=d.traceCreation(h.ctor),b=this._createInstance(h.ctor,h.staticArguments.concat(C),D)):(D=d.traceCreation(h),b=this._createInstance(h,C,D)),D.stop(),b}_createInstance(h,C=[],D){let b=A._util.getServiceDependencies(h).sort((s,a)=>s.index-a.index),I=[];for(const s of b){let a=this._getOrCreateServiceInstance(s.id,D);if(!a&&this._strict&&!s.optional)throw new Error(`[createInstance] ${h.name} depends on UNKNOWN service ${s.id}.`);I.push(a)}let p=b.length>0?b[0].index:C.length;if(C.length!==p){console.warn(`[createInstance] First service dependency of ${h.name} at position ${p+1} conflicts with ${C.length} static arguments`);let s=p-C.length;s>0?C=C.concat(new Array(s)):C=C.slice(0,p)}return new h(...[...C,...I])}_setServiceInstance(h,C){if(this._services.get(h)instanceof L.SyncDescriptor)this._services.set(h,C);else if(this._parent)this._parent._setServiceInstance(h,C);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(h){let C=this._services.get(h);return!C&&this._parent?this._parent._getServiceInstanceOrDescriptor(h):C}_getOrCreateServiceInstance(h,C){let D=this._getServiceInstanceOrDescriptor(h);return D instanceof L.SyncDescriptor?this._safeCreateAndCacheServiceInstance(h,D,C.branch(h,!0)):(C.branch(h,!1),D)}_safeCreateAndCacheServiceInstance(h,C,D){if(this._activeInstantiations.has(h))throw new Error(`illegal state - RECURSIVELY instantiating service '${h}'`);this._activeInstantiations.add(h);try{return this._createAndCacheServiceInstance(h,C,D)}finally{this._activeInstantiations.delete(h)}}_createAndCacheServiceInstance(h,C,D){const b=new k.Graph(s=>s.id.toString());let I=0;const p=[{id:h,desc:C,_trace:D}];for(;p.length;){const s=p.pop();if(b.lookupOrInsertNode(s),I++>1e3)throw new w(b);for(let a of A._util.getServiceDependencies(s.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${h} depends on ${a.id} which is NOT registered.`),t instanceof L.SyncDescriptor){const r={id:a.id,desc:t,_trace:s._trace.branch(a.id,!0)};b.insertEdge(s,r),p.push(r)}}}for(;;){const s=b.roots();if(s.length===0){if(!b.isEmpty())throw new w(b);break}for(const{data:a}of s){if(this._getServiceInstanceOrDescriptor(a.id)instanceof L.SyncDescriptor){const r=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,r)}b.removeNode(a)}}return this._getServiceInstanceOrDescriptor(h)}_createServiceInstanceWithOwner(h,C,D=[],b,I){if(this._services.get(h)instanceof L.SyncDescriptor)return this._createServiceInstance(C,D,b,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(h,C,D,b,I);throw new Error(`illegalState - creating UNKNOWN service instance ${C.name}`)}_createServiceInstance(h,C=[],D,b){if(D){const I=new P.IdleValue(()=>this._createInstance(h,C,b));return new Proxy(Object.create(null),{get(p,s){if(s in p)return p[s];let a=I.value,t=a[s];return typeof t!="function"||(t=t.bind(a),p[s]=t),t},set(p,s,a){return I.value[s]=a,!0}})}else return this._createInstance(h,C,b)}}e.InstantiationService=n;var m;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(m||(m={}));class d{constructor(h,C){this.type=h,this.name=C,this._start=Date.now(),this._dep=[]}static traceInvocation(h){return S?new d(1,h.name||h.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(h){return S?new d(0,h.name):d._None}branch(h,C){let D=new d(2,h.toString());return this._dep.push([h,C,D]),D}stop(){let h=Date.now()-this._start;d._totals+=h;let C=!1;function D(I,p){let s=[],a=new Array(I+1).join("	");for(const[t,r,i]of p._dep)if(r&&i){C=!0,s.push(`${a}CREATES -> ${t}`);let o=D(I+1,i);o&&s.push(o)}else s.push(`${a}uses -> ${t}`);return s.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${D(1,this)}`,`DONE, took ${h.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(h>2||C)&&console.log(b.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(Z[150],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class v{constructor(L,A){this.server=L,this.router=A}getChannel(L){return this.server.getChannel(L,this.router)}registerChannel(L,A){this.server.registerChannel(L,A)}}e.MessagePortMainProcessService=v}),define(Z[151],ee([0,1,36,50,140,4]),function(K,e,v,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class O{constructor(g,h,C){const D=C.getChannel(g);return P(h)?new h.channelClientCtor(D):v.ProxyChannel.toService(D,h?.proxyOptions)}}function P(d){return!!d?.channelClientCtor}e.IMainProcessService=A.createDecorator("mainProcessService");let S=class extends O{constructor(g,h,C){super(g,h,C)}};S=de([Y(2,e.IMainProcessService)],S);function w(d,g,h){L.registerSingleton(d,new k.SyncDescriptor(S,[g,h],h?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=w,e.ISharedProcessService=A.createDecorator("sharedProcessService");let n=class extends O{constructor(g,h,C){super(g,h,C)}};n=de([Y(2,e.ISharedProcessService)],n);function m(d,g,h){L.registerSingleton(d,new k.SyncDescriptor(n,[g,h],h?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=m}),define(Z[56],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=v.createDecorator("localizationsService");function k(L){if(typeof L.languageId!="string"||!Array.isArray(L.translations)||L.translations.length===0)return!1;for(const A of L.translations)if(typeof A.id!="string"||typeof A.path!="string")return!1;return!(L.languageName&&typeof L.languageName!="string"||L.localizedLanguageName&&typeof L.localizedLanguageName!="string")}e.isValidLocalization=k}),define(Z[152],ee([0,1,2,56]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let L=class extends v.Disposable{constructor(O){super();this.localizationsService=O,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};L=de([Y(0,k.ILocalizationsService)],L),e.LocalizationsUpdater=L}),define(Z[15],ee([0,1,4,2,7,3,43]),function(K,e,v,k,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=v.createDecorator("logService"),e.ILoggerService=v.createDecorator("loggerService");function P(){return new Date().toISOString()}var S;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class w extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new A.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class n extends w{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(S.Error))if(t instanceof Error){const i=Array.prototype.slice.call(arguments);i[0]=t.stack,this.log(S.Error,this.format(i))}else this.log(S.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let i=0;i<t.length;i++){let o=t[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch(u){}r+=(i>0?" ":"")+o}return r}}e.AbstractMessageLogger=n;class m extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!L.isWindows}trace(t,...r){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}debug(t,...r){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}info(t,...r){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...r):console.log(`[main ${P()}]`,t,...r))}warn(t,...r){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...r):console.warn(`[main ${P()}]`,t,...r))}error(t,...r){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}critical(t,...r){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...r):console.error(`[main ${P()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=m;class d extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=d;class g extends w{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:O.toErrorMessage(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=g;class h extends w{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const i of this.logServices)i.trace(t,...r)}debug(t,...r){for(const i of this.logServices)i.debug(t,...r)}info(t,...r){for(const i of this.logServices)i.info(t,...r)}warn(t,...r){for(const i of this.logServices)i.warn(t,...r)}error(t,...r){for(const i of this.logServices)i.error(t,...r)}critical(t,...r){for(const i of this.logServices)i.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=h;class C extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=C;class D extends k.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(i=>{this.logLevel=i,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(i))}))}createLogger(t,r){let i=this.loggers.get(t.toString());return i||(i=this.doCreateLogger(t,r?.always?S.Trace:this.logLevel,r),this.loggers.set(t.toString(),i),r?.always||this.logLevelChangeableLoggers.push(i)),i}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=D;class b{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function I(a){if(a.verbose)return S.Trace;if(typeof a.logLevel=="string"){const t=p(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=I;function p(a){switch(a){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=p;function s(a){switch(a){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=s}),define(Z[153],ee([0,1,9,8,18,11,2,6,15]),function(K,e,v,k,L,A,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let w=class extends O.Disposable{constructor(m,d){super();this.environmentService=m,this.logService=d,this._register(new P.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.info("[logs cleanup]: Starting to clean up old logs.");try{const m=k.basename(this.environmentService.logsPath),d=k.dirname(this.environmentService.logsPath),C=(await L.Promises.readdir(d)).filter(b=>/^\d{8}T\d{6}$/.test(b)).sort().filter(b=>b!==m),D=C.slice(0,Math.max(0,C.length-9));D.length>0&&(this.logService.info(`[logs cleanup]: Removing log folders '${D.join(", ")}'`),await Promise.all(D.map(b=>L.Promises.rm(k.join(d,b)))))}catch(m){A.onUnexpectedError(m)}}};w=de([Y(0,v.IEnvironmentService),Y(1,S.ILogService)],w),e.LogsDataCleaner=w}),define(Z[154],ee([0,1,9,8,18,11,2,6,15]),function(K,e,v,k,L,A,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let w=class lt extends O.Disposable{constructor(m,d,g){super();this.backupWorkspacesPath=m,this.environmentService=d,this.logService=g,this._register(new P.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.info("[storage cleanup]: Starting to clean up storage folders.");try{const m=await L.Promises.readFile(this.backupWorkspacesPath,"utf8"),g=JSON.parse(m).emptyWorkspaceInfos.map(C=>C.backupFolder),h=await L.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(h.map(async C=>{C.length!==lt.NON_EMPTY_WORKSPACE_ID_LENGTH&&g.indexOf(C)===-1&&(this.logService.info(`[storage cleanup]: Deleting storage folder ${C}.`),await L.Promises.rm(k.join(this.environmentService.workspaceStorageHome.fsPath,C)))}))}catch(m){A.onUnexpectedError(m)}}};w.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,w=de([Y(1,v.INativeEnvironmentService),Y(2,S.ILogService)],w),e.StorageDataCleaner=w}),define(Z[155],ee([0,1,18,2,10,28,9,5,14,33,15,30,57,7,6,11]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let b=class extends k.Disposable{constructor(p,s,a,t){super();this.fileService=s,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=P.URI.file(p.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(p,s){await this.cleanUpPromise;const a=this.getName(p),t=S.joinPath(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const r=S.joinPath(this.extensionsDownloadDir,`.${m.generateUuid()}`);await this.fileService.exists(r)||await this.extensionGalleryService.download(p,r,s);try{await this.rename(r,t,Date.now()+2*60*1e3)}catch(i){try{await this.fileService.del(r)}catch(o){}if(i.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",p.identifier.id);else throw this.logService.info(`Rename failed because of ${C.getErrorMessage(i)}. Deleted the vsix from downloaded location`,r.path),i}}return t}async delete(p){}async rename(p,s,a){try{await v.Promises.rename(p.fsPath,s.fsPath)}catch(t){if(g.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${p} to ${s} with 'EPERM' error. Trying again...`),this.rename(p,s,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const p=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(p.children){const s=[],a=[];for(const i of p.children){const o=this.parse(i.name);o&&a.push([o,i])}const t=w.groupByExtension(a,([i])=>i),r=[];for(const i of t)i.sort((o,u)=>d.rcompare(o[0].version,u[0].version)),s.push(...i.slice(1).map(o=>o[1].resource)),r.push(i[0][1]);r.sort((i,o)=>i.mtime-o.mtime),s.push(...r.slice(0,Math.max(0,r.length-this.cache)).map(i=>i.resource)),await h.Promises.settled(s.map(i=>(this.logService.trace("Deleting vsix from cache",i.path),this.fileService.del(i))))}}catch(p){this.logService.error(p)}}getName(p){return this.cache?new w.ExtensionIdentifierWithVersion(p.identifier,p.version).key().toLowerCase():m.generateUuid()}parse(p){const s=D.exec(p);return s&&s[1]&&s[2]?new w.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};b=de([Y(0,O.INativeEnvironmentService),Y(1,L.IFileService),Y(2,A.IExtensionGalleryService),Y(3,n.ILogService)],b),e.ExtensionsDownloader=b}),define(Z[156],ee([0,1,2,15,42,43,8,6,3,17,18,9]),function(K,e,v,k,L,A,O,P,S,w,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends v.Disposable{constructor(h,C){super();this.environmentService=h,this.logService=C,this.processesLimiter=new P.Limiter(5)}async postUninstall(h){const C=this.parseScript(h,"uninstall");return C&&(this.logService.info(h.identifier.id,h.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(C.script,"uninstall",C.args,!0,h).then(()=>this.logService.info(h.identifier.id,h.manifest.version,"Finished running post uninstall script"),D=>this.logService.error(h.identifier.id,h.manifest.version,`Failed to run post uninstall script: ${D}`)))),n.Promises.rm(this.getExtensionStoragePath(h)).then(void 0,D=>this.logService.error("Error while removing extension storage path",D))}parseScript(h,C){const D=`vscode:${C}`;if(h.location.scheme===w.Schemas.file&&h.manifest&&h.manifest.scripts&&typeof h.manifest.scripts[D]=="string"){const b=h.manifest.scripts[D].split(" ");return b.length<2||b[0]!=="node"||!b[1]?(this.logService.warn(h.identifier.id,h.manifest.version,`${D} should be a node script`),null):{script:O.join(h.location.fsPath,b[1]),args:b.slice(2)||[]}}return null}runLifecycleHook(h,C,D,b,I){return new Promise((p,s)=>{const a=this.start(h,C,D,I);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?s(i):p(void 0)};a.on("error",i=>{r(A.toErrorMessage(i)||"Unknown")}),a.on("exit",(i,o)=>{r(i?`post-${C} process exited with code ${i}`:void 0)}),b&&(t=setTimeout(()=>{t=null,a.kill(),s("timed out")},5e3))})}start(h,C,D,b){const I={silent:!0,execArgv:void 0},p=L.fork(h,[`--type=extension-post-${C}`,...D],I);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const s=S.Event.fromNodeEventEmitter(p.stdout,"data"),a=S.Event.fromNodeEventEmitter(p.stderr,"data");s(i=>this.logService.info(b.identifier.id,b.manifest.version,`post-${C}`,i)),a(i=>this.logService.error(b.identifier.id,b.manifest.version,`post-${C}`,i));const t=S.Event.any(S.Event.map(s,i=>({data:`%c${i}`,format:[""]})),S.Event.map(a,i=>({data:`%c${i}`,format:["color: red"]})));return S.Event.debounce(t,(i,o)=>i?{data:i.data+o.data,format:[...i.format,...o.format]}:{data:o.data,format:o.format},100)(i=>{console.group(b.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),p}getExtensionStoragePath(h){return O.join(this.environmentService.globalStorageHome.fsPath,h.identifier.id.toLowerCase())}};d=de([Y(0,m.IEnvironmentService),Y(1,k.ILogService)],d),e.ExtensionsLifecycle=d}),define(Z[157],ee([0,1,2,9,3,10,5,33,14,15]),function(K,e,v,k,L,A,O,P,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends v.Disposable{constructor(d,g,h,C){super();this.extensionsManagementService=d,this.logService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new L.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(I=>{this.installedExtensions=I.map(p=>p.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(I=>this.onInstallExtension(I))),this._register(d.onDidInstallExtension(I=>this.onDidInstallExtension(I))),this._register(d.onDidUninstallExtension(I=>this.onDidUninstallExtension(I)));const D=O.URI.file(h.extensionsPath),b=new S.ExtUri(I=>!g.hasCapability(I,1024));this._register(g.watch(D)),this._register(L.Event.filter(g.onDidChangeFilesRaw,I=>I.changes.some(p=>this.doesChangeAffects(p,D,b)))(()=>this.onDidChange()))}doesChangeAffects(d,g,h){return h.isEqual(h.dirname(d.resource),g)?h.isEqual(d.resource,h.joinPath(g,".obsolete"))?!0:!(d.type!==1&&d.type!==2||h.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtension(d){this.removeInstallingExtension(d.identifier),d.error||this.addInstalledExtension(d.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(g=>!P.areSameExtensions(g,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(g=>!P.areSameExtensions(g,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),g=d.filter(C=>[...this.installingExtensions,...this.installedExtensions].some(D=>P.areSameExtensions(D,C.identifier))?!1:C.installedTimestamp&&C.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",C.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",C.identifier.id),!1)),h=this.installedExtensions.filter(C=>this.installingExtensions.some(D=>P.areSameExtensions(D,C))?!1:d.every(D=>!P.areSameExtensions(D.identifier,C))?(this.logService.info("Detected extension removed from another source",C.id),!0):!1);this.installedExtensions=d.map(C=>C.identifier),(g.length||h.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:g,removed:h})}}};n=de([Y(1,A.IFileService),Y(2,k.INativeEnvironmentService),Y(3,w.ILogService)],n),e.ExtensionsWatcher=n}),define(Z[158],ee([0,1,18,147,28,2,9,6,33,15,56,19,3,17,8]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let C=class extends A.Disposable{constructor(I,p,s){super();this.extensionManagementService=I,this.logService=s,this._onDidLanguagesChange=this._register(new d.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new D(p,s)),this._register(I.onDidInstallExtension(({local:a})=>this.onDidInstallExtension(a))),this._register(I.onDidUninstallExtension(({identifier:a})=>this.onDidUninstallExtension(a)))}getLanguageIds(){return this.cache.getLanguagePacks().then(I=>{const p=["en",...Object.keys(I)];return m.distinct(p)})}onDidInstallExtension(I){I&&I.manifest&&I.manifest.contributes&&I.manifest.contributes.localizations&&I.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",I.identifier.id),this.update().then(p=>{p&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(I){this.cache.getLanguagePacks().then(p=>{Object.keys(p).some(s=>p[s]&&p[s].extensions.some(a=>S.areSameExtensions(a.extensionIdentifier,I)))&&(this.logService.debug("Removing language packs from the extension",I.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))})}async update(){const[I,p]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),s=await this.cache.update(p);return!m.equals(Object.keys(I),Object.keys(s))}};C=de([Y(0,L.IExtensionManagementService),Y(1,O.INativeEnvironmentService),Y(2,w.ILogService)],C),e.LocalizationsService=C;let D=class extends A.Disposable{constructor(I,p){super();this.logService=p,this.languagePacks={},this.languagePacksFilePath=h.join(I.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new P.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(I){return this.withLanguagePacks(p=>{Object.keys(p).forEach(s=>delete p[s]),this.createLanguagePacksFromExtensions(p,...I)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(I,...p){for(const s of p)s&&s.manifest&&s.manifest.contributes&&s.manifest.contributes.localizations&&s.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(I,s);Object.keys(I).forEach(s=>this.updateHash(I[s]))}createLanguagePacksFromExtension(I,p){const s=p.identifier,a=p.manifest.contributes&&p.manifest.contributes.localizations?p.manifest.contributes.localizations:[];for(const t of a)if(p.location.scheme===g.Schemas.file&&n.isValidLocalization(t)){let r=I[t.languageId];r||(r={hash:"",extensions:[],translations:{}},I[t.languageId]=r);let i=r.extensions.filter(o=>S.areSameExtensions(o.extensionIdentifier,s))[0];i?i.version=p.manifest.version:r.extensions.push({extensionIdentifier:s,version:p.manifest.version});for(const o of t.translations)r.translations[o.id]=h.join(p.location.fsPath,o.path)}}updateHash(I){if(I){const p=k.createHash("md5");for(const s of I.extensions)p.update(s.extensionIdentifier.uuid||s.extensionIdentifier.id).update(s.version);I.hash=p.digest("hex")}}withLanguagePacks(I=()=>null){return this.languagePacksFileLimiter.queue(()=>{let p=null;return v.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,s=>s.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(s)).then(s=>{try{return JSON.parse(s)}catch(a){return{}}}).then(s=>(p=I(s),s)).then(s=>{for(const t of Object.keys(s))s[t]||delete s[t];this.languagePacks=s,this.initializedCache=!0;const a=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",a),v.Promises.writeFile(this.languagePacksFilePath,a)}).then(()=>p,s=>this.logService.error(s))})}};D=de([Y(0,O.INativeEnvironmentService),Y(1,w.ILogService)],D)}),define(Z[77],ee([0,1,15,3,5]),function(K,e,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class A{constructor(d){this.service=d,this.onDidChangeLogLevel=k.Event.buffer(d.onDidChangeLogLevel,!0)}listen(d,g){switch(g){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${g}`)}async call(d,g,h){switch(g){case"setLevel":return this.service.setLevel(h)}throw new Error(`Call not found: ${g}`)}}e.LogLevelChannel=A;class O{constructor(d){this.channel=d}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(d){O.setLevel(this.channel,d)}static setLevel(d,g){return d.call("setLevel",g)}}e.LogLevelChannelClient=O;class P{constructor(d){this.loggerService=d,this.loggers=new Map}listen(d,g){throw new Error(`Event not found: ${g}`)}async call(d,g,h){switch(g){case"createLogger":this.createLogger(L.URI.revive(h[0]),h[1]);return;case"log":return this.log(L.URI.revive(h[0]),h[1]);case"consoleLog":return this.consoleLog(h[0],h[1])}throw new Error(`Call not found: ${g}`)}createLogger(d,g){this.loggers.set(d.toString(),this.loggerService.createLogger(d,g))}consoleLog(d,g){let h=console.log;switch(d){case v.LogLevel.Error:h=console.error;break;case v.LogLevel.Warning:h=console.warn;break;case v.LogLevel.Info:h=console.info;break}h.call(console,...g)}log(d,g){const h=this.loggers.get(d.toString());if(!h)throw new Error("Create the logger before logging");for(const[C,D]of g)switch(C){case v.LogLevel.Trace:h.trace(D);break;case v.LogLevel.Debug:h.debug(D);break;case v.LogLevel.Info:h.info(D);break;case v.LogLevel.Warning:h.warn(D);break;case v.LogLevel.Error:h.error(D);break;case v.LogLevel.Critical:h.critical(D);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=P;class S extends v.AbstractLoggerService{constructor(d,g,h){super(d,g);this.channel=h}createConsoleMainLogger(){return new v.AdapterLogger({log:(d,g)=>{this.channel.call("consoleLog",[d,g])}})}doCreateLogger(d,g,h){return new w(this.channel,d,g,h)}}e.LoggerChannelClient=S;class w extends v.AbstractMessageLogger{constructor(d,g,h,C){super(C?.always);this.channel=d,this.file=g,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(h),this.channel.call("createLogger",[g,C]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(d,g){const h=[[d,g]];this.isLoggerCreated?this.doLog(h):this.buffer.push(...h)}doLog(d){this.channel.call("log",[this.file,d])}}class n extends v.LogService{constructor(d,g){super(g);this.parent=d,this._register(d.onDidChangeLogLevel(h=>g.setLevel(h)))}setLevel(d){super.setLevel(d),this.parent.setLevel(d)}}e.FollowerLogService=n}),define(Z[58],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=v.createDecorator("nativeHostService")}),define(Z[51],ee([0,1,17,7,34,14]),function(K,e,v,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let O;if(typeof k.globals.vscode!="undefined"&&typeof k.globals.vscode.context!="undefined"){const P=k.globals.vscode.context.configuration();if(P)O=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof K?.__$__nodeRequire=="function"){const P=A.dirname(v.FileAccess.asFileUri("",K));O=K.__$__nodeRequire(A.joinPath(P,"product.json").fsPath);const S=K.__$__nodeRequire(A.joinPath(P,"package.json").fsPath);L.env.VSCODE_DEV&&Object.assign(O,{nameShort:`${O.nameShort} Dev`,nameLong:`${O.nameLong} Dev`,dataFolderName:`${O.dataFolderName}-dev`}),Object.assign(O,{version:S.version})}else O={},Object.keys(O).length===0&&Object.assign(O,{version:"1.58.0-dev",nameShort:k.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:k.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=O}),define(Z[78],ee([0,1,118,25,10,11,51]),function(K,e,v,k,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function P(m,d,g,h,C,D){let b;try{await S(m,d,g,h,C,D)}catch(I){b=I}finally{b&&C.errorTransformer&&(b=C.errorTransformer(b)),typeof b!="undefined"&&g.error(b),g.end()}}e.readFileIntoStream=P;async function S(m,d,g,h,C,D){w(D);const b=await m.open(d,{create:!1});try{w(D);let I=0,p=0,s=C&&typeof C.length=="number"?C.length:void 0,a=k.VSBuffer.alloc(Math.min(C.bufferSize,typeof s=="number"?s:C.bufferSize)),t=C&&typeof C.position=="number"?C.position:0,r=0;do p=await m.read(b,t,a.buffer,r,a.byteLength-r),t+=p,r+=p,I+=p,typeof s=="number"&&(s-=p),r===a.byteLength&&(await g.write(h(a)),a=k.VSBuffer.alloc(Math.min(C.bufferSize,typeof s=="number"?s:C.bufferSize)),r=0);while(p>0&&(typeof s!="number"||s>0)&&w(D)&&n(I,C));if(r>0){let i=r;typeof s=="number"&&(i=Math.min(r,s)),g.write(h(a.slice(0,i)))}}catch(I){throw L.ensureFileSystemProviderError(I)}finally{await m.close(b)}}function w(m){if(m.isCancellationRequested)throw A.canceled();return!0}function n(m,d){if(d?.limits){if(typeof d.limits.memory=="number"&&m>d.limits.memory)throw L.createFileSystemProviderError(v.localize(0,null,O.default.nameShort),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof d.limits.size=="number"&&m>d.limits.size)throw L.createFileSystemProviderError(v.localize(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[159],ee([0,1,116,160,2,10,3,14,38,19,15,25,47,6,29,17,78,53]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let I=class je extends L.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new O.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new O.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new O.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new O.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new O.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new O.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new O.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new g.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new A.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new g.ThrottledWorker(je.FILE_EVENTS_THROTTLING.maxChangesChunkSize,je.FILE_EVENTS_THROTTLING.maxChangesBufferSize,je.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new A.FileChangesEvent(a,!0)))),this.watchedResources=S.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new g.ResourceQueue)}registerProvider(s,a){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);k.mark(`code/registerFilesystem/${s}`),this.provider.set(s,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:a});const t=new L.DisposableStore;return t.add(a.onDidChangeFile(r=>this.onDidChangeFile(r,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:s}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(r=>this._onError.fire(new Error(r)))),L.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:a}),this.provider.delete(s),L.dispose(t)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(t){a.push(t)}}),!this.provider.has(s)&&await g.Promises.settled(a)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,a){const t=this.provider.get(s.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return b.Iterable.map(this.provider,([s,a])=>({scheme:s,capabilities:a.capabilities}))}async withProvider(s){if(!P.isAbsolutePath(s))throw new A.FileOperationError(v.localize(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const a=this.provider.get(s.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=v.localize(1,null,s.toString()),t}return a}async withReadProvider(s){const a=await this.withProvider(s);if(A.hasOpenReadWriteCloseCapability(a)||A.hasReadWriteCapability(a)||A.hasFileReadStreamCapability(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const a=await this.withProvider(s);if(A.hasOpenReadWriteCloseCapability(a)||A.hasReadWriteCapability(a))return a;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,a){try{return await this.doResolveFile(s,a)}catch(t){throw A.toFileSystemProviderErrorCode(t)===A.FileSystemProviderErrorCode.FileNotFound?new A.FileOperationError(v.localize(2,null,this.resourceForError(s)),1):A.ensureFileSystemProviderError(t)}}async doResolveFile(s,a){const t=await this.withProvider(s),r=this.isPathCaseSensitive(t),i=a?.resolveTo,o=a?.resolveSingleChildDescendants,u=a?.resolveMetadata,c=await t.stat(s);let l;return this.toFileStat(t,s,c,void 0,!!u,(y,E)=>(l||(l=S.TernarySearchTree.forUris(()=>!r),l.set(s,!0),w.isNonEmptyArray(i)&&i.forEach(f=>l.set(f,!0))),Boolean(l.findSuperstr(y.resource)||l.get(y.resource))?!0:y.isDirectory&&o?E===1:!1))}async toFileStat(s,a,t,r,i,o){const{providerExtUri:u}=this.getExtUri(s),c={resource:a,name:u.basename(a),isFile:(t.type&A.FileType.File)!=0,isDirectory:(t.type&A.FileType.Directory)!=0,isSymbolicLink:(t.type&A.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&A.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:A.etag({mtime:t.mtime,size:t.size})};if(c.isDirectory&&o(c,r)){try{const l=await s.readdir(a),y=await g.Promises.settled(l.map(async([E,f])=>{try{const U=u.joinPath(a,E),F=i?await s.stat(U):{type:f};return await this.toFileStat(s,U,F,l.length,i,o)}catch(U){return this.logService.trace(U),null}}));c.children=w.coalesce(y)}catch(l){this.logService.trace(l),c.children=[]}return c}return c}async resolveAll(s){return g.Promises.settled(s.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(s){const a=await this.withProvider(s);try{return!!await a.stat(s)}catch(t){return!1}}async canCreateFile(s,a){try{await this.doValidateCreateFile(s,a)}catch(t){return t}return!0}async doValidateCreateFile(s,a){if(!a?.overwrite&&await this.exists(s))throw new A.FileOperationError(v.localize(3,null,this.resourceForError(s)),3,a)}async createFile(s,a=m.VSBuffer.fromString(""),t){await this.doValidateCreateFile(s,t);const r=await this.writeFile(s,a);return this._onDidRunOperation.fire(new A.FileOperationEvent(s,0,r)),r}async writeFile(s,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:i}=this.getExtUri(r);try{await this.validateWriteFile(r,s,t)||await this.mkdirp(r,i.dirname(s));let u;if(A.hasReadWriteCapability(r)&&!(a instanceof m.VSBuffer))if(d.isReadableStream(a)){const c=await d.peekStream(a,3);c.ended?u=m.VSBuffer.concat(c.buffer):u=c}else u=d.peekReadable(a,c=>m.VSBuffer.concat(c),3);else u=a;!A.hasOpenReadWriteCloseCapability(r)||A.hasReadWriteCapability(r)&&u instanceof m.VSBuffer?await this.doWriteUnbuffered(r,s,t,u):await this.doWriteBuffered(r,s,t,u instanceof m.VSBuffer?m.bufferToReadable(u):u)}catch(o){throw new A.FileOperationError(v.localize(4,null,this.resourceForError(s),A.ensureFileSystemProviderError(o).toString()),A.toFileOperationResult(o),t)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,a,t){if(!!t?.unlock&&!(s.capabilities&8192))throw new Error(v.localize(5,null,this.resourceForError(a)));let i;try{i=await s.stat(a)}catch(o){return}if((i.type&A.FileType.Directory)!=0)throw new A.FileOperationError(v.localize(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,i),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==A.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&t.mtime<i.mtime&&t.etag!==A.etag({mtime:t.mtime,size:i.size}))throw new A.FileOperationError(v.localize(7,null),3,t);return i}async readFile(s,a){const t=await this.withReadProvider(s);return a?.atomic?this.doReadFileAtomic(t,s,a):this.doReadFile(t,s,a)}async doReadFileAtomic(s,a,t){return new Promise((r,i)=>{this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(s,a,t);r(o)}catch(o){i(o)}})})}async doReadFile(s,a,t){const r=await this.doReadFileStream(s,a,{...t,preferUnbuffered:!0});return{...r,value:await m.streamToBuffer(r.value)}}async readFileStream(s,a){const t=await this.withReadProvider(s);return this.doReadFileStream(t,s,a)}async doReadFileStream(s,a,t){const r=new h.CancellationTokenSource,i=this.validateReadFile(a,t).then(u=>u,u=>{throw r.cancel(),u});let o;try{return t&&typeof t.etag=="string"&&t.etag!==A.ETAG_DISABLED&&await i,!(A.hasOpenReadWriteCloseCapability(s)||A.hasFileReadStreamCapability(s))||A.hasReadWriteCapability(s)&&t?.preferUnbuffered?o=this.readFileUnbuffered(s,a,t):A.hasFileReadStreamCapability(s)?o=this.readFileStreamed(s,a,r.token,t):o=this.readFileBuffered(s,a,r.token,t),{...await i,value:o}}catch(u){o&&await d.consumeStream(o);const c=v.localize(8,null,this.resourceForError(a),A.ensureFileSystemProviderError(u).toString());throw u instanceof A.NotModifiedSinceFileOperationError?new A.NotModifiedSinceFileOperationError(c,u.stat,t):new A.FileOperationError(c,A.toFileOperationResult(u),t)}}readFileStreamed(s,a,t,r=Object.create(null)){const i=s.readFileStream(a,r,t);return d.transform(i,{data:o=>o instanceof m.VSBuffer?o:m.VSBuffer.wrap(o),error:o=>new A.FileOperationError(v.localize(9,null,this.resourceForError(a),A.ensureFileSystemProviderError(o).toString()),A.toFileOperationResult(o),r)},o=>m.VSBuffer.concat(o))}readFileBuffered(s,a,t,r=Object.create(null)){const i=m.newWriteableBufferStream();return D.readFileIntoStream(s,a,i,o=>o,{...r,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new A.FileOperationError(v.localize(10,null,this.resourceForError(a),A.ensureFileSystemProviderError(o).toString()),A.toFileOperationResult(o),r)},t),i}readFileUnbuffered(s,a,t){const r=d.newWriteableStream(i=>m.VSBuffer.concat(i));return(async()=>{try{let i=await s.readFile(a);t&&typeof t.position=="number"&&(i=i.slice(t.position)),t&&typeof t.length=="number"&&(i=i.slice(0,t.length)),this.validateReadFileLimits(a,i.byteLength,t),r.end(m.VSBuffer.wrap(i))}catch(i){r.error(i),r.end()}})(),r}async validateReadFile(s,a){const t=await this.resolve(s,{resolveMetadata:!0});if(t.isDirectory)throw new A.FileOperationError(v.localize(11,null,this.resourceForError(s)),0,a);if(a&&typeof a.etag=="string"&&a.etag!==A.ETAG_DISABLED&&a.etag===t.etag)throw new A.NotModifiedSinceFileOperationError(v.localize(12,null),t,a);return this.validateReadFileLimits(s,t.size,a),t}validateReadFileLimits(s,a,t){if(t?.limits){let r;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(r=9),typeof t.limits.size=="number"&&a>t.limits.size&&(r=7),typeof r=="number")throw new A.FileOperationError(v.localize(13,null,this.resourceForError(s)),r)}}async canMove(s,a,t){return this.doCanMoveCopy(s,a,"move",t)}async canCopy(s,a,t){return this.doCanMoveCopy(s,a,"copy",t)}async doCanMoveCopy(s,a,t,r){if(s.toString()!==a.toString())try{const i=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(i,s,o,a,t,r)}catch(i){return i}return!0}async move(s,a,t){const r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),o=await this.doMoveCopy(r,s,i,a,"move",!!t),u=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new A.FileOperationEvent(s,o==="move"?2:3,u)),u}async copy(s,a,t){const r=await this.withReadProvider(s),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),o=await this.doMoveCopy(r,s,i,a,"copy",!!t),u=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new A.FileOperationEvent(s,o==="copy"?3:2,u)),u}async doMoveCopy(s,a,t,r,i,o){if(a.toString()===r.toString())return i;const{exists:u,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(s,a,t,r,i,o);if(u&&!c&&o&&await this.del(r,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(r)),i==="copy"){if(s===t&&A.hasFileFolderCopyCapability(s))await s.copy(a,r,{overwrite:o});else{const l=await this.resolve(a);l.isDirectory?await this.doCopyFolder(s,l,t,r):await this.doCopyFile(s,a,t,r)}return i}else return s===t?(await s.rename(a,r,{overwrite:o}),i):(await this.doMoveCopy(s,a,t,r,"copy",o),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(s,a,t,r){if(A.hasOpenReadWriteCloseCapability(s)&&A.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(s,a,t,r);if(A.hasOpenReadWriteCloseCapability(s)&&A.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(s,a,t,r);if(A.hasReadWriteCapability(s)&&A.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(s,a,t,r);if(A.hasReadWriteCapability(s)&&A.hasReadWriteCapability(t))return this.doPipeUnbuffered(s,a,t,r)}async doCopyFolder(s,a,t,r){await t.mkdir(r),Array.isArray(a.children)&&await g.Promises.settled(a.children.map(async i=>{const o=this.getExtUri(t).providerExtUri.joinPath(r,i.name);return i.isDirectory?this.doCopyFolder(s,await this.resolve(i.resource),t,o):this.doCopyFile(s,i.resource,t,o)}))}async doValidateMoveCopy(s,a,t,r,i,o){let u=!1;if(s===t){const{providerExtUri:l,isPathCaseSensitive:y}=this.getExtUri(s);if(y||(u=l.isEqual(a,r)),u&&i==="copy")throw new Error(v.localize(14,null,this.resourceForError(a),this.resourceForError(r)));if(!u&&l.isEqualOrParent(r,a))throw new Error(v.localize(15,null,this.resourceForError(a),this.resourceForError(r)))}const c=await this.exists(r);if(c&&!u){if(!o)throw new A.FileOperationError(v.localize(16,null,this.resourceForError(a),this.resourceForError(r)),4);if(s===t){const{providerExtUri:l}=this.getExtUri(s);if(l.isEqualOrParent(a,r))throw new Error(v.localize(17,null,this.resourceForError(a),this.resourceForError(r)))}}return{exists:c,isSameResourceWithDifferentPathCase:u}}getExtUri(s){const a=this.isPathCaseSensitive(s);return{providerExtUri:a?P.extUri:P.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(a,s);const t=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new A.FileOperationEvent(s,0,t)),t}async mkdirp(s,a){const t=[],{providerExtUri:r}=this.getExtUri(s);for(;!r.isEqual(a,r.dirname(a));)try{if(((await s.stat(a)).type&A.FileType.Directory)==0)throw new Error(v.localize(18,null,this.resourceForError(a)));break}catch(i){if(A.toFileSystemProviderErrorCode(i)!==A.FileSystemProviderErrorCode.FileNotFound)throw i;t.push(r.basename(a)),a=r.dirname(a)}for(let i=t.length-1;i>=0;i--){a=r.joinPath(a,t[i]);try{await s.mkdir(a)}catch(o){if(A.toFileSystemProviderErrorCode(o)!==A.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,a){try{await this.doValidateDelete(s,a)}catch(t){return t}return!0}async doValidateDelete(s,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error(v.localize(19,null,this.resourceForError(s)));let i;try{i=await t.stat(s)}catch(u){}if(i)this.throwIfFileIsReadonly(s,i);else throw new A.FileOperationError(v.localize(20,null,this.resourceForError(s)),1);if(!!!a?.recursive){const u=await this.resolve(s);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error(v.localize(21,null,this.resourceForError(s)))}return t}async del(s,a){const t=await this.doValidateDelete(s,a),r=!!a?.useTrash,i=!!a?.recursive;await t.delete(s,{recursive:i,useTrash:r}),this._onDidRunOperation.fire(new A.FileOperationEvent(s,1))}onDidChangeFile(s,a){this._onDidChangeFilesRaw.fire({changes:s});let t,r;{for(const i of s)this.watchedResources.has(i.resource)?(t||(t=[]),t.push(i)):(r||(r=[]),r.push(i));t&&this._onDidFilesChange.fire(new A.FileChangesEvent(t,!a))}if(r){const i=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!i.work(r)&&je.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),i.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${i.pending}, most recent change: ${r[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(s,a={recursive:!1,excludes:[]}){const t=new L.DisposableStore;{let r=!1,i=()=>{r=!0};t.add(L.toDisposable(()=>i())),this.doWatch(s,a).then(o=>{r?L.dispose(o):i=()=>L.dispose(o)},o=>this.logService.error(o))}return a.recursive||(this.watchedResources.set(s,(this.watchedResources.get(s)??0)+1),t.add(L.toDisposable(()=>{const r=this.watchedResources.get(s);typeof r=="number"&&(r<=1?this.watchedResources.delete(s):this.watchedResources.set(s,r-1))}))),t}async doWatch(s,a){const t=await this.withProvider(s),r=this.toWatchKey(t,s,a),i=this.activeWatchers.get(r)||{count:0,disposable:t.watch(s,a)};return this.activeWatchers.has(r)||this.activeWatchers.set(r,i),i.count+=1,L.toDisposable(()=>{i.count--,i.count===0&&(L.dispose(i.disposable),this.activeWatchers.delete(r))})}toWatchKey(s,a,t){const{providerExtUri:r}=this.getExtUri(s);return[r.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(s=>L.dispose(s.disposable)),this.activeWatchers.clear()}async doWriteBuffered(s,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(async()=>{const i=await s.open(a,{create:!0,unlock:t?.unlock??!1});try{d.isReadableStream(r)||d.isReadableBufferedStream(r)?await this.doWriteStreamBufferedQueued(s,i,r):await this.doWriteReadableBufferedQueued(s,i,r)}catch(o){throw A.ensureFileSystemProviderError(o)}finally{await s.close(i)}})}async doWriteStreamBufferedQueued(s,a,t){let r=0,i;if(d.isReadableBufferedStream(t)){if(t.buffer.length>0){const o=m.VSBuffer.concat(t.buffer);await this.doWriteBuffer(s,a,o,o.byteLength,r,0),r+=o.byteLength}if(t.ended)return;i=t.stream}else i=t;return new Promise(async(o,u)=>{d.listenStream(i,{onData:async c=>{i.pause();try{await this.doWriteBuffer(s,a,c,c.byteLength,r,0)}catch(l){return u(l)}r+=c.byteLength,setTimeout(()=>i.resume())},onError:c=>u(c),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,a,t){let r=0,i;for(;(i=t.read())!==null;)await this.doWriteBuffer(s,a,i,i.byteLength,r,0),r+=i.byteLength}async doWriteBuffer(s,a,t,r,i,o){let u=0;for(;u<r;)u+=await s.write(a,i+u,t.buffer,o+u,r-u)}async doWriteUnbuffered(s,a,t,r){return this.writeQueue.queueFor(a,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,a,t,r))}async doWriteUnbufferedQueued(s,a,t,r){let i;r instanceof m.VSBuffer?i=r:d.isReadableStream(r)?i=await m.streamToBuffer(r):d.isReadableBufferedStream(r)?i=await m.bufferedStreamToBuffer(r):i=m.readableToBuffer(r),await s.writeFile(a,i.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(s,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,a,t,r))}async doPipeBufferedQueued(s,a,t,r){let i,o;try{i=await s.open(a,{create:!1}),o=await t.open(r,{create:!0,unlock:!1});const u=m.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,l=0,y=0;do y=await s.read(i,c,u.buffer,l,u.byteLength-l),await this.doWriteBuffer(t,o,u,y,c,l),c+=y,l+=y,l===u.byteLength&&(l=0);while(y>0)}catch(u){throw A.ensureFileSystemProviderError(u)}finally{await g.Promises.settled([typeof i=="number"?s.close(i):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,a,t,r))}async doPipeUnbufferedQueued(s,a,t,r){return t.writeFile(r,await s.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,a,t,r){return this.writeQueue.queueFor(r,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,a,t,r))}async doPipeUnbufferedToBufferedQueued(s,a,t,r){const i=await t.open(r,{create:!0,unlock:!1});try{const o=await s.readFile(a);await this.doWriteBuffer(t,i,m.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw A.ensureFileSystemProviderError(o)}finally{await t.close(i)}}async doPipeBufferedToUnbuffered(s,a,t,r){const i=await m.streamToBuffer(this.readFileBuffered(s,a,h.CancellationToken.None));await this.doWriteUnbuffered(t,r,void 0,i)}throwIfFileSystemIsReadonly(s,a){if(s.capabilities&2048)throw new A.FileOperationError(v.localize(22,null,this.resourceForError(a)),6);return s}throwIfFileIsReadonly(s,a){if((a.permissions??0)&A.FilePermission.Readonly)throw new A.FileOperationError(v.localize(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===C.Schemas.file?s.fsPath:s.toString(!0)}};I.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},I=de([Y(0,n.ILogService)],I),e.FileService=I}),define(Z[161],ee([0,1,2,10,3,7,18,8,14,41,6,15,119,75,137,139,136,148,47,78,19,25]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h,C,D,b,I,p,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends v.Disposable{constructor(i,o){super();this.logService=i,this.options=o,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=L.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new L.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,A.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(i){try{const{stat:o,symbolicLink:u}=await O.SymlinkSupport.stat(this.toFilePath(i));return{type:this.toType(o,u),ctime:o.birthtime.getTime(),mtime:o.mtime.getTime(),size:o.size}}catch(o){throw this.toFileSystemProviderError(o)}}async readdir(i){try{const o=await O.Promises.readdir(this.toFilePath(i),{withFileTypes:!0}),u=[];return await Promise.all(o.map(async c=>{try{let l;c.isSymbolicLink()?l=(await this.stat(S.joinPath(i,c.name))).type:l=this.toType(c),u.push([c.name,l])}catch(l){this.logService.trace(l)}})),u}catch(o){throw this.toFileSystemProviderError(o)}}toType(i,o){let u;return o?.dangling?u=k.FileType.Unknown:i.isFile()?u=k.FileType.File:i.isDirectory()?u=k.FileType.Directory:u=k.FileType.Unknown,o&&(u|=k.FileType.SymbolicLink),u}async readFile(i){try{const o=this.toFilePath(i);return await O.Promises.readFile(o)}catch(o){throw this.toFileSystemProviderError(o)}}readFileStream(i,o,u){const c=I.newWriteableStream(l=>a.VSBuffer.concat(l.map(y=>a.VSBuffer.wrap(y))).buffer);return p.readFileIntoStream(this,i,c,l=>l.buffer,{...o,bufferSize:this.BUFFER_SIZE},u),c}async writeFile(i,o,u){let c;try{const l=this.toFilePath(i);if(!u.create||!u.overwrite){if(await O.Promises.exists(l)){if(!u.overwrite)throw k.createFileSystemProviderError(d.localize(0,null),k.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw k.createFileSystemProviderError(d.localize(1,null),k.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(i,{create:!0,unlock:u.unlock}),await this.write(c,0,o,0,o.byteLength)}catch(l){throw await this.toFileSystemProviderWriteError(i,l)}finally{typeof c=="number"&&await this.close(c)}}async open(i,o){try{const u=this.toFilePath(i);if(k.isFileOpenForWriteOptions(o)&&o.unlock)try{const{stat:y}=await O.SymlinkSupport.stat(u);y.mode&128||await O.Promises.chmod(u,y.mode|128)}catch(y){this.logService.trace(y)}let c;if(k.isFileOpenForWriteOptions(o)){if(A.isWindows)try{await O.Promises.truncate(u,0),c="r+"}catch(y){y.code!=="ENOENT"&&this.logService.trace(y)}c||(c="w")}else c="r";const l=await O.Promises.open(u,c);return this.mapHandleToPos.set(l,0),k.isFileOpenForWriteOptions(o)&&this.writeHandles.set(l,i),l}catch(u){throw k.isFileOpenForWriteOptions(o)?await this.toFileSystemProviderWriteError(i,u):this.toFileSystemProviderError(u)}}async close(i){try{if(this.mapHandleToPos.delete(i),this.writeHandles.delete(i)&&this.canFlush)try{await O.Promises.fdatasync(i)}catch(o){this.canFlush=!1,this.logService.error(o)}return await O.Promises.close(i)}catch(o){throw this.toFileSystemProviderError(o)}}async read(i,o,u,c,l){const y=this.normalizePos(i,o);let E=null;try{const f=await O.Promises.read(i,u,c,l,y);return typeof f=="number"?E=f:E=f.bytesRead,E}catch(f){throw this.toFileSystemProviderError(f)}finally{this.updatePos(i,y,E)}}normalizePos(i,o){return o===this.mapHandleToPos.get(i)?null:o}updatePos(i,o,u){const c=this.mapHandleToPos.get(i);typeof c=="number"&&(typeof o=="number"||(typeof u=="number"?this.mapHandleToPos.set(i,c+u):this.mapHandleToPos.delete(i)))}async write(i,o,u,c,l){return n.retry(()=>this.doWrite(i,o,u,c,l),100,3)}async doWrite(i,o,u,c,l){const y=this.normalizePos(i,o);let E=null;try{const f=await O.Promises.write(i,u,c,l,y);return typeof f=="number"?E=f:E=f.bytesWritten,E}catch(f){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(i),f)}finally{this.updatePos(i,y,E)}}async mkdir(i){try{await O.Promises.mkdir(this.toFilePath(i))}catch(o){throw this.toFileSystemProviderError(o)}}async delete(i,o){try{const u=this.toFilePath(i);await this.doDelete(u,o)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(i,o){o.recursive?await O.Promises.rm(i,O.RimRafMode.MOVE):await O.Promises.unlink(i)}async rename(i,o,u){const c=this.toFilePath(i),l=this.toFilePath(o);if(c!==l)try{await this.validateTargetDeleted(i,o,"move",u.overwrite),await O.Promises.move(c,l)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error(d.localize(2,null,P.basename(c),P.basename(P.dirname(l)),y.toString()))),this.toFileSystemProviderError(y)}}async copy(i,o,u){const c=this.toFilePath(i),l=this.toFilePath(o);if(c!==l)try{await this.validateTargetDeleted(i,o,"copy",u.overwrite),await O.Promises.copy(c,l,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error(d.localize(3,null,P.basename(c),P.basename(P.dirname(l)),y.toString()))),this.toFileSystemProviderError(y)}}async validateTargetDeleted(i,o,u,c){const l=this.toFilePath(i),y=this.toFilePath(o);let E=!1;if(!!(this.capabilities&1024)||(E=w.isEqual(l,y,!0)),E&&u==="copy")throw k.createFileSystemProviderError(d.localize(4,null),k.FileSystemProviderErrorCode.FileExists);if(!E&&await O.Promises.exists(y)){if(!c)throw k.createFileSystemProviderError(d.localize(5,null),k.FileSystemProviderErrorCode.FileExists);await this.delete(o,{recursive:!0,useTrash:!1})}}watch(i,o){return o.recursive?this.watchRecursive(i,o.excludes):this.watchNonRecursive(i)}watchRecursive(i,o){const u={path:this.toFilePath(i),excludes:o},c=s.insert(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),v.toDisposable(()=>{c(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(v.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let i,o;this.options?.watcher?.usePolling?(i=h.FileWatcher,o=this.options?.watcher):this.recursiveFoldersToWatch.length===1?A.isWindows?i=C.FileWatcher:i=h.FileWatcher:i=D.FileWatcher,this.recursiveWatcher=new i(this.recursiveFoldersToWatch,u=>this._onDidChangeFile.fire(g.toFileChanges(u)),u=>{u.type==="error"&&this._onDidWatchErrorOccur.fire(u.message),this.logService[u.type](u.message)},this.logService.getLevel()===m.LogLevel.Trace,o),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)}))}}watchNonRecursive(i){const o=new b.FileWatcher(this.toFilePath(i),c=>this._onDidChangeFile.fire(g.toFileChanges(c)),c=>{c.type==="error"&&this._onDidWatchErrorOccur.fire(c.message),this.logService[c.type](c.message)},this.logService.getLevel()===m.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{o.setVerboseLogging(this.logService.getLevel()===m.LogLevel.Trace)});return v.combinedDisposable(o,u)}toFilePath(i){return P.normalize(i.fsPath)}toFileSystemProviderError(i){if(i instanceof k.FileSystemProviderError)return i;let o;switch(i.code){case"ENOENT":o=k.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=k.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=k.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=k.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=k.FileSystemProviderErrorCode.NoPermissions;break;default:o=k.FileSystemProviderErrorCode.Unknown}return k.createFileSystemProviderError(i,o)}async toFileSystemProviderWriteError(i,o){let u=this.toFileSystemProviderError(o);if(i&&u.code===k.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await O.SymlinkSupport.stat(this.toFilePath(i));c.mode&128||(u=k.createFileSystemProviderError(o,k.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return u}dispose(){super.dispose(),v.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,v.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(Z[27],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=v.createDecorator("productService")}),define(Z[162],ee([0,1,8,11,2,18,27,6,15]),function(K,e,v,k,L,A,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let w=class extends L.Disposable{constructor(m,d,g){super();this.productService=d,this.logService=g,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,m&&this._register(new P.RunOnceScheduler(()=>{this.cleanUpCodeCaches(m)},30*1e3)).schedule()}async cleanUpCodeCaches(m){this.logService.info("[code cache cleanup]: Starting to clean up old code cache folders.");try{const d=Date.now(),g=v.dirname(m),h=v.basename(m),C=await A.Promises.readdir(g);await Promise.all(C.map(async D=>{if(D===h)return;const b=v.join(g,D),I=await A.Promises.stat(b);if(I.isDirectory()&&d-I.mtime.getTime()>this._DataMaxAge)return this.logService.info(`[code cache cleanup]: Removing code cache folder ${D}.`),A.Promises.rm(b)}))}catch(d){k.onUnexpectedError(d)}}};w=de([Y(1,O.IProductService),Y(2,S.ILogService)],w),e.CodeCacheCleaner=w}),define(Z[163],ee([0,1,8,18,27,2,11,15,9,6]),function(K,e,v,k,L,A,O,P,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends A.Disposable{constructor(d,g,h){super();this.environmentService=d,this.logService=g,this.productService=h,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new w.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.info("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const d=Object.create(null),g=JSON.parse(await k.Promises.readFile(v.join(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let I of Object.keys(g)){const p=g[I];d[`${p.hash}.${I}`]=!0}const h=v.join(this.environmentService.userDataPath,"clp");if(!await k.Promises.exists(h))return;const D=await k.Promises.readdir(h);for(const I of D){if(d[I]){this.logService.info(`[language pack cache cleanup]: Skipping folder ${I}. Language pack still in use.`);continue}this.logService.info(`[language pack cache cleanup]: Removing unused language pack: ${I}`),await k.Promises.rm(v.join(h,I))}const b=Date.now();for(const I of Object.keys(d)){const p=v.join(h,I),s=await k.Promises.readdir(p);for(const a of s){if(a==="tcf.json")continue;const t=v.join(p,a),r=await k.Promises.stat(t);r.isDirectory()&&b-r.mtime.getTime()>this._DataMaxAge&&(this.logService.info(`[language pack cache cleanup]: Removing language pack cache folder: ${v.join(I,a)}`),await k.Promises.rm(t))}}}catch(d){O.onUnexpectedError(d)}}};n=de([Y(0,S.INativeEnvironmentService),Y(1,P.ILogService),Y(2,L.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(Z[31],ee([0,1,16,87]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class L{constructor(){this.data=new Map}add(O,P){k.ok(v.isString(O)),k.ok(v.isObject(P)),k.ok(!this.data.has(O),"There is already an extension with this id"),this.data.set(O,P)}knows(O){return this.data.has(O)}as(O){return this.data.get(O)||null}}e.Registry=new L}),define(Z[79],ee([0,1,31,3]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function L(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this._onDidChangeSchema=new k.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,w){this.schemasById[L(S)]=w,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const O=new A;v.Registry.add(e.Extensions.JSONContribution,O)}),define(Z[37],ee([0,1,109,3,31,16,79]),function(K,e,v,k,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const S=L.Registry.as(O.Extensions.JSONContribution);class w{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:v.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,I=!0){this.registerConfigurations([b],I)}registerConfigurations(b,I=!0){const p=[];b.forEach(s=>{p.push(...this.validateAndRegisterProperties(s,I,s.extensionInfo)),this.configurationContributors.push(s),this.registerJSONConfiguration(s)}),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterConfigurations(b){const I=[],p=s=>{if(s.properties)for(const a in s.properties)I.push(a),delete this.configurationProperties[a],this.removeFromSchema(a,s.properties[a]);s.allOf&&s.allOf.forEach(a=>p(a))};for(const s of b){p(s);const a=this.configurationContributors.indexOf(s);a!==-1&&this.configurationContributors.splice(a,1)}S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}registerDefaultConfigurations(b){const I=[],p=[];for(const s of b)for(const a in s)if(I.push(a),e.OVERRIDE_PROPERTY_PATTERN.test(a)){this.defaultValues[a]={...this.defaultValues[a]||{},...s[a]};const t={type:"object",default:this.defaultValues[a],description:v.localize(1,null,a),$ref:e.resourceLanguageSettingsSchemaId};p.push(m(a)),this.configurationProperties[a]=t,this.defaultLanguageConfigurationOverridesNode.properties[a]=t}else{this.defaultValues[a]=s[a];const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.registerOverrideIdentifiers(p),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}deregisterDefaultConfigurations(b){const I=[];for(const p of b)for(const s in p)if(I.push(s),delete this.defaultValues[s],e.OVERRIDE_PROPERTY_PATTERN.test(s))delete this.configurationProperties[s],delete this.defaultLanguageConfigurationOverridesNode.properties[s];else{const a=this.configurationProperties[s];a&&(this.updatePropertyDefaultValue(s,a),this.updateSchema(s,a))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(I)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const I of b)this.overrideIdentifiers.add(I);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,I=!0,p,s=3){s=A.isUndefinedOrNull(b.scope)?s:b.scope;let a=[],t=b.properties;if(t)for(let i in t){if(I&&h(i)){delete t[i];continue}const o=t[i];if(this.updatePropertyDefaultValue(i,o),e.OVERRIDE_PROPERTY_PATTERN.test(i)?o.scope=void 0:(o.scope=A.isUndefinedOrNull(o.scope)?s:o.scope,o.restricted=A.isUndefinedOrNull(o.restricted)?!!p?.restrictedConfigurations?.includes(i):o.restricted),t[i].hasOwnProperty("included")&&!t[i].included){this.excludedConfigurationProperties[i]=t[i],delete t[i];continue}else this.configurationProperties[i]=t[i];!t[i].deprecationMessage&&t[i].markdownDeprecationMessage&&(t[i].deprecationMessage=t[i].markdownDeprecationMessage),a.push(i)}let r=b.allOf;if(r)for(let i of r)a.push(...this.validateAndRegisterProperties(i,I,p,s));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const I=p=>{let s=p.properties;if(s)for(const t in s)this.updateSchema(t,s[t]);let a=p.allOf;a&&a.forEach(I)};I(b)}updateSchema(b,I){switch(e.allSettings.properties[b]=I,I.scope){case 1:e.applicationSettings.properties[b]=I;break;case 2:e.machineSettings.properties[b]=I;break;case 6:e.machineOverridableSettings.properties[b]=I;break;case 3:e.windowSettings.properties[b]=I;break;case 4:e.resourceSettings.properties[b]=I;break;case 5:e.resourceSettings.properties[b]=I,this.resourceLanguageSettingsSchema.properties[b]=I;break}}removeFromSchema(b,I){switch(delete e.allSettings.properties[b],I.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const I=`[${b}]`,p={type:"object",description:v.localize(2,null),errorMessage:v.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(I,p),e.allSettings.properties[I]=p,e.applicationSettings.properties[I]=p,e.machineSettings.properties[I]=p,e.machineOverridableSettings.properties[I]=p,e.windowSettings.properties[I]=p,e.resourceSettings.properties[I]=p}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,I){let p=this.defaultValues[b];A.isUndefined(p)&&(p=I.default),A.isUndefined(p)&&(p=d(I.type)),I.default=p}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function m(D){return D.substring(1,D.length-1)}e.overrideIdentifierFromKey=m;function d(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const g=new w;L.Registry.add(e.Extensions.Configuration,g);function h(D){return D.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(D)?v.localize(5,null,D):g.getConfigurationProperties()[D]!==void 0?v.localize(6,null,D):null:v.localize(4,null)}e.validateProperty=h;function C(){const D=[],b=g.getConfigurationProperties();for(const I of Object.keys(b))D.push([I,b[I].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=C}),define(Z[23],ee([0,1,26,16,5,31,4,37]),function(K,e,v,k,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=O.createDecorator("configurationService");function S(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof L.URI)}e.isConfigurationOverrides=S;var w;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(w=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function m(r,i){const o=i?r?i.keys.filter(U=>r.keys.indexOf(U)===-1):[...i.keys]:[],u=r?i?r.keys.filter(U=>i.keys.indexOf(U)===-1):[...r.keys]:[],c=[];if(i&&r){for(const U of r.keys)if(i.keys.indexOf(U)!==-1){const F=b(r.contents,U),z=b(i.contents,U);v.equals(F,z)||c.push(U)}}const l=[],y=U=>{const F={};for(const z of U)for(const $ of z.identifiers)F[a($)]=z;return F},E=i?y(i.overrides):{},f=r?y(r.overrides):{};if(Object.keys(E).length)for(const U of o){const F=E[U];F&&l.push([P.overrideIdentifierFromKey(U),F.keys])}if(Object.keys(f).length)for(const U of u){const F=f[U];F&&l.push([P.overrideIdentifierFromKey(U),F.keys])}if(Object.keys(E).length&&Object.keys(f).length)for(const U of c){const F=f[U],z=E[U];if(F&&z){const $=m({contents:F.contents,keys:F.keys,overrides:[]},{contents:z.contents,keys:z.keys,overrides:[]});l.push([P.overrideIdentifierFromKey(U),[...$.added,...$.removed,...$.updated]])}}return{added:o,removed:u,updated:c,overrides:l}}e.compare=m;function d(r,i){const o=[];for(const u of Object.keys(r))if(P.OVERRIDE_PROPERTY_PATTERN.test(u)){const c={};for(const l in r[u])c[l]=r[u][l];o.push({identifiers:[P.overrideIdentifierFromKey(u).trim()],keys:Object.keys(c),contents:g(c,i)})}return o}e.toOverrides=d;function g(r,i){const o=Object.create(null);for(let u in r)h(o,u,r[u],i);return o}e.toValuesTree=g;function h(r,i,o,u){const c=i.split("."),l=c.pop();let y=r;for(let E=0;E<c.length;E++){let f=c[E],U=y[f];switch(typeof U){case"undefined":U=y[f]=Object.create(null);break;case"object":break;default:u(`Ignoring ${i} as ${c.slice(0,E+1).join(".")} is ${JSON.stringify(U)}`);return}y=U}if(typeof y=="object"&&y!==null)try{y[l]=o}catch(E){u(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(y)}`)}else u(`Ignoring ${i} as ${c.join(".")} is ${JSON.stringify(y)}`)}e.addToValueTree=h;function C(r,i){const o=i.split(".");D(r,o)}e.removeFromValueTree=C;function D(r,i){const o=i.shift();if(i.length===0){delete r[o];return}if(Object.keys(r).indexOf(o)!==-1){const u=r[o];typeof u=="object"&&!Array.isArray(u)&&(D(u,i),Object.keys(u).length===0&&delete r[o])}}function b(r,i,o){function u(y,E){let f=y;for(const U of E){if(typeof f!="object"||f===null)return;f=f[U]}return f}const c=i.split("."),l=u(r,c);return typeof l=="undefined"?o:l}e.getConfigurationValue=b;function I(r,i,o){Object.keys(i).forEach(u=>{u!=="__proto__"&&(u in r?k.isObject(r[u])&&k.isObject(i[u])?I(r[u],i[u],o):o&&(r[u]=i[u]):r[u]=i[u])})}e.merge=I;function p(){const r=A.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=p;function s(){const r=Object.create(null),i=A.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let o in i){let u=i[o].default;h(r,o,u,c=>console.error(`Conflict in default settings: ${c}`))}return r}e.getDefaultValues=s;function a(r){return`[${r}]`}e.keyFromOverrideIdentifier=a;function t(r,i,o){const u=r.inspect(i),c=r.inspect(o);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:u.defaultValue}e.getMigratedSettingValue=t}),define(Z[164],ee([0,1,32,38,19,16,26,5,37,23,31,2,3]),function(K,e,v,k,L,A,O,P,S,w,n,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(t={},r=[],i=[]){this._contents=t,this._keys=r,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?w.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const i=this.getContentsForOverrideIdentifer(r);return i?t?w.getConfigurationValue(i,t):i:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let i={};for(const o of L.distinct([...Object.keys(this.contents),...Object.keys(r)])){let u=this.contents[o],c=r[o];c&&(typeof u=="object"&&typeof c=="object"?(u=O.deepClone(u),this.mergeContents(u,c)):u=c),i[o]=u}return new g(i,this.keys,this.overrides)}merge(...t){const r=O.deepClone(this.contents),i=O.deepClone(this.overrides),o=[...this.keys];for(const u of t){this.mergeContents(r,u.contents);for(const c of u.overrides){const[l]=i.filter(y=>L.equals(y.identifiers,c.identifiers));l?this.mergeContents(l.contents,c.contents):i.push(O.deepClone(c))}for(const c of u.keys)o.indexOf(c)===-1&&o.push(c)}return new g(r,o,i)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const i of Object.keys(r)){if(i in t&&A.isObject(t[i])&&A.isObject(r[i])){this.mergeContents(t[i],r[i]);continue}t[i]=O.deepClone(r[i])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?O.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),w.addToValueTree(this.contents,t,r,i=>{throw new Error(i)})}removeValue(t){this.removeKey(t)&&w.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let i=0;i<r;i++)t.indexOf(this.keys[i])===0&&(r=i);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=g;class h extends g{constructor(){const t=w.getDefaultValues(),r=w.getConfigurationKeys(),i=[];for(const o of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(o)&&i.push({identifiers:[S.overrideIdentifierFromKey(o).trim()],keys:Object.keys(t[o]),contents:w.toValuesTree(t[o],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,r,i)}}e.DefaultConfigurationModel=h;class C{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!A.isUndefinedOrNull(t)){const i=this.doParseContent(t);this.parseRaw(i,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:i,keys:o,overrides:u,restricted:c}=this.doParseRaw(t,r);this._configurationModel=new g(i,o,u),this._restrictedConfigurations=c||[]}doParseContent(t){let r={},i=null,o=[],u=[],c=[];function l(E){Array.isArray(o)?o.push(E):i&&(o[i]=E)}let y={onObjectBegin:()=>{let E={};l(E),u.push(o),o=E,i=null},onObjectProperty:E=>{i=E},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{let E=[];l(E),u.push(o),o=E,i=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:l,onError:(E,f,U)=>{c.push({error:E,offset:f,length:U})}};if(t)try{v.visit(t,y),r=o[0]||{}}catch(E){console.error(`Error while parsing settings file ${this._name}: ${E}`),this._parseErrors=[E]}return r}doParseRaw(t,r){const i=n.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,i,!0,r);t=o.raw;const u=w.toValuesTree(t,y=>console.error(`Conflict in settings file ${this._name}: ${y}`)),c=Object.keys(t),l=w.toOverrides(t,y=>console.error(`Conflict in settings file ${this._name}: ${y}`));return{contents:u,keys:c,overrides:l,restricted:o.restricted}}filter(t,r,i,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:t,restricted:[]};const u={},c=[];for(let l in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(l)&&i){const y=this.filter(t[l],r,!1,o);u[l]=y.raw,c.push(...y.restricted)}else{const y=r[l],E=y?typeof y.scope!="undefined"?y.scope:3:void 0;y?.restricted&&c.push(l),(E===void 0||o.scopes===void 0||o.scopes.includes(E))&&(o.skipRestricted&&y?.restricted||(u[l]=t[l]))}return{raw:u,restricted:c}}}e.ConfigurationModelParser=C;class D extends m.Disposable{constructor(t,r,i,o){super();this.userSettingsResource=t,this.scopes=r,this.fileService=o,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new C(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=D;class b{constructor(t,r,i=new g,o=new g,u=new k.ResourceMap,c=new g,l=new k.ResourceMap,y=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=i,this._workspaceConfiguration=o,this._folderConfigurations=u,this._memoryConfiguration=c,this._memoryConfigurationByResource=l,this._freeze=y,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new k.ResourceMap,this._userConfiguration=null}getValue(t,r,i){return this.getConsolidateConfigurationModel(r,i).getValue(t)}updateValue(t,r,i={}){let o;i.resource?(o=this._memoryConfigurationByResource.get(i.resource),o||(o=new g,this._memoryConfigurationByResource.set(i.resource,o))):o=this._memoryConfiguration,r===void 0?o.removeValue(t):o.setValue(t,r),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,i){const o=this.getConsolidateConfigurationModel(r,i),u=this.getFolderConfigurationModelForResource(r.resource,i),c=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,l=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),y=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),E=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),f=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),U=i?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,F=u?r.overrideIdentifier?u.freeze().override(r.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,z=r.overrideIdentifier?c.override(r.overrideIdentifier).getValue(t):c.getValue(t),$=o.getValue(t),H=L.distinct(L.flatten(o.overrides.map(V=>V.identifiers))).filter(V=>o.getOverrideValue(t,V)!==void 0);return{defaultValue:l,userValue:y,userLocalValue:E,userRemoteValue:f,workspaceValue:U,workspaceFolderValue:F,memoryValue:z,value:$,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:y!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:E!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:f!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:U!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:F!==void 0?{value:u?.freeze().getValue(t),override:r.overrideIdentifier?u?.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:z!==void 0?{value:c.getValue(t),override:r.overrideIdentifier?c.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:H.length?H:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const i=r.filter(o=>S.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const u=S.overrideIdentifierFromKey(o),c=this._defaultConfiguration.getKeysForOverrideIdentifier(u),l=t.getKeysForOverrideIdentifier(u),y=[...l.filter(E=>c.indexOf(E)===-1),...c.filter(E=>l.indexOf(E)===-1),...c.filter(E=>!O.equals(this._defaultConfiguration.override(u).getValue(E),t.override(u).getValue(E)))];return[u,y]});return this.updateDefaultConfiguration(t),{keys:r,overrides:i}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:i,removed:o,overrides:u}=w.compare(this.localUserConfiguration,t),c=[...r,...i,...o];return c.length&&this.updateLocalUserConfiguration(t),{keys:c,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:i,removed:o,overrides:u}=w.compare(this.remoteUserConfiguration,t);let c=[...r,...i,...o];return c.length&&this.updateRemoteUserConfiguration(t),{keys:c,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:i,removed:o,overrides:u}=w.compare(this.workspaceConfiguration,t);let c=[...r,...i,...o];return c.length&&this.updateWorkspaceConfiguration(t),{keys:c,overrides:u}}compareAndUpdateFolderConfiguration(t,r){const i=this.folderConfigurations.get(t),{added:o,updated:u,removed:c,overrides:l}=w.compare(i,r);let y=[...o,...u,...c];return(y.length||!i)&&this.updateFolderConfiguration(t,r),{keys:y,overrides:l}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:i,updated:o,removed:u,overrides:c}=w.compare(r,void 0);return{keys:[...i,...o,...u],overrides:c}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let i=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?i.override(t.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:t},r){let i=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const o=r.getFolder(t);o&&(i=this.getFolderConsolidatedConfiguration(o.uri)||i);const u=this._memoryConfigurationByResource.get(t);u&&(i=i.merge(u))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const i=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(r=i.merge(o),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=i}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const i=r.getFolder(t);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:i,overrides:o,keys:u}=this._folderConfigurations.get(r);return t.push([r,{contents:i,overrides:o,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(i=>t.add(i))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(t).forEach(o=>r.add(o))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),i=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((c,l)=>(c.set(P.URI.revive(l[0]),this.parseConfigurationModel(l[1])),c),new k.ResourceMap);return new b(r,i,new g,o,u,new g,new k.ResourceMap,!1)}static parseConfigurationModel(t){return new g(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function I(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,r=new Map;for(const o of a)o.keys.forEach(u=>t.add(u)),o.overrides.forEach(([u,c])=>{const l=k.getOrSet(r,u,new Set);c.forEach(y=>l.add(y))});const i=[];return r.forEach((o,u)=>i.push([u,[...o.values()]])),{keys:[...t.values()],overrides:i}}e.mergeChanges=I;class p{constructor(t,r,i,o){this.change=t,this.previous=r,this.currentConfiguraiton=i,this.currentWorkspace=o,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(l=>u.add(l)),t.overrides.forEach(([,l])=>l.forEach(y=>u.add(y))),this.affectedKeys=[...u.values()];const c=new g;this.affectedKeys.forEach(l=>c.setValue(l,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,r,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!O.equals(i,o)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let i=w.toValuesTree({[r]:!0},()=>{}),o;for(;typeof i=="object"&&(o=Object.keys(i)[0]);){if(t=t[o],!t)return!1;i=i[o]}return!0}}e.ConfigurationChangeEvent=p;class s extends p{constructor(t,r,i,o){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=i,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=s}),define(Z[165],ee([0,1,31,37,2,23,164,3,6,14]),function(K,e,v,k,L,A,O,P,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends L.Disposable{constructor(d,g){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new O.UserSettings(this.settingsResource,void 0,w.extUriBiasedIgnorePathCase,g)),this.configuration=new O.Configuration(new O.DefaultConfigurationModel,new O.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(k.Extensions.Configuration).onDidUpdateConfiguration(h=>this.onDidDefaultConfigurationChange(h))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new O.Configuration(new O.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,g){const h=typeof d=="string"?d:void 0,C=A.isConfigurationOverrides(d)?d:A.isConfigurationOverrides(g)?g:{};return this.configuration.getValue(h,C,void 0)}updateValue(d,g,h,C){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const g=this.configuration.toData(),h=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(h,g,1)}onDidDefaultConfigurationChange(d){const g=this.configuration.toData(),h=this.configuration.compareAndUpdateDefaultConfiguration(new O.DefaultConfigurationModel,d);this.trigger(h,g,6)}trigger(d,g,h){const C=new O.ConfigurationChangeEvent(d,{data:g},this.configuration);C.source=h,C.sourceConfig=this.getTargetConfiguration(h),this._onDidChangeConfiguration.fire(C)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(Z[166],ee([0,1,23,15,103]),function(K,e,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let A=class{constructor(P,S){this.configurationService=P,this.logService=S}request(P,S){return this.logService.trace("RequestService#request",P.url),P.proxyAuthorization||(P.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),L.request(P,S)}async resolveProxy(P){}};A=de([Y(0,v.IConfigurationService),Y(1,k.ILogService)],A),e.RequestService=A}),define(Z[39],ee([0,1,120,4,37,31,25]),function(K,e,v,k,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=k.createDecorator("requestService");function P(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.isSuccess=P;function S(h){return h.res.statusCode===204}async function w(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);return S(h)?null:(await O.streamToBuffer(h.stream)).toString()}e.asText=w;async function n(h){if(!P(h))throw new Error("Server returned "+h.res.statusCode);if(S(h))return null;const D=(await O.streamToBuffer(h.stream)).toString();try{return JSON.parse(D)}catch(b){throw b.message+=`:
`+D,b}}e.asJson=n;function m(h){g(h)}e.updateProxyConfigurationsScope=m;let d;function g(h){const C=A.Registry.as(L.Extensions.Configuration);d&&C.deregisterConfigurations([d]),d={id:"http",order:15,title:v.localize(0,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:v.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:v.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:v.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[v.localize(4,null),v.localize(5,null),v.localize(6,null),v.localize(7,null)],default:"override",description:v.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:v.localize(9,null),restricted:!0}}},C.registerConfiguration(d)}g(2)}),define(Z[167],ee([0,1,39,29,10,17]),function(K,e,v,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let O=class{constructor(S,w){this.requestService=S,this.fileService=w}async download(S,w,n=k.CancellationToken.None){if(S.scheme===A.Schemas.file||S.scheme===A.Schemas.vscodeRemote){await this.fileService.copy(S,w);return}const m={type:"GET",url:S.toString()},d=await this.requestService.request(m,n);if(d.res.statusCode===200)await this.fileService.writeFile(w,d.stream);else{const g=await v.asText(d);throw new Error(`Expected 200, got back ${d.res.statusCode} instead.

${g}`)}}};O=de([Y(0,v.IRequestService),Y(1,L.IFileService)],O),e.DownloadService=O}),define(Z[168],ee([0,1,27,10,19,63,39,29,15,14,132,2]),function(K,e,v,k,L,A,O,P,S,w,n,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let d=class extends m.Disposable{constructor(h,C,D,b){super();this.fileService=h,this.productService=C,this.requestService=D,this.logService=b,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&A.forEach(this.productService.configBasedExtensionTips,({value:I})=>this.allConfigBasedTips.set(I.configPath,I))}getConfigBasedTips(h){return this.getValidConfigBasedTips(h)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(h){const C=[];for(const[D,b]of this.allConfigBasedTips)try{const I=await this.fileService.readFile(w.joinPath(h,D)),p=new Map;A.forEach(b.recommendations,({key:a,value:t})=>{if(L.isNonEmptyArray(t.remotes))for(const r of t.remotes)p.set(r,{extensionId:a,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else C.push({extensionId:a,extensionName:t.name,configName:b.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const s=n.getDomainsOfRemotes(I.value.toString(),[...p.keys()]);for(const a of s){const t=p.get(a);t&&C.push(t)}}catch(I){}return C}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const h=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},P.CancellationToken.None);if(h.res.statusCode!==200)return[];const C=await O.asJson(h);return C?C.workspaceRecommendations||[]:[]}catch(h){return this.logService.error(h),[]}}};d=de([Y(0,k.IFileService),Y(1,v.IProductService),Y(2,O.IRequestService),Y(3,S.ILogService)],d),e.ExtensionTipsService=d}),define(Z[44],ee([0,1,30,25]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function L(A,O,P){let S=P&&P.get("storage.serviceMachineId",0)||null;if(S)return S;try{const n=(await O.readFile(A.serviceMachineIdResource)).value.toString();S=v.isUUID(n)?n:null}catch(w){S=null}if(!S){S=v.generateUuid();try{await O.writeFile(A.serviceMachineIdResource,k.VSBuffer.fromString(S))}catch(w){}}return P&&P.store("storage.serviceMachineId",S,0,1),S}e.getServiceMachineId=L}),define(Z[21],ee([0,1,4,3,2,16,69,6]),function(K,e,v,k,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const S="__$__targetStorageMarker";e.IStorageService=v.createDecorator("storageService");var w;(function(C){C[C.NONE=0]="NONE",C[C.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(C){C[C.GLOBAL=0]="GLOBAL",C[C.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var m;(function(C){C[C.USER=0]="USER",C[C.MACHINE=1]="MACHINE"})(m=e.StorageTarget||(e.StorageTarget={}));class d extends L.Disposable{constructor(D={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=D,this._onDidChangeValue=this._register(new k.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new k.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new k.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new P.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new L.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=P.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){L.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(D,b){b===S?(D===0?this._globalKeyTargets=void 0:D===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:D})):this._onDidChangeValue.fire({scope:D,key:b,target:this.getKeyTargets(D)[b]})}emitWillSaveState(D){this._onWillSaveState.fire({reason:D})}get(D,b,I){return this.getStorage(b)?.get(D,I)}getBoolean(D,b,I){return this.getStorage(b)?.getBoolean(D,I)}getNumber(D,b,I){return this.getStorage(b)?.getNumber(D,I)}store(D,b,I,p){if(A.isUndefinedOrNull(b)){this.remove(D,I);return}this.withPausedEmitters(()=>{this.updateKeyTarget(D,I,p),this.getStorage(I)?.set(D,b)})}remove(D,b){this.withPausedEmitters(()=>{this.updateKeyTarget(D,b,void 0),this.getStorage(b)?.delete(D)})}withPausedEmitters(D){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{D()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(D,b){const I=[],p=this.getKeyTargets(D);for(const s of Object.keys(p))p[s]===b&&I.push(s);return I}updateKeyTarget(D,b,I){const p=this.getKeyTargets(b);typeof I=="number"?p[D]!==I&&(p[D]=I,this.getStorage(b)?.set(S,JSON.stringify(p))):typeof p[D]=="number"&&(delete p[D],this.getStorage(b)?.set(S,JSON.stringify(p)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(D){return D===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(D){const b=this.get(S,D);if(b)try{return JSON.parse(b)}catch(I){}return Object.create(null)}isNew(D){return this.getBoolean(e.IS_NEW_KEY,D)===!0}async flush(){this._onWillSaveState.fire({reason:w.NONE}),await P.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const D=this.getStorage(0)?.items??new Map,b=this.getStorage(1)?.items??new Map;return h(D,b,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;class g extends d{constructor(){super();this.globalStorage=this._register(new O.Storage(new O.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new O.Storage(new O.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(D=>this.emitDidChangeValue(1,D))),this._register(this.globalStorage.onDidChangeStorage(D=>this.emitDidChangeValue(0,D)))}getStorage(D){return D===0?this.globalStorage:this.workspaceStorage}getLogDetails(D){return D===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(D){}}e.InMemoryStorageService=g;async function h(C,D,b,I){const p=u=>{try{return JSON.parse(u)}catch(c){return u}},s=new Map,a=new Map;C.forEach((u,c)=>{s.set(c,u),a.set(c,p(u))});const t=new Map,r=new Map;D.forEach((u,c)=>{t.set(c,u),r.set(c,p(u))}),console.group(`Storage: Global (path: ${b})`);let i=[];s.forEach((u,c)=>{i.push({key:c,value:u})}),console.table(i),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${I})`);let o=[];t.forEach((u,c)=>{o.push({key:c,value:u})}),console.table(o),console.groupEnd(),console.log(r)}e.logStorage=h}),define(Z[169],ee([0,1,3,2,28,33,21,16]),function(K,e,v,k,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let S=class extends k.Disposable{constructor(m){super();this._onDidChangeEnablement=new v.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new w(m)),this._register(this.storageManger.onDidChange(d=>this._onDidChangeEnablement.fire({extensions:d,source:"storage"})))}async enableExtension(m,d){return this._removeFromDisabledExtensions(m)?(this._onDidChangeEnablement.fire({extensions:[m],source:d}),!0):!1}async disableExtension(m,d){return this._addToDisabledExtensions(m)?(this._onDidChangeEnablement.fire({extensions:[m],source:d}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(m){let d=this.getDisabledExtensions();return d.every(g=>!A.areSameExtensions(g,m))?(d.push(m),this._setDisabledExtensions(d),!0):!1}_removeFromDisabledExtensions(m){let d=this.getDisabledExtensions();for(let g=0;g<d.length;g++){const h=d[g];if(A.areSameExtensions(h,m))return d.splice(g,1),this._setDisabledExtensions(d),!0}return!1}_setDisabledExtensions(m){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,m)}_getExtensions(m){return this.storageManger.get(m,0)}_setExtensions(m,d){this.storageManger.set(m,d,0)}};S=de([Y(0,O.IStorageService)],S),e.GlobalExtensionEnablementService=S;class w extends k.Disposable{constructor(m){super();this.storageService=m,this.storage=Object.create(null),this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this._register(m.onDidChangeValue(d=>this.onDidStorageChange(d)))}get(m,d){let g;return d===0?(P.isUndefinedOrNull(this.storage[m])&&(this.storage[m]=this._get(m,d)),g=this.storage[m]):g=this._get(m,d),JSON.parse(g)}set(m,d,g){let h=JSON.stringify(d.map(({id:D,uuid:b})=>({id:D,uuid:b})));this._get(m,g)!==h&&(g===0&&(d.length?this.storage[m]=h:delete this.storage[m]),this._set(m,d.length?h:void 0,g))}onDidStorageChange(m){if(m.scope===0&&!P.isUndefinedOrNull(this.storage[m.key])&&this._get(m.key,m.scope)!==this.storage[m.key]){const g=this.get(m.key,m.scope);delete this.storage[m.key];const h=this.get(m.key,m.scope),C=g.filter(b=>!h.some(I=>A.areSameExtensions(b,I))),D=h.filter(b=>!g.some(I=>A.areSameExtensions(I,b)));(C.length||D.length)&&this._onDidChange.fire([...C,...D])}}_get(m,d){return this.storageService.get(m,d,"[]")}_set(m,d,g){d?this.storageService.store(m,d,g,1):this.storageService.remove(m,g)}}e.StorageManager=w}),define(Z[170],ee([0,1,3,2]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class L extends k.Disposable{constructor(w,n){super();this.channel=w,this.workspace=n}async getItems(){const w={workspace:this.workspace},n=await this.channel.call("getItems",w);return new Map(n)}updateItems(w){const n={workspace:this.workspace};return w.insert&&(n.insert=Array.from(w.insert.entries())),w.delete&&(n.delete=Array.from(w.delete.values())),this.channel.call("updateItems",n)}}class A extends L{constructor(w){super(w,void 0);this._onDidChangeItemsExternal=this._register(new v.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(w=>this.onDidChangeGlobalStorage(w)))}onDidChangeGlobalStorage(w){(Array.isArray(w.changed)||Array.isArray(w.deleted))&&this._onDidChangeItemsExternal.fire({changed:w.changed?new Map(w.changed):void 0,deleted:w.deleted?new Set(w.deleted):void 0})}async close(){this.dispose()}}class O extends L{constructor(w,n){super(w,n);this.onDidChangeItemsExternal=v.Event.None}async close(){const w={workspace:this.workspace};return this.channel.call("close",w)}}class P extends k.Disposable{constructor(w,n){super();this.channel=w,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new A(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new O(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=P}),define(Z[171],ee([0,1,2,21,69,6,160,170,14]),function(K,e,v,k,L,A,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class w extends k.AbstractStorageService{constructor(m,d,g){super();this.mainProcessService=d,this.environmentService=g,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new v.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(m)}createGlobalStorage(){const m=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),d=new L.Storage(m.globalStorage);return this._register(d.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),d}createWorkspaceStorage(m){const d=new P.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),m);if(d.workspaceStorage){const g=new L.Storage(d.workspaceStorage);return this.workspaceStorageDisposable.value=g.onDidChangeStorage(h=>this.emitDidChangeValue(1,h)),this.workspaceStorageId=m?.id,g}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){O.mark("code/willInitStorage");try{await A.Promises.settled([this.globalStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}finally{O.mark("code/didInitStorage")}}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${S.joinPath(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(k.WillSaveStateReason.SHUTDOWN),await A.Promises.settled([this.globalStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async migrate(m){const d=this.workspaceStorage,g=d?.items??new Map;d&&(await d.close(),d.dispose()),this.workspaceStorage=this.createWorkspaceStorage(m),await this.workspaceStorage.init();for(const[h,C]of g)this.workspaceStorage.set(h,C)}}e.NativeStorageService=w}),define(Z[172],ee([0,1,7,34,30,5]),function(K,e,v,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(w){if(v.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function P(w,n,m,d,g,h,C,D,b,I){const p=Object.create(null);p["common.machineId"]=C,p.sessionID=L.generateUuid()+Date.now(),p.commitHash=g,p.version=h,p["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),p["common.platform"]=v.PlatformToString(v.platform),p["common.nodePlatform"]=k.platform,p["common.nodeArch"]=d,p["common.product"]=I||"desktop";const s=S(D||[]);s&&(p["common.msftInternal"]=s);let a=0;const t=Date.now();Object.defineProperties(p,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),v.isLinuxSnap&&(p["common.snap"]="true");const r=O(m);r&&(p["common.platformDetail"]=r);try{const i=await w.readFile(A.URI.file(b));p["common.source"]=i.value.toString().slice(0,30)}catch(i){}return p}e.resolveCommonProperties=P;function S(w){const n=k.env.USERDNSDOMAIN;if(!n)return!1;const m=n.toLowerCase();return w.some(d=>m===d)}e.verifyMicrosoftInternalDomain=S}),define(Z[24],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=v.createDecorator("telemetryService"),e.ICustomEndpointTelemetryService=v.createDecorator("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[173],ee([0,1,35,95,71,8,32,98,27,7,5,24,53,17,10,18]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function D(a,t){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],i=new Map,o=new Map,u=2e4;function c(E,f,U,F){const z=f.substring(E.length+1);return new Promise(async $=>{let H;try{H=await C.Promises.readdir(f,{withFileTypes:!0})}catch(x){$();return}if(F.count>=u){F.count+=H.length,F.maxReached=!0,$();return}let V=H.length;if(V===0){$();return}let _=H;F.count+H.length>u&&(F.maxReached=!0,V=u-F.count,_=H.slice(0,V)),F.count+=H.length;for(const x of _)if(x.isDirectory()){if(U.includes(x.name)||await c(E,A.join(f,x.name),U,F),--V==0){$();return}}else{const j=x.name.lastIndexOf(".");if(j>=0){const q=x.name.substring(j+1);q&&i.set(q,(i.get(q)??0)+1)}for(const q of r)q.relativePathPattern?.test(z)!==!1&&q.filePattern.test(x.name)&&o.set(q.tag,(o.get(q.tag)??0)+1);if(--V==0){$();return}}})}const l={count:0,maxReached:!1};await c(a,a,t,l);const y=await p(a);return{configFiles:b(o),fileTypes:b(i),fileCount:l.count,maxFilesReached:l.maxReached,launchConfigFiles:y}}e.collectWorkspaceStats=D;function b(a){return[...d.Iterable.map(a.entries(),([t,r])=>({name:t,count:r}))].sort((t,r)=>r.count-t.count)}function I(){const a={os:`${v.type()} ${v.arch()} ${v.release()}`,memory:`${(v.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(k.virtualMachineHint.value()*100)}%`},t=v.cpus();return t&&t.length>0&&(a.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),a}e.getMachineInfo=I;async function p(a){try{const t=new Map,r=A.join(a,".vscode","launch.json"),i=await C.Promises.readFile(r),o=[],u=O.parse(i.toString(),o);if(o.length)return console.log(`Unable to parse ${r}`),[];if(O.getNodeType(u)==="object"&&u.configurations)for(const c of u.configurations){const l=c.type;l&&(t.has(l)?t.set(l,t.get(l)+1):t.set(l,1))}return b(t)}catch(t){return[]}}e.collectLaunchConfigs=p;let s=class{constructor(t,r){this.telemetryService=t,this.productService=r}formatMachineInfo(t){const r=[];return r.push(`OS Version:       ${t.os}`),r.push(`CPUs:             ${t.cpus}`),r.push(`Memory (System):  ${t.memory}`),r.push(`VM:               ${t.vmHint}`),r.join(`
`)}formatEnvironment(t){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${v.type()} ${v.arch()} ${v.release()}`);const i=v.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(v.totalmem()/h.ByteSize.GB).toFixed(2)}GB (${(v.freemem()/h.ByteSize.GB).toFixed(2)}GB free)`),w.isWindows||r.push(`Load (avg):       ${v.loadavg().map(o=>Math.round(o)).join(", ")}`),r.push(`VM:               ${Math.round(k.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${t.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(t,r){return Promise.all([P.listProcesses(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async i=>{let[o,u]=i,c=this.formatProcessList(t,o);return r.forEach(l=>{if(L.isRemoteDiagnosticError(l))c+=`
${l.errorMessage}`,u+=`
${l.errorMessage}`;else if(c+=`

Remote: ${l.hostName}`,l.processes&&(c+=`
${this.formatProcessList(t,l.processes)}`),l.workspaceMetadata){u+=`
|  Remote: ${l.hostName}`;for(const y of Object.keys(l.workspaceMetadata)){const E=l.workspaceMetadata[y];let f=`${E.fileCount} files`;E.maxFilesReached&&(f=`more than ${f}`),u+=`|    Folder (${y}): ${f}`,u+=this.formatWorkspaceStats(E)}}}),{processInfo:c,workspaceInfo:u}})}async getSystemInfo(t,r){const{memory:i,vmHint:o,os:u,cpus:c}=I(),l={os:u,memory:i,cpus:c,vmHint:o,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:r};return w.isWindows||(l.load=`${v.loadavg().map(y=>Math.round(y)).join(", ")}`),w.isLinux&&(l.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(l)}async getDiagnostics(t,r){const i=[];return P.listProcesses(t.mainPID).then(async o=>(i.push(""),i.push(this.formatEnvironment(t)),i.push(""),i.push(this.formatProcessList(t,o)),t.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.formatWorkspaceMetadata(t))),r.forEach(u=>{if(L.isRemoteDiagnosticError(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.formatMachineInfo(u.machineInfo)),u.processes&&i.push(this.formatProcessList(t,u.processes)),u.workspaceMetadata)for(const c of Object.keys(u.workspaceMetadata)){const l=u.workspaceMetadata[c];let y=`${l.fileCount} files`;l.maxFilesReached&&(y=`more than ${y}`),i.push(`Folder (${c}): ${y}`),i.push(this.formatWorkspaceStats(l))}}),i.push(""),i.push(""),i.join(`
`)))}formatWorkspaceStats(t){const r=[],i=60;let o=0;const u=(E,f)=>{const U=` ${E}(${f})`;o+U.length>i?(r.push(c),c="|                 ",o=c.length):o+=U.length,c+=U};let c="|      File types:";const l=10;let y=t.fileTypes.length>l?l:t.fileTypes.length;for(let E=0;E<y;E++){const f=t.fileTypes[E];u(f.name,f.count)}if(r.push(c),t.configFiles.length>=0&&(c="|      Conf files:",o=0,t.configFiles.forEach(E=>{u(E.name,E.count)}),r.push(c)),t.launchConfigFiles.length>0){let E="|      Launch Configs:";t.launchConfigFiles.forEach(f=>{E+=f.count>1?` ${f.name}(${f.count})`:` ${f.name}`}),r.push(E)}return r.join(`
`)}expandGPUFeatures(t){const r=Math.max(...Object.keys(t).map(i=>i.length));return Object.keys(t).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${t[i]}`).join(`
                  `)}formatWorkspaceMetadata(t){const r=[],i=[];return t.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(r.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const c=n.URI.revive(u);if(c.scheme===g.Schemas.file){const l=c.fsPath;i.push(D(l,["node_modules",".git"]).then(y=>{let E=`${y.fileCount} files`;y.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${A.basename(l)}): ${E}`),r.push(this.formatWorkspaceStats(y))}).catch(y=>{r.push(`|      Error: Unable to collect workspace stats for folder ${l} (${y.toString()})`)}))}else r.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>r.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}formatProcessList(t,r){const i=new Map;t.windows.forEach(u=>i.set(u.pid,u.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(t.mainPID,i,o,r,0),o.join(`
`)}formatProcessItem(t,r,i,o,u){const c=u===0;let l;c?l=o.pid===t?`${this.productService.applicationName} main`:"remote agent":(l=`${"  ".repeat(u)} ${o.name}`,o.name==="window"&&(l=`${l} (${r.get(o.pid)})`));const y=process.platform==="win32"?o.mem:v.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(y/h.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${l}`),Array.isArray(o.children)&&o.children.forEach(E=>this.formatProcessItem(t,r,i,E,u+1))}async reportWorkspaceStats(t){for(const{uri:r}of t.folders){const i=n.URI.revive(r);if(i.scheme!==g.Schemas.file)continue;const o=i.fsPath;try{const u=await D(o,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),u.fileTypes.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),u.launchConfigFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})}),u.configFiles.forEach(c=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};s=de([Y(0,m.ITelemetryService),Y(1,S.IProductService)],s),e.DiagnosticsService=s}),define(Z[174],ee([0,1,11,28,33,26,24,39,70,9,29,15,10,5,27,21,44,4]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var I;(function(x){x[x.None=0]="None",x[x.IncludeVersions=1]="IncludeVersions",x[x.IncludeFiles=2]="IncludeFiles",x[x.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",x[x.IncludeSharedAccounts=8]="IncludeSharedAccounts",x[x.IncludeVersionProperties=16]="IncludeVersionProperties",x[x.ExcludeNonValidated=32]="ExcludeNonValidated",x[x.IncludeInstallationTargets=64]="IncludeInstallationTargets",x[x.IncludeAssetUri=128]="IncludeAssetUri",x[x.IncludeStatistics=256]="IncludeStatistics",x[x.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",x[x.Unpublished=4096]="Unpublished"})(I||(I={}));function p(...x){return String(x.reduce((j,q)=>j|q,0))}var s;(function(x){x[x.Tag=1]="Tag",x[x.ExtensionId=4]="ExtensionId",x[x.Category=5]="Category",x[x.ExtensionName=7]="ExtensionName",x[x.Target=8]="Target",x[x.Featured=9]="Featured",x[x.SearchText=10]="SearchText",x[x.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},t={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},i={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:I.None,criteria:[],assetTypes:[]};class o{constructor(j=i){this.state=j}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(j,q=this.state.pageSize){return new o({...this.state,pageNumber:j,pageSize:q})}withFilter(j,...q){const R=[...this.state.criteria,...q.length?q.map(T=>({filterType:j,value:T})):[{filterType:j}]];return new o({...this.state,criteria:R})}withSortBy(j){return new o({...this.state,sortBy:j})}withSortOrder(j){return new o({...this.state,sortOrder:j})}withFlags(...j){return new o({...this.state,flags:j.reduce((q,R)=>q|R,0)})}withAssetTypes(...j){return new o({...this.state,assetTypes:j})}get raw(){const{criteria:j,pageNumber:q,pageSize:R,sortBy:T,sortOrder:M,flags:N,assetTypes:B}=this.state;return{filters:[{criteria:j,pageNumber:q,pageSize:R,sortBy:T,sortOrder:M}],assetTypes:B,flags:N}}get searchText(){const j=this.state.criteria.filter(q=>q.filterType===s.SearchText)[0];return j&&j.value?j.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(j=>String(j.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function u(x,j){const q=(x||[]).filter(R=>R.statisticName===j)[0];return q?q.value:0}function c(x){const j="Microsoft.VisualStudio.Code.Translation.";return x.files.filter(R=>R.assetType.indexOf(j)===0).reduce((R,T)=>{const M=f(x,T.assetType);return M&&R.push([T.assetType.substring(j.length),M]),R},[])}function l(x){if(x.properties){const j=x.properties.filter(T=>T.key===a.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),R=j.filter(T=>q.test(T.value))[0];return R?{uri:R.value,fallbackUri:R.value}:null}return f(x,a.Repository)}function y(x){return{uri:`${x.fallbackAssetUri}/${a.VSIX}?redirect=true`,fallbackUri:`${x.fallbackAssetUri}/${a.VSIX}`}}function E(x){const j=f(x,a.Icon);if(j)return j;const q=k.DefaultIconPath;return{uri:q,fallbackUri:q}}function f(x,j){return x.files.filter(R=>R.assetType===j)[0]?{uri:`${x.assetUri}/${j}`,fallbackUri:`${x.fallbackAssetUri}/${j}`}:null}function U(x,j){const q=x.properties?x.properties.filter(T=>T.key===j):[],R=q.length>0&&q[0].value;return R?R.split(",").map(T=>L.adoptToGalleryExtensionId(T)):[]}function F(x){const j=x.properties?x.properties.filter(q=>q.key===t.Engine):[];return j.length>0&&j[0].value||""}function z(x){const j=x.properties?x.properties.filter(R=>R.key===t.LocalizedLanguages):[],q=j.length>0&&j[0].value||"";return q?q.split(","):[]}function $(x){return x.indexOf("preview")!==-1}function H(x,j,q,R,T){const M={manifest:f(j,a.Manifest),readme:f(j,a.Details),changelog:f(j,a.Changelog),license:f(j,a.License),repository:l(j),download:y(j),icon:E(j),coreTranslations:c(j)};return{identifier:{id:L.getGalleryExtensionId(x.publisher.publisherName,x.extensionName),uuid:x.extensionId},name:x.extensionName,version:j.version,date:j.lastUpdated,displayName:x.displayName,publisherId:x.publisher.publisherId,publisher:x.publisher.publisherName,publisherDisplayName:x.publisher.displayName,description:x.shortDescription||"",installCount:u(x.statistics,"install"),rating:u(x.statistics,"averagerating"),ratingCount:u(x.statistics,"ratingcount"),assetUri:g.URI.parse(j.assetUri),webExtension:!!x.tags?.includes(k.WEB_EXTENSION_TAG),assetTypes:j.files.map(({assetType:N})=>N),assets:M,properties:{dependencies:U(j,t.Dependency),extensionPack:U(j,t.ExtensionPack),engine:F(j),localizedLanguages:z(j)},telemetryData:{index:(R.pageNumber-1)*R.pageSize+q,querySource:T},preview:$(x.flags)}}let V=class{constructor(j,q,R,T,M,N,B){this.requestService=j,this.logService=q,this.environmentService=R,this.telemetryService=T,this.fileService=M,this.productService=N;const G=N.extensionsGallery;this.extensionsGalleryUrl=G&&G.serviceUrl,this.extensionsControlUrl=G&&G.controlUrl,this.commonHeadersPromise=_(N.version,this.environmentService,this.fileService,B)}api(j=""){return`${this.extensionsGalleryUrl}${j}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(j,q){const R=[];let{total:T,firstPage:M,getPage:N}=await this.query({names:j,pageSize:j.length},q);R.push(...M);for(let B=1;R.length<T&&(M=await N(B,q),M.length);B++)R.push(...M);return R}async getCompatibleExtension(j,q){return this.getCompatibleExtensionByEngine(j,q)}async getCompatibleExtensionByEngine(j,q){const R=k.isIExtensionIdentifier(j)?null:j;if(R&&R.properties.engine&&S.isEngineValid(R.properties.engine,this.productService.version,this.productService.date))return R;const{id:T,uuid:M}=R?R.identifier:j;let N=new o().withFlags(I.IncludeAssetUri,I.IncludeStatistics,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");M?N=N.withFilter(s.ExtensionId,M):N=N.withFilter(s.ExtensionName,T);const{galleryExtensions:B}=await this.queryGallery(N,n.CancellationToken.None),[G]=B;if(!G||!G.versions.length)return null;if(q){const X=G.versions.filter(ie=>ie.version===q)[0];if(X){const ie=H(G,X,0,N);if(ie.properties.engine&&S.isEngineValid(ie.properties.engine,this.productService.version,this.productService.date))return ie}return null}const Q=await this.getLastValidExtensionVersion(G,G.versions);return Q?H(G,Q,0,N):null}async query(j,q){const R=n.CancellationToken.isCancellationToken(j)?{}:j,T=n.CancellationToken.isCancellationToken(j)?j:q;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let M=R.text||"";const N=A.getOrDefault(R,ne=>ne.pageSize,50);let B=new o().withFlags(I.IncludeLatestVersionOnly,I.IncludeAssetUri,I.IncludeStatistics,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,N).withFilter(s.Target,"Microsoft.VisualStudio.Code");M?(M=M.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ne,oe,he)=>(B=B.withFilter(s.Category,he||oe),"")),M=M.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ne,oe,he)=>(B=B.withFilter(s.Tag,he||oe),"")),M=M.replace(/\bfeatured(\s+|\b|$)/g,()=>(B=B.withFilter(s.Featured),"")),M=M.trim(),M&&(M=M.length<200?M:M.substring(0,200),B=B.withFilter(s.SearchText,M)),B=B.withSortBy(0)):R.ids?B=B.withFilter(s.ExtensionId,...R.ids):R.names?B=B.withFilter(s.ExtensionName,...R.names):B=B.withSortBy(4),typeof R.sortBy=="number"&&(B=B.withSortBy(R.sortBy)),typeof R.sortOrder=="number"&&(B=B.withSortOrder(R.sortOrder));const{galleryExtensions:G,total:Q}=await this.queryGallery(B,T),X=G.map((ne,oe)=>H(ne,ne.versions[0],oe,B,R.source)),ie=async(ne,oe)=>{if(oe.isCancellationRequested)throw v.canceled();const he=B.withPage(ne+1),{galleryExtensions:me}=await this.queryGallery(he,oe);return me.map((pe,Ie)=>H(pe,pe.versions[0],Ie,he,R.source))};return{firstPage:X,total:Q,pageSize:B.pageSize,getPage:ie}}async queryGallery(j,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");j=j.withFlags(j.flags,I.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,p(I.Unpublished));const R=await this.commonHeadersPromise,T=JSON.stringify(j.raw),M={...R,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(T.length)},N=new Date().getTime();let B,G,Q=0;try{if(B=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:T,headers:M},q),B.res.statusCode&&B.res.statusCode>=400&&B.res.statusCode<500)return{galleryExtensions:[],total:Q};const X=await P.asJson(B);if(X){const ie=X.results[0],ne=ie.extensions,oe=ie.resultMetadata&&ie.resultMetadata.filter(he=>he.metadataType==="ResultCount")[0];return Q=oe&&oe.metadataItems.filter(he=>he.name==="TotalCount")[0].count||0,{galleryExtensions:ne,total:Q}}return{galleryExtensions:[],total:Q}}catch(X){throw G=X,X}finally{this.telemetryService.publicLog2("galleryService:query",{...j.telemetryData,requestBodySize:String(T.length),duration:new Date().getTime()-N,success:!!B&&P.isSuccess(B),responseBodySize:B?.res.headers["Content-Length"],statusCode:B?String(B.res.statusCode):void 0,errorCode:G?v.isPromiseCanceledError(G)?"canceled":v.getErrorMessage(G).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(Q)})}}async reportStatistic(j,q,R,T){if(!this.isEnabled())return;const N={...await this.commonHeadersPromise,Accept:"*/*;api-version=4.0-preview.1"};try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${j}/extensions/${q}/${R}/stats?statType=${T}`),headers:N},n.CancellationToken.None)}catch(B){}}async download(j,q,R){this.logService.trace("ExtensionGalleryService#download",j.identifier.id);const T=L.getGalleryExtensionTelemetryData(j),M=new Date().getTime(),N=X=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...T,duration:X}),B=R===1?"install":R===2?"update":"",G=B?{uri:`${j.assets.download.uri}&${B}=true`,fallbackUri:`${j.assets.download.fallbackUri}?${B}=true`}:j.assets.download,Q=await this.getAsset(G);await this.fileService.writeFile(q,Q.stream),N(new Date().getTime()-M)}async getReadme(j,q){if(j.assets.readme){const R=await this.getAsset(j.assets.readme,{},q);return await P.asText(R)||""}return""}async getManifest(j,q){if(j.assets.manifest){const R=await this.getAsset(j.assets.manifest,{},q),T=await P.asText(R);return T?JSON.parse(T):null}return null}async getCoreTranslation(j,q){const R=j.assets.coreTranslations.filter(T=>T[0]===q.toUpperCase())[0];if(R){const T=await this.getAsset(R[1]),M=await P.asText(T);return M?JSON.parse(M):null}return null}async getChangelog(j,q){if(j.assets.changelog){const R=await this.getAsset(j.assets.changelog,{},q);return await P.asText(R)||""}return""}async getAllVersions(j,q){let R=new o().withFlags(I.IncludeVersions,I.IncludeCategoryAndTags,I.IncludeFiles,I.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");j.identifier.uuid?R=R.withFilter(s.ExtensionId,j.identifier.uuid):R=R.withFilter(s.ExtensionName,j.identifier.id);const T=[],{galleryExtensions:M}=await this.queryGallery(R,n.CancellationToken.None);return M.length&&(q?await Promise.all(M[0].versions.map(async N=>{let B;try{B=await this.getEngine(N)}catch(G){}B&&S.isEngineValid(B,this.productService.version,this.productService.date)&&T.push({version:N.version,date:N.lastUpdated})})):T.push(...M[0].versions.map(N=>({version:N.version,date:N.lastUpdated})))),T}async getAsset(j,q={},R=n.CancellationToken.None){const T=await this.commonHeadersPromise,M={type:"GET"},N={...T,...q.headers||{}};q={...q,...M,headers:N};const B=j.uri,G=j.fallbackUri,Q={...q,url:B};try{const X=await this.requestService.request(Q,R);if(X.res.statusCode===200)return X;const ie=await P.asText(X);throw new Error(`Expected 200, got back ${X.res.statusCode} instead.

${ie}`)}catch(X){if(v.isPromiseCanceledError(X))throw X;const ie=v.getErrorMessage(X);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:B,message:ie});const ne={...q,url:G};return this.requestService.request(ne,R)}}async getLastValidExtensionVersion(j,q){const R=this.getLastValidExtensionVersionFromProperties(j,q);return R||this.getLastValidExtensionVersionRecursively(j,q)}getLastValidExtensionVersionFromProperties(j,q){for(const R of q){const T=F(R);if(!T)return null;if(S.isEngineValid(T,this.productService.version,this.productService.date))return R}return null}async getEngine(j){const q=F(j);if(q)return q;const R=f(j,a.Manifest);if(!R)throw new Error("Manifest was not found");const T={"Accept-Encoding":"gzip"},M=await this.getAsset(R,{headers:T}),N=await P.asJson(M);if(N)return N.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(j,q){if(!q.length)return null;const R=q[0],T=await this.getEngine(R);return S.isEngineValid(T,this.productService.version,this.productService.date)?{...R,properties:[...R.properties||[],{key:t.Engine,value:T}]}:this.getLastValidExtensionVersionRecursively(j,q.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const j=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(j.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await P.asJson(j),R=new Map;if(q)for(const T of q.malicious){const M=R.get(T)||{id:{id:T},malicious:!0,slow:!1};M.malicious=!0,R.set(T,M)}return[...R.values()]}};V=de([Y(0,P.IRequestService),Y(1,m.ILogService),Y(2,w.IEnvironmentService),Y(3,O.ITelemetryService),Y(4,d.IFileService),Y(5,h.IProductService),Y(6,b.optional(C.IStorageService))],V),e.ExtensionGalleryService=V;async function _(x,j,q,R){const T={"X-Market-Client-Id":`VSCode ${x}`,"User-Agent":`VSCode ${x}`},M=await D.getServiceMachineId(j,q,R);return T["X-Market-User-Id"]=M,T}e.resolveMarketplaceHeaders=_}),define(Z[175],ee([0,1,5,8,27,9,34,10,7,19,28,63,39,15,168,6,24,73,111,21,3,58]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h,C,D,b,I,p,s,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let i=class extends h.ExtensionTipsService{constructor(u,c,l,y,E,f,U,F,z,$){super(U,F,z,$);this.environmentService=u,this.telemetryService=c,this.extensionManagementService=l,this.storageService=y,this.nativeHostService=E,this.extensionRecommendationNotificationService=f,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,F.exeBasedExtensionTips&&m.forEach(F.exeBasedExtensionTips,({key:H,value:V})=>{const _=[],x=[],j=[];m.forEach(V.recommendations,({key:q,value:R})=>{R.important?V.important?_.push({extensionId:q,extensionName:R.name,isExtensionPack:!!R.isExtensionPack}):x.push({extensionId:q,extensionName:R.name,isExtensionPack:!!R.isExtensionPack}):j.push({extensionId:q,extensionName:R.name,isExtensionPack:!!R.isExtensionPack})}),_.length&&this.highImportanceExecutableTips.set(H,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:_}),x.length&&this.mediumImportanceExecutableTips.set(H,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:x}),j.length&&this.allOtherExecutableTips.set(H,{exeFriendlyName:V.friendlyName,windowsPath:V.windowsPath,recommendations:j})}),C.timeout(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...u,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const u=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),l=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(u,l),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,l)}groupImportantTipsByExe(u,c){const l=new Map;u.forEach(F=>l.set(F.extensionId.toLowerCase(),F));const{installed:y,uninstalled:E}=this.groupByInstalled([...l.keys()],c);for(const F of y){const z=l.get(F);z&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:F,exeName:z.exeName})}for(const F of E){const z=l.get(F);z&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:F,exeName:z.exeName})}const f=this.getPromptedExecutableTips(),U=new Map;for(const F of E){const z=l.get(F);if(z&&(!f[z.exeName]||!f[z.exeName].includes(z.extensionId))){let $=U.get(z.exeName);$||($=[],U.set(z.exeName,$)),$.push(z)}}return U}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[u,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(l=>{switch(l){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(u);break;case"incompatibleWindow":const y=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(y(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const E=this._register(C.disposableTimeout(()=>{E.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const u=this.getLastPromptedMediumExeTime(),c=Date.now()-u,l=7*24*60*60*1e3;if(c<l){const f=this._register(C.disposableTimeout(()=>{f.dispose(),this.promptMediumImportanceExeBasedTip()},l-c));return}const[y,E]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(E).then(f=>{switch(f){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(y),this.addToRecommendedExecutables(E[0].exeName,E);const U=this._register(C.disposableTimeout(()=>{U.dispose(),this.promptMediumImportanceExeBasedTip()},l));break;case"ignored":this.mediumImportanceTipsByExe.delete(y),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const F=s.Event.once(s.Event.latch(s.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(F(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const z=this._register(C.disposableTimeout(()=>{z.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}promptExeRecommendations(u){const c=u.map(({extensionId:y})=>y.toLowerCase()),l=I.localize(0,null,u[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(c,l,`@exe:"${u[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let u=this.storageService.getNumber(r,0);return u||(u=Date.now(),this.updateLastPromptedMediumExeTime(u)),u}updateLastPromptedMediumExeTime(u){this.storageService.store(r,u,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(u,c){const l=this.getPromptedExecutableTips();l[u]=c.map(({extensionId:y})=>y.toLowerCase()),this.storageService.store(t,JSON.stringify(l),0,0)}groupByInstalled(u,c){const l=[],y=[],E=c.reduce((f,U)=>(f.add(U.identifier.id.toLowerCase()),f),new Set);return u.forEach(f=>{E.has(f.toLowerCase())?l.push(f):y.push(f)}),{installed:l,uninstalled:y}}async getValidExecutableBasedExtensionTips(u){const c=[],l=new Map;for(const y of u.keys()){const E=u.get(y);if(!E||!w.isNonEmptyArray(E.recommendations))continue;const f=[];S.isWindows?E.windowsPath&&f.push(E.windowsPath.replace("%USERPROFILE%",O.env.USERPROFILE).replace("%ProgramFiles(x86)%",O.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",O.env.ProgramFiles).replace("%APPDATA%",O.env.APPDATA).replace("%WINDIR%",O.env.WINDIR)):(f.push(k.join("/usr/local/bin",y)),f.push(k.join("/usr/bin",y)),f.push(k.join(this.environmentService.userHome.fsPath,y)));for(const U of f){let F=l.get(U);if(F===void 0&&(F=await this.fileService.exists(v.URI.file(U)),l.set(U,F)),F)for(const{extensionId:z,extensionName:$,isExtensionPack:H}of E.recommendations)c.push({extensionId:z,extensionName:$,isExtensionPack:H,exeName:y,exeFriendlyName:E.exeFriendlyName,windowsPath:E.windowsPath})}}return c}};i=de([Y(0,A.INativeEnvironmentService),Y(1,D.ITelemetryService),Y(2,n.IExtensionManagementService),Y(3,p.IStorageService),Y(4,a.INativeHostService),Y(5,b.IExtensionRecommendationNotificationService),Y(6,P.IFileService),Y(7,L.IProductService),Y(8,d.IRequestService),Y(9,g.ILogService)],i),e.ExtensionTipsService=i}),define(Z[80],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class v{constructor(A){this.appender=A}listen(A,O){throw new Error(`Event not found: ${O}`)}call(A,O,{eventName:P,data:S}){return this.appender.log(P,S),Promise.resolve(null)}}e.TelemetryAppenderChannel=v;class k{constructor(A){this.channel=A}log(A,O){return this.channel.call("log",{eventName:A,data:O}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=k}),define(Z[81],ee([0,1,51,121,20,4,23,37,2,26,31]),function(K,e,v,k,L,A,O,P,S,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(h,C){this._configurationService=C,this._experimentProperties={},this._disposables=new S.DisposableStore,this._cleanupPatterns=[],this._appender=h.appender,this._commonProperties=h.commonProperties||Promise.resolve({}),this._piiPaths=h.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!h.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let D of this._piiPaths)this._cleanupPatterns.push(new RegExp(L.escapeRegExpCharacters(D),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(D=>{const b=/^[a-f0-9]+$/i.test(D["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!b})}))}setExperimentProperty(h,C){this._experimentProperties[h]=C}setEnabled(h){this._enabled=h}_updateUserOptIn(){const h=this._configurationService?.getValue(d);this._userOptIn=h?h.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const h=await this._commonProperties;let C=h.sessionID,D=h["common.instanceId"],b=h["common.machineId"],I=h["common.firstSessionDate"],p=h["common.msftInternal"];return{sessionId:C,instanceId:D,machineId:b,firstSessionDate:I,msftInternal:p}}dispose(){this._disposables.dispose()}publicLog(h,C,D){return this.isOptedIn?this._commonProperties.then(b=>{C=w.mixin(C,b),C=w.mixin(C,this._experimentProperties),C=w.cloneAndChange(C,I=>{if(typeof I=="string")return this._cleanupInfo(I,D)}),this._appender.log(h,C)},b=>{console.error(b)}):Promise.resolve(void 0)}publicLog2(h,C,D){return this.publicLog(h,C,D)}publicLogError(h,C){return this.sendErrorTelemetry?this.publicLog(h,C,!0):Promise.resolve(void 0)}publicLogError2(h,C){return this.publicLogError(h,C)}_cleanupInfo(h,C){let D=h;if(C){const b=[];for(let a of this._cleanupPatterns)for(;;){const t=a.exec(h);if(!t)break;b.push([t.index,a.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,p=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(D="";;){const a=p.exec(h);if(!a)break;!I.test(a[0])&&b.every(([t,r])=>a.index<t||a.index>=r)&&(D+=h.substring(s,a.index)+"<REDACTED: user-file-path>",s=p.lastIndex)}s<h.length&&(D+=h.substr(s))}for(let b of this._cleanupPatterns)D=D.replace(b,"");return D}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=de([Y(1,A.optional(O.IConfigurationService))],m),e.TelemetryService=m;const d="telemetry";n.Registry.as(P.Extensions.Configuration).registerConfiguration({id:d,order:110,type:"object",title:k.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:v.default.privacyStatementUrl?k.localize(2,null,v.default.privacyStatementUrl):k.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Z[59],ee([0,1,23,26,16,6]),function(K,e,v,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(h,C){return Promise.resolve(void 0)}publicLog2(h,C){return this.publicLog(h,C)}publicLogError(h,C){return Promise.resolve(void 0)}publicLogError2(h,C){return this.publicLogError(h,C)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class O{async publicLog(C,D,b){}async publicLogError(C,D,b){}}e.NullEndpointTelemetryService=O;function P(...h){return{log:(C,D)=>h.forEach(b=>b.log(C,D)),flush:()=>A.Promises.settled(h.map(C=>C.flush()))}}e.combinedAppender=P,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(h,C){return C.onDidChangeConfiguration(D=>{D.source!==6&&h.publicLog2("updateConfiguration",{configurationSource:v.ConfigurationTargetToString(D.source),configurationKeys:d(D.sourceConfig)})})}e.configurationTelemetry=S;function w(h){const C=Object.create(null),D=Object.create(null),b=Object.create(null);m(h,b);for(let I in b){I=I.length>150?I.substr(I.length-149):I;const p=b[I];typeof p=="number"?D[I]=p:typeof p=="boolean"?D[I]=p?1:0:typeof p=="string"?C[I]=p.substring(0,1023):typeof p!="undefined"&&p!==null&&(C[I]=p)}return{properties:C,measurements:D}}e.validateTelemetryData=w;function n(h){if(!h)return"none";let C="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(b=>{h.indexOf(`${b}+`)===0&&(C=b)}),C}e.cleanRemoteAuthority=n;function m(h,C,D=0,b){if(!!h)for(let I of Object.getOwnPropertyNames(h)){const p=h[I],s=b?b+I:I;Array.isArray(p)?C[s]=k.safeStringify(p):p instanceof Date?C[s]=p.toISOString():L.isObject(p)?D<2?m(p,C,D+1,s+"."):C[s]=k.safeStringify(p):C[s]=p}}function d(h){if(!h)return[];const C=[];return g(C,"",h),C}function g(h,C,D){D&&typeof D=="object"&&!Array.isArray(D)?Object.keys(D).forEach(b=>g(h,C?`${C}.${b}`:b,D[b])):h.push(C)}}),define(Z[176],ee([0,1,2,9,15,59]),function(K,e,v,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let O=class extends v.Disposable{constructor(S,w){super();this.logger=this._register(S.createLogger(w.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(S,w){this.logger.trace(`telemetry/${S}`,A.validateTelemetryData(w))}};O=de([Y(0,L.ILoggerService),Y(1,k.IEnvironmentService)],O),e.TelemetryLogAppender=O}),define(Z[177],ee([0,1,11,26,59]),function(K,e,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function A(P){const S=await new Promise((n,m)=>{K(["applicationinsights"],n,m)});let w;return S.defaultClient?(w=new S.TelemetryClient(P),w.channel.setUseDiskRetryCaching(!0)):(S.setup(P).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),w=S.defaultClient),P.indexOf("AIF-")===0&&(w.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),w}class O{constructor(S,w,n){this._eventPrefix=S,this._defaultData=w,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(S){if(!!this._aiClient){if(typeof this._aiClient!="string"){S(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=A(this._aiClient)),this._asyncAIClient.then(w=>{S(w)},w=>{v.onUnexpectedError(w),console.error(w)})}}log(S,w){!this._aiClient||(w=k.mixin(w,this._defaultData),w=L.validateTelemetryData(w),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+S,properties:w.properties,measurements:w.measurements})))}flush(){return this._aiClient?new Promise(S=>{this._withAIClient(w=>{w.flush({callback:()=>{this._aiClient=void 0,S(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=O}),define(Z[178],ee([0,1,49,80,17,81,23,24]),function(K,e,v,k,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let S=class{constructor(n,m){this.configurationService=n,this.telemetryService=m,this.customTelemetryServices=new Map}async getCustomTelemetryService(n){if(!this.customTelemetryServices.has(n.id)){const{machineId:m,sessionId:d}=await this.telemetryService.getTelemetryInfo(),g=Object.create(null);g["common.vscodemachineid"]=m,g["common.vscodesessionid"]=d;const h=[n.id,JSON.stringify(g),n.aiKey],D=new v.Client(L.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:h,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),b=new k.TelemetryAppenderClient(D);this.customTelemetryServices.set(n.id,new A.TelemetryService({appender:b,sendErrorTelemetry:n.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(n.id)}async publicLog(n,m,d){await(await this.getCustomTelemetryService(n)).publicLog(m,d)}async publicLogError(n,m,d){await(await this.getCustomTelemetryService(n)).publicLogError(m,d)}};S=de([Y(0,O.IConfigurationService),Y(1,P.ITelemetryService)],S),e.CustomEndpointTelemetryService=S}),define(Z[82],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocation=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var k;(function(g){g.Shell="terminal.integrated.shell.",g.ShellArgs="terminal.integrated.shellArgs.",g.DefaultProfile="terminal.integrated.defaultProfile.",g.Profiles="terminal.integrated.profiles."})(k=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var L;(function(g){g.ShellLinux="terminal.integrated.shell.linux",g.ShellMacOs="terminal.integrated.shell.osx",g.ShellWindows="terminal.integrated.shell.windows",g.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",g.AutomationShellLinux="terminal.integrated.automationShell.linux",g.AutomationShellMacOs="terminal.integrated.automationShell.osx",g.AutomationShellWindows="terminal.integrated.automationShell.windows",g.ShellArgsLinux="terminal.integrated.shellArgs.linux",g.ShellArgsMacOs="terminal.integrated.shellArgs.osx",g.ShellArgsWindows="terminal.integrated.shellArgs.windows",g.ProfilesWindows="terminal.integrated.profiles.windows",g.ProfilesMacOs="terminal.integrated.profiles.osx",g.ProfilesLinux="terminal.integrated.profiles.linux",g.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",g.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",g.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",g.UseWslProfiles="terminal.integrated.useWslProfiles",g.TabsEnabled="terminal.integrated.tabs.enabled",g.TabsHideCondition="terminal.integrated.tabs.hideCondition",g.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",g.TabsShowActions="terminal.integrated.tabs.showActions",g.TabsLocation="terminal.integrated.tabs.location",g.TabsFocusMode="terminal.integrated.tabs.focusMode",g.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",g.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",g.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",g.CopyOnSelection="terminal.integrated.copyOnSelection",g.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",g.FontFamily="terminal.integrated.fontFamily",g.FontSize="terminal.integrated.fontSize",g.LetterSpacing="terminal.integrated.letterSpacing",g.LineHeight="terminal.integrated.lineHeight",g.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",g.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",g.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",g.BellDuration="terminal.integrated.bellDuration",g.FontWeight="terminal.integrated.fontWeight",g.FontWeightBold="terminal.integrated.fontWeightBold",g.CursorBlinking="terminal.integrated.cursorBlinking",g.CursorStyle="terminal.integrated.cursorStyle",g.CursorWidth="terminal.integrated.cursorWidth",g.Scrollback="terminal.integrated.scrollback",g.DetectLocale="terminal.integrated.detectLocale",g.DefaultLocation="terminal.integrated.defaultLocation",g.GpuAcceleration="terminal.integrated.gpuAcceleration",g.RightClickBehavior="terminal.integrated.rightClickBehavior",g.Cwd="terminal.integrated.cwd",g.ConfirmOnExit="terminal.integrated.confirmOnExit",g.EnableBell="terminal.integrated.enableBell",g.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",g.AllowChords="terminal.integrated.allowChords",g.AllowMnemonics="terminal.integrated.allowMnemonics",g.EnvMacOs="terminal.integrated.env.osx",g.EnvLinux="terminal.integrated.env.linux",g.EnvWindows="terminal.integrated.env.windows",g.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",g.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",g.ShowExitAlert="terminal.integrated.showExitAlert",g.SplitCwd="terminal.integrated.splitCwd",g.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",g.WordSeparators="terminal.integrated.wordSeparators",g.TitleMode="terminal.integrated.titleMode",g.EnableFileLinks="terminal.integrated.enableFileLinks",g.UnicodeVersion="terminal.integrated.unicodeVersion",g.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",g.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",g.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",g.LocalEchoStyle="terminal.integrated.localEchoStyle",g.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",g.InheritEnv="terminal.integrated.inheritEnv",g.ShowLinkHover="terminal.integrated.showLinkHover"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var A;(function(g){g.CommandPrompt="cmd",g.PowerShell="pwsh",g.Wsl="wsl",g.GitBash="gitbash"})(A=e.WindowsShellType||(e.WindowsShellType={}));var O;(function(g){g[g.Api=0]="Api",g[g.Process=1]="Process",g[g.Sequence=2]="Sequence"})(O=e.TitleEventSource||(e.TitleEventSource={}));var P;(function(g){g.LocalPty="localPty",g.PtyHost="ptyHost",g.Log="log",g.Heartbeat="heartbeat"})(P=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=v.createDecorator("localTerminalService"),e.IPtyService=v.createDecorator("ptyService");var S;(function(g){g[g.BeatInterval=5e3]="BeatInterval",g[g.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",g[g.SecondWaitMultiplier=1]="SecondWaitMultiplier",g[g.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(S=e.HeartbeatConstants||(e.HeartbeatConstants={}));var w;(function(g){g.TerminalView="view",g.Editor="editor"})(w=e.TerminalLocation||(e.TerminalLocation={}));var n;(function(g){g[g.GraceTime=6e4]="GraceTime",g[g.ShortGraceTime=6e3]="ShortGraceTime"})(n=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var m;(function(g){g[g.HighWatermarkChars=1e5]="HighWatermarkChars",g[g.LowWatermarkChars=5e3]="LowWatermarkChars",g[g.CharCountAckSize=5e3]="CharCountAckSize"})(m=e.FlowControlConstants||(e.FlowControlConstants={}));var d;(function(g){g.GitBash="Git Bash",g.Pwsh="PowerShell"})(d=e.ProfileSource||(e.ProfileSource={}))}),define(Z[179],ee([0,1,4]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=v.createDecorator("localPtyService")}),define(Z[180],ee([0,1,35,8,34,18,16,26,7]),function(K,e,v,k,L,A,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function w(){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(v.release());let d=0;return m&&m.length===4&&(d=parseInt(m[3])),d}e.getWindowsBuildNumber=w;async function n(m,d,g,h=L.env,C=A.Promises.exists){if(k.isAbsolute(m))return await C(m)?m:void 0;if(d===void 0&&(d=L.cwd()),k.dirname(m)!=="."){const p=k.join(d,m);return await C(p)?p:void 0}const b=P.getCaseInsensitive(h,"PATH");if(g===void 0&&O.isString(b)&&(g=b.split(k.delimiter)),g===void 0||g.length===0){const p=k.join(d,m);return await C(p)?p:void 0}for(let p of g){let s;if(k.isAbsolute(p)?s=k.join(p,m):s=k.join(d,p,m),await C(s))return s;if(S.isWindows){let a=s+".com";if(await C(a)||(a=s+".exe",await C(a)))return a}}const I=k.join(d,m);return await C(I)?I:void 0}e.findExecutable=n}),define(Z[181],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var v;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST="hc"})(v=e.ColorScheme||(e.ColorScheme={}))}),define(Z[83],ee([0,1,4,2,31,3,181,54]),function(K,e,v,k,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=v.createDecorator("themeService");var S;(function(D){function b(I){return I&&typeof I=="object"&&typeof I.id=="string"}D.isThemeColor=b})(S=e.ThemeColor||(e.ThemeColor={}));function w(D){return{id:D}}e.themeColorFromId=w;var n;(function(D){function b(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||S.isThemeColor(r.color))}D.isThemeIcon=b;const I=new RegExp(`^\\$\\((${P.CSSIcon.iconNameExpression}(?:${P.CSSIcon.iconModifierExpression})?)\\)$`);function p(r){const i=I.exec(r);if(!i)return;let[,o]=i;return{id:o}}D.fromString=p;function s(r,i){let o=r.id;const u=o.lastIndexOf("~");return u!==-1&&(o=o.substring(0,u)),i&&(o=`${o}~${i}`),{id:o}}D.modify=s;function a(r,i){return r.id===i.id&&r.color?.id===i.color?.id}D.isEqual=a;function t(r){return{id:r.id}}D.asThemeIcon=t,D.asClassNameArray=P.CSSIcon.asClassNameArray,D.asClassName=P.CSSIcon.asClassName,D.asCSSSelector=P.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=P.Codicon.file,e.FolderThemeIcon=P.Codicon.folder;function m(D){switch(D){case O.ColorScheme.DARK:return"vs-dark";case O.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=m,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new A.Emitter}onColorThemeChange(b){return this.themingParticipants.push(b),this.onThemingParticipantAddedEmitter.fire(b),k.toDisposable(()=>{const I=this.themingParticipants.indexOf(b);this.themingParticipants.splice(I,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new d;L.Registry.add(e.Extensions.ThemingContribution,g);function h(D){return g.onColorThemeChange(D)}e.registerThemingParticipant=h;class C extends k.Disposable{constructor(b){super();this.themeService=b,this.theme=b.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(I=>this.onThemeChange(I)))}onThemeChange(b){this.theme=b,this.updateStyles()}updateStyles(){}getColor(b,I){let p=this.theme.getColor(b);return p&&I&&(p=I(p,this.theme)),p?p.toString():null}}e.Themable=C}),define(Z[182],ee([0,1,37,122,31,54,83]),function(K,e,v,k,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const P={args:{description:k.localize(0,null),type:"array",items:{type:"string"}},overrideName:{description:k.localize(1,null),type:"boolean"},icon:{description:k.localize(2,null),type:"string",enum:Array.from(A.iconRegistry.all,b=>b.id),markdownEnumDescriptions:Array.from(A.iconRegistry.all,b=>`$(${b.id})`)},color:{description:k.localize(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:k.localize(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},S={type:"object",required:["path"],properties:{path:{description:k.localize(5,null),type:["string","array"],items:{type:"string"}},...P}},w=k.localize(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),n=k.localize(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=k.localize(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),d={id:"terminal",order:100,title:k.localize(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:k.localize(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:k.localize(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:k.localize(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:k.localize(13,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:k.localize(14,null),type:["string","null"],default:null,markdownDeprecationMessage:n},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:k.localize(15,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:k.localize(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:k.localize(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:n},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:k.localize(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:k.localize(19,null)}},{type:"string",markdownDescription:k.localize(20,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:k.localize(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:k.localize(22,null),enum:["PowerShell","Git Bash"]},...P}},{type:"null"},S]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:k.localize(23,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},S]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:k.localize(24,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},S]}},["terminal.integrated.useWslProfiles"]:{description:k.localize(25,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:k.localize(26,null),type:"boolean",default:!0},["terminal.integrated.showLinkHover"]:{scope:1,description:k.localize(27,null),type:"boolean",default:!0}}};function g(){L.Registry.as(v.Extensions.Configuration).registerConfiguration(d),C()}e.registerTerminalPlatformConfiguration=g;let h;function C(b){const I=L.Registry.as(v.Extensions.Configuration);h&&I.deregisterConfigurations([h]);let p,s;if(b){const a=b.profiles.map(t=>({name:t.profileName,description:D(t)}));p=a.map(t=>t.name),s=a.map(t=>t.description)}h={id:"terminal",order:100,title:k.localize(28,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:k.localize(29,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:b?.os===3?p:void 0,markdownEnumDescriptions:b?.os===3?s:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:k.localize(30,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:b?.os===2?p:void 0,markdownEnumDescriptions:b?.os===2?s:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:k.localize(31,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:b?.os===1?p:void 0,markdownEnumDescriptions:b?.os===1?s:void 0}}},I.registerConfiguration(h)}e.registerTerminalDefaultProfileConfiguration=C;function D(b){let I=`$(${O.ThemeIcon.isThemeIcon(b.icon)?b.icon.id:b.icon?b.icon:A.Codicon.terminal.id}) ${b.profileName}
- path: ${b.path}`;return b.args&&(typeof b.args=="string"?I+=`
- args: "${b.args}"`:I+=`
- args: [${b.args.length===0?"":b.args.join("','")}]`),b.overrideName!==void 0&&(I+=`
- overrideName: ${b.overrideName}`),b.color&&(I+=`
- color: ${b.color}`),b.env&&(I+=`
- env: ${JSON.stringify(b.env)}`),I}}),define(Z[183],ee([0,1,8,97,180,42,18,54,7,83]),function(K,e,v,k,L,A,O,P,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let n;function m(t,r,i,o,u,c,l,y){return u=u||{existsFile:O.SymlinkSupport.existsFile,readFile:O.Promises.readFile},S.isWindows?d(i,u,c,o.getValue("terminal.integrated.useWslProfiles")!==!1,t&&typeof t=="object"?{...t}:o.getValue("terminal.integrated.profiles.windows"),typeof r=="string"?r:o.getValue("terminal.integrated.defaultProfile.windows"),y,l):p(u,c,i,t&&typeof t=="object"?{...t}:o.getValue(S.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof r=="string"?r:o.getValue(S.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),y,l)}e.detectAvailableProfiles=m;async function d(t,r,i,o,u,c,l,y){const E=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),f=`${process.env.windir}\\${E?"Sysnative":"System32"}`;let U=!1;L.getWindowsBuildNumber()>=16299&&(U=!0),await C(l);const F=new Map;t&&(F.set("PowerShell",{source:"PowerShell",icon:P.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Windows PowerShell",{path:`${f}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:P.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),F.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),F.set("Command Prompt",{path:`${f}\\cmd.exe`,icon:P.Codicon.terminalCmd,isAutoDetected:!0})),s(u,F);const z=await g(F.entries(),c,r,i,y);if(t||!t&&o)try{const $=await b(`${f}\\${U?"wsl":"bash"}.exe`,c);for(const H of $)(!u||!(H.profileName in u))&&z.push(H)}catch($){i?.info("WSL is not installed, so could not detect WSL profiles")}return z}async function g(t,r,i,o,u){const c=[];for(const[l,y]of t){if(y===null)continue;let E,f,U;if("source"in y){const $=n?.get(y.source);if(!$)continue;E=$.paths,f=y.args||$.args,y.icon?U=h(y.icon):$.icon&&(U=$.icon)}else E=Array.isArray(y.path)?y.path:[y.path],f=S.isWindows||Array.isArray(y.args)?y.args:void 0,U=h(y.icon)||void 0;const F=await u?.(E)||E.slice(),z=await a(l,r,F,i,f,y.env,y.overrideName,y.isAutoDetected,o);z?(z.isAutoDetected=y.isAutoDetected,z.icon=U,z.color=y.color,c.push(z)):o?.trace("profile not validated",l,E)}return c}function h(t){return typeof t=="string"?{id:t}:t}async function C(t){n&&!t||(n=new Map,n.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),n.set("PowerShell",{profileName:"PowerShell",paths:t||await D(),icon:w.ThemeIcon.asThemeIcon(P.Codicon.terminalPowershell)}))}async function D(){const t=[];for await(const r of k.enumeratePowerShellInstallations())t.push(r.exePath);return t}async function b(t,r){const i=[],o=await new Promise((l,y)=>{A.exec("wsl.exe -l -q",{encoding:"utf16le"},(E,f)=>{if(E)return y("Problem occurred when getting wsl distros");l(f)})});if(!o)return[];const u=new RegExp(/[\r?\n]/),c=o.split(u).filter(l=>l.trim().length>0&&l!=="");for(const l of c){if(l===""||l.startsWith("docker-desktop"))continue;const y=`${l} (WSL)`,E={profileName:y,path:t,args:["-d",`${l}`],isDefault:y===r,icon:I(l)};i.push(E)}return i}function I(t){return t.includes("Ubuntu")?w.ThemeIcon.asThemeIcon(P.Codicon.terminalUbuntu):t.includes("Debian")?w.ThemeIcon.asThemeIcon(P.Codicon.terminalDebian):w.ThemeIcon.asThemeIcon(P.Codicon.terminalLinux)}async function p(t,r,i,o,u,c,l){const y=new Map;if(i){const E=(await t.readFile("/etc/shells")).toString(),f=c||E.split(`
`).filter(F=>F.trim().indexOf("#")!==0&&F.trim().length>0),U=new Map;for(const F of f){let z=v.basename(F),$=U.get(z)||0;$++,$>1&&(z=`${z} (${$})`),U.set(z,$),y.set(z,{path:F,isAutoDetected:!0})}}return s(o,y),await g(y.entries(),u,t,r,l)}function s(t,r){if(!!t)for(const[i,o]of Object.entries(t))o===null||!("path"in o)&&!("source"in o)?r.delete(i):r.set(i,o)}async function a(t,r,i,o,u,c,l,y,E){if(i.length===0)return Promise.resolve(void 0);const f=i.shift();if(f==="")return a(t,r,i,o,u,c,l,y);const U={profileName:t,path:f,args:u,env:c,overrideName:l,isAutoDetected:y,isDefault:t===r};if(v.basename(f)===f){const z=process.env.PATH?process.env.PATH.split(v.delimiter):void 0;return await L.findExecutable(f,void 0,z,void 0,o.existsFile)?U:a(t,r,i,o,u)}return await o.existsFile(v.normalize(f))?U:a(t,r,i,o,u,c,l,y)}}),define(Z[184],ee([0,1,2,15,82,49,17,36,3,77,24,183,23,182]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var h;(function(I){I[I.MaxRestarts=5]="MaxRestarts"})(h||(h={}));let C=0,D=0,b=class extends v.Disposable{constructor(p,s,a,t){super();this._reconnectConstants=p,this._configurationService=s,this._logService=a,this._telemetryService=t,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new S.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new S.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new S.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new S.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new S.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new S.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new S.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new S.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new S.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new S.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new S.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new S.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new S.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new S.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._pendingResolveVariablesRequests=new Map,g.registerTerminalPlatformConfiguration(),this._register(v.toDisposable(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const p=new A.Client(O.FileAccess.asFileUri("bootstrap-fork",K).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:C,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.GraceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.ShortGraceTime}});this._onPtyHostStart.fire(),P.ProxyChannel.toService(p.getChannel(L.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(p.onDidProcessExit(r=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(r.code),this._isDisposed||(this._restartCount<=h.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const a=p.getChannel(L.TerminalIpcChannels.Log);w.LogLevelChannelClient.setLevel(a,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{w.LogLevelChannelClient.setLevel(a,this._logService.getLevel())}));const t=P.ProxyChannel.toService(p.getChannel(L.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(r=>this._onProcessData.fire(r))),this._register(t.onProcessExit(r=>this._onProcessExit.fire(r))),this._register(t.onProcessReady(r=>this._onProcessReady.fire(r))),this._register(t.onProcessTitleChanged(r=>this._onProcessTitleChanged.fire(r))),this._register(t.onProcessShellTypeChanged(r=>this._onProcessShellTypeChanged.fire(r))),this._register(t.onProcessOverrideDimensions(r=>this._onProcessOverrideDimensions.fire(r))),this._register(t.onProcessResolvedShellLaunchConfig(r=>this._onProcessResolvedShellLaunchConfig.fire(r))),this._register(t.onProcessReplay(r=>this._onProcessReplay.fire(r))),this._register(t.onProcessOrphanQuestion(r=>this._onProcessOrphanQuestion.fire(r))),[p,t]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(p,s,a,t,r,i,o,u,c,l){const y=setTimeout(()=>this._handleUnresponsiveCreateProcess(),L.HeartbeatConstants.CreateProcessTimeout),E=await this._proxy.createProcess(p,s,a,t,r,i,o,u,c,l);return clearTimeout(y),C=Math.max(C,E),E}updateTitle(p,s,a){return this._proxy.updateTitle(p,s,a)}updateIcon(p,s,a){return this._proxy.updateIcon(p,s,a)}attachToProcess(p){return this._proxy.attachToProcess(p)}detachFromProcess(p){return this._proxy.detachFromProcess(p)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(p){return this._proxy.start(p)}shutdown(p,s){return this._proxy.shutdown(p,s)}input(p,s){return this._proxy.input(p,s)}processBinary(p,s){return this._proxy.processBinary(p,s)}resize(p,s,a){return this._proxy.resize(p,s,a)}acknowledgeDataEvent(p,s){return this._proxy.acknowledgeDataEvent(p,s)}getInitialCwd(p){return this._proxy.getInitialCwd(p)}getCwd(p){return this._proxy.getCwd(p)}getLatency(p){return this._proxy.getLatency(p)}orphanQuestionReply(p){return this._proxy.orphanQuestionReply(p)}getDefaultSystemShell(p){return this._proxy.getDefaultSystemShell(p)}async getProfiles(p,s,a=!1){return m.detectAvailableProfiles(p,s,a,this._configurationService,void 0,this._logService,this._resolveVariables.bind(this))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(p){return this._proxy.getWslPath(p)}setTerminalLayoutInfo(p){return this._proxy.setTerminalLayoutInfo(p)}async getTerminalLayoutInfo(p){return await this._proxy.getTerminalLayoutInfo(p)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier+L.HeartbeatConstants.BeatInterval*L.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${L.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(p){return new Promise(s=>{const a=++D;this._pendingResolveVariablesRequests.set(a,s),this._onPtyHostRequestResolveVariables.fire({id:a,originalText:p})})}async acceptPtyHostResolvedVariables(p,s){const a=this._pendingResolveVariablesRequests.get(p);a?(a(s),this._pendingResolveVariablesRequests.delete(p)):this._logService.warn(`Resolved variables received without matching request ${p}`)}};b=de([Y(1,d.IConfigurationService),Y(2,k.ILogService),Y(3,n.ITelemetryService)],b),e.PtyHostService=b}),define(Z[52],ee([0,1,40]),function(K,e,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function k(O,P,S,w){const n=v.setProperty(O,P,S,w)[0];return n&&(O=O.substring(0,n.offset)+n.content+O.substring(n.offset+n.length)),O}e.edit=k;function L(O,P,S){let w=S;for(;w>=0;){if(O.charAt(w)===P.charAt(P.length-1)&&P.length===1)return w+1;if(w--,P.length===2&&w>=0&&O.charAt(w)===P.charAt(0))return w+2}return 0}e.getLineStartOffset=L;function A(O,P,S){let w=S;for(;w>=0;)if(O.charAt(w)===P.charAt(P.length-1)&&P.length===1||(w++,P.length===2&&w>=0&&O.charAt(w)===P.charAt(1)))return w;return O.length-1}e.getLineEndOffset=A}),define(Z[185],ee([0,1,26,57]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(m,d,g,h,C){const D=[],b=[],I=[];if(!d){const U=m.filter(({identifier:F})=>C.every(z=>z.toLowerCase()!==F.id.toLowerCase()));return{local:{added:D,removed:b,updated:I},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}m=m.map(w),d=d.map(w),g=g?g.map(w):null;const p=new Map,s=U=>{U.uuid&&p.set(U.id.toLowerCase(),U.uuid)};m.forEach(({identifier:U})=>s(U)),d.forEach(({identifier:U})=>s(U)),g&&g.forEach(({identifier:U})=>s(U));const a=U=>{const F=U.identifier.uuid||p.get(U.identifier.id.toLowerCase());return F?`uuid:${F}`:`id:${U.identifier.id.toLowerCase()}`},t=(U,F)=>(U.set(a(F),F),U),r=m.reduce(t,new Map),i=d.reduce(t,new Map),o=d.reduce((U,F)=>{const z=a(F);F=v.deepClone(F);const $=r.get(z);return $&&($.installed&&(F.installed=!0),F.version||(F.version=$.version)),t(U,F)},new Map),u=g?g.reduce(t,new Map):null,c=h.reduce(t,new Map),l=C.reduce((U,F)=>{const z=p.get(F.toLowerCase());return U.add(z?`uuid:${z}`:`id:${F.toLowerCase()}`)},new Set),y=A(r,i,l);if(y.added.size>0||y.removed.size>0||y.updated.size>0){const U=A(u,r,l),F=A(u,i,l),z=($,H)=>{const V=r.get($);if(V){const _=i.get($);return{...H?_:V,version:(_.version&&k.gt(_.version,V.version),V.version),state:O(V,_,u?.get($))}}};for(const $ of F.removed.values()){const H=r.get($);H&&b.push(H.identifier)}for(const $ of F.added.values())if(U.added.has($)){if(y.updated.has($)){const H=z($,!0);H&&(I.push(n(H,$)),o.set($,H))}}else{const H=i.get($);H.installed&&D.push(n(H,$))}for(const $ of F.updated.values()){const H=z($,!0);H&&(I.push(n(H,$)),o.set($,H))}for(const $ of U.added.values())F.added.has($)||o.set($,r.get($));for(const $ of U.updated.values())if(!F.removed.has($)&&!F.updated.has($)){const H=z($,!1);H&&(o.get($)?.installed&&(H.installed=!0),o.set($,H))}for(const $ of U.removed.values())!c.has($)&&!F.updated.has($)&&u?.get($)?.installed&&o.delete($)}const E=[],f=A(i,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(f.added.size>0||f.updated.size>0||f.removed.size>0)&&o.forEach((U,F)=>E.push(n(U,F))),{local:{added:D,removed:b,updated:I},remote:E.length?{added:[...f.added].map(U=>o.get(U)),updated:[...f.updated].map(U=>o.get(U)),removed:[...f.removed].map(U=>i.get(U)),all:E}:null}}e.merge=L;function A(m,d,g,{checkInstalledProperty:h,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const D=m?[...m.keys()].filter(a=>!g.has(a)):[],b=[...d.keys()].filter(a=>!g.has(a)),I=b.filter(a=>D.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),p=D.filter(a=>b.indexOf(a)===-1).reduce((a,t)=>(a.add(t),a),new Set),s=new Set;for(const a of D){if(p.has(a))continue;const t=m.get(a),r=d.get(a);(!r||t.disabled!==r.disabled||!S(t.state,r.state)||C&&t.version!==r.version||h&&t.installed!==r.installed)&&s.add(a)}return{added:I,removed:p,updated:s}}function O(m,d,g){const h=m.state,C=d.state,D=g?.state;if(!d.version||h&&k.gt(m.version,d.version))return h;if(C&&k.gt(d.version,m.version)||!h)return C;if(!C)return h;const b=v.deepClone(h),I=D?P(D,C):{added:Object.keys(C).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set},p=D?P(D,h):{added:Object.keys(h).reduce((s,a)=>(s.add(a),s),new Set),removed:new Set,updated:new Set};for(const s of[...I.added.values(),...I.updated.values()])b[s]=C[s];for(const s of I.removed.values())p.updated.has(s)||delete b[s];return b}function P(m,d){const g=Object.keys(m),h=Object.keys(d),C=h.filter(I=>g.indexOf(I)===-1).reduce((I,p)=>(I.add(p),I),new Set),D=g.filter(I=>h.indexOf(I)===-1).reduce((I,p)=>(I.add(p),I),new Set),b=new Set;for(const I of g){if(D.has(I))continue;const p=m[I],s=d[I];v.equals(p,s)||b.add(I)}return{added:C,removed:D,updated:b}}function S(m={},d={}){const{added:g,removed:h,updated:C}=P(m,d);return g.size===0&&h.size===0&&C.size===0}function w(m){return{...m,disabled:!!m.disabled,installed:!!m.installed}}function n(m,d){const g={identifier:{id:m.identifier.id,uuid:d.startsWith("uuid:")?d.substring("uuid:".length):void 0}};return m.version&&(g.version=m.version),m.disabled&&(g.disabled=!0),m.installed&&(g.installed=!0),m.state&&(g.state=m.state),g}}),define(Z[84],ee([0,1,19,3,2,33,4,27,21]),function(K,e,v,k,L,A,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=O.createDecorator("IExtensionsStorageSyncService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class Ze extends L.Disposable{constructor(d,g){super();this.storageService=d,this.productService=g,this._onDidChangeExtensionsStorage=this._register(new k.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(h=>this.onDidChangeStorageValue(h)))}static toKey(d){return`extensionKeys/${A.adoptToGalleryExtensionId(d.id)}@${d.version}`}static fromKey(d){const g=w.exec(d);if(g&&g[1])return{id:g[1],version:g[2]}}initialize(){const d=this.storageService.keys(0,1);for(const g of d){const h=Ze.fromKey(g);h&&this.extensionsWithKeysForSync.add(h.id.toLowerCase())}}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const g=Ze.fromKey(d.key);if(g){this.extensionsWithKeysForSync.add(g.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}setKeysForSync(d,g){this.storageService.store(Ze.toKey(d),JSON.stringify(g),0,1)}getKeysForSync(d){const g=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],h=this.storageService.get(Ze.toKey(d),0),C=h?JSON.parse(h):void 0;return C&&g?v.distinct([...C,...g]):C||g}};n=de([Y(0,S.IStorageService),Y(1,P.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(Z[85],ee([0,1,19,23,4]),function(K,e,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=L.createDecorator("IIgnoredExtensionsManagementService");let A=class{constructor(P){this.configurationService=P}hasToNeverSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.getConfiguredIgnoredExtensions().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,S){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return w=w.filter(n=>n!==P&&n!==`-${P}`),S&&w.push(P.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,1)}updateSynchronizedExtensions(P,S){let w=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return w=w.filter(n=>n!==P&&n!==`-${P}`),S&&w.push(`-${P.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",w.length?w:void 0,1)}getIgnoredExtensions(P){const S=P.filter(d=>d.isMachineScoped).map(d=>d.identifier.id.toLowerCase()),w=this.getConfiguredIgnoredExtensions().map(d=>d.toLowerCase()),n=[],m=[];if(Array.isArray(w))for(const d of w)d.startsWith("-")?m.push(d.substring(1)):n.push(d);return v.distinct([...S,...n].filter(d=>m.indexOf(d)===-1))}getConfiguredIgnoredExtensions(){let P=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.configurationService.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};A=de([Y(0,k.IConfigurationService)],A),e.IgnoredExtensionsManagementService=A}),define(Z[186],ee([0,1,26,32,19,143,52]),function(K,e,v,k,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function P(s){return k.parse(s)||[]}e.parseKeybindings=P;async function S(s,a,t,r,i){const o=P(s),u=P(a),c=t?P(t):null,l=[...o,...u,...c||[]].map(x=>x.key),y=await i.resolveUserBindings(l);let E=n(o,u,c,y);if(!E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:s,hasChanges:!1,hasConflicts:!1};if(!E.hasLocalForwarded&&E.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};if(E.hasLocalForwarded&&!E.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};const f=d(o),U=d(u),F=c?d(c):null,z=h(f,U,y),$=F?h(F,f,y):{added:[...f.keys()].reduce((x,j)=>(x.add(j),x),new Set),removed:new Set,updated:new Set},H=F?h(F,U,y):{added:[...U.keys()].reduce((x,j)=>(x.add(j),x),new Set),removed:new Set,updated:new Set},V=w(z,$,H);let _=s;for(const x of V.removed.values())V.conflicts.has(x)||(_=I(_,x,r));for(const x of V.added.values()){if(V.conflicts.has(x))continue;const j=U.get(x);if(j.some(q=>q.command!==`-${x}`&&E.conflicts.has(y[q.key]))){V.conflicts.add(x);continue}_=b(_,j,r)}for(const x of V.updated.values()){if(V.conflicts.has(x))continue;const j=U.get(x);if(j.some(q=>q.command!==`-${x}`&&E.conflicts.has(y[q.key]))){V.conflicts.add(x);continue}_=p(_,x,j,r)}return{mergeContent:_,hasChanges:!0,hasConflicts:V.conflicts.size>0}}e.merge=S;function w(s,a,t){const r=new Set,i=new Set,o=new Set,u=new Set;for(const c of a.removed.values())t.updated.has(c)&&u.add(c);for(const c of t.removed.values())u.has(c)||(a.updated.has(c)?u.add(c):i.add(c));for(const c of a.added.values())u.has(c)||t.added.has(c)&&s.updated.has(c)&&u.add(c);for(const c of t.added.values())u.has(c)||(a.added.has(c)?s.updated.has(c)&&u.add(c):r.add(c));for(const c of a.updated.values())u.has(c)||t.updated.has(c)&&s.updated.has(c)&&u.add(c);for(const c of t.updated.values())u.has(c)||(a.updated.has(c)?s.updated.has(c)&&u.add(c):o.add(c));return{added:r,removed:i,updated:o,conflicts:u}}function n(s,a,t,r){const i=new Set,o=m(s,r),u=m(a,r),c=t?m(t,r):null,l=g(o,u);if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const y=c?g(c,o):{added:[...o.keys()].reduce(($,H)=>($.add(H),$),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:i,removed:i,updated:i,conflicts:i};const E=c?g(c,u):{added:[...u.keys()].reduce(($,H)=>($.add(H),$),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:i,removed:i,updated:i,conflicts:i};const{added:f,removed:U,updated:F,conflicts:z}=w(l,y,E);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:f,removed:U,updated:F,conflicts:z}}function m(s,a){const t=new Map;for(const r of s){const i=a[r.key];let o=t.get(i);o||(o=[],t.set(i,o)),o.push(r)}return t}function d(s){const a=new Map;for(const t of s){const r=t.command[0]==="-"?t.command.substring(1):t.command;let i=a.get(r);i||(i=[],a.set(r,i)),i.push(t)}return a}function g(s,a){const t=[...s.keys()],r=[...a.keys()],i=r.filter(c=>t.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),o=t.filter(c=>r.indexOf(c)===-1).reduce((c,l)=>(c.add(l),c),new Set),u=new Set;for(const c of t){if(o.has(c))continue;const l=s.get(c).map(E=>({...E,key:c})),y=a.get(c).map(E=>({...E,key:c}));L.equals(l,y,(E,f)=>D(E,f))||u.add(c)}return{added:i,removed:o,updated:u}}function h(s,a,t){const r=[...s.keys()],i=[...a.keys()],o=i.filter(l=>r.indexOf(l)===-1).reduce((l,y)=>(l.add(y),l),new Set),u=r.filter(l=>i.indexOf(l)===-1).reduce((l,y)=>(l.add(y),l),new Set),c=new Set;for(const l of r){if(u.has(l))continue;const y=s.get(l).map(f=>({...f,key:t[f.key]})),E=a.get(l).map(f=>({...f,key:t[f.key]}));C(y,E)||c.add(l)}return{added:o,removed:u,updated:c}}function C(s,a){return!(!L.equals(s.filter(({command:t})=>t[0]!=="-"),a.filter(({command:t})=>t[0]!=="-"),(t,r)=>D(t,r))||!L.equals(s.filter(({command:t})=>t[0]==="-"),a.filter(({command:t})=>t[0]==="-"),(t,r)=>D(t,r)))}function D(s,a){if(s.command!==a.command||s.key!==a.key)return!1;const t=A.ContextKeyExpr.deserialize(s.when),r=A.ContextKeyExpr.deserialize(a.when);return!(t&&!r||!t&&r||t&&r&&!t.equals(r)||!v.equals(s.args,a.args))}function b(s,a,t){for(const r of a)s=O.edit(s,[-1],r,t);return s}function I(s,a,t){const r=P(s);for(let i=r.length-1;i>=0;i--)(r[i].command===a||r[i].command===`-${a}`)&&(s=O.edit(s,[i],void 0,t));return s}function p(s,a,t,r){const i=P(s),o=i.findIndex(u=>u.command===a||u.command===`-${a}`);for(let u=i.length-1;u>=0;u--)(i[u].command===a||i[u].command===`-${a}`)&&(s=O.edit(s,[u],void 0,r));for(let u=t.length-1;u>=0;u--)s=O.edit(s,[o],t[u],r);return s}}),define(Z[187],ee([0,1]),function(K,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function v(A,O,P){const S={},w={},n=new Set;if(!O)return{local:{added:S,updated:w,removed:[...n.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const m=k(A,O);if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{local:{added:S,updated:w,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const d=k(P,A),g=k(P,O),h={},C={},D=new Set,b=new Set;for(const I of d.removed.values())g.updated.has(I)?S[I]=O[I]:D.add(I);for(const I of g.removed.values())b.has(I)||(d.updated.has(I)?b.add(I):n.add(I));for(const I of d.updated.values())b.has(I)||(g.updated.has(I)?m.updated.has(I)&&b.add(I):C[I]=A[I]);for(const I of g.updated.values())b.has(I)||(d.updated.has(I)?m.updated.has(I)&&b.add(I):A[I]!==void 0&&(w[I]=O[I]));for(const I of d.added.values())b.has(I)||(g.added.has(I)?m.updated.has(I)&&b.add(I):h[I]=A[I]);for(const I of g.added.values())b.has(I)||(d.added.has(I)?m.updated.has(I)&&b.add(I):S[I]=O[I]);return{local:{added:S,removed:[...n.values()],updated:w},remote:{added:h,removed:[...D.values()],updated:C},conflicts:[...b.values()]}}e.merge=v;function k(A,O){const P=A?Object.keys(A):[],S=O?Object.keys(O):[],w=S.filter(d=>P.indexOf(d)===-1).reduce((d,g)=>(d.add(g),d),new Set),n=P.filter(d=>S.indexOf(d)===-1).reduce((d,g)=>(d.add(g),d),new Set),m=new Set;for(const d of P){if(n.has(d))continue;const g=A[d],h=O[d];g!==h&&m.add(d)}return{added:w,removed:n,updated:m}}function L(A,O){const{added:P,removed:S,updated:w}=k(A,O);return P.size===0&&S.size===0&&w.size===0}e.areSame=L}),define(Z[22],ee([0,1,4,28,31,37,127,79,14,19,16]),function(K,e,v,k,L,A,O,P,S,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function m(){const c=L.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(l=>!!c[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=m;function d(){const c=L.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(c).filter(f=>!!c[f].ignoreSync),y=Object.keys(c).filter(f=>c[f].scope===2||c[f].scope===6),E=m();return w.distinct([e.CONFIGURATION_SYNC_STORE_KEY,...l,...y,...E])}e.getDefaultIgnoredSettings=d;function g(){const c="vscode://schemas/ignoredSettings",l=L.Registry.as(A.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:O.localize(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:O.localize(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:O.localize(2,null),items:[{type:"string",pattern:k.EXTENSION_IDENTIFIER_PATTERN,errorMessage:O.localize(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:O.localize(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const y=L.Registry.as(P.Extensions.JSONContribution),E=()=>{const f=m(),U=d().filter(H=>H!==e.CONFIGURATION_SYNC_STORE_KEY),F=Object.keys(A.allSettings.properties).filter(H=>U.indexOf(H)===-1),z=U.filter(H=>f.indexOf(H)===-1),$={items:{type:"string",enum:[...F,...z.map(H=>`-${H}`)]}};y.registerSchema(c,$)};return l.onDidUpdateConfiguration(()=>E())}e.registerConfiguration=g;function h(c){return c&&n.isObject(c)&&n.isString(c.id)&&n.isArray(c.scopes)}e.isAuthenticationProvider=h;var C;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Extensions="extensions",c.GlobalState="globalState"})(C=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"];function D(c,l,y){return y.joinPath(l.userDataSyncHome,c,`lastSync${c}.json`)}e.getLastSyncResourceUri=D,e.IUserDataSyncStoreManagementService=v.createDecorator("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=v.createDecorator("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=v.createDecorator("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function b(c){const l={};return l[e.HEADER_EXECUTION_ID]=c,l}e.createSyncHeaders=b;var I;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.NoRef="NoRef",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(I=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class p extends Error{constructor(l,y,E,f){super(l);this.code=y,this.resource=E,this.operationId=f,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=p;class s extends p{constructor(l,y,E,f){super(l,E,void 0,f);this.url=y}}e.UserDataSyncStoreError=s;class a extends p{constructor(l,y){super(l,y)}}e.UserDataAutoSyncError=a,function(c){function l(y){if(y instanceof c)return y;const E=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(y.name);if(E&&E[1]){const f=E[2]==="unknown"?void 0:E[2],U=E[3]==="unknown"?void 0:E[3];return new c(y.message,E[1],f,U)}return new c(y.message,I.Unknown)}c.toUserDataSyncError=l}(p=e.UserDataSyncError||(e.UserDataSyncError={}));var t;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(t=e.SyncStatus||(e.SyncStatus={}));var r;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var i;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function o(c){return`sync.enable.${c}`}e.getEnablementKey=o,e.IUserDataSyncResourceEnablementService=v.createDecorator("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=v.createDecorator("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=v.createDecorator("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=v.createDecorator("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=v.createDecorator("IUserDataSyncUtilService"),e.IUserDataSyncLogService=v.createDecorator("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function u(c,l){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(y=>S.isEqualOrParent(c,S.joinPath(l.userDataSyncHome,y,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=u}),define(Z[45],ee([0,1,2,10,25,5,22,9,14,6,3,24,32,123,23,16,20,19,44,21,29]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h,C,D,b,I,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function a(u){return!!(u&&u.version!==void 0&&typeof u.version=="number"&&u.content!==void 0&&typeof u.content=="string"&&(Object.keys(u).length===2||Object.keys(u).length===3&&u.machineId!==void 0&&typeof u.machineId=="string"))}e.isSyncData=a;let t=class extends v.Disposable{constructor(c,l,y,E,f,U,F,z,$,H){super();this.resource=c,this.fileService=l,this.environmentService=y,this.userDataSyncStoreService=f,this.userDataSyncBackupStoreService=U,this.userDataSyncResourceEnablementService=F,this.telemetryService=z,this.logService=$,this.configurationService=H,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new n.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new n.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new w.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new n.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=D.uppercaseFirstLetter(this.resource),this.extUri=this.fileService.hasCapability(y.userDataSyncHome,1024)?S.extUri:S.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(y.userDataSyncHome,c),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,O.PREVIEW_DIR_NAME),this.lastSyncResource=O.getLastSyncResourceUri(c,y,this.extUri),this.currentMachineIdPromise=I.getServiceMachineId(y,l,E)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const c=await this.syncPreviewPromise;this.syncPreviewPromise=null;const l=await this.performSync(c.remoteUserData,c.lastSyncUserData,!0);this.setStatus(l)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const c=await this.getLastSyncUserData();(c?(await this.doGenerateSyncResourcePreview(c,c,!0,s.CancellationToken.None)).resourcePreviews.some(({remoteChange:y})=>y!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(c){if(this._status!==c){const l=this._status;c==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),l==="hasConflicts"&&c==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=c,this._onDidChangStatus.fire(c)}}async sync(c,l={}){await this._sync(c,!0,l)}async preview(c,l={}){return this._sync(c,!1,l)}async apply(c,l={}){try{this.syncHeaders={...l};const y=await this.doApply(c);return this.setStatus(y),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(c,l,y){try{if(this.syncHeaders={...y},!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let E="idle";try{const f=await this.getLastSyncUserData(),U=await this.getLatestRemoteUserData(c,f);return E=await this.performSync(U,f,l),E==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):E==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(E)}}finally{this.syncHeaders={}}}async replace(c){const l=await this.resolveContent(c);if(!l)return!1;const y=this.parseSyncData(l);if(!y)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const E=await this.getLastSyncUserData(),f=await this.getLatestRemoteUserData(null,E),U=await this.isRemoteDataFromCurrentMachine(f),F=await this.generateSyncPreview({ref:f.ref,syncData:y},E,U,s.CancellationToken.None),z=[];for(const $ of F){const H=await this.getAcceptResult($,$.remoteResource,void 0,s.CancellationToken.None),{remoteChange:V}=await this.getAcceptResult($,$.previewResource,$.remoteContent,s.CancellationToken.None);z.push([$,{...H,remoteChange:V!==0?V:2}])}await this.applyResult(f,E,z,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(c){const l=await this.currentMachineIdPromise;return!!c.syncData?.machineId&&c.syncData.machineId===l}async getLatestRemoteUserData(c,l){if(l){const y=c&&c.latest?c.latest[this.resource]:void 0;if(l.ref===y||y===void 0&&l.syncData===null)return l}return this.getRemoteUserData(l)}async performSync(c,l,y){if(c.syncData&&c.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new O.UserDataSyncError(g.localize(0,null,this.resource,this.version,c.syncData.version),O.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(c,l,y)}catch(E){if(E instanceof O.UserDataSyncError)switch(E.code){case O.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(c,l,y);case O.UserDataSyncErrorCode.Conflict:case O.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),c=await this.getRemoteUserData(null),l=await this.getLastSyncUserData(),this.performSync(c,l,y)}throw E}}async doSync(c,l,y){try{this.syncPreviewPromise||(this.syncPreviewPromise=w.createCancelablePromise(f=>this.doGenerateSyncResourcePreview(c,l,y,f)));const E=await this.syncPreviewPromise;return this.updateConflicts(E.resourcePreviews),E.resourcePreviews.some(({mergeState:f})=>f==="conflict")?"hasConflicts":y?await this.doApply(!1):"syncing"}catch(E){throw this.syncPreviewPromise=null,E}}async merge(c){return await this.updateSyncResourcePreview(c,async l=>{const y=await this.getMergeResult(l,s.CancellationToken.None);await this.fileService.writeFile(l.previewResource,L.VSBuffer.fromString(y?.content||""));const E=y&&!y.hasConflicts?await this.getAcceptResult(l,l.previewResource,void 0,s.CancellationToken.None):void 0;return l.acceptResult=E,l.mergeState=y.hasConflicts?"conflict":E?"accepted":"preview",l.localChange=E?E.localChange:y.localChange,l.remoteChange=E?E.remoteChange:y.remoteChange,l}),this.syncPreviewPromise}async accept(c,l){return await this.updateSyncResourcePreview(c,async y=>{const E=await this.getAcceptResult(y,c,l,s.CancellationToken.None);return y.acceptResult=E,y.mergeState="accepted",y.localChange=E.localChange,y.remoteChange=E.remoteChange,y}),this.syncPreviewPromise}async discard(c){return await this.updateSyncResourcePreview(c,async l=>{const y=await this.getMergeResult(l,s.CancellationToken.None);return await this.fileService.writeFile(l.previewResource,L.VSBuffer.fromString(y.content||"")),l.acceptResult=void 0,l.mergeState="preview",l.localChange=y.localChange,l.remoteChange=y.remoteChange,l}),this.syncPreviewPromise}async updateSyncResourcePreview(c,l){if(!this.syncPreviewPromise)return;let y=await this.syncPreviewPromise;const E=y.resourcePreviews.findIndex(({localResource:f,remoteResource:U,previewResource:F})=>this.extUri.isEqual(f,c)||this.extUri.isEqual(U,c)||this.extUri.isEqual(F,c));E!==-1&&(this.syncPreviewPromise=w.createCancelablePromise(async f=>{const U=[...y.resourcePreviews];return U[E]=await l(U[E]),{...y,resourcePreviews:U}}),y=await this.syncPreviewPromise,this.updateConflicts(y.resourcePreviews),y.resourcePreviews.some(({mergeState:f})=>f==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(c){if(!this.syncPreviewPromise)return"idle";const l=await this.syncPreviewPromise;return l.resourcePreviews.some(({mergeState:y})=>y==="conflict")?"hasConflicts":l.resourcePreviews.some(({mergeState:y})=>y!=="accepted")?"syncing":(await this.applyResult(l.remoteUserData,l.lastSyncUserData,l.resourcePreviews.map(y=>[y,y.acceptResult]),c),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(c){}}updateConflicts(c){const l=c.filter(({mergeState:y})=>y==="conflict");b.equals(this._conflicts,l,(y,E)=>this.extUri.isEqual(y.previewResource,E.previewResource))||(this._conflicts=l,this._onDidChangeConflicts.fire(l))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:l,ref:y})=>({created:l,uri:this.toRemoteBackupResource(y)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:l,ref:y})=>({created:l,uri:this.toLocalBackupResource(y)}))}toRemoteBackupResource(c){return A.URI.from({scheme:O.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${c}`})}toLocalBackupResource(c){return A.URI.from({scheme:O.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${c}`})}async getMachineId({uri:c}){const l=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(l))){const{content:y}=await this.getUserData(l);if(y)return this.parseSyncData(y)?.machineId}}async resolveContent(c){const l=this.extUri.basename(c);if(this.extUri.isEqual(c,this.toRemoteBackupResource(l))){const{content:y}=await this.getUserData(l);return y}return this.extUri.isEqual(c,this.toLocalBackupResource(l))?this.userDataSyncBackupStoreService.resolveContent(this.resource,l):null}async resolvePreviewContent(c){const l=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(l)for(const y of l.resourcePreviews){if(this.extUri.isEqual(y.acceptedResource,c))return y.acceptResult?y.acceptResult.content:null;if(this.extUri.isEqual(y.remoteResource,c))return y.remoteContent;if(this.extUri.isEqual(y.localResource,c))return y.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(c){}}async doGenerateSyncResourcePreview(c,l,y,E){const f=await this.isRemoteDataFromCurrentMachine(c),U=await this.generateSyncPreview(c,l,f,E),F=[];for(const z of U){const $=z.previewResource.with({scheme:O.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(z.localChange===0&&z.remoteChange===0)F.push({...z,acceptedResource:$,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const H=y?await this.getMergeResult(z,E):void 0;if(E.isCancellationRequested)break;await this.fileService.writeFile(z.previewResource,L.VSBuffer.fromString(H?.content||""));const V=H&&!H.hasConflicts?await this.getAcceptResult(z,z.previewResource,void 0,E):void 0;F.push({...z,acceptResult:V,mergeState:H?.hasConflicts?"conflict":V?"accepted":"preview",localChange:V?V.localChange:H?H.localChange:z.localChange,remoteChange:V?V.remoteChange:H?H.remoteChange:z.remoteChange})}}return{remoteUserData:c,lastSyncUserData:l,resourcePreviews:F,isLastSyncFromCurrentMachine:f}}async getLastSyncUserData(){try{const c=await this.fileService.readFile(this.lastSyncResource),l=JSON.parse(c.value.toString()),y=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=l.version&&y&&l.version!==y,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${l.version} is not compatible with current sync state version ${y}.`),await this.resetLocal(),null;const E=l;if(E.content===null)return{ref:l.ref,syncData:null};const f=JSON.parse(E.content);if(a(f))return{...l,syncData:f,content:void 0}}catch(c){c instanceof k.FileOperationError&&c.fileOperationResult===1||this.logService.error(c)}return null}async updateLastSyncUserData(c,l={}){if(l.ref||l.content||l.version)throw new Error("Cannot have core properties as additional");const y=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),E={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,version:y,...l};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(E)))}async getRemoteUserData(c){const{ref:l,content:y}=await this.getUserData(c);let E=null;return y!==null&&(E=this.parseSyncData(y)),{ref:l,syncData:E}}parseSyncData(c){try{const l=JSON.parse(c);if(a(l))return l}catch(l){this.logService.error(l)}throw new O.UserDataSyncError(g.localize(1,null),O.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(c){if(C.isString(c)){const l=await this.userDataSyncStoreService.resolveContent(this.resource,c);return{ref:c,content:l}}else{const l=c?{ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,l,this.syncHeaders)}}async updateRemoteUserData(c,l){const y=await this.currentMachineIdPromise,E={version:this.version,machineId:y,content:c};return l=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(E),l,this.syncHeaders),{ref:l,syncData:E}}async backupLocal(c){const l={version:this.version,content:c};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(l))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};t=de([Y(1,k.IFileService),Y(2,P.IEnvironmentService),Y(3,p.IStorageService),Y(4,O.IUserDataSyncStoreService),Y(5,O.IUserDataSyncBackupStoreService),Y(6,O.IUserDataSyncResourceEnablementService),Y(7,m.ITelemetryService),Y(8,O.IUserDataSyncLogService),Y(9,h.IConfigurationService)],t),e.AbstractSynchroniser=t;let r=class extends t{constructor(c,l,y,E,f,U,F,z,$,H,V){super(l,y,E,f,U,F,z,$,H,V);this.file=c,this._register(this.fileService.watch(this.extUri.dirname(c))),this._register(this.fileService.onDidFilesChange(_=>this.onFileChanges(_)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(c){return null}}async updateLocalFileContent(c,l,y){try{l?await this.fileService.writeFile(this.file,L.VSBuffer.fromString(c),y?void 0:l):await this.fileService.createFile(this.file,L.VSBuffer.fromString(c),{overwrite:y})}catch(E){throw E instanceof k.FileOperationError&&E.fileOperationResult===1||E instanceof k.FileOperationError&&E.fileOperationResult===3?new O.UserDataSyncError(E.message,O.UserDataSyncErrorCode.LocalPreconditionFailed):E}}onFileChanges(c){!c.contains(this.file)||this.triggerLocalChange()}};r=de([Y(2,k.IFileService),Y(3,P.IEnvironmentService),Y(4,p.IStorageService),Y(5,O.IUserDataSyncStoreService),Y(6,O.IUserDataSyncBackupStoreService),Y(7,O.IUserDataSyncResourceEnablementService),Y(8,m.ITelemetryService),Y(9,O.IUserDataSyncLogService),Y(10,h.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let i=class extends r{constructor(c,l,y,E,f,U,F,z,$,H,V,_){super(c,l,y,E,f,U,F,z,$,H,_);this.userDataSyncUtilService=V,this._formattingOptions=void 0}hasErrors(c){const l=[];return d.parse(c,l,{allowEmptyContent:!0,allowTrailingComma:!0}),l.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};i=de([Y(2,k.IFileService),Y(3,P.IEnvironmentService),Y(4,p.IStorageService),Y(5,O.IUserDataSyncStoreService),Y(6,O.IUserDataSyncBackupStoreService),Y(7,O.IUserDataSyncResourceEnablementService),Y(8,m.ITelemetryService),Y(9,O.IUserDataSyncLogService),Y(10,O.IUserDataSyncUtilService),Y(11,h.IConfigurationService)],i),e.AbstractJsonFileSynchroniser=i;let o=class{constructor(c,l,y,E){this.resource=c,this.environmentService=l,this.logService=y,this.fileService=E,this.extUri=this.fileService.hasCapability(l.userDataSyncHome,1024)?S.extUri:S.extUriIgnorePathCase,this.lastSyncResource=O.getLastSyncResourceUri(this.resource,l,S.extUri)}async initialize({ref:c,content:l}){if(!l){this.logService.info("Remote content does not exist.",this.resource);return}const y=this.parseSyncData(l);if(!y)return;if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:c,syncData:y})}catch(f){this.logService.error(f)}}parseSyncData(c){try{const l=JSON.parse(c);if(a(l))return l}catch(l){this.logService.error(l)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(c,l={}){const y={ref:c.ref,content:c.syncData?JSON.stringify(c.syncData):null,...l};await this.fileService.writeFile(this.lastSyncResource,L.VSBuffer.fromString(JSON.stringify(y)))}};o=de([Y(1,P.IEnvironmentService),Y(2,O.IUserDataSyncLogService),Y(3,k.IFileService)],o),e.AbstractInitializer=o}),define(Z[188],ee([0,1,22,3,9,28,33,10,23,185,45,24,5,46,40,20,21,85,11,84,6]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h,C,D,b,I,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function a(u,c){const l=JSON.parse(u.content);if(u.version===1||u.version===2){const y=(await c.getInstalled(0)).filter(E=>E.isBuiltin);for(const E of l)u.version===1&&(E.enabled===!1&&(E.disabled=!0),delete E.enabled),u.version===2&&y.every(f=>!O.areSameExtensions(f.identifier,E.identifier))&&(E.installed=!0)}return l}function t(u,c,l){const y=l.get(O.getExtensionId(u,c),0)||"{}";return JSON.parse(y)}e.getExtensionStorageState=t;function r(u,c,l,y){y.store(O.getExtensionId(u,c),JSON.stringify(l),0,1)}e.storeExtensionStorageState=r;let i=class at extends n.AbstractSynchroniser{constructor(c,l,y,E,f,U,F,z,$,H,V,_,x,j){super("extensions",l,c,y,E,f,_,x,$,V);this.storageService=y,this.extensionManagementService=U,this.extensionEnablementService=F,this.ignoredExtensionsManagementService=z,this.extensionGalleryService=H,this.extensionsStorageSyncService=j,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.debounce(k.Event.any(k.Event.filter(this.extensionManagementService.onDidInstallExtension,q=>!!q.gallery),k.Event.filter(this.extensionManagementService.onDidUninstallExtension,q=>!q.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(c,l){const y=c.syncData?await a(c.syncData,this.extensionManagementService):null,E=l?.skippedExtensions||[],f=l?.syncData?await a(l.syncData,this.extensionManagementService):null,U=await this.extensionManagementService.getInstalled(),F=this.getLocalExtensions(U),z=this.ignoredExtensionsManagementService.getIgnoredExtensions(U);y?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:$,remote:H}=w.merge(F,y,f,E,z),V={local:$,remote:H,content:this.getPreviewContent(F,$.added,$.updated,$.removed),localChange:$.added.length>0||$.removed.length>0||$.updated.length>0?2:0,remoteChange:H!==null?2:0};return[{skippedExtensions:E,localResource:this.localResource,localContent:this.format(F),localExtensions:F,remoteResource:this.remoteResource,remoteContent:y?this.format(y):null,previewResource:this.previewResource,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(c,l,y,E){const f=[...l,...y],U=new Set,F=z=>{U.add(z.id.toLowerCase()),z.uuid&&U.add(z.uuid)};f.forEach(({identifier:z})=>F(z)),E.forEach(F);for(const z of c)U.has(z.identifier.id.toLowerCase())||z.identifier.uuid&&U.has(z.identifier.uuid)||f.push(z);return this.format(f)}async getMergeResult(c,l){return{...c.previewResult,hasConflicts:!1}}async getAcceptResult(c,l,y,E){if(this.extUri.isEqual(l,this.localResource))return this.acceptLocal(c);if(this.extUri.isEqual(l,this.remoteResource))return this.acceptRemote(c);if(this.extUri.isEqual(l,this.previewResource))return c.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async acceptLocal(c){const l=await this.extensionManagementService.getInstalled(),y=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),E=w.merge(c.localExtensions,null,null,c.skippedExtensions,y),{local:f,remote:U}=E;return{content:c.localContent,local:f,remote:U,localChange:f.added.length>0||f.removed.length>0||f.updated.length>0?2:0,remoteChange:U!==null?2:0}}async acceptRemote(c){const l=await this.extensionManagementService.getInstalled(),y=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),E=c.remoteContent?JSON.parse(c.remoteContent):null;if(E!==null){const f=w.merge(c.localExtensions,E,c.localExtensions,[],y),{local:U,remote:F}=f;return{content:c.remoteContent,local:U,remote:F,localChange:U.added.length>0||U.removed.length>0||U.updated.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:c.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(c,l,y,E){let{skippedExtensions:f,localExtensions:U}=y[0][0],{local:F,remote:z,localChange:$,remoteChange:H}=y[0][1];if($===0&&H===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),$!==0&&(await this.backupLocal(JSON.stringify(U)),f=await this.updateLocalExtensions(F.added,F.removed,F.updated,f)),z){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const V=JSON.stringify(z.all);c=await this.updateRemoteUserData(V,E?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(_=>_.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(_=>_.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(_=>_.identifier.id))}.`:""}`)}l?.ref!==c.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(c,{skippedExtensions:f}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${f.length?` Skipped: ${JSON.stringify(f.map(V=>V.identifier.id))}.`:""}`))}async getAssociatedResources({uri:c}){return[{resource:this.extUri.joinPath(c,"extensions.json"),comparableResource:at.EXTENSIONS_DATA_URI}]}async resolveContent(c){if(this.extUri.isEqual(c,at.EXTENSIONS_DATA_URI)){const y=await this.extensionManagementService.getInstalled(),E=this.ignoredExtensionsManagementService.getIgnoredExtensions(y),f=this.getLocalExtensions(y).filter(U=>!E.some(F=>O.areSameExtensions({id:F},U.identifier)));return this.format(f)}if(this.extUri.isEqual(this.remoteResource,c)||this.extUri.isEqual(this.localResource,c)||this.extUri.isEqual(this.acceptedResource,c))return this.resolvePreviewContent(c);let l=await super.resolveContent(c);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(c)),l){const y=this.parseSyncData(l);if(y)switch(this.extUri.basename(c)){case"extensions.json":return this.format(this.parseExtensions(y))}}return null}format(c){c.sort((E,f)=>!E.identifier.uuid&&f.identifier.uuid?-1:E.identifier.uuid&&!f.identifier.uuid?1:C.compare(E.identifier.id,f.identifier.id));const l=JSON.stringify(c),y=g.format(l,void 0,{});return h.applyEdits(l,y)}async hasLocalData(){try{const c=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(c).some(y=>y.installed||y.disabled))return!0}catch(c){}return!1}async updateLocalExtensions(c,l,y,E){const f=[],U=[],F=await this.extensionManagementService.getInstalled();if(l.length){const $=F.filter(({identifier:H,isBuiltin:V})=>!V&&l.some(_=>O.areSameExtensions(H,_)));await s.Promises.settled($.map(async H=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,H.identifier.id),await this.extensionManagementService.uninstall(H,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,H.identifier.id),f.push(H.identifier)}))}(c.length||y.length)&&await s.Promises.settled([...c,...y].map(async $=>{const H=F.find(_=>O.areSameExtensions(_.identifier,$.identifier));if(H&&H.isBuiltin){$.state&&H.manifest.version===$.version&&this.updateExtensionState($.state,H.manifest.publisher,H.manifest.name,H.manifest.version),$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id),await this.extensionEnablementService.disableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id),await this.extensionEnablementService.enableExtension($.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id)),f.push($.identifier);return}const V=await this.extensionGalleryService.getCompatibleExtension($.identifier);if($.state&&(H?H.manifest.version===$.version:!!V)){const _=H?H.manifest.publisher:V.publisher,x=H?H.manifest.name:V.name;this.updateExtensionState($.state,_,x,H?.manifest.version)}if(V)try{$.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,$.identifier.id,V.version),await this.extensionEnablementService.disableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,$.identifier.id,V.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,$.identifier.id,V.version),await this.extensionEnablementService.enableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,$.identifier.id,V.version)),H||(await this.extensionManagementService.canInstall(V)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,$.identifier.id,V.version),await this.extensionManagementService.installFromGallery(V,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,$.identifier.id,V.version),f.push(V.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,V.displayName||V.identifier.id),U.push($)))}catch(_){U.push($),this.logService.error(_),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,V.displayName||V.identifier.id)}else this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,$.identifier.id),U.push($)}));const z=[];for(const $ of E)f.some(H=>O.areSameExtensions(H,$.identifier))||z.push($);for(const $ of U)z.some(H=>O.areSameExtensions(H.identifier,$.identifier))||z.push($);return z}updateExtensionState(c,l,y,E){const f=t(l,y,this.storageService),U=E?this.extensionsStorageSyncService.getKeysForSync({id:O.getGalleryExtensionId(l,y),version:E}):void 0;U?U.forEach(F=>{f[F]=c[F]}):Object.keys(c).forEach(F=>f[F]=c[F]),r(l,y,f,this.storageService)}parseExtensions(c){return JSON.parse(c.content)}getLocalExtensions(c){const l=this.extensionEnablementService.getDisabledExtensions();return c.map(({identifier:y,isBuiltin:E,manifest:f})=>{const U={identifier:y,version:f.version};l.some(F=>O.areSameExtensions(F,y))&&(U.disabled=!0),E||(U.installed=!0);try{const F=this.extensionsStorageSyncService.getKeysForSync({id:y.id,version:f.version});if(F){const z=t(f.publisher,f.name,this.storageService);U.state=Object.keys(z).reduce(($,H)=>(F.includes(H)&&($[H]=z[H]),$),{})}}catch(F){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,I.getErrorMessage(F))}return U})}};i.EXTENSIONS_DATA_URI=d.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=de([Y(0,L.IEnvironmentService),Y(1,P.IFileService),Y(2,D.IStorageService),Y(3,v.IUserDataSyncStoreService),Y(4,v.IUserDataSyncBackupStoreService),Y(5,A.IExtensionManagementService),Y(6,A.IGlobalExtensionEnablementService),Y(7,b.IIgnoredExtensionsManagementService),Y(8,v.IUserDataSyncLogService),Y(9,A.IExtensionGalleryService),Y(10,S.IConfigurationService),Y(11,v.IUserDataSyncResourceEnablementService),Y(12,m.ITelemetryService),Y(13,p.IExtensionsStorageSyncService)],i),e.ExtensionsSynchroniser=i;let o=class extends n.AbstractInitializer{constructor(c,l,y,E,f){super("extensions",E,f,y);this.extensionManagementService=c,this.ignoredExtensionsManagementService=l}async parseExtensions(c){return c.syncData?await a(c.syncData,this.extensionManagementService):null}generatePreview(c,l){const y=[],E=[],f=[];for(const U of c){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(U.identifier.id))continue;const F=l.find(z=>O.areSameExtensions(z.identifier,U.identifier));F?(y.push(F),U.disabled&&f.push(U.identifier)):U.installed&&(E.push(U.identifier),U.disabled&&f.push(U.identifier))}return{installedExtensions:y,newExtensions:E,disabledExtensions:f,remoteExtensions:c}}};o=de([Y(0,A.IExtensionManagementService),Y(1,b.IIgnoredExtensionsManagementService),Y(2,P.IFileService),Y(3,L.IEnvironmentService),Y(4,v.IUserDataSyncLogService)],o),e.AbstractExtensionsInitializer=o}),define(Z[189],ee([0,1,26,22]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(P,S,w,n,m){if(!S)return{remote:Object.keys(P).length>0?P:null,local:{added:{},removed:[],updated:{}}};const d=A(P,S);if(d.added.size===0&&d.removed.size===0&&d.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const g=w?A(w,S):{added:Object.keys(S).reduce((I,p)=>(I.add(p),I),new Set),removed:new Set,updated:new Set},h=w?A(w,P):{added:Object.keys(P).reduce((I,p)=>(I.add(p),I),new Set),removed:new Set,updated:new Set},C={added:{},removed:[],updated:{}},D=v.deepClone(S),b=!w;for(const I of h.added.values())I!==k.SYNC_SERVICE_URL_TYPE&&b&&g.added.has(I)||(D[I]=P[I]);for(const I of h.updated.values())D[I]=P[I];for(const I of h.removed.values())n.unregistered.includes(I)||delete D[I];for(const I of g.added.values()){const p=S[I];if(n.machine.includes(I)){m.info(`GlobalState: Skipped adding ${I} in local storage because it is declared as machine scoped.`);continue}if(w&&h.added.has(I))continue;const s=P[I];s&&s.value===p.value||I===k.SYNC_SERVICE_URL_TYPE&&b&&h.added.has(I)||(s?C.updated[I]=p:C.added[I]=p)}for(const I of g.updated.values()){const p=S[I];if(n.machine.includes(I)){m.info(`GlobalState: Skipped updating ${I} in local storage because it is declared as machine scoped.`);continue}if(h.updated.has(I)||h.removed.has(I))continue;const s=P[I];s&&s.value===p.value||(C.updated[I]=p)}for(const I of g.removed.values()){if(n.machine.includes(I)){m.trace(`GlobalState: Skipped removing ${I} in local storage because it is declared as machine scoped.`);continue}h.updated.has(I)||h.removed.has(I)||C.removed.push(I)}return{local:C,remote:O(D,S)?null:D}}e.merge=L;function A(P,S){const w=Object.keys(P),n=Object.keys(S),m=n.filter(h=>w.indexOf(h)===-1).reduce((h,C)=>(h.add(C),h),new Set),d=w.filter(h=>n.indexOf(h)===-1).reduce((h,C)=>(h.add(C),h),new Set),g=new Set;for(const h of w){if(d.has(h))continue;const C=P[h],D=S[h];v.equals(C,D)||g.add(h)}return{added:m,removed:d,updated:g}}function O(P,S){const{added:w,removed:n,updated:m}=A(P,S);return w.size===0&&n.size===0&&m.size===0}}),define(Z[190],ee([0,1,22,25,3,9,10,52,189,32,45,24,23,5,46,40,21,7,44,30,15]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h,C,D,b,I,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const a="globalState.argv.",t=["locale"];function r(l){const y=l.storage?Object.keys(l.storage).sort():[],E={};y.forEach(F=>E[F]=l.storage[F]),l.storage=E;const f=JSON.stringify(l),U=h.format(f,void 0,{});return C.applyEdits(f,U)}const i=1;let o=class ot extends n.AbstractSynchroniser{constructor(y,E,f,U,F,z,$,H,V){super("globalState",y,F,V,E,f,z,$,U,H);this.storageService=V,this.version=i,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(y.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(L.Event.any(L.Event.filter(y.onDidFilesChange,_=>_.contains(this.environmentService.argvResource)),L.Event.filter(V.onDidChangeValue,_=>_.scope===0&&_.target!==void 0?_.target===0:V.keys(0,0).includes(_.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(y,E,f,U){const F=y.syncData?JSON.parse(y.syncData.content):null;E=E===null&&f?y:E;const z=E&&E.syncData?JSON.parse(E.syncData.content):null,$=await this.getLocalGlobalState();F?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const H=this.getStorageKeys(z),{local:V,remote:_}=S.merge($.storage,F?F.storage:null,z?z.storage:null,H,this.logService),x={content:null,local:V,remote:_,localChange:Object.keys(V.added).length>0||Object.keys(V.updated).length>0||V.removed.length>0?2:0,remoteChange:_!==null?2:0};return[{localResource:this.localResource,localContent:r($),localUserData:$,remoteResource:this.remoteResource,remoteContent:F?r(F):null,previewResource:this.previewResource,previewResult:x,localChange:x.localChange,remoteChange:x.remoteChange,acceptedResource:this.acceptedResource,storageKeys:H}]}async getMergeResult(y,E){return{...y.previewResult,hasConflicts:!1}}async getAcceptResult(y,E,f,U){if(this.extUri.isEqual(E,this.localResource))return this.acceptLocal(y);if(this.extUri.isEqual(E,this.remoteResource))return this.acceptRemote(y);if(this.extUri.isEqual(E,this.previewResource))return y.previewResult;throw new Error(`Invalid Resource: ${E.toString()}`)}async acceptLocal(y){return{content:y.localContent,local:{added:{},removed:[],updated:{}},remote:y.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(y){if(y.remoteContent!==null){const E=JSON.parse(y.remoteContent),{local:f,remote:U}=S.merge(y.localUserData.storage,E.storage,null,y.storageKeys,this.logService);return{content:y.remoteContent,local:f,remote:U,localChange:Object.keys(f.added).length>0||Object.keys(f.updated).length>0||f.removed.length>0?2:0,remoteChange:U!==null?2:0}}else return{content:y.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(y,E,f,U){let{localUserData:F}=f[0][0],{local:z,remote:$,localChange:H,remoteChange:V}=f[0][1];if(H===0&&V===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),H!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(F)),await this.writeLocalGlobalState(z),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),V!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const _=JSON.stringify({storage:$});y=await this.updateRemoteUserData(_,U?null:y.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}E?.ref!==y.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(y),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:y}){return[{resource:this.extUri.joinPath(y,"globalState.json"),comparableResource:ot.GLOBAL_STATE_DATA_URI}]}async resolveContent(y){if(this.extUri.isEqual(y,ot.GLOBAL_STATE_DATA_URI)){const f=await this.getLocalGlobalState();return r(f)}if(this.extUri.isEqual(this.remoteResource,y)||this.extUri.isEqual(this.localResource,y)||this.extUri.isEqual(this.acceptedResource,y))return this.resolvePreviewContent(y);let E=await super.resolveContent(y);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(y)),E){const f=this.parseSyncData(E);if(f)switch(this.extUri.basename(y)){case"globalState.json":return r(JSON.parse(f.content))}}return null}async hasLocalData(){try{const{storage:y}=await this.getLocalGlobalState();if(Object.keys(y).length>1||y[`${a}.locale`]?.value!=="en")return!0}catch(y){}return!1}async getLocalGlobalState(){const y={},E=await this.getLocalArgvContent(),f=w.parse(E);for(const U of t)f[U]!==void 0&&(y[`${a}${U}`]={version:1,value:f[U]});for(const U of this.storageService.keys(0,0)){const F=this.storageService.get(U,0);F&&(y[U]={version:1,value:F})}return{storage:y}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(y){}return"{}"}async writeLocalGlobalState({added:y,removed:E,updated:f}){const U={},F={},z=(H,V)=>{for(const _ of H){if(_.startsWith(a)){U[_.substring(a.length)]=V?V[_].value:void 0;continue}if(V){const x=V[_];x.value!==String(this.storageService.get(_,0))&&(F[_]=x.value)}else this.storageService.get(_,0)!==void 0&&(F[_]=void 0)}};if(z(Object.keys(y),y),z(Object.keys(f),f),z(E),Object.keys(U).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(U),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(F).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const H of Object.keys(F))this.storageService.store(H,F[H],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(F))}}async updateArgv(y){const E=await this.getLocalArgvContent();let f=E;for(const U of Object.keys(y))f=P.edit(f,[U],y[U],{});E!==f&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(f)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(y){const E=this.storageService.keys(0,0),f=this.storageService.keys(0,1),U=[...E,...f],F=y?.storage?Object.keys(y.storage).filter(z=>!z.startsWith(a)&&!U.includes(z)&&this.storageService.get(z,0)!==void 0):[];if(!b.isWeb){const z=[...v.ALL_SYNC_RESOURCES.map($=>v.getEnablementKey($)),v.SYNC_SERVICE_URL_TYPE];F.push(...z),f.push(...z)}return{user:E,machine:f,unregistered:F}}};o.GLOBAL_STATE_DATA_URI=g.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=de([Y(0,O.IFileService),Y(1,v.IUserDataSyncStoreService),Y(2,v.IUserDataSyncBackupStoreService),Y(3,v.IUserDataSyncLogService),Y(4,A.IEnvironmentService),Y(5,v.IUserDataSyncResourceEnablementService),Y(6,m.ITelemetryService),Y(7,d.IConfigurationService),Y(8,D.IStorageService)],o),e.GlobalStateSynchroniser=o;let u=class extends n.AbstractInitializer{constructor(y,E,f,U){super("globalState",f,U,E);this.storageService=y}async doInitialize(y){const E=y.syncData?JSON.parse(y.syncData.content):null;if(!E){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const f={},U={};for(const F of Object.keys(E.storage))F.startsWith(a)?f[F.substring(a.length)]=E.storage[F].value:this.storageService.get(F,0)===void 0&&(U[F]=E.storage[F].value);if(Object.keys(f).length){let F="{}";try{F=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(z){}for(const z of Object.keys(f))F=P.edit(F,[z],f[z],{});await this.fileService.writeFile(this.environmentService.argvResource,k.VSBuffer.fromString(F))}if(Object.keys(U).length)for(const F of Object.keys(U))this.storageService.store(F,U[F],0,0)}};u=de([Y(0,D.IStorageService),Y(1,O.IFileService),Y(2,A.IEnvironmentService),Y(3,v.IUserDataSyncLogService)],u),e.GlobalStateInitializer=u;let c=class{constructor(y,E,f,U,F){this.userDataSyncStoreClient=y,this.storageService=E,this.environmentService=f,this.fileService=U,this.logService=F}getSyncStoreType(y){return this.parseGlobalState(y)?.storage[v.SYNC_SERVICE_URL_TYPE]?.value}async sync(y){const E=v.createSyncHeaders(p.generateUuid());try{return await this.doSync(y,E)}catch(f){if(f instanceof v.UserDataSyncError)switch(f.code){case v.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(y,E)}throw f}}async doSync(y,E){const f=await this.userDataSyncStoreClient.read("globalState",null,E),U=this.parseGlobalState(f)||{storage:{}};U.storage[v.SYNC_SERVICE_URL_TYPE]={value:y,version:i};const F=await I.getServiceMachineId(this.environmentService,this.fileService,this.storageService),z={version:i,machineId:F,content:r(U)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(z),f.ref,E)}parseGlobalState({content:y}){if(!y)return null;const E=JSON.parse(y);if(n.isSyncData(E))return E?JSON.parse(E.content):null;throw new Error("Invalid remote data")}};c=de([Y(1,D.IStorageService),Y(2,A.IEnvironmentService),Y(3,O.IFileService),Y(4,s.ILogService)],c),e.UserDataSyncStoreTypeSynchronizer=c}),define(Z[191],ee([0,1,10,22,186,32,124,9,23,7,16,19,45,24,21,25,3]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h,C,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function b(s,a){const t=JSON.parse(s);if(!a)return n.isUndefined(t.all)?null:t.all;switch(w.OS){case 2:return n.isUndefined(t.mac)?null:t.mac;case 3:return n.isUndefined(t.linux)?null:t.linux;case 1:return n.isUndefined(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=b;let I=class extends d.AbstractJsonFileSynchroniser{constructor(a,t,r,i,o,u,c,l,y,E){super(c.keybindingsResource,"keybindings",u,c,l,a,t,o,E,r,y,i);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.Event.filter(i.onDidChangeConfiguration,f=>f.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(a,t,r,i){const o=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;t=t===null&&r?a:t;const u=t?this.getKeybindingsContentFromLastSyncUserData(t):null,c=await this.getLocalFileContent(),l=await this.getFormattingOptions();let y=null,E=!1,f=!1,U=!1;if(o){let z=c?c.value.toString():"[]";if(z=z||"[]",this.hasErrors(z))throw new k.UserDataSyncError(O.localize(0,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!u||u!==z||u!==o){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const $=await L.merge(z,o,u,l,this.userDataSyncUtilService);$.hasChanges&&(y=$.mergeContent,U=$.hasConflicts,E=U||$.mergeContent!==z,f=U||$.mergeContent!==o)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),y=c.value.toString(),f=!0);const F={content:y,localChange:E?c?2:1:0,remoteChange:f?2:0,hasConflicts:U};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:F.localChange,remoteResource:this.remoteResource,remoteContent:o,remoteChange:F.remoteChange,previewResource:this.previewResource,previewResult:F,acceptedResource:this.acceptedResource}]}async getMergeResult(a,t){return a.previewResult}async getAcceptResult(a,t,r,i){if(this.extUri.isEqual(t,this.localResource))return{content:a.fileContent?a.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:a.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return r===void 0?{content:a.previewResult.content,localChange:a.previewResult.localChange,remoteChange:a.previewResult.remoteChange}:{content:r,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(a,t,r,i){const{fileContent:o}=r[0][0];let{content:u,localChange:c,remoteChange:l}=r[0][1];if(c===0&&l===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),u!==null&&(u=u.trim(),u=u||"[]",this.hasErrors(u)))throw new k.UserDataSyncError(O.localize(1,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(c!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),o&&await this.backupLocal(this.toSyncContent(o.value.toString())),await this.updateLocalFileContent(u||"[]",o,i),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),l!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const y=this.toSyncContent(u||"[]",a.syncData?.content);a=await this.updateRemoteUserData(y,i?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(y){}t?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(a,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const a=await this.getLocalFileContent();if(a){const t=A.parse(a.value.toString());if(m.isNonEmptyArray(t))return!0}}catch(a){if(a.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:a}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(a,"keybindings.json"),comparableResource:t}]}async resolveContent(a){if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a))return this.resolvePreviewContent(a);let t=await super.resolveContent(a);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(a)),t){const r=this.parseSyncData(t);if(r)switch(this.extUri.basename(a)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(r.content)}}return null}getKeybindingsContentFromLastSyncUserData(a){return!a.syncData||a.platformSpecific!==void 0&&a.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(a.syncData.content)}getKeybindingsContentFromSyncContent(a){try{return b(a,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(a,t){let r={};try{r=JSON.parse(t||"{}")}catch(i){this.logService.error(i)}switch(this.syncKeybindingsPerPlatform()?delete r.all:r.all=a,w.OS){case 2:r.mac=a;break;case 3:r.linux=a;break;case 1:r.windows=a;break}return JSON.stringify(r)}syncKeybindingsPerPlatform(){let a=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return a!==void 0||(a=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,a!==void 0)?a:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};I=de([Y(0,k.IUserDataSyncStoreService),Y(1,k.IUserDataSyncBackupStoreService),Y(2,k.IUserDataSyncLogService),Y(3,S.IConfigurationService),Y(4,k.IUserDataSyncResourceEnablementService),Y(5,v.IFileService),Y(6,P.IEnvironmentService),Y(7,h.IStorageService),Y(8,k.IUserDataSyncUtilService),Y(9,g.ITelemetryService)],I),e.KeybindingsSynchroniser=I;let p=class extends d.AbstractInitializer{constructor(a,t,r){super("keybindings",t,r,a)}async doInitialize(a){const t=a.syncData?this.getKeybindingsContentFromSyncContent(a.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,C.VSBuffer.fromString(t)),await this.updateLastSyncUserData(a)}async isEmpty(){try{const a=await this.fileService.readFile(this.environmentService.settingsResource),t=A.parse(a.value.toString());return!m.isNonEmptyArray(t)}catch(a){return a.fileOperationResult===1}}getKeybindingsContentFromSyncContent(a){try{return b(a,!0)}catch(t){return this.logService.error(t),null}}};p=de([Y(0,v.IFileService),Y(1,P.IEnvironmentService),Y(2,k.IUserDataSyncLogService)],p),e.KeybindingsInitializer=p}),define(Z[192],ee([0,1,26,32,40,46,52,22,19]),function(K,e,v,k,L,A,O,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function w(c,l,y){let E=[];y?E=m(y):E=n(l);const f=[],U=[...P.getDisallowedIgnoredSettings()];if(Array.isArray(E))for(const F of E)F.startsWith("-")?U.push(F.substring(1)):f.push(F);return S.distinct([...c,...f].filter(F=>U.indexOf(F)===-1))}e.getIgnoredSettings=w;function n(c){let l=c.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=c.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:c.getValue("settingsSync.ignoredSettings")||[]}function m(c){const l=k.parse(c);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function d(c,l,y,E){if(y.length){const f=u(l),U=k.parse(l),F=k.parse(c),z=[];for(const $ of y){const H=U[$],V=F[$];H===void 0?c=O.edit(c,[$],void 0,E):V!==void 0?c=O.edit(c,[$],H,E):z.push(a($,f))}z.sort(($,H)=>$.startOffset-H.startOffset),z.forEach($=>c=b($.setting.key,l,c,E))}return c}e.updateIgnoredSettings=d;function g(c,l,y,E,f,U){const F=d(c,l,E,U),z=y!==F,$=y!==l;if(!z&&!$)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(z&&!$)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if($&&!z)return{conflictsSettings:[],localContent:d(l,c,E,U),remoteContent:null,hasConflicts:!1};if(y===null&&C(c)){const ne=h(c,l,E)?null:d(l,c,E,U);return{conflictsSettings:[],localContent:ne,remoteContent:null,hasConflicts:!1}}let H=c,V=l;const _=k.parse(c),x=k.parse(l),j=y?k.parse(y):null,q=E.reduce((ne,oe)=>(ne.add(oe),ne),new Set),R=D(_,x,q),T=D(j,_,q),M=D(j,x,q),N=new Map,B=new Set,G=ne=>{B.add(ne);const oe=f.filter(({key:he})=>he===ne)[0];oe?(H=O.edit(H,[ne],oe.value,U),V=O.edit(V,[ne],oe.value,U)):N.set(ne,{key:ne,localValue:_[ne],remoteValue:x[ne]})};for(const ne of T.removed.values())M.updated.has(ne)?G(ne):V=O.edit(V,[ne],void 0,U);for(const ne of M.removed.values())B.has(ne)||(T.updated.has(ne)?G(ne):H=O.edit(H,[ne],void 0,U));for(const ne of T.updated.values())B.has(ne)||(M.updated.has(ne)?R.updated.has(ne)&&G(ne):V=O.edit(V,[ne],_[ne],U));for(const ne of M.updated.values())B.has(ne)||(T.updated.has(ne)?R.updated.has(ne)&&G(ne):H=O.edit(H,[ne],x[ne],U));for(const ne of T.added.values())B.has(ne)||(M.added.has(ne)?R.updated.has(ne)&&G(ne):V=b(ne,H,V,U));for(const ne of M.added.values())B.has(ne)||(T.added.has(ne)?R.updated.has(ne)&&G(ne):H=b(ne,V,H,U));const Q=N.size>0||!h(H,V,E),X=Q||!h(H,c,[]),ie=Q||!h(V,l,[]);return{localContent:X?H:null,remoteContent:ie?V:null,conflictsSettings:[...N.values()],hasConflicts:Q}}e.merge=g;function h(c,l,y){if(c===l)return!0;const E=k.parse(c),f=k.parse(l),U=y.reduce(($,H)=>($.add(H),$),new Set),F=u(c).filter($=>!($.setting&&U.has($.setting.key))),z=u(l).filter($=>!($.setting&&U.has($.setting.key)));if(F.length!==z.length)return!1;for(let $=0;$<F.length;$++){const H=F[$],V=z[$];if(H.setting&&V.setting){if(H.setting.key!==V.setting.key||!v.equals(E[H.setting.key],f[H.setting.key]))return!1}else if(!H.setting&&!V.setting){if(H.value!==V.value)return!1}else return!1}return!0}e.areSame=h;function C(c){return c?u(c).length===0:!0}e.isEmpty=C;function D(c,l,y){const E=c?Object.keys(c).filter($=>!y.has($)):[],f=Object.keys(l).filter($=>!y.has($)),U=f.filter($=>E.indexOf($)===-1).reduce(($,H)=>($.add(H),$),new Set),F=E.filter($=>f.indexOf($)===-1).reduce(($,H)=>($.add(H),$),new Set),z=new Set;if(c)for(const $ of E){if(F.has($))continue;const H=c[$],V=l[$];v.equals(H,V)||z.add($)}return{added:U,removed:F,updated:z}}function b(c,l,y,E){const f=k.parse(l),U=u(l),F=u(y),z=I(c,U,F);return p(y,c,f[c],z,F,E)}e.addSetting=b;function I(c,l,y){const E=l.findIndex(U=>U.setting?.key===c),f=l[E-1];if(f){if(f.setting){const F=a(f.setting.key,y);if(F)return{index:y.indexOf(F),insertAfter:!0}}else{const F=t(E,l);if(F){const z=a(F.setting.key,y);if(z){const $=r(y.indexOf(z),y),H=i(l,F,l[E]);if($){const V=i(y,z,$),_=o(H,V);return _?{index:y.indexOf(_),insertAfter:!0}:{index:y.indexOf($),insertAfter:!1}}else{const V=i(y,z,y[y.length-1]),_=o(H,V);return _?{index:y.indexOf(_),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const U=l[E+1];if(U)if(U.setting){const F=a(U.setting.key,y);if(F)return{index:y.indexOf(F),insertAfter:!1}}else{const F=r(E,l);if(F){const z=a(F.setting.key,y);if(z){const $=t(y.indexOf(z),y),H=i(l,l[E],F);if($){const V=i(y,$,z),_=o(H.reverse(),V.reverse());return _?{index:y.indexOf(_),insertAfter:!1}:{index:y.indexOf($),insertAfter:!0}}else{const V=i(y,y[0],z),_=o(H.reverse(),V.reverse());return _?{index:y.indexOf(_),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function p(c,l,y,E,f,U){let F;return E.index===-1?F=L.setProperty(c,[l],y,U):F=s(c,l,y,E,f,U).map(z=>L.withFormatting(c,z,U)[0]),L.applyEdits(c,F)}function s(c,l,y,E,f,U){const F=`${JSON.stringify(l)}: ${JSON.stringify(y)}`,z=A.getEOL(U,c),$=f[E.index];if(E.insertAfter){const H=[];if($.setting)H.push({offset:$.endOffset,length:0,content:","+F});else{const V=r(E.index,f),_=t(E.index,f),x=_?.setting?.commaOffset;_&&x===void 0&&H.push({offset:_.endOffset,length:0,content:","});const j=x!==void 0&&x>$.endOffset;H.push({offset:j?x+1:$.endOffset,length:0,content:V?z+F+",":z+F})}return H}else{if($.setting)return[{offset:$.startOffset,length:0,content:F+","}];const H=(f[E.index-1]&&!f[E.index-1].setting?z:"")+F+(r(E.index,f)?",":"")+z;return[{offset:$.startOffset,length:0,content:H}]}}function a(c,l){return l.filter(y=>y.setting?.key===c)[0]}function t(c,l){for(let y=c-1;y>=0;y--)if(l[y].setting)return l[y]}function r(c,l){for(let y=c+1;y<l.length;y++)if(l[y].setting)return l[y]}function i(c,l,y){const E=c.indexOf(l),f=c.indexOf(y);return c.filter((U,F)=>E<F&&F<f)}function o(c,l){if(c.length&&l.length){let y=0;for(;y<l.length&&y<c.length;y++)if(c[y].value!==l[y].value)return l[y-1];return l[y-1]}}function u(c){const l=[];let y=-1,E,f;const U={onObjectBegin:F=>{y++},onObjectProperty:(F,z,$)=>{y===0&&(E=z,f=F)},onObjectEnd:(F,z)=>{y--,y===0&&l.push({startOffset:E,endOffset:F+z,value:c.substring(E,F+z),setting:{key:f,commaOffset:void 0}})},onArrayBegin:(F,z)=>{y++},onArrayEnd:(F,z)=>{y--,y===0&&l.push({startOffset:E,endOffset:F+z,value:c.substring(E,F+z),setting:{key:f,commaOffset:void 0}})},onLiteralValue:(F,z,$)=>{y===0&&l.push({startOffset:E,endOffset:z+$,value:c.substring(E,z+$),setting:{key:f,commaOffset:void 0}})},onSeparator:(F,z,$)=>{if(y===0&&F===","){let H=l.length-1;for(;H>=0&&!l[H].setting;H--);const V=l[H];V&&l.splice(H,1,{startOffset:V.startOffset,endOffset:V.endOffset,value:V.value,setting:{key:V.setting.key,commaOffset:z}})}},onComment:(F,z)=>{y===0&&l.push({startOffset:F,endOffset:F+z,value:c.substring(F,F+z)})}};return k.visit(c,U),l}}),define(Z[193],ee([0,1,10,22,25,125,3,9,23,192,52,45,24,28,21,40]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function D(a){return a&&a.settings&&typeof a.settings=="string"&&Object.keys(a).length===1}function b(a){const t=JSON.parse(a);return D(t)?t:{settings:a}}e.parseSettingsSyncContent=b;let I=class extends m.AbstractJsonFileSynchroniser{constructor(t,r,i,o,u,c,l,y,E,f,U){super(r.settingsResource,"settings",t,r,i,o,u,E,f,c,l,y);this.extensionManagementService=U,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:k.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,r,i,o){const u=await this.getLocalFileContent(),c=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t);r=r===null&&i?t:r;const y=r?this.getSettingsSyncContent(r):null,E=await this.getIgnoredSettings();let f=null,U=!1,F=!1,z=!1;if(l){let H=u?u.value.toString().trim():"{}";H=H||"{}",this.validateContent(H),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const V=w.merge(H,l.settings,y?y.settings:null,E,[],c);f=V.localContent||V.remoteContent,U=V.localContent!==null,F=V.remoteContent!==null,z=V.hasConflicts}else u&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),f=u.value.toString(),F=!0);const $={content:f,localChange:U?2:0,remoteChange:F?2:0,hasConflicts:z};return[{fileContent:u,localResource:this.localResource,localContent:u?u.value.toString():null,localChange:$.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:$.remoteChange,previewResource:this.previewResource,previewResult:$,acceptedResource:this.acceptedResource}]}async getMergeResult(t,r){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return{...t.previewResult,content:t.previewResult.content?w.updateIgnoredSettings(t.previewResult.content,"{}",o,i):null}}async getAcceptResult(t,r,i,o){const u=await this.getFormattingOptions(),c=await this.getIgnoredSettings();if(this.extUri.isEqual(r,this.localResource))return{content:t.fileContent?w.updateIgnoredSettings(t.fileContent.value.toString(),"{}",c,u):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(r,this.remoteResource))return{content:t.remoteContent!==null?w.updateIgnoredSettings(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",c,u):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(r,this.previewResource))return i===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:i!==null?w.updateIgnoredSettings(i,t.fileContent?t.fileContent.value.toString():"{}",c,u):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${r.toString()}`)}async applyResult(t,r,i,o){const{fileContent:u}=i[0][0];let{content:c,localChange:l,remoteChange:y}=i[0][1];if(l===0&&y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.validateContent(c),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),u&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(u.value.toString()))),await this.updateLocalFileContent(c,u,o),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),y!==0){const E=await this.getFormattingOptions(),f=this.getSettingsSyncContent(t),U=await this.getIgnoredSettings(c);c=w.updateIgnoredSettings(c,f?f.settings:"{}",U,E),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(c)),o?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(E){}r?.ref!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const r=await this.getFormattingOptions(),i=n.edit(t.value.toString(),[k.CONFIGURATION_SYNC_STORE_KEY],void 0,r);return!w.isEmpty(i)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const r=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:r}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let r=await super.resolveContent(t);if(r)return r;if(r=await super.resolveContent(this.extUri.dirname(t)),r){const i=this.parseSyncData(r);if(i){const o=this.parseSettingsSyncContent(i.content);if(o)switch(this.extUri.basename(t)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(t){let r=await super.resolvePreviewContent(t);if(r){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();r=w.updateIgnoredSettings(r,"{}",o,i)}return r}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=O.Event.any(O.Event.filter(this.extensionManagementService.onDidInstallExtension,o=>!!o.gallery),O.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const r=await this._defaultIgnoredSettings;return w.getIgnoredSettings(r,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new k.UserDataSyncError(A.localize(0,null),k.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const r=JSON.parse(t.value.toString());if(!s(r))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const i=this.parseSettingsSyncContent(r.content);if(!i||!i.settings)return;let o=i.settings;const u=await this.getFormattingOptions();for(const c in r)if(["version","content","machineId"].indexOf(c)===-1&&r[c]!==void 0){const l=C.setProperty(o,[c],r[c],u);l.length&&(o=C.applyEdits(o,l))}await this.fileService.writeFile(this.file,L.VSBuffer.fromString(o))}catch(t){}}};I=de([Y(0,v.IFileService),Y(1,P.IEnvironmentService),Y(2,h.IStorageService),Y(3,k.IUserDataSyncStoreService),Y(4,k.IUserDataSyncBackupStoreService),Y(5,k.IUserDataSyncLogService),Y(6,k.IUserDataSyncUtilService),Y(7,S.IConfigurationService),Y(8,k.IUserDataSyncResourceEnablementService),Y(9,d.ITelemetryService),Y(10,g.IExtensionManagementService)],I),e.SettingsSynchroniser=I;let p=class extends m.AbstractInitializer{constructor(t,r,i){super("settings",r,i,t)}async doInitialize(t){const r=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!r){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,L.VSBuffer.fromString(r.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return w.isEmpty(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return b(t)}catch(r){this.logService.error(r)}return null}};p=de([Y(0,v.IFileService),Y(1,P.IEnvironmentService),Y(2,k.IUserDataSyncLogService)],p),e.SettingsInitializer=p;function s(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&a.machineId!==void 0&&typeof a.machineId=="string")}}),define(Z[194],ee([0,1,22,9,10,23,45,24,25,187,21,26,3]),function(K,e,v,k,L,A,O,P,S,w,n,m,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let g=class extends O.AbstractSynchroniser{constructor(D,b,I,p,s,a,t,r,i){super("snippets",b,D,I,p,s,r,i,a,t);this.version=1,this.snippetsFolder=D.snippetsHome,this._register(this.fileService.watch(D.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(d.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(D,b,I,p){const s=await this.getSnippetsFileContents(),a=this.toSnippetsContents(s),t=D.syncData?this.parseSnippets(D.syncData):null;b=b===null&&I?D:b;const r=b&&b.syncData?this.parseSnippets(b.syncData):null;t?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=w.merge(a,t,r);return this.getResourcePreviews(i,s,t||{})}async getMergeResult(D,b){return D.previewResult}async getAcceptResult(D,b,I,p){if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:D.fileContent?D.fileContent.value.toString():null,localChange:0,remoteChange:D.fileContent?D.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:D.remoteContent,localChange:D.remoteContent!==null?D.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(b,this.syncPreviewFolder))return I===void 0?{content:D.previewResult.content,localChange:D.previewResult.localChange,remoteChange:D.previewResult.remoteChange}:{content:I,localChange:I===null?D.fileContent!==null?3:0:2,remoteChange:I===null?D.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${b.toString()}`)}async applyResult(D,b,I,p){const s=I.map(([a,t])=>({...a,acceptResult:t}));s.every(({localChange:a,remoteChange:t})=>a===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),s.some(({localChange:a})=>a!==0)&&(await this.updateLocalBackup(s),await this.updateLocalSnippets(s,p)),s.some(({remoteChange:a})=>a!==0)&&(D=await this.updateRemoteSnippets(s,D,p)),b?.ref!==D.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(D),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:a}of s)try{await this.fileService.del(a)}catch(t){}}getResourcePreviews(D,b,I){const p=new Map;for(const s of Object.keys(D.local.added)){const a={content:D.local.added[s],hasConflicts:!1,localChange:1,remoteChange:0};p.set(s,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(D.local.updated)){const a={content:D.local.updated[s],hasConflicts:!1,localChange:2,remoteChange:0};p.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of D.local.removed){const a={content:null,hasConflicts:!1,localChange:3,remoteChange:0};p.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(D.remote.added)){const a={content:D.remote.added[s],hasConflicts:!1,localChange:0,remoteChange:1};p.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(D.remote.updated)){const a={content:D.remote.updated[s],hasConflicts:!1,localChange:0,remoteChange:2};p.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s],localContent:b[s].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of D.remote.removed){const a={content:null,hasConflicts:!1,localChange:0,remoteChange:3};p.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s],previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of D.conflicts){const a={content:b[s]?b[s].value.toString():null,hasConflicts:!0,localChange:b[s]?2:1,remoteChange:I[s]?2:1};p.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s]||null,localContent:b[s]?b[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const s of Object.keys(b))if(!p.has(s)){const a={content:b[s]?b[s].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};p.set(s,{localResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:b[s]||null,localContent:b[s]?b[s].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:I[s]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,s),previewResult:a,localChange:a.localChange,remoteChange:a.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...p.values()]}async getAssociatedResources({uri:D}){let b=await super.resolveContent(D);if(b){const I=this.parseSyncData(b);if(I){const p=this.parseSnippets(I),s=[];for(const a of Object.keys(p)){const t=this.extUri.joinPath(D,a),r=this.extUri.joinPath(this.snippetsFolder,a),i=await this.fileService.exists(r);s.push({resource:t,comparableResource:i?r:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"})})}return s}}return[]}async resolveContent(D){if(this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(D,this.syncPreviewFolder.with({scheme:v.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(D);let b=await super.resolveContent(D);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(D)),b){const I=this.parseSyncData(b);if(I)return this.parseSnippets(I)[this.extUri.basename(D)]||null}return null}async hasLocalData(){try{const D=await this.getSnippetsFileContents();if(Object.keys(D).length)return!0}catch(D){}return!1}async updateLocalBackup(D){const b={};for(const I of D)I.fileContent&&(b[this.extUri.basename(I.localResource)]=I.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(b)))}async updateLocalSnippets(D,b){for(const{fileContent:I,acceptResult:p,localResource:s,remoteResource:a,localChange:t}of D)if(t!==0){const r=a?this.extUri.basename(a):this.extUri.basename(s),i=this.extUri.joinPath(this.snippetsFolder,r);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(i)),await this.fileService.del(i),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(i))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(i)),await this.fileService.createFile(i,S.VSBuffer.fromString(p.content),{overwrite:b}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(i))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(i)),await this.fileService.writeFile(i,S.VSBuffer.fromString(p.content),b?void 0:I),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(i)))}}async updateRemoteSnippets(D,b,I){const p=b.syncData?this.parseSnippets(b.syncData):{},s=m.deepClone(p);for(const{acceptResult:a,localResource:t,remoteResource:r,remoteChange:i}of D)if(i!==0){const o=t?this.extUri.basename(t):this.extUri.basename(r);i===3?delete s[o]:s[o]=a.content}return w.areSame(p,s)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),b=await this.updateRemoteUserData(JSON.stringify(s),I?null:b.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),b}parseSnippets(D){return JSON.parse(D.content)}toSnippetsContents(D){const b={};for(const I of Object.keys(D))b[I]=D[I].value.toString();return b}async getSnippetsFileContents(){const D={};let b;try{b=await this.fileService.resolve(this.snippetsFolder)}catch(I){if(I instanceof L.FileOperationError&&I.fileOperationResult===1)return D;throw I}for(const I of b.children||[]){const p=I.resource,s=this.extUri.extname(p);if(s===".json"||s===".code-snippets"){const a=this.extUri.relativePath(this.snippetsFolder,p),t=await this.fileService.readFile(p);D[a]=t}}return D}};g=de([Y(0,k.IEnvironmentService),Y(1,L.IFileService),Y(2,n.IStorageService),Y(3,v.IUserDataSyncStoreService),Y(4,v.IUserDataSyncBackupStoreService),Y(5,v.IUserDataSyncLogService),Y(6,A.IConfigurationService),Y(7,v.IUserDataSyncResourceEnablementService),Y(8,P.ITelemetryService)],g),e.SnippetsSynchroniser=g;let h=class extends O.AbstractInitializer{constructor(D,b,I){super("snippets",b,I,D)}async doInitialize(D){const b=D.syncData?JSON.parse(D.syncData.content):null;if(!b){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const p of Object.keys(b)){const s=b[p];if(s){const a=this.extUri.joinPath(this.environmentService.snippetsHome,p);await this.fileService.createFile(a,S.VSBuffer.fromString(s)),this.logService.info("Created snippet",this.extUri.basename(a))}}await this.updateLastSyncUserData(D)}async isEmpty(){try{return!(await this.fileService.resolve(this.environmentService.snippetsHome)).children?.length}catch(D){return D.fileOperationResult===1}}};h=de([Y(0,L.IFileService),Y(1,k.IEnvironmentService),Y(2,v.IUserDataSyncLogService)],h),e.SnippetsInitializer=h}),define(Z[60],ee([0,1,4,3,2,22]),function(K,e,v,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=v.createDecorator("IUserDataSyncAccountService");let O=class extends L.Disposable{constructor(S){super();this.userDataSyncStoreService=S,this._onDidChangeAccount=this._register(new k.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new k.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(S.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(S.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(S){(S&&this._account?S.token!==this._account.token||S.authenticationProviderId!==this._account.authenticationProviderId:S!==this._account)&&(this._account=S,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(S))}};O=de([Y(0,A.IUserDataSyncStoreService)],O),e.UserDataSyncAccountService=O}),define(Z[195],ee([0,1,2,22,14,23,10,9,55,25,6]),function(K,e,v,k,L,A,O,P,S,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let m=class extends v.Disposable{constructor(g,h,C,D){super();this.environmentService=g,this.fileService=h,this.configurationService=C,this.logService=D,k.ALL_SYNC_RESOURCES.forEach(b=>this.cleanUpBackup(b))}async getAllRefs(g){const h=L.joinPath(this.environmentService.userDataSyncHome,g),C=await this.fileService.resolve(h);return C.children?C.children.filter(b=>b.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(b.name)).sort().reverse().map(b=>({ref:b.name,created:this.getCreationTime(b)})):[]}async resolveContent(g,h){if(!h){const C=await this.getAllRefs(g);C.length&&(h=C[C.length-1].ref)}if(h){const C=L.joinPath(this.environmentService.userDataSyncHome,g,h);return(await this.fileService.readFile(C)).value.toString()}return null}async backup(g,h){const C=L.joinPath(this.environmentService.userDataSyncHome,g),D=L.joinPath(C,`${S.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(D,w.VSBuffer.fromString(h))}catch(b){this.logService.error(b)}try{this.cleanUpBackup(g)}catch(b){}}async cleanUpBackup(g){const h=L.joinPath(this.environmentService.userDataSyncHome,g);try{try{if(!await this.fileService.exists(h))return}catch(D){return}const C=await this.fileService.resolve(h);if(C.children){const D=C.children.filter(s=>s.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(s.name)).sort(),b=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let I=D.filter(s=>Date.now()-this.getCreationTime(s)>b);const p=D.length-I.length;p<10&&(I=I.slice(10-p)),await n.Promises.settled(I.map(async s=>{this.logService.info("Deleting from backup",s.resource.path),await this.fileService.del(s.resource)}))}}catch(C){this.logService.error(C)}}getCreationTime(g){return g.ctime||new Date(parseInt(g.name.substring(0,4)),parseInt(g.name.substring(4,6))-1,parseInt(g.name.substring(6,8)),parseInt(g.name.substring(9,11)),parseInt(g.name.substring(11,13)),parseInt(g.name.substring(13,15))).getTime()}};m=de([Y(0,P.IEnvironmentService),Y(1,O.IFileService),Y(2,A.IConfigurationService),Y(3,k.IUserDataSyncLogService)],m),e.UserDataSyncBackupStoreService=m}),define(Z[196],ee([0,1,5,2]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class L{constructor(d){this.service=d}listen(d,g){switch(g){case"onError":return this.service.onError}throw new Error(`Event not found: ${g}`)}call(d,g,h){switch(g){case"triggerSync":return this.service.triggerSync(h[0],h[1],h[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(h[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=L;class A{constructor(d){this.service=d}listen(d,g){throw new Error(`Event not found: ${g}`)}call(d,g,h){switch(g){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(h[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(v.URI.revive(h[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=A;class O{constructor(d){this.channel=d}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(d){return this.channel.call("resolveUserKeybindings",[d])}async resolveFormattingOptions(d){return this.channel.call("resolveFormattingOptions",[d])}}e.UserDataSyncUtilServiceClient=O;class P{constructor(d){this.service=d}listen(d,g){switch(g){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${g}`)}async call(d,g,h){switch(g){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(h[0],h[1]);case"setEnablement":return this.service.setEnablement(h[0],h[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=P;class S{constructor(d){this.service=d}listen(d,g){switch(g){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${g}`)}call(d,g,h){switch(g){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(h)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=S;class w{constructor(d){this.service=d}listen(d,g){switch(g){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${g}`)}call(d,g,h){switch(g){case"switch":return this.service.switch(h[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=w;class n extends k.Disposable{constructor(d){super();this.channel=d,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(d){return this.channel.call("switch",[d])}async getPreviousUserDataSyncStore(){const d=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(d)}revive(d){return{url:v.URI.revive(d.url),type:d.type,defaultUrl:v.URI.revive(d.defaultUrl),insidersUrl:v.URI.revive(d.insidersUrl),stableUrl:v.URI.revive(d.stableUrl),canSwitch:d.canSwitch,authenticationProviders:d.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(Z[197],ee([0,1,15,9]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let L=class extends v.AbstractLogger{constructor(O,P){super();this.logger=this._register(O.createLogger(P.userDataSyncLogResource,{name:"settingssync"}))}trace(O,...P){this.logger.trace(O,...P)}debug(O,...P){this.logger.debug(O,...P)}info(O,...P){this.logger.info(O,...P)}warn(O,...P){this.logger.warn(O,...P)}error(O,...P){this.logger.error(O,...P)}critical(O,...P){this.logger.critical(O,...P)}flush(){this.logger.flush()}};L=de([Y(0,v.ILoggerService),Y(1,k.IEnvironmentService)],L),e.UserDataSyncLogService=L}),define(Z[61],ee([0,1,4,2,44,9,10,21,22,128,27,7,20,3]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=v.createDecorator("IUserDataSyncMachinesService");const h="sync.currentMachineName";let C=class Ge extends k.Disposable{constructor(b,I,p,s,a,t){super();this.storageService=p,this.userDataSyncStoreService=s,this.logService=a,this.productService=t,this._onDidChange=this._register(new g.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=L.getServiceMachineId(b,I,p)}async getMachines(b){const I=await this.currentMachineIdPromise;return(await this.readMachinesData(b)).machines.map(s=>({...s,isCurrent:s.id===I}))}async addCurrentMachine(b){const I=await this.currentMachineIdPromise,p=await this.readMachinesData(b);p.machines.some(({id:s})=>s===I)||(p.machines.push({id:I,name:this.computeCurrentMachineName(p.machines)}),await this.writeMachinesData(p))}async removeCurrentMachine(b){const I=await this.currentMachineIdPromise,p=await this.readMachinesData(b),s=p.machines.filter(({id:a})=>a!==I);s.length!==p.machines.length&&(p.machines=s,await this.writeMachinesData(p))}async renameMachine(b,I,p){const s=await this.currentMachineIdPromise,a=await this.readMachinesData(p),t=a.machines.find(({id:r})=>r===b);t&&(t.name=I,await this.writeMachinesData(a),a.machines.some(({id:r})=>r===s)&&this.storageService.store(h,I,0,1))}async setEnablement(b,I){const p=await this.readMachinesData(),s=p.machines.find(({id:a})=>a===b);s&&(s.disabled=I?void 0:!0,await this.writeMachinesData(p))}computeCurrentMachineName(b){const I=this.storageService.get(h,0);if(I)return I;const p=`${this.productService.nameLong} (${m.PlatformToString(m.isWeb?0:m.platform)})`,s=new RegExp(`${d.escapeRegExpCharacters(p)}\\s#(\\d+)`);let a=0;for(const t of b){const r=s.exec(t.name),i=r?parseInt(r[1]):0;a=i>a?i:a}return`${p} #${a+1}`}async readMachinesData(b){this.userData=await this.readUserData(b);const I=this.parse(this.userData);if(I.version!==Ge.VERSION)throw new Error(w.localize(0,null,this.productService.nameLong));return I}async writeMachinesData(b){const I=JSON.stringify(b),p=await this.userDataSyncStoreService.write(Ge.RESOURCE,I,this.userData?.ref||null);this.userData={ref:p,content:I},this._onDidChange.fire()}async readUserData(b){if(this.userData){const I=b&&b.latest?b.latest[Ge.RESOURCE]:void 0;if(this.userData.ref===I)return this.userData;if(I===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ge.RESOURCE,this.userData)}parse(b){if(b.content!==null)try{return JSON.parse(b.content)}catch(I){this.logService.error(I)}return{version:Ge.VERSION,machines:[]}}};C.VERSION=1,C.RESOURCE="machines",C=de([Y(0,A.IEnvironmentService),Y(1,O.IFileService),Y(2,P.IStorageService),Y(3,S.IUserDataSyncStoreService),Y(4,S.IUserDataSyncLogService),Y(5,n.IProductService)],C),e.UserDataSyncMachinesService=C}),define(Z[86],ee([0,1,6,3,2,22,60,24,11,21,9,61,126,55,5,14,7,27]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h,C,D,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const I="sync.enable",p="sync.disableMachineEventually",s="sync.sessionId",a="sync.storeUrl",t="sync.productQuality";let r=class extends L.Disposable{constructor(c,l,y){super();this.storageService=c,this.environmentService=l,this.userDataSyncStoreManagementService=y,this._onDidChangeEnablement=new k.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(c.onDidChangeValue(E=>this.onDidStorageChange(E)))}isEnabled(c){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(I,0,!!c)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(c){c&&!this.canToggleEnablement()||this.storageService.store(I,c,0,1)}onDidStorageChange(c){if(c.scope===0&&I===c.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};r=de([Y(0,w.IStorageService),Y(1,n.IEnvironmentService),Y(2,A.IUserDataSyncStoreManagementService)],r),e.UserDataAutoSyncEnablementService=r;let i=class extends L.Disposable{constructor(c,l,y,E,f,U,F,z,$,H,V){super();this.userDataSyncStoreManagementService=l,this.userDataSyncStoreService=y,this.userDataSyncResourceEnablementService=E,this.userDataSyncService=f,this.logService=U,this.userDataSyncAccountService=F,this.telemetryService=z,this.userDataSyncMachinesService=$,this.storageService=H,this.autoSync=this._register(new L.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=V,this.syncTriggerDelayer=this._register(new v.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=l.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=c.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(l.onDidChangeUserDataSyncStore(()=>{C.isEqual(this.syncUrl,l.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=l.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(F.onDidChangeAccount(()=>this.updateAutoSync())),this._register(y.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(k.Event.debounce(f.onDidChangeLocal,(_,x)=>_?[..._,x]:[x],1e3)(_=>this.triggerSync(_,!1,!1))),this._register(k.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,_])=>_)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const c=this.storageService.get(a,0);return c?h.URI.parse(c):void 0}set syncUrl(c){c?this.storageService.store(a,c.toString(),0,1):this.storageService.remove(a,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(c){c?this.storageService.store(t,c,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:c,message:l}=this.isAutoSyncEnabled();c?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(y=>this.onDidFinishSync(y))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(l&&this.logService.info(l),this.autoSync.clear()):l&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(l))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${g.toLocalISOString(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(c,l,y){try{this.userDataSyncAccountService.account&&!y&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(s,0),c?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(E){if(l)this.logService.error(E),this.updateEnablement(!1);else throw E}}updateEnablement(c){this.userDataAutoSyncEnablementService.isEnabled()!==c&&(this.telemetryService.publicLog2(I,{enabled:c}),this.userDataAutoSyncEnablementService.setEnablement(c),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(c){if(!c){this.successiveFailures=0;return}const l=A.UserDataSyncError.toUserDataSyncError(c);l instanceof A.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:l.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),l.code===A.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):l.code===A.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):l.code===A.UserDataSyncErrorCode.LocalTooManyRequests||l.code===A.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):l.code===A.UserDataSyncErrorCode.UpgradeRequired||l.code===A.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):l.code===A.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with newer version than of client. Requires client upgrade.`)):l.code===A.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${l.resource} content with older version than of client. Requires server reset.`)):l.code===A.UserDataSyncErrorCode.ServiceChanged||l.code===A.UserDataSyncErrorCode.DefaultServiceChanged?D.isWeb&&l.code===A.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(l),this.successiveFailures++),this._onError.fire(l)}async disableMachineEventually(){this.storageService.store(p,!0,0,1),await v.timeout(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(p,0,!1)}stopDisableMachineEventually(){this.storageService.remove(p,0)}async triggerSync(c,l,y){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(l&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...c),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",y)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};i=de([Y(0,b.IProductService),Y(1,A.IUserDataSyncStoreManagementService),Y(2,A.IUserDataSyncStoreService),Y(3,A.IUserDataSyncResourceEnablementService),Y(4,A.IUserDataSyncService),Y(5,A.IUserDataSyncLogService),Y(6,O.IUserDataSyncAccountService),Y(7,P.ITelemetryService),Y(8,m.IUserDataSyncMachinesService),Y(9,w.IStorageService),Y(10,A.IUserDataAutoSyncEnablementService)],i),e.UserDataAutoSyncService=i;class o extends L.Disposable{constructor(c,l,y,E,f,U,F,z){super();this.lastSyncUrl=c,this.interval=l,this.userDataSyncStoreManagementService=y,this.userDataSyncStoreService=E,this.userDataSyncService=f,this.userDataSyncMachinesService=U,this.logService=F,this.storageService=z,this.intervalHandler=this._register(new L.MutableDisposable),this._onDidStartSync=this._register(new k.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new k.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register(L.toDisposable(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=v.disposableTimeout(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(c,l){const y=v.createCancelablePromise(async E=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(f){if(S.isPromiseCanceledError(f))return}return this.doSync(c,l,E)});return this.syncPromise=y,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!C.isEqual(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const c=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),l=this.userDataSyncStoreManagementService.userDataSyncStore;return!!l&&!!c&&(!C.isEqual(l.defaultUrl,c.defaultUrl)||!C.isEqual(l.insidersUrl,c.insidersUrl)||!C.isEqual(l.stableUrl,c.stableUrl))}async doSync(c,l,y){this.logService.info(`Auto Sync: Triggered by ${c}`),this._onDidStartSync.fire();let E;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(l),y.isCancellationRequested)return;let f=this.syncTask.manifest;if(f===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new A.UserDataAutoSyncError(d.localize(0,null),A.UserDataSyncErrorCode.DefaultServiceChanged):new A.UserDataAutoSyncError(d.localize(1,null),A.UserDataSyncErrorCode.ServiceChanged):new A.UserDataAutoSyncError(d.localize(2,null),A.UserDataSyncErrorCode.TurnedOff);const U=this.storageService.get(s,0);if(U&&f&&U!==f.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new A.UserDataAutoSyncError(d.localize(3,null),A.UserDataSyncErrorCode.DefaultServiceChanged):new A.UserDataAutoSyncError(d.localize(4,null),A.UserDataSyncErrorCode.ServiceChanged):new A.UserDataAutoSyncError(d.localize(5,null),A.UserDataSyncErrorCode.SessionExpired);const F=await this.userDataSyncMachinesService.getMachines(f||void 0);if(y.isCancellationRequested)return;const z=F.find($=>$.isCurrent);if(z?.disabled)throw new A.UserDataAutoSyncError(d.localize(6,null),A.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),f===null&&(f=await this.userDataSyncStoreService.manifest()),f&&f.session!==U&&this.storageService.store(s,f.session,0,1),y.isCancellationRequested)return;z||await this.userDataSyncMachinesService.addCurrentMachine(f||void 0)}catch(f){this.logService.error(f),E=f}this._onDidFinishSync.fire(E)}register(c){return super._register(c)}}o.INTERVAL_SYNCING="Interval"}),define(Z[198],ee([0,1,22,2,3,21,24,7]),function(K,e,v,k,L,A,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let S=class extends k.Disposable{constructor(n,m){super();this.storageService=n,this.telemetryService=m,this._onDidChangeResourceEnablement=new L.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(d=>this.onDidStorageChange(d)))}isResourceEnabled(n){return this.storageService.getBoolean(v.getEnablementKey(n),0,!0)}setResourceEnablement(n,m){if(this.isResourceEnabled(n)!==m){const d=v.getEnablementKey(n);this.telemetryService.publicLog2(d,{enabled:m}),this.storeResourceEnablement(d,m)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,m){this.storageService.store(n,m,0,P.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const m=v.ALL_SYNC_RESOURCES.filter(d=>v.getEnablementKey(d)===n.key)[0];if(m){this._onDidChangeResourceEnablement.fire([m,this.isResourceEnabled(m)]);return}}}};S=de([Y(0,A.IStorageService),Y(1,O.ITelemetryService)],S),e.UserDataSyncResourceEnablementService=S}),define(Z[199],ee([0,1,22,2,4,3,188,191,190,43,24,19,21,193,14,194,30,6,11]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h,C,D,b,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const p="sync.lastSyncTime";let s=class extends k.Disposable{constructor(i,o,u,c,l,y){super();this.userDataSyncStoreService=i,this.userDataSyncStoreManagementService=o,this.instantiationService=u,this.logService=c,this.telemetryService=l,this.storageService=y,this._status="uninitialized",this._onDidChangeStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new A.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new A.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new A.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new A.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(g.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(P.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(C.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(S.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(O.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(A.Event.any(...this.synchronisers.map(E=>A.Event.map(E.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(A.Event.any(...this.synchronisers.map(E=>A.Event.map(E.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(p,0,void 0),this.onDidChangeLocal=A.Event.any(...this.synchronisers.map(E=>A.Event.map(E.onDidChangeLocal,()=>E.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(i){await this.checkEnablement();const o=D.generateUuid();let u;try{const E=v.createSyncHeaders(o);i&&(E["Cache-Control"]="no-cache"),u=await this.userDataSyncStoreService.manifest(E)}catch(E){const f=v.UserDataSyncError.toUserDataSyncError(E);throw this.reportUserDataSyncError(f,o),f}let c=!1;const l=this;let y;return{manifest:u,run(){if(c)throw new Error("Can run a task only once");return y=b.createCancelablePromise(E=>l.sync(u,o,E)),y.finally(()=>y=void 0)},async stop(){if(y&&y.cancel(),l.status!=="idle")return l.stop()}}}async createManualSyncTask(){await this.checkEnablement();const i=D.generateUuid(),o=v.createSyncHeaders(i);let u;try{u=await this.userDataSyncStoreService.manifest(o)}catch(c){const l=v.UserDataSyncError.toUserDataSyncError(c);throw this.reportUserDataSyncError(l,i),l}return new a(i,u,o,this.synchronisers,this.logService)}async sync(i,o,u){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),u.isCancellationRequested)return;const c=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const l=v.createSyncHeaders(o);for(const y of this.synchronisers){if(u.isCancellationRequested)return;try{await y.sync(i,l)}catch(E){if(E instanceof v.UserDataSyncError)switch(E.code){case v.UserDataSyncErrorCode.TooLarge:throw new v.UserDataSyncError(E.message,E.code,y.resource);case v.UserDataSyncErrorCode.TooManyRequests:case v.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case v.UserDataSyncErrorCode.LocalTooManyRequests:case v.UserDataSyncErrorCode.Gone:case v.UserDataSyncErrorCode.UpgradeRequired:case v.UserDataSyncErrorCode.IncompatibleRemoteContent:case v.UserDataSyncErrorCode.IncompatibleLocalContent:throw E}const f=v.UserDataSyncError.toUserDataSyncError(E);this.reportUserDataSyncError(f,o),this.logService.error(E),this.logService.error(`${y.resource}: ${w.toErrorMessage(E)}`),this._syncErrors.push([y.resource,f])}}this.logService.info(`Sync done. Took ${new Date().getTime()-c}ms`),this.updateLastSyncTime()}catch(l){const y=v.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(y,o),y}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}async stop(){if(this.status!=="idle")for(const i of this.synchronisers)try{i.status!=="idle"&&await i.stop()}catch(o){this.logService.error(o)}}async replace(i){await this.checkEnablement();for(const o of this.synchronisers)if(await o.replace(i))return}async accept(i,o,u,c){await this.checkEnablement();const l=this.getSynchroniser(i);await l.accept(o,u),c&&await l.apply(!1,v.createSyncHeaders(D.generateUuid()))}async resolveContent(i){for(const o of this.synchronisers){const u=await o.resolveContent(i);if(u)return u}return null}getRemoteSyncResourceHandles(i){return this.getSynchroniser(i).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(i){return this.getSynchroniser(i).getLocalSyncResourceHandles()}getAssociatedResources(i,o){return this.getSynchroniser(i).getAssociatedResources(o)}getMachineId(i,o){return this.getSynchroniser(i).getMachineId(o)}async hasLocalData(){const i=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const o of i)if(await o.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(i){this.logService.error(i)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(p,0);for(const i of this.synchronisers)try{await i.resetLocal()}catch(o){this.logService.error(`${i.resource}: ${w.toErrorMessage(o)}`),this.logService.error(o)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const i of this.synchronisers)if(await i.hasPreviouslySynced())return!0;return!1}setStatus(i){const o=this._status;this._status!==i&&(this._status=i,this._onDidChangeStatus.fire(i),o==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const i=this.computeStatus();this.setStatus(i)}updateConflicts(){const i=this.computeConflicts();m.equals(this._conflicts,i,([o,u],[c,l])=>o===o&&m.equals(u,l,(y,E)=>h.isEqual(y.previewResource,E.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(i))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(p,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(i,o){this.telemetryService.publicLog2("sync/error",{code:i.code,url:i instanceof v.UserDataSyncStoreError?i.url:void 0,resource:i.resource,executionId:o,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(i=>i.status==="hasConflicts").map(i=>[i.resource,i.conflicts.map(t)])}getSynchroniser(i){return this.synchronisers.find(o=>o.resource===i)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};s=de([Y(0,v.IUserDataSyncStoreService),Y(1,v.IUserDataSyncStoreManagementService),Y(2,L.IInstantiationService),Y(3,v.IUserDataSyncLogService),Y(4,n.ITelemetryService),Y(5,d.IStorageService)],s),e.UserDataSyncService=s;class a extends k.Disposable{constructor(i,o,u,c,l){super();this.id=i,this.manifest=o,this.syncHeaders=u,this.synchronisers=c,this.logService=l,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new A.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(i=>i.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(i=>i.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=b.createCancelablePromise(i=>this.getPreviews(i))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(i){throw this.logService.error(i),i}}async accept(i,o){try{return await this.performAction(i,u=>u.accept(i,o))}catch(u){throw this.logService.error(u),u}}async merge(i){try{return i?await this.performAction(i,o=>o.merge(i)):await this.mergeAll()}catch(o){throw this.logService.error(o),o}}async discard(i){try{return await this.performAction(i,o=>o.discard(i))}catch(o){throw this.logService.error(o),o}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const i=[];for(const[,o]of this.previews)for(const u of o.resourcePreviews)u.mergeState==="conflict"&&i.push(u.previewResource);for(const o of i)await this.discard(o);return this.previews}catch(i){throw this.logService.error(i),i}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const i=[];for(const[o,u]of this.previews){this.synchronizingResources.push([o,u.resourcePreviews.map(y=>y.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(y=>y.resource===o);for(const y of u.resourcePreviews)(y.localChange!==0||y.remoteChange!==0)&&y.mergeState==="preview"&&await c.merge(y.previewResource);const l=await c.apply(!1,this.syncHeaders);l&&i.push(this.toSyncResourcePreview(c.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(y=>y[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}catch(i){throw this.logService.error(i),i}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,o]of this.previews){this.synchronizingResources.push([i,o.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(c=>c.resource===i);for(const c of o.resourcePreviews)await u.accept(c.remoteResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[i,o]of this.previews){this.synchronizingResources.push([i,o.resourcePreviews.map(c=>c.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const u=this.synchronisers.find(c=>c.resource===i);for(const c of o.resourcePreviews)await u.accept(c.localResource);await u.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(c=>c[0]===i),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(i){throw this.logService.error(i),i}}async stop(){for(const i of this.synchronisers)try{await i.stop()}catch(o){I.isPromiseCanceledError(o)||this.logService.error(o)}this.reset()}async performAction(i,o){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const u=this.previews.findIndex(([,z])=>z.resourcePreviews.some(({localResource:$,previewResource:H,remoteResource:V})=>h.isEqual(i,$)||h.isEqual(i,H)||h.isEqual(i,V)));if(u===-1)return this.previews;const[c,l]=this.previews[u],y=l.resourcePreviews.find(({localResource:z,remoteResource:$,previewResource:H})=>h.isEqual(z,i)||h.isEqual($,i)||h.isEqual(H,i));if(!y)return this.previews;let E=this.synchronizingResources.find(z=>z[0]===c);E||(E=[c,[]],this.synchronizingResources.push(E)),E[1].some(z=>h.isEqual(z,y.localResource))||(E[1].push(y.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const f=this.synchronisers.find(z=>z.resource===this.previews[u][0]),U=await o(f);U?this.previews.splice(u,1,this.toSyncResourcePreview(f.resource,U)):this.previews.splice(u,1);const F=this.synchronizingResources.findIndex(z=>z[0]===c);return this.synchronizingResources[F][1].splice(E[1].findIndex(z=>h.isEqual(z,y.localResource)),1),E[1].length||(this.synchronizingResources.splice(F,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const i=[];for(const[o,u]of this.previews){this.synchronizingResources.push([o,u.resourcePreviews.map(y=>y.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(y=>y.resource===o);let l=u;for(const y of u.resourcePreviews)(y.localChange!==0||y.remoteChange!==0)&&y.mergeState==="preview"&&(l=await c.merge(y.previewResource));l&&i.push(this.toSyncResourcePreview(c.resource,l)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(y=>y[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=i,this.previews}async getPreviews(i){const o=[];for(const u of this.synchronisers){if(i.isCancellationRequested)return[];const c=await u.preview(this.manifest,this.syncHeaders);c&&o.push(this.toSyncResourcePreview(u.resource,c))}return o}toSyncResourcePreview(i,o){return[i,{isLastSyncFromCurrentMachine:o.isLastSyncFromCurrentMachine,resourcePreviews:o.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(r){return{localResource:r.localResource,previewResource:r.previewResource,remoteResource:r.remoteResource,acceptedResource:r.acceptedResource,localChange:r.localChange,remoteChange:r.remoteChange,mergeState:r.mergeState}}}),define(Z[200],ee([0,1,3,22,5,2,16]),function(K,e,v,k,L,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class P{constructor(m,d){this.service=m,this.logService=d,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new v.Emitter}listen(m,d){switch(d){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${d}`)}async call(m,d,g){try{return await this._call(m,d,g)}catch(h){throw this.logService.error(h),h}}async _call(m,d,g){switch(d){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(L.URI.revive(g[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(g[0],L.URI.revive(g[1]),g[2],g[3]);case"resolveContent":return this.service.resolveContent(L.URI.revive(g[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(g[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(g[0]);case"getAssociatedResources":return this.service.getAssociatedResources(g[0],{created:g[1].created,uri:L.URI.revive(g[1].uri)});case"getMachineId":return this.service.getMachineId(g[0],{created:g[1].created,uri:L.URI.revive(g[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(d.startsWith("manualSync/")){const h=d.substring("manualSync/".length),C=g[0],D=this.getManualSyncTask(C);switch(g=g.slice(1),h){case"preview":return D.preview();case"accept":return D.accept(L.URI.revive(g[0]),g[1]);case"merge":return D.merge(L.URI.revive(g[0]));case"discard":return D.discard(L.URI.revive(g[0]));case"discardConflicts":return D.discardConflicts();case"apply":return D.apply();case"pull":return D.pull();case"push":return D.push();case"stop":return D.stop();case"_getStatus":return D.status;case"dispose":return this.disposeManualSyncTask(D)}}throw new Error("Invalid call")}getManualSyncTask(m){const d=this.manualSyncTasks.get(this.createKey(m));if(!d)throw new Error(`Manual sync taks not found: ${m}`);return d.manualSyncTask}async createManualSyncTask(){const m=new A.DisposableStore,d=m.add(await this.service.createManualSyncTask());return m.add(d.onSynchronizeResources(g=>this.onManualSynchronizeResources.fire({manualSyncTaskId:d.id,data:g}))),this.manualSyncTasks.set(this.createKey(d.id),{manualSyncTask:d,disposables:m}),{id:d.id,manifest:d.manifest,status:d.status}}disposeManualSyncTask(m){m.dispose();const d=this.createKey(m.id);this.manualSyncTasks.get(d)?.disposables.dispose(),this.manualSyncTasks.delete(d)}createKey(m){return`manualSyncTask-${m}`}}e.UserDataSyncChannel=P;class S extends A.Disposable{constructor(m){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new v.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new v.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new v.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new v.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(d,g,h){return m.call(d,g,h).then(null,C=>{throw k.UserDataSyncError.toUserDataSyncError(C)})},listen(d,g){return m.listen(d,g)}},this.channel.call("_getInitialData").then(([d,g,h])=>{this.updateStatus(d),this.updateConflicts(g),h&&this.updateLastSyncTime(h),this._register(this.channel.listen("onDidChangeStatus")(C=>this.updateStatus(C))),this._register(this.channel.listen("onDidChangeLastSyncTime")(C=>this.updateLastSyncTime(C)))}),this._register(this.channel.listen("onDidChangeConflicts")(d=>this.updateConflicts(d))),this._register(this.channel.listen("onSyncErrors")(d=>this._onSyncErrors.fire(d.map(([g,h])=>[g,k.UserDataSyncError.toUserDataSyncError(h)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:m,manifest:d,status:g}=await this.channel.call("createManualSyncTask"),h=this,C=new w(m,d,g,{async call(D,b,I){return h.channel.call(`manualSync/${D}`,[m,...O.isArray(b)?b:[b]],I)},listen(D,b){return v.Event.map(v.Event.filter(h.channel.listen(`manualSync/${D}`,b),I=>!C.isDiposed()&&I.manualSyncTaskId===m),I=>I.data)}});return C}replace(m){return this.channel.call("replace",[m])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(m,d,g,h){return this.channel.call("accept",[m,d,g,h])}resolveContent(m){return this.channel.call("resolveContent",[m])}async getLocalSyncResourceHandles(m){return(await this.channel.call("getLocalSyncResourceHandles",[m])).map(({created:g,uri:h})=>({created:g,uri:L.URI.revive(h)}))}async getRemoteSyncResourceHandles(m){return(await this.channel.call("getRemoteSyncResourceHandles",[m])).map(({created:g,uri:h})=>({created:g,uri:L.URI.revive(h)}))}async getAssociatedResources(m,d){return(await this.channel.call("getAssociatedResources",[m,d])).map(({resource:h,comparableResource:C})=>({resource:L.URI.revive(h),comparableResource:L.URI.revive(C)}))}async getMachineId(m,d){return this.channel.call("getMachineId",[m,d])}async updateStatus(m){this._status=m,this._onDidChangeStatus.fire(m)}async updateConflicts(m){this._conflicts=m.map(([d,g])=>[d,g.map(h=>({...h,localResource:L.URI.revive(h.localResource),remoteResource:L.URI.revive(h.remoteResource),previewResource:L.URI.revive(h.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(m){this._lastSyncTime!==m&&(this._lastSyncTime=m,this._onDidChangeLastSyncTime.fire(m))}}e.UserDataSyncChannelClient=S;class w extends A.Disposable{constructor(m,d,g,h){super();this.id=m,this.manifest=d,this._disposed=!1,this._status=g;const C=this;this.channel={async call(D,b,I){try{const p=await h.call(D,b,I);return C.isDiposed()||(C._status=await h.call("_getStatus")),p}catch(p){throw k.UserDataSyncError.toUserDataSyncError(p)}},listen(D,b){return h.listen(D,b)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const m=await this.channel.call("preview");return this.deserializePreviews(m)}async accept(m,d){const g=await this.channel.call("accept",[m,d]);return this.deserializePreviews(g)}async merge(m){const d=await this.channel.call("merge",[m]);return this.deserializePreviews(d)}async discard(m){const d=await this.channel.call("discard",[m]);return this.deserializePreviews(d)}async discardConflicts(){const m=await this.channel.call("discardConflicts");return this.deserializePreviews(m)}async apply(){const m=await this.channel.call("apply");return this.deserializePreviews(m)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(m){return m.map(([d,g])=>[d,{isLastSyncFromCurrentMachine:g.isLastSyncFromCurrentMachine,resourcePreviews:g.resourcePreviews.map(h=>({...h,localResource:L.URI.revive(h.localResource),remoteResource:L.URI.revive(h.remoteResource),previewResource:L.URI.revive(h.previewResource),acceptedResource:L.URI.revive(h.acceptedResource)}))}])}}}),define(Z[201],ee([0,1,2,22,39,14,29,23,27,44,9,10,21,30,7,3,6,16,5,11,92]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h,C,D,b,I,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const a="sync.previous.store",t="sync.donot-make-requests-until",r="sync.user-session-id",i="sync.machine-session-id",o=100,u=1e3*60*5;let c=class extends v.Disposable{constructor(F,z,$){super();this.productService=F,this.configurationService=z,this.storageService=$,this._onDidChangeUserDataSyncStore=this._register(new C.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(C.Event.filter($.onDidChangeValue,H=>H.key===k.SYNC_SERVICE_URL_TYPE&&H.scope===0&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(k.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(F){this.storageService.store(k.SYNC_SERVICE_URL_TYPE,F,0,h.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[k.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(k.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(F,z){F=h.isWeb&&F?.web?{...F,...F.web}:F;const $={...F||{},...z||{}};if($&&b.isString($.url)&&b.isObject($.authenticationProviders)&&Object.keys($.authenticationProviders).every(H=>b.isArray($.authenticationProviders[H].scopes))){const H=$,V=!!H.canSwitch&&!z?.url,_=H.url===H.insidersUrl?"insiders":"stable",x=(V?this.userDataSyncStoreType:void 0)||_,j=z?.url||(x==="insiders"?H.insidersUrl:x==="stable"?H.stableUrl:H.url);return{url:I.URI.parse(j),type:x,defaultType:_,defaultUrl:I.URI.parse(H.url),stableUrl:I.URI.parse(H.stableUrl),insidersUrl:I.URI.parse(H.insidersUrl),canSwitch:V,authenticationProviders:Object.keys(H.authenticationProviders).reduce((q,R)=>(q.push({id:R,scopes:H.authenticationProviders[R].scopes}),q),[])}}}};c=de([Y(0,S.IProductService),Y(1,P.IConfigurationService),Y(2,d.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let l=class extends c{constructor(F,z,$){super(F,z,$);const H=this.storageService.get(a,0);H&&(this.previousConfigurationSyncStore=JSON.parse(H));const V=this.productService[k.CONFIGURATION_SYNC_STORE_KEY];V?this.storageService.store(a,JSON.stringify(V),0,1):this.storageService.remove(a,0)}async switch(F){F!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=F,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=de([Y(0,S.IProductService),Y(1,P.IConfigurationService),Y(2,d.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let y=class extends v.Disposable{constructor(F,z,$,H,V,_,x){super();this.requestService=$,this.logService=H,this.storageService=x,this._onTokenFailed=this._register(new C.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new C.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new C.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(F),this.commonHeadersPromise=w.getServiceMachineId(V,_,x).then(j=>{const q={"X-Client-Name":`${z.applicationName}${h.isWeb?"-web":""}`,"X-Client-Version":z.version,"X-Machine-Id":j};return z.commit&&(q["X-Client-Commit"]=z.commit),q}),this.session=new f(o,u,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register(v.toDisposable(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(F,z){this.authToken={token:F,type:z}}updateUserDataSyncStoreUrl(F){this.userDataSyncStoreUrl=F?A.joinPath(F,"v1"):void 0}initDonotMakeRequestsUntil(){const F=this.storageService.getNumber(t,0);F&&Date.now()<F&&this.setDonotMakeRequestsUntil(new Date(F))}setDonotMakeRequestsUntil(F){this._donotMakeRequestsUntil?.getTime()!==F?.getTime()&&(this._donotMakeRequestsUntil=F,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(t,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=D.createCancelablePromise(z=>D.timeout(this._donotMakeRequestsUntil.getTime()-Date.now(),z).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,z=>null)):this.storageService.remove(t,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=A.joinPath(this.userDataSyncStoreUrl,"resource",F),$={},H=await this.request(z.toString(),{type:"GET",headers:$},[],O.CancellationToken.None);return(await L.asJson(H)||[]).map(({url:_,created:x})=>({ref:A.relativePath(z,z.with({path:_})),created:x*1e3}))}async resolveContent(F,z){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const $=A.joinPath(this.userDataSyncStoreUrl,"resource",F,z).toString(),H={};H["Cache-Control"]="no-cache";const V=await this.request($,{type:"GET",headers:H},[],O.CancellationToken.None);return await L.asText(V)}async delete(F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=A.joinPath(this.userDataSyncStoreUrl,"resource",F).toString(),$={};await this.request(z,{type:"DELETE",headers:$},[],O.CancellationToken.None)}async read(F,z,$={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const H=A.joinPath(this.userDataSyncStoreUrl,"resource",F,"latest").toString();$={...$},$["Cache-Control"]="no-cache",z&&($["If-None-Match"]=z.ref);const V=await this.request(H,{type:"GET",headers:$},[304],O.CancellationToken.None);if(V.res.statusCode===304)return z;const _=V.res.headers.etag;if(!_)throw new k.UserDataSyncStoreError("Server did not return the ref",H,k.UserDataSyncErrorCode.NoRef,V.res.headers[k.HEADER_OPERATION_ID]);const x=await L.asText(V);return{ref:_,content:x}}async write(F,z,$,H={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const V=A.joinPath(this.userDataSyncStoreUrl,"resource",F).toString();H={...H},H["Content-Type"]=s.Mimes.text,$&&(H["If-Match"]=$);const _=await this.request(V,{type:"POST",data:z,headers:H},[],O.CancellationToken.None),x=_.res.headers.etag;if(!x)throw new k.UserDataSyncStoreError("Server did not return the ref",V,k.UserDataSyncErrorCode.NoRef,_.res.headers[k.HEADER_OPERATION_ID]);return x}async manifest(F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const z=A.joinPath(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json";const $=await this.request(z,{type:"GET",headers:F},[],O.CancellationToken.None),H=await L.asJson($),V=this.storageService.get(r,0);return V&&H&&V!==H.session&&this.clearSession(),H===null&&V&&this.clearSession(),H&&this.storageService.store(r,H.session,0,1),H}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=A.joinPath(this.userDataSyncStoreUrl,"resource").toString(),z={"Content-Type":s.Mimes.text};await this.request(F,{type:"DELETE",headers:z},[],O.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,0),this.storageService.remove(i,0)}async request(F,z,$,H){if(!this.authToken)throw new k.UserDataSyncStoreError("No Auth Token Available",F,k.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new k.UserDataSyncStoreError(`${z.type} request '${F}' failed because of too many requests (429).`,F,k.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const V=await this.commonHeadersPromise;z.headers={...z.headers||{},...V,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(z.headers),this.logService.trace("Sending request to server",{url:F,type:z.type,headers:{...z.headers,authorization:void 0}});let _;try{_=await this.session.request(F,z,H)}catch(R){if(!(R instanceof k.UserDataSyncStoreError)){const T=p.isPromiseCanceledError(R)?k.UserDataSyncErrorCode.RequestCanceled:p.getErrorMessage(R).startsWith("XHR timeout")?k.UserDataSyncErrorCode.RequestTimeout:k.UserDataSyncErrorCode.RequestFailed;R=new k.UserDataSyncStoreError(`Connection refused for the request '${F}'.`,F,T,void 0)}throw this.logService.info("Request failed",F),R}const x=_.res.headers[k.HEADER_OPERATION_ID],j={url:F,status:_.res.statusCode,"execution-id":z.headers[k.HEADER_EXECUTION_ID],"operation-id":x},q=L.isSuccess(_)||_.res.statusCode&&$.indexOf(_.res.statusCode)!==-1;if(q?this.logService.trace("Request succeeded",j):this.logService.info("Request failed",j),_.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new k.UserDataSyncStoreError(`Request '${F}' failed because of Unauthorized (401).`,F,k.UserDataSyncErrorCode.Unauthorized,x);if(this._onTokenSucceed.fire(),_.res.statusCode===409)throw new k.UserDataSyncStoreError(`${z.type} request '${F}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,F,k.UserDataSyncErrorCode.Conflict,x);if(_.res.statusCode===410)throw new k.UserDataSyncStoreError(`${z.type} request '${F}' failed because the requested resource is not longer available (410).`,F,k.UserDataSyncErrorCode.Gone,x);if(_.res.statusCode===412)throw new k.UserDataSyncStoreError(`${z.type} request '${F}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,F,k.UserDataSyncErrorCode.PreconditionFailed,x);if(_.res.statusCode===413)throw new k.UserDataSyncStoreError(`${z.type} request '${F}' failed because of too large payload (413).`,F,k.UserDataSyncErrorCode.TooLarge,x);if(_.res.statusCode===426)throw new k.UserDataSyncStoreError(`${z.type} request '${F}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,F,k.UserDataSyncErrorCode.UpgradeRequired,x);if(_.res.statusCode===429){const R=_.res.headers["retry-after"];throw R?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(R)*1e3)),new k.UserDataSyncStoreError(`${z.type} request '${F}' failed because of too many requests (429).`,F,k.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,x)):new k.UserDataSyncStoreError(`${z.type} request '${F}' failed because of too many requests (429).`,F,k.UserDataSyncErrorCode.TooManyRequests,x)}if(!q)throw new k.UserDataSyncStoreError("Server returned "+_.res.statusCode,F,k.UserDataSyncErrorCode.Unknown,x);return _}addSessionHeaders(F){let z=this.storageService.get(i,0);z===void 0&&(z=g.generateUuid(),this.storageService.store(i,z,0,1)),F["X-Machine-Session-Id"]=z;const $=this.storageService.get(r,0);$!==void 0&&(F["X-User-Session-Id"]=$)}};y=de([Y(1,S.IProductService),Y(2,L.IRequestService),Y(3,k.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,m.IFileService),Y(6,d.IStorageService)],y),e.UserDataSyncStoreClient=y;let E=class extends y{constructor(F,z,$,H,V,_,x){super(F.userDataSyncStore?.url,z,$,H,V,_,x);this._register(F.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(F.userDataSyncStore?.url)))}};E=de([Y(0,k.IUserDataSyncStoreManagementService),Y(1,S.IProductService),Y(2,L.IRequestService),Y(3,k.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,m.IFileService),Y(6,d.IStorageService)],E),e.UserDataSyncStoreService=E;class f{constructor(F,z,$,H){this.limit=F,this.interval=z,this.requestService=$,this.logService=H,this.requests=[],this.startTime=void 0}request(F,z,$){if(this.isExpired()&&this.reset(),z.url=F,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new k.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,F,k.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(F),this.requestService.request(z,$)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=f}),define(Z[202],ee([0,1,22,3,58,86,60,24,21,61,27]),function(K,e,v,k,L,A,O,P,S,w,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let m=class extends A.UserDataAutoSyncService{constructor(g,h,C,D,b,I,p,s,a,t,r,i){super(g,h,C,D,b,p,s,a,t,r,i);this._register(k.Event.debounce(k.Event.any(k.Event.map(I.onDidFocusWindow,()=>"windowFocus"),k.Event.map(I.onDidOpenWindow,()=>"windowOpen")),(o,u)=>o?[...o,u]:[u],1e3)(o=>this.triggerSync(o,!0,!1)))}};m=de([Y(0,n.IProductService),Y(1,v.IUserDataSyncStoreManagementService),Y(2,v.IUserDataSyncStoreService),Y(3,v.IUserDataSyncResourceEnablementService),Y(4,v.IUserDataSyncService),Y(5,L.INativeHostService),Y(6,v.IUserDataSyncLogService),Y(7,O.IUserDataSyncAccountService),Y(8,P.ITelemetryService),Y(9,w.IUserDataSyncMachinesService),Y(10,S.IStorageService),Y(11,v.IUserDataAutoSyncEnablementService)],m),e.UserDataAutoSyncService=m}),define(Z[203],ee([0,1,3,2,6]),function(K,e,v,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class A extends k.Disposable{constructor({onDidOpenWindow:P,onDidFocusWindow:S,getActiveWindowId:w}){super();this.disposables=this._register(new k.DisposableStore),v.Event.latch(v.Event.any(P,S))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=L.createCancelablePromise(()=>w()),(async()=>{try{const m=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:m}catch(m){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(P){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=P}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=A}),define(Z[62],ee([0,1,108,8,48,6,18,210,211,16]),function(K,e,v,k,L,A,O,P,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,r){let i=r.message;switch(t){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i);this.type=t,this.cause=r}}e.ExtractError=n;function m(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(r=>t&r).reduce((r,i)=>r+i,t&61440)}function d(a){if(a instanceof n)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new n(t,a)}function g(a,t,r,i,o,u){const c=k.dirname(t),l=k.join(i,c);if(!l.startsWith(i))return Promise.reject(new Error(v.localize(0,null,t)));const y=k.join(i,t);let E;return u.onCancellationRequested(()=>{E&&E.destroy()}),Promise.resolve(O.Promises.mkdir(l,{recursive:!0})).then(()=>new Promise((f,U)=>{if(!u.isCancellationRequested)try{E=L.createWriteStream(y,{mode:r}),E.once("close",()=>f()),E.once("error",U),a.once("error",U),a.pipe(E)}catch(F){U(F)}}))}function h(a,t,r,i){let o=A.createCancelablePromise(()=>Promise.resolve()),u=0;return i.onCancellationRequested(()=>{o.cancel(),a.close()}),new Promise((c,l)=>{const y=new A.Sequencer,E=f=>{f.isCancellationRequested||(u++,a.readEntry())};a.once("error",l),a.once("close",()=>o.then(()=>{i.isCancellationRequested||a.entryCount===u?c():l(new n("Incomplete",new Error(v.localize(1,null,u,a.entryCount))))},l)),a.readEntry(),a.on("entry",f=>{if(i.isCancellationRequested)return;if(!r.sourcePathRegex.test(f.fileName)){E(i);return}const U=f.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(U)){const $=k.join(t,U);o=A.createCancelablePromise(H=>O.Promises.mkdir($,{recursive:!0}).then(()=>E(H)).then(void 0,l));return}const F=D(a,f),z=m(f);o=A.createCancelablePromise($=>y.queue(()=>F.then(H=>g(H,U,z,t,r,$).then(()=>E($)))).then(null,l))})})}function C(a,t=!1){return new Promise((r,i)=>{P.open(a,t?{lazyEntries:!0}:void 0,(o,u)=>{o?i(d(o)):r(w.assertIsDefined(u))})})}function D(a,t){return new Promise((r,i)=>{a.openReadStream(t,(o,u)=>{o?i(d(o)):r(w.assertIsDefined(u))})})}function b(a,t){return new Promise((r,i)=>{const o=new S.ZipFile;t.forEach(c=>{c.contents?o.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&o.addFile(c.localPath,c.path)}),o.end();const u=L.createWriteStream(a);o.outputStream.pipe(u),o.outputStream.once("error",i),u.once("error",i),u.once("finish",()=>r(a))})}e.zip=b;function I(a,t,r={},i){const o=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let u=C(a,!0);return r.overwrite&&(u=u.then(c=>O.Promises.rm(t).then(()=>c))),u.then(c=>h(c,t,{sourcePathRegex:o},i))}e.extract=I;function p(a,t){return C(a).then(r=>new Promise((i,o)=>{r.on("entry",u=>{u.fileName===t&&D(r,u).then(c=>i(c),c=>o(c))}),r.once("close",()=>o(new Error(v.localize(2,null,t))))}))}function s(a,t){return p(a,t).then(r=>new Promise((i,o)=>{const u=[];r.once("error",o),r.on("data",c=>u.push(c)),r.on("end",()=>i(Buffer.concat(u)))}))}e.buffer=s}),define(Z[204],ee([0,1,62,113]),function(K,e,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function L(A){return v.buffer(A,"extension/package.json").then(O=>{try{return JSON.parse(O.toString("utf8"))}catch(P){throw new Error(k.localize(0,null))}})}e.getManifest=L}),define(Z[205],ee([0,1,57,2,18,8,15,28,33,6,5,9,134,114,27,62,7,19,17,10,14,30,11]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h,C,D,b,I,p,s,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",i="scanningUser",o="extracting",u="deleting",c="renaming";let l=class extends k.Disposable{constructor(E,f,U,F,z){super();this.beforeRemovingExtension=E,this.fileService=f,this.logService=U,this.environmentService=F,this.productService=z,this._devSystemExtensionsPath=null,this.systemExtensionsPath=F.builtinExtensionsPath,this.extensionsPath=F.extensionsPath,this.uninstalledPath=A.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new w.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(E){const f=[];(E===null||E===0)&&f.push(this.scanSystemExtensions().then(null,U=>Promise.reject(new P.ExtensionManagementError(this.joinErrors(U).message,r)))),(E===null||E===1)&&f.push(this.scanUserExtensions(!0).then(null,U=>Promise.reject(new P.ExtensionManagementError(this.joinErrors(U).message,i))));try{const U=await Promise.all(f);return b.flatten(U)}catch(U){throw this.joinErrors(U)}}async scanUserExtensions(E){this.logService.trace("Started scanning user extensions");let[f,U]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return U=U.filter(F=>!f[new S.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).key()]),E&&(U=S.groupByExtension(U,z=>z.identifier).map(z=>z.sort(($,H)=>v.rcompare($.manifest.version,H.manifest.version))[0])),this.logService.trace("Scanned user extensions:",U.length),U}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(E,f,U){const F=E.key(),z=A.join(this.extensionsPath,`.${a.generateUuid()}`),$=A.join(this.extensionsPath,F);try{await L.Promises.rm($)}catch(V){try{await L.Promises.rm($)}catch(_){}throw new P.ExtensionManagementError(g.localize(0,null,$,E.id),u)}await this.extractAtLocation(E,f,z,U);let H=await this.scanExtension(n.URI.file(z),1);if(!H)throw new Error(g.localize(1,null,z));await this.storeMetadata(H,{installedTimestamp:Date.now()});try{await this.rename(E,z,$,Date.now()+2*60*1e3),this.logService.info("Renamed to",$)}catch(V){try{await L.Promises.rm(z)}catch(_){}if(V.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",E.id);else throw this.logService.info(`Rename failed because of ${t.getErrorMessage(V)}. Deleted from extracted location`,z),V}try{H=await this.scanExtension(n.URI.file($),1)}catch(V){}if(H)return H;throw new Error(g.localize(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(E,f){return this.setMetadata(E,f),await this.storeMetadata(E,{...f,installedTimestamp:E.installedTimestamp}),E}async storeMetadata(E,f){f.isMachineScoped=f.isMachineScoped||void 0,f.isBuiltin=f.isBuiltin||void 0,f.installedTimestamp=f.installedTimestamp||void 0;const U=A.join(E.location.fsPath,"package.json"),F=await L.Promises.readFile(U,"utf8"),{manifest:z}=await this.parseManifest(F);return z.__metadata=f,await L.Promises.writeFile(U,JSON.stringify(z,null,"	")),E}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...E){const f=E.map(U=>new S.ExtensionIdentifierWithVersion(U.identifier,U.manifest.version));await this.withUninstalledExtensions(U=>{f.forEach(F=>U[F.key()]=!0)})}async setInstalled(E){await this.withUninstalledExtensions(F=>delete F[E.key()]);const U=(await this.scanExtensions(1)).find(F=>new S.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version).equals(E))||null;return U?(await this.storeMetadata(U,{installedTimestamp:Date.now()}),this.scanExtension(U.location,1)):null}async withUninstalledExtensions(E){return this.uninstalledFileLimiter.queue(async()=>{let f;try{f=await L.Promises.readFile(this.uninstalledPath,"utf8")}catch(F){if(F.code!=="ENOENT")throw F}let U={};if(f)try{U=JSON.parse(f)}catch(F){}return E&&(E(U),Object.keys(U).length?await L.Promises.writeFile(this.uninstalledPath,JSON.stringify(U)):await L.Promises.rm(this.uninstalledPath)),U})}async removeExtension(E,f){this.logService.trace(`Deleting ${f} extension from disk`,E.identifier.id,E.location.fsPath),await L.Promises.rm(E.location.fsPath),this.logService.info("Deleted from disk",E.identifier.id,E.location.fsPath)}async removeUninstalledExtension(E){await this.removeExtension(E,"uninstalled"),await this.withUninstalledExtensions(f=>delete f[new S.ExtensionIdentifierWithVersion(E.identifier,E.manifest.version).key()])}async extractAtLocation(E,f,U,F){this.logService.trace(`Started extracting the extension from ${f} to ${U}`);try{await L.Promises.rm(U)}catch(z){throw new P.ExtensionManagementError(this.joinErrors(z).message,u)}try{await C.extract(f,U,{sourcePath:"extension",overwrite:!0},F),this.logService.info(`Extracted extension to ${U}:`,E.id)}catch(z){try{await L.Promises.rm(U)}catch($){}throw new P.ExtensionManagementError(z.message,z instanceof C.ExtractError&&z.type?z.type:o)}}async rename(E,f,U,F){try{await L.Promises.rename(f,U)}catch(z){if(D.isWindows&&z&&z.code==="EPERM"&&Date.now()<F)return this.logService.info(`Failed renaming ${f} to ${U} with 'EPERM' error. Trying again...`,E.id),this.rename(E,f,U,F);throw new P.ExtensionManagementError(z.message||g.localize(3,null,f,U),z.code||c)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const E=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return E;const f=this.scanDevSystemExtensions(),[U,F]=await Promise.all([E,f]);return[...U,...F]}async scanExtensionsInDir(E,f){const U=new w.Limiter(10),F=await this.fileService.resolve(n.URI.file(E));return F.children?(await Promise.all(F.children.filter($=>$.isDirectory).map($=>U.queue(async()=>f===1&&s.basename($.resource).indexOf(".")===0?null:this.scanExtension($.resource,f))))).filter($=>$&&$.identifier):[]}async scanExtension(E,f){try{const U=await this.fileService.resolve(E);if(U.children){const{manifest:F,metadata:z}=await this.readManifest(E.fsPath),$=U.children.find(({name:x})=>/^readme(\.txt|\.md|)$/i.test(x))?.resource,H=U.children.find(({name:x})=>/^changelog(\.txt|\.md|)$/i.test(x))?.resource,V={id:S.getGalleryExtensionId(F.publisher,F.name)},_={type:f,identifier:V,manifest:F,location:E,readmeUrl:$,changelogUrl:H,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:f===0};return z&&(this.setMetadata(_,z),_.installedTimestamp=z.installedTimestamp),_}}catch(U){f!==0&&this.logService.trace(U)}return null}async scanDefaultSystemExtensions(){const E=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",E.length),E}async scanDevSystemExtensions(){const E=this.getDevSystemExtensionsList();if(E.length){const f=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",f.length),f.filter(U=>E.some(F=>S.areSameExtensions(U.identifier,{id:F})))}else return[]}setMetadata(E,f){E.publisherDisplayName=f.publisherDisplayName||null,E.publisherId=f.publisherId||null,E.identifier.uuid=f.id,E.isMachineScoped=!!f.isMachineScoped,E.isBuiltin=E.type===0||!!f.isBuiltin}async removeUninstalledExtensions(){const E=await this.getUninstalledExtensions(),f=await this.scanAllUserExtensions(),U=new Set;for(const $ of f)E[new S.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).key()]||U.add($.identifier.id.toLowerCase());const F=S.groupByExtension(f,$=>$.identifier);await w.Promises.settled(F.map(async $=>{const H=$.sort((V,_)=>v.rcompare(V.manifest.version,_.manifest.version))[0];U.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(H)}));const z=f.filter($=>E[new S.ExtensionIdentifierWithVersion($.identifier,$.manifest.version).key()]);await w.Promises.settled(z.map($=>this.removeUninstalledExtension($)))}async removeOutdatedExtensions(){const E=await this.scanAllUserExtensions(),f=[],U=S.groupByExtension(E,F=>F.identifier);f.push(...b.flatten(U.map(F=>F.sort((z,$)=>v.rcompare(z.manifest.version,$.manifest.version)).slice(1)))),await w.Promises.settled(f.map(F=>this.removeExtension(F,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(E=>E.name)}joinErrors(E){const f=Array.isArray(E)?E:[E];return f.length===1?f[0]instanceof Error?f[0]:new Error(f[0]):f.reduce((U,F)=>new Error(`${U.message}${U.message?",":""}${F instanceof Error?F.message:F}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=A.normalize(A.join(I.FileAccess.asFileUri("",K).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(E){const f=[L.Promises.readFile(A.join(E,"package.json"),"utf8").then($=>this.parseManifest($)),L.Promises.readFile(A.join(E,"package.nls.json"),"utf8").then(void 0,$=>$.code!=="ENOENT"?Promise.reject($):"{}").then($=>JSON.parse($))],[{manifest:U,metadata:F},z]=await Promise.all(f);return{manifest:d.localizeManifest(U,z),metadata:F}}parseManifest(E){return new Promise((f,U)=>{try{const F=JSON.parse(E),z=F.__metadata||null;f({manifest:F,metadata:z})}catch(F){U(new Error(g.localize(4,null)))}})}};l=de([Y(1,p.IFileService),Y(2,O.ILogService),Y(3,m.INativeEnvironmentService),Y(4,h.IProductService)],l),e.ExtensionsScanner=l}),define(Z[206],ee([0,1,112,8,18,2,19,62,28,33,9,6,3,57,5,51,7,15,145,43,24,70,14,30,72,4,17,29,204,155,205,156,157,10]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h,C,D,b,I,p,s,a,t,r,i,o,u,c,l,y,E,f,U,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const z="unsetUninstalled",$="downloading",H="validating",V="local",_="cancelled",x="unknown";let j=class extends A.Disposable{constructor(R,T,M,N,B,G,Q){super();this.environmentService=R,this.galleryService=T,this.logService=M,this.downloadService=N,this.telemetryService=B,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new d.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new d.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new d.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new d.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const X=this._register(G.createInstance(f.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(E.ExtensionsScanner,ne=>X.postUninstall(ne))),this.manifestCache=this._register(new I.ExtensionsManifestCache(R,this)),this.extensionsDownloader=this._register(G.createInstance(y.ExtensionsDownloader));const ie=this._register(new U.ExtensionsWatcher(this,Q,R,M));this._register(ie.onDidChangeExtensionsByAnotherSource(({added:ne,removed:oe})=>{ne.forEach(he=>this._onDidInstallExtension.fire({identifier:he.identifier,operation:0,local:he})),oe.forEach(he=>this._onDidUninstallExtension.fire({identifier:he}))})),this._register(A.toDisposable(()=>{this.installingExtensions.forEach(ne=>ne.cancel()),this.uninstallingExtensions.forEach(ne=>ne.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(R){this.logService.trace("ExtensionManagementService#zip",R.identifier.id);const T=await this.collectFiles(R),M=await P.zip(t.joinPath(this.environmentService.tmpDir,r.generateUuid()).fsPath,T);return h.URI.file(M)}async unzip(R){return this.logService.trace("ExtensionManagementService#unzip",R.toString()),(await this.install(R)).identifier}async getManifest(R){const T=await this.downloadVsix(R),M=k.resolve(T.fsPath);return l.getManifest(M)}async collectFiles(R){const T=async N=>{let B=await L.Promises.readdir(N);B=B.map(X=>k.join(N,X));const G=await Promise.all(B.map(X=>L.Promises.stat(X)));let Q=Promise.resolve([]);return G.forEach((X,ie)=>{const ne=B[ie];X.isFile()&&(Q=Q.then(oe=>[...oe,ne])),X.isDirectory()&&(Q=Q.then(oe=>T(ne).then(he=>[...oe,...he])))}),Q};return(await T(R.location.fsPath)).map(N=>({path:`extension/${k.relative(R.location.fsPath,N)}`,localPath:N}))}async install(R,T={}){return this.logService.trace("ExtensionManagementService#install",R.toString()),m.createCancelablePromise(async M=>{const N=await this.downloadVsix(R),B=k.resolve(N.fsPath),G=await l.getManifest(B),Q={id:w.getGalleryExtensionId(G.publisher,G.name)};let X=1;if(G.engines&&G.engines.vscode&&!a.isEngineValid(G.engines.vscode,C.default.version,C.default.date))throw new Error(v.localize(0,null,Q.id,C.default.version));const ie=new w.ExtensionIdentifierWithVersion(Q,G.version),oe=(await this.getInstalled(1)).find(me=>w.areSameExtensions(Q,me.identifier));if(oe)if(T.isMachineScoped=T.isMachineScoped||oe.isMachineScoped,T.isBuiltin=T.isBuiltin||oe.isBuiltin,X=2,ie.equals(new w.ExtensionIdentifierWithVersion(oe.identifier,oe.manifest.version)))try{await this.extensionsScanner.removeExtension(oe,"existing")}catch(me){throw new Error(v.localize(1,null,G.displayName||G.name))}else g.gt(oe.manifest.version,G.version)&&await this.uninstallExtension(oe);else{const me=await this.unsetUninstalledAndGetLocal(ie);if(me)try{await this.extensionsScanner.removeExtension(me,"existing")}catch(pe){throw new Error(v.localize(2,null,G.displayName||G.name))}}this.logService.info("Installing the extension:",Q.id),this._onInstallExtension.fire({identifier:Q,zipPath:B});let he;try{he=await this.getGalleryMetadata(w.getGalleryExtensionId(G.publisher,G.name))}catch(me){}try{const me=await this.installFromZipPath(ie,B,T.installOnlyNewlyAddedFromExtensionPack?oe:void 0,{...he||{},...T},T,X,M);return this.logService.info("Successfully installed the extension:",Q.id),me}catch(me){throw this.logService.error("Failed to install the extension:",Q.id,me.message),me}})}async downloadVsix(R){if(R.scheme===u.Schemas.file)return R;if(!this.downloadService)throw new Error("Download service is not available");const T=t.joinPath(this.environmentService.tmpDir,r.generateUuid());return await this.downloadService.download(R,T),T}async installFromZipPath(R,T,M,N,B,G,Q){try{const X=await this.installExtension({zipPath:T,identifierWithVersion:R,metadata:N},Q);try{B.donotIncludePackAndDependencies||await this.installDependenciesAndPackExtensions(X,M,B)}catch(ie){O.isNonEmptyArray(X.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",X.identifier.id,ie.message),O.isNonEmptyArray(X.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",X.identifier.id,ie.message)}return this._onDidInstallExtension.fire({identifier:R,zipPath:T,local:X,operation:G}),X}catch(X){throw this._onDidInstallExtension.fire({identifier:R,zipPath:T,operation:G,error:X}),X}}async canInstall(R){return!0}async installFromGallery(R,T={}){if(!this.galleryService.isEnabled())throw new Error(v.localize(3,null));try{R=await this.checkAndGetCompatibleVersion(R)}catch(N){const B=N&&N.code?N.code:x;throw this.logService.error("Failed to install extension:",R.identifier.id,N?N.message:B),this.reportTelemetry(this.getTelemetryEvent(1),w.getGalleryExtensionTelemetryData(R),void 0,N),N instanceof Error&&(N.name=B),N}let M=this.installingExtensions.get(new w.ExtensionIdentifierWithVersion(R.identifier,R.version).key());return M?(this.logService.info("Extensions is already requested to install",R.identifier.id),(await M.resultPromise).local):(M=this.createInstallFromGalleryExtensionTask(R,T),(await this.runInstallGalleryExtensionTask(M,T)).local)}createInstallFromGalleryExtensionTask(R,T){const M=new w.ExtensionIdentifierWithVersion(R.identifier,R.version).key();this._onInstallExtension.fire({identifier:R.identifier,gallery:R}),this.logService.info("Installing extension:",R.identifier.id);let N;const B=new m.Barrier,G={extension:R,get resultPromise(){return B.wait().then(()=>N)},run:async()=>(N||(N=m.createCancelablePromise(async Q=>{try{const X=await this.installGalleryExtension(R,T,Q);return this.logService.info("Extensions installed successfully:",R.identifier.id),this._onDidInstallExtension.fire({identifier:R.identifier,gallery:X.gallery,local:X.local,operation:X.operation}),X}catch(X){const ie=X&&X.code?X.code:x;throw this.logService.error("Failed to install extension:",R.identifier.id,X?X.message:ie),this._onDidInstallExtension.fire({identifier:R.identifier,gallery:R,operation:1,error:ie}),X instanceof Error&&(X.name=ie),X}})),B.open(),N.finally(()=>this.installingExtensions.delete(M)),N),cancel:()=>{N?N.cancel():this._onDidInstallExtension.fire({identifier:R.identifier,gallery:R,operation:1,error:_})}};return this.installingExtensions.set(M,G),G}async runInstallGalleryExtensionTask(R,T){if(T.donotIncludePackAndDependencies)return this.logService.info("Installing the extension without checking dependencies and pack",R.extension.identifier.id),R.run();const M=new Map,N=[];try{const B=await this.galleryService.getManifest(R.extension,c.CancellationToken.None);if(B===null){const ie=new S.ExtensionManagementError(`Missing manifest for extension ${R.extension.identifier.id}`,H);throw this.logService.error("Failed to install extension:",R.extension.identifier.id,ie.message),ie}M.set(R.extension.identifier.id.toLowerCase(),{task:R,manifest:B});const G=await this.getAllDepsAndPackExtensionsToInstall(R.extension.identifier,B,c.CancellationToken.None);let Q=!1;for(const{gallery:ie,manifest:ne}of G)if(Q=Q||!!ne.extensionDependencies?.some(oe=>w.areSameExtensions({id:oe},R.extension.identifier)),this.installingExtensions.has(new w.ExtensionIdentifierWithVersion(ie.identifier,ie.version).key()))this.logService.info("Extension is already requested to install",ie.identifier.id);else{const oe=this.createInstallFromGalleryExtensionTask(ie,{...T,donotIncludePackAndDependencies:!0});M.set(ie.identifier.id.toLowerCase(),{task:oe,manifest:ne})}for(;M.size;){const ie=[...M.values()].filter(({manifest:oe})=>!oe.extensionDependencies?.some(he=>M.has(he.toLowerCase())));let ne;ie.length?ne=M.size===1?ie:ie.filter(({task:oe})=>!(oe===R&&!Q)):(this.logService.info("Found extensions with circular dependencies",ie.map(({task:oe})=>oe.extension.identifier.id)),ne=[...M.values()]),await Promise.all(ne.map(async({task:oe})=>{N.push(await oe.run()),M.delete(oe.extension.identifier.id.toLowerCase())}))}const X=N.find(({local:ie})=>w.areSameExtensions(ie.identifier,R.extension.identifier));if(X)return X;throw new Error("Extension is not installed")}catch(B){throw M.size?M.forEach(({task:G})=>G.cancel()):R.cancel(),B}}async installGalleryExtension(R,T,M){const N=new Date().getTime();let B=1;try{const Q=(await this.getInstalled()).find(ne=>w.areSameExtensions(ne.identifier,R.identifier));Q&&(B=2);const X=await this.downloadInstallableExtension(R,B);X.metadata.isMachineScoped=T.isMachineScoped||Q?.isMachineScoped,X.metadata.isBuiltin=T.isBuiltin||Q?.isBuiltin;const ie=await this.installExtension(X,M);Q&&g.neq(Q.manifest.version,R.version)&&await this.extensionsScanner.setUninstalled(Q);try{await this.extensionsDownloader.delete(h.URI.file(X.zipPath))}catch(ne){}return this.reportTelemetry(this.getTelemetryEvent(B),w.getGalleryExtensionTelemetryData(R),new Date().getTime()-N,void 0),{local:ie,operation:B,gallery:R}}catch(G){throw this.reportTelemetry(this.getTelemetryEvent(B),w.getGalleryExtensionTelemetryData(R),new Date().getTime()-N,G),G}}async getAllDepsAndPackExtensionsToInstall(R,T,M){let N=await this.getInstalled();const B=[R,...N.map(X=>X.identifier)],G=[],Q=async(X,ie)=>{const ne=ie.extensionDependencies||[];if(ie.extensionPack){const oe=N.find(he=>w.areSameExtensions(he.identifier,X));for(const he of ie.extensionPack)oe&&oe.manifest.extensionPack&&oe.manifest.extensionPack.some(me=>w.areSameExtensions({id:me},{id:he}))||ne.every(me=>!w.areSameExtensions({id:me},{id:he}))&&ne.push(he)}if(ne.length){const oe=[...B,...G.map(me=>me.gallery.identifier)],he=ne.filter(me=>oe.every(pe=>!w.areSameExtensions(pe,{id:me})));if(he.length){const me=await this.galleryService.query({names:he,pageSize:ne.length},c.CancellationToken.None);for(const pe of me.firstPage){if(oe.find(Fe=>w.areSameExtensions(Fe,pe.identifier)))continue;const Ie=await this.checkAndGetCompatibleVersion(pe),Re=await this.galleryService.getManifest(Ie,c.CancellationToken.None);if(Re===null)throw new S.ExtensionManagementError(`Missing manifest for extension ${Ie.identifier.id}`,H);G.push({gallery:Ie,manifest:Re}),await Q(Ie.identifier,Re)}}}};return await Q(R,T),N=await this.getInstalled(),G.filter(X=>!N.some(ie=>w.areSameExtensions(ie.identifier,X.gallery.identifier)))}async checkAndGetCompatibleVersion(R){if(await this.isMalicious(R))throw new S.ExtensionManagementError(v.localize(4,null),S.INSTALL_ERROR_MALICIOUS);const T=await this.galleryService.getCompatibleExtension(R);if(!T)throw new S.ExtensionManagementError(v.localize(5,null,R.identifier.id,C.default.version),S.INSTALL_ERROR_INCOMPATIBLE);return T}async reinstallFromGallery(R){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",R.identifier.id),!this.galleryService.isEnabled())throw new Error(v.localize(6,null));const T=await this.findGalleryExtension(R);if(!T)throw new Error(v.localize(7,null));await this.extensionsScanner.setUninstalled(R);try{await this.extensionsScanner.removeUninstalledExtension(R)}catch(M){throw new Error(v.localize(8,null,p.toErrorMessage(M)))}await this.installFromGallery(T)}getTelemetryEvent(R){return R===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(R){const T=await this.getExtensionsReport();return w.getMaliciousExtensionsSet(T).has(R.identifier.id)}async downloadInstallableExtension(R,T){const M={id:R.identifier.uuid,publisherId:R.publisherId,publisherDisplayName:R.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",R.identifier.id),N=(await this.extensionsDownloader.downloadExtension(R,T)).fsPath,this.logService.info("Downloaded extension:",R.identifier.id,N)}catch(B){throw new S.ExtensionManagementError(this.joinErrors(B).message,$)}try{const B=await l.getManifest(N);return{zipPath:N,identifierWithVersion:new w.ExtensionIdentifierWithVersion(R.identifier,B.version),metadata:M}}catch(B){throw new S.ExtensionManagementError(this.joinErrors(B).message,H)}}async installExtension(R,T){try{const M=await this.unsetUninstalledAndGetLocal(R.identifierWithVersion);if(M)return R.metadata?this.extensionsScanner.saveMetadataForLocalExtension(M,R.metadata):M}catch(M){throw D.isMacintosh?new S.ExtensionManagementError(v.localize(9,null),z):new S.ExtensionManagementError(v.localize(10,null),z)}return this.extractAndInstall(R,T)}async unsetUninstalledAndGetLocal(R){if(!await this.isUninstalled(R))return null;this.logService.trace("Removing the extension from uninstalled list:",R.id);const M=await this.extensionsScanner.setInstalled(R);return this.logService.info("Removed the extension from uninstalled list:",R.id),M}async extractAndInstall({zipPath:R,identifierWithVersion:T,metadata:M},N){let B=await this.extensionsScanner.extractUserExtension(T,R,N);return this.logService.info("Installation completed.",T.id),M&&(B=await this.extensionsScanner.saveMetadataForLocalExtension(B,M)),B}async installDependenciesAndPackExtensions(R,T,M){if(!this.galleryService.isEnabled())return;const N=R.manifest.extensionDependencies||[];if(R.manifest.extensionPack)for(const B of R.manifest.extensionPack)T&&T.manifest.extensionPack&&T.manifest.extensionPack.some(G=>w.areSameExtensions({id:G},{id:B}))||N.every(G=>!w.areSameExtensions({id:G},{id:B}))&&N.push(B);if(N.length){const B=await this.getInstalled(),G=N.filter(Q=>B.every(({identifier:X})=>!w.areSameExtensions(X,{id:Q})));if(G.length){const X=(await this.galleryService.query({names:G,pageSize:N.length},c.CancellationToken.None)).firstPage;try{await m.Promises.settled(X.map(ie=>this.installFromGallery(ie,M)))}catch(ie){try{await this.rollback(X)}catch(ne){}throw ie}}}}async rollback(R){const M=(await this.getInstalled(1)).filter(N=>R.some(B=>new w.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version).equals(new w.ExtensionIdentifierWithVersion(B.identifier,B.version))));await m.Promises.settled(M.map(N=>this.uninstall(N)))}async uninstall(R,T={}){this.logService.trace("ExtensionManagementService#uninstall",R.identifier.id);const M=await this.getInstalled(1),N=M.find(B=>w.areSameExtensions(B.identifier,R.identifier));if(!N)throw new Error(v.localize(11,null,R.manifest.displayName||R.manifest.name));try{await this.checkForDependenciesAndUninstall(N,M,T)}catch(B){throw this.joinErrors(B)}}async updateMetadata(R,T){return this.logService.trace("ExtensionManagementService#updateMetadata",R.identifier.id),R=await this.extensionsScanner.saveMetadataForLocalExtension(R,{...R.manifest.__metadata||{},...T}),this.manifestCache.invalidate(),R}async updateExtensionScope(R,T){return this.logService.trace("ExtensionManagementService#updateExtensionScope",R.identifier.id),R=await this.extensionsScanner.saveMetadataForLocalExtension(R,{...R.manifest.__metadata||{},isMachineScoped:T}),this.manifestCache.invalidate(),R}async getGalleryMetadata(R){const T=await this.findGalleryExtensionByName(R);return T?{id:T.identifier.uuid,publisherDisplayName:T.publisherDisplayName,publisherId:T.publisherId}:void 0}async findGalleryExtension(R){if(R.identifier.uuid){const T=await this.findGalleryExtensionById(R.identifier.uuid);return T||this.findGalleryExtensionByName(R.identifier.id)}return this.findGalleryExtensionByName(R.identifier.id)}async findGalleryExtensionById(R){return(await this.galleryService.query({ids:[R],pageSize:1},c.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(R){return(await this.galleryService.query({names:[R],pageSize:1},c.CancellationToken.None)).firstPage[0]}joinErrors(R){const T=Array.isArray(R)?R:[R];return T.length===1?T[0]instanceof Error?T[0]:new Error(T[0]):T.reduce((M,N)=>new Error(`${M.message}${M.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}async checkForDependenciesAndUninstall(R,T,M){try{await this.preUninstallExtension(R);const N=M.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(R,T);await this.uninstallExtensions(R,N,T,M)}catch(N){throw await this.postUninstallExtension(R,new S.ExtensionManagementError(N instanceof Error?N.message:N,V)),N}await this.postUninstallExtension(R)}async uninstallExtensions(R,T,M,N){const B=[R,...T];if(!N.donotCheckDependents)for(const G of B)this.checkForDependents(G,B,M,R);await m.Promises.settled([this.uninstallExtension(R),...T.map(G=>this.doUninstall(G))])}checkForDependents(R,T,M,N){const B=this.getDependents(R,M);if(B.length){const G=B.filter(Q=>T.indexOf(Q)===-1);if(G.length)throw new Error(this.getDependentsErrorMessage(R,G,N))}}getDependentsErrorMessage(R,T,M){return M===R?T.length===1?v.localize(12,null,M.manifest.displayName||M.manifest.name,T[0].manifest.displayName||T[0].manifest.name):T.length===2?v.localize(13,null,M.manifest.displayName||M.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name):v.localize(14,null,M.manifest.displayName||M.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name):T.length===1?v.localize(15,null,M.manifest.displayName||M.manifest.name,R.manifest.displayName||R.manifest.name,T[0].manifest.displayName||T[0].manifest.name):T.length===2?v.localize(16,null,M.manifest.displayName||M.manifest.name,R.manifest.displayName||R.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name):v.localize(17,null,M.manifest.displayName||M.manifest.name,R.manifest.displayName||R.manifest.name,T[0].manifest.displayName||T[0].manifest.name,T[1].manifest.displayName||T[1].manifest.name)}getAllPackExtensionsToUninstall(R,T,M=[]){if(M.indexOf(R)!==-1)return[];M.push(R);const N=R.manifest.extensionPack?R.manifest.extensionPack:[];if(N.length){const B=T.filter(Q=>!Q.isBuiltin&&N.some(X=>w.areSameExtensions({id:X},Q.identifier))),G=[];for(const Q of B)G.push(...this.getAllPackExtensionsToUninstall(Q,T,M));return[...B,...G]}return[]}getDependents(R,T){return T.filter(M=>M.manifest.extensionDependencies&&M.manifest.extensionDependencies.some(N=>w.areSameExtensions({id:N},R.identifier)))}async doUninstall(R){try{await this.preUninstallExtension(R),await this.uninstallExtension(R)}catch(T){throw await this.postUninstallExtension(R,new S.ExtensionManagementError(T instanceof Error?T.message:T,V)),T}await this.postUninstallExtension(R)}async preUninstallExtension(R){if(!await L.Promises.exists(R.location.fsPath))throw new Error(v.localize(18,null));this.logService.info("Uninstalling extension:",R.identifier.id),this._onUninstallExtension.fire(R.identifier)}async uninstallExtension(R){let T=this.uninstallingExtensions.get(R.identifier.id);return T||(T=m.createCancelablePromise(async()=>{const M=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...M.filter(N=>w.areSameExtensions(N.identifier,R.identifier)))}),this.uninstallingExtensions.set(R.identifier.id,T),T.finally(()=>this.uninstallingExtensions.delete(R.identifier.id))),T}async postUninstallExtension(R,T){if(T)this.logService.error("Failed to uninstall extension:",R.identifier.id,T.message);else if(this.logService.info("Successfully uninstalled extension:",R.identifier.id),R.identifier.uuid)try{await this.galleryService.reportStatistic(R.manifest.publisher,R.manifest.name,R.manifest.version,"uninstall")}catch(N){}this.reportTelemetry("extensionGallery:uninstall",w.getLocalExtensionTelemetryData(R),void 0,T);const M=T?T instanceof S.ExtensionManagementError?T.code:x:void 0;this._onDidUninstallExtension.fire({identifier:R.identifier,error:M})}getInstalled(R=null){return this.extensionsScanner.scanExtensions(R)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(R){return(await this.filterUninstalled(R)).length===1}async filterUninstalled(...R){const T=[],M=await this.extensionsScanner.getUninstalledExtensions();for(const N of R)M[N.key()]&&T.push(N.key());return T}getExtensionsReport(){const R=new Date().getTime();return(!this.reportedExtensions||R-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=R),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const R=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${R.length} reported extensions from service`),R}catch(R){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(R,T,M,N){const B=N?N instanceof S.ExtensionManagementError?N.code:x:void 0;this.telemetryService.publicLogError(R,{...T,success:!N,duration:M,errorcode:B})}};j=de([Y(0,n.INativeEnvironmentService),Y(1,S.IExtensionGalleryService),Y(2,b.ILogService),Y(3,o.optional(i.IDownloadService)),Y(4,s.ITelemetryService),Y(5,o.IInstantiationService),Y(6,F.IFileService)],j),e.ExtensionManagementService=j}),define(Z[212],ee([0,1,48,35,213,102,51,101,36,76,50,149,9,131,133,28,206,174,23,165,39,166,24,59,172,80,81,177,15,77,158,56,2,167,72,162,163,154,153,151,150,173,71,159,10,161,17,27,22,199,201,196,58,197,202,171,21,169,198,60,195,175,61,73,135,203,176,86,85,84,4,152,144,11,43,82,184,179,200,142,146,178,5,14]),function(K,e,v,k,L,A,O,P,S,w,n,m,d,g,h,C,D,b,I,p,s,a,t,r,i,o,u,c,l,y,E,f,U,F,z,$,H,V,_,x,j,q,R,T,M,N,B,G,Q,X,ie,ne,oe,he,me,pe,Ie,Re,Fe,Oe,ke,_e,be,Ae,Ke,Ye,$e,xe,J,re,se,ye,ve,Pe,we,Te,Ce,Le,Ue,W,te,ae,le,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class fe extends U.Disposable{constructor(ue){super();this.configuration=ue,this.server=this._register(new P.Server),L.gracefulify(v),this.registerListeners()}registerListeners(){const ue=()=>this.dispose();process.once("exit",ue),A.ipcRenderer.once("vscode:electron-main->shared-process=exit",ue)}async open(){const ue=await this.initServices();Q.registerConfiguration(),ue.invokeFunction(Ee=>{const De=Ee.get(l.ILogService);De.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Ee),this.registerErrorHandler(De)}),this._register(U.combinedDisposable(ue.createInstance($.CodeCacheCleaner,this.configuration.codeCachePath),ue.createInstance(H.LanguagePackCachedDataCleaner),ue.createInstance(V.StorageDataCleaner,this.configuration.backupWorkspacesPath),ue.createInstance(_.LogsDataCleaner),ue.createInstance(ye.LocalizationsUpdater),ue.createInstance(ve.DeprecatedExtensionsCleaner)))}async initServices(){const ue=new w.ServiceCollection,Ee={_serviceBrand:void 0,...O.default};ue.set(G.IProductService,Ee);const De=new S.StaticRouter(Be=>Be==="main"),Me=new j.MessagePortMainProcessService(this.server,De);ue.set(x.IMainProcessService,Me);const Ne=new g.NativeEnvironmentService(this.configuration.args,Ee);ue.set(d.INativeEnvironmentService,Ne);const et=new y.LogLevelChannelClient(this.server.getChannel("logLevel",De)),Je=new y.LoggerChannelClient(this.configuration.logLevel,et.onDidChangeLogLevel,Me.getChannel("logger"));ue.set(l.ILoggerService,Je);const nt=this._register(new l.MultiplexLogService([this._register(new l.ConsoleLogger(this.configuration.logLevel)),this._register(Je.createLogger(ce.joinPath(le.URI.file(Ne.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),We=this._register(new y.FollowerLogService(et,nt));ue.set(l.ILogService,We);const Ve=this._register(new T.FileService(We));ue.set(M.IFileService,Ve);const it=this._register(new N.DiskFileSystemProvider(We));Ve.registerProvider(B.Schemas.file,it);const qe=this._register(new p.ConfigurationService(Ne.settingsResource,Ve));ue.set(I.IConfigurationService,qe),await qe.initialize();const Xe=new pe.NativeStorageService(void 0,Me,Ne);ue.set(Ie.IStorageService,Xe),await Xe.initialize(),this._register(U.toDisposable(()=>Xe.flush())),ue.set(s.IRequestService,new n.SyncDescriptor(a.RequestService)),ue.set(W.IChecksumService,new n.SyncDescriptor(te.ChecksumService));const tt=S.ProxyChannel.toService(Me.getChannel("nativeHost"),{context:this.configuration.windowId});ue.set(oe.INativeHostService,tt),ue.set(z.IDownloadService,new n.SyncDescriptor(F.DownloadService));const rt=this._register(new Ye.ActiveWindowManager(tt)),ht=new S.StaticRouter(Be=>rt.getActiveClientId().then(st=>Be===st));ue.set(Ae.IExtensionRecommendationNotificationService,new Ke.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",ht)));let Qe,He;if(!Ne.isExtensionDevelopment&&!Ne.disableTelemetry&&Ee.enableTelemetry){He=new $e.TelemetryLogAppender(Je,Ne);const{appRoot:Be,extensionsPath:st,isBuilt:dt,installSourcePath:gt}=Ne;if(Ee.aiConfig&&Ee.aiConfig.asimovKey&&dt){const ct=new c.AppInsightsAppender("monacoworkbench",null,Ee.aiConfig.asimovKey);this._register(U.toDisposable(()=>ct.flush())),He=r.combinedAppender(ct,He)}Qe=new u.TelemetryService({appender:He,commonProperties:i.resolveCommonProperties(Ve,k.release(),k.hostname(),process.arch,Ee.commit,Ee.version,this.configuration.machineId,Ee.msftInternalDomains,gt),sendErrorTelemetry:!0,piiPaths:[Be,st]},qe)}else Qe=r.NullTelemetryService,He=r.NullAppender;this.server.registerChannel("telemetryAppender",new o.TelemetryAppenderChannel(He)),ue.set(t.ITelemetryService,Qe);const ft=new ae.CustomEndpointTelemetryService(qe,Qe);return ue.set(t.ICustomEndpointTelemetryService,ft),ue.set(C.IExtensionManagementService,new n.SyncDescriptor(D.ExtensionManagementService)),ue.set(C.IExtensionGalleryService,new n.SyncDescriptor(b.ExtensionGalleryService)),ue.set(C.IExtensionTipsService,new n.SyncDescriptor(_e.ExtensionTipsService)),ue.set(f.ILocalizationsService,new n.SyncDescriptor(E.LocalizationsService)),ue.set(R.IDiagnosticsService,new n.SyncDescriptor(q.DiagnosticsService)),ue.set(Oe.IUserDataSyncAccountService,new n.SyncDescriptor(Oe.UserDataSyncAccountService)),ue.set(Q.IUserDataSyncLogService,new n.SyncDescriptor(he.UserDataSyncLogService)),ue.set(Q.IUserDataSyncUtilService,new ne.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Be=>Be.ctx!=="main"))),ue.set(C.IGlobalExtensionEnablementService,new n.SyncDescriptor(Re.GlobalExtensionEnablementService)),ue.set(J.IIgnoredExtensionsManagementService,new n.SyncDescriptor(J.IgnoredExtensionsManagementService)),ue.set(re.IExtensionsStorageSyncService,new n.SyncDescriptor(re.ExtensionsStorageSyncService)),ue.set(Q.IUserDataSyncStoreManagementService,new n.SyncDescriptor(ie.UserDataSyncStoreManagementService)),ue.set(Q.IUserDataSyncStoreService,new n.SyncDescriptor(ie.UserDataSyncStoreService)),ue.set(be.IUserDataSyncMachinesService,new n.SyncDescriptor(be.UserDataSyncMachinesService)),ue.set(Q.IUserDataSyncBackupStoreService,new n.SyncDescriptor(ke.UserDataSyncBackupStoreService)),ue.set(Q.IUserDataAutoSyncEnablementService,new n.SyncDescriptor(xe.UserDataAutoSyncEnablementService)),ue.set(Q.IUserDataSyncResourceEnablementService,new n.SyncDescriptor(Fe.UserDataSyncResourceEnablementService)),ue.set(Q.IUserDataSyncService,new n.SyncDescriptor(X.UserDataSyncService)),ue.set(Le.ILocalPtyService,this._register(new Ce.PtyHostService({GraceTime:6e4,ShortGraceTime:6e3},qe,We,Qe))),new m.InstantiationService(ue)}initChannels(ue){const Ee=new h.ExtensionManagementChannel(ue.get(C.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Ee);const De=S.ProxyChannel.fromService(ue.get(f.ILocalizationsService));this.server.registerChannel("localizations",De);const Me=S.ProxyChannel.fromService(ue.get(R.IDiagnosticsService));this.server.registerChannel("diagnostics",Me);const Ne=new h.ExtensionTipsChannel(ue.get(C.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ne);const et=S.ProxyChannel.fromService(ue.get(W.IChecksumService));this.server.registerChannel("checksum",et);const Je=new ne.UserDataSyncMachinesServiceChannel(ue.get(be.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Je);const nt=S.ProxyChannel.fromService(ue.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",nt);const We=new ne.UserDataSyncAccountServiceChannel(ue.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",We);const Ve=new ne.UserDataSyncStoreManagementServiceChannel(ue.get(Q.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ve);const it=new Ue.UserDataSyncChannel(ue.get(Q.IUserDataSyncService),ue.get(l.ILogService));this.server.registerChannel("userDataSync",it);const qe=this._register(ue.get(se.IInstantiationService).createInstance(me.UserDataAutoSyncService)),Xe=new ne.UserDataAutoSyncChannel(qe);this.server.registerChannel("userDataAutoSync",Xe);const tt=ue.get(Le.ILocalPtyService),rt=S.ProxyChannel.fromService(tt);this.server.registerChannel(Te.TerminalIpcChannels.LocalPty,rt)}registerErrorHandler(ue){window.addEventListener("unhandledrejection",Ee=>{Pe.onUnexpectedError(Ee.reason),Ee.preventDefault()}),Pe.setUnexpectedErrorHandler(Ee=>{const De=we.toErrorMessage(Ee,!0);!De||ue.error(`[uncaught exception in sharedProcess]: ${De}`)})}}async function ge(Se){const ue=new fe(Se);A.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ue.open(),A.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=ge})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/1db97b8c87fb32aa47b58135832733f4950362b4/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
